<?php
error_reporting(0);
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');
class Claims extends MY_controller {	

	private $header  = 'header';
	private $sidebar = 'sidebar';
	private $footer  = 'footer';

	public function __construct()
	{
		parent::__construct();
		if(!$this->session->has_userdata('uid'))
			return redirect('login');

		if( $this->session->has_userdata('atype') || $this->session->has_userdata('otype'))
			return self::logout();
			
		$this->load->helper('form');
		//.....................set default css and js for output.........................
		set_includes(array(BASIC_CSS, BASIC_JS, NOTIFY, APP, TIMER, SESSION_TIMEOUT));		
		set_header($this->header); 	set_sidebar($this->sidebar); 	set_footer($this->footer);
	   //............................ends here.........................................
	}

	public function index()
	{
		self::dashboard();
	}

	public function dashboard() 
	{
		$this->data['nav'] = 1;
		$this->data['include'] = include_file_batch();
								 view('claims/dashboard',$this->data);
	}
	
	//............for opsatglance............................
	public function opsatglance($gridStatus = 1)
	{
		$this->data['gridStatus'] =  $gridStatus;
		$this->data['year_list'] 	 = $this->pass->getYearListForNominationGrid();
		unset($this->data['year_list']['']);
		$this->data['nav'] = ($gridStatus == 1) ? 2 : (($gridStatus == 2) ? 3 : 4);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID,SWEET_ALERT,DATEPICKER,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('claims/opsatglance',$this->data);
	}
	
	public function view_fixture($gridStatus = 1, $nomid)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] = ($gridStatus == 1) ? 2 : (($gridStatus == 2) ? 3 : 4);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' ELSE 'Time Charter' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select STATUS_NAME from status_master where status_master.STATUSID=nom_details.FIXTURE_STATUS) as FIXTURESTATUSNAME","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('cargo_master','CARGOID')));
		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('port_master','PORTID')));
		$this->data['etanextPort'] = extractString($this->data['nom']->ADD_NEXT_PORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('nom_details_slave2','NOM_SLAVE2ID'));
		$this->data['slave2'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave2.PORTID) as PORTNAME, (case when (PORTTYPEID = 1) THEN 'LP' ELSE 'DP' END) as PORTTYPE","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave3','NOM_SLAVE3ID'));
		$this->data['slave3'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave3.PORTID) as PORTNAME, (select PURPOSE_NAME from purposeofcall_master where purposeofcall_master.CALLID=nom_details_slave3.PURPOSEOFCALL) as PURPOSE_NAME","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave4'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'BROKER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave5'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'VOYAGE')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave6'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'OWNER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave7'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'CHARTERER')));
		
		$this->pass->setTable(array('nom_details_slave','SLAVEID'));
		$this->data['slave'] = $this->pass->all(array("select"=>"*, (select NAME from broker_master where broker_master.BROKERID=nom_details_slave.BROKERID) as BROKERNAME","where"=>array('NOMID'=>$nomid)));
								 
		$this->data['include'] = include_file_batch();
								 view('claims/view_fixture',$this->data);
	}
	
	
	
	public function invoice($gridStatus = 1, $nomid)
	{
		$this->load->helper(['dateFormat','array']);
		$this->load->library("numbertowordconversion");
		$this->data['nav'] = ($gridStatus == 1) ? 2 : (($gridStatus == 2) ? 3 : 4);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' ELSE 'Time Charter' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME, (select VENDORADDRESS1 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS1, (select VENDORADDRESS2 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS2, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select VENDORADDRESS3 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS3 , (select VENDORADDRESS4 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS4","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>" , ","table"=>array('cargo_master','CARGOID')));

		$this->pass->setTable(array('summary_slave','NOMID'));

		$this->data['summre'] = $this->pass->find_by_pk($nomid);

		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>"\n","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>"\n","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('company_master','COMPANYID'));
		$this->data['companydata'] = $this->pass->all(array("where"=>array('COMPANYID'=>$this->data['nom']->COMPANYID)));
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));	
		$this->data['f_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_demu_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));		
		$this->data['o_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Deviation' WHEN (INVOICENOTE = 4) THEN CONCAT('Others ( ', INVOICENOTEOTHER, ' )') ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('payment_received','PAYMENTID'));
		$this->data['f_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));	
		$this->data['o_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('summary','SUMMARYID'));
		$this->data['f_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));
		$this->data['o_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));

		
		
		$this->data['owner_list'] = $this->pass->getOwnerChartererList();
		$this->data['invoice_list'] = $this->pass->getInvoiceStatusList();
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE,DATEPICKER,NUMERIC,CALC));
		$this->data['include'] = include_file_batch();
								 view('claims/invoice',$this->data);
	}
	
	public function insert_summary($gridStatus = 1, $invoice_type, $fixtureType)
	{
		$this->load->helper(['dateFormat','array']);
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		
		if($invoice_type == 'Freight'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s1',$data['PID']);}
		if($invoice_type == 'Demurrage'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s2',$data['DID']);}
		if($invoice_type == 'Others'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s3',$data['OID']);}

		
		//echo '<pre>'; print_r($data); die;
		
		$alerts = [
					[
						'ALERTBY' 		=> $this->session->uid,
						'ALERTTO' 		=> 1,
						'ALERTTEXT'		=> $invoice_type.'  Claims Summary saved by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
						'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'admin/invoice/'.$gridStatus.'/'.$data['NOMID'],
						'ALERTTYPE'		=> 'Claims Summary'
					 ],
					 [
						'ALERTBY'		=> $this->session->uid,
						'ALERTTO'		=> $data['OPERATIONLOGINID'],
						'ALERTTEXT'		=> $invoice_type.'  Claims Summary saved by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
						'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'operation/'.(($fixtureType == 1) ? 'invoiceVoyage' : 'invoiceTime').'/'.$gridStatus.'/'.$data['NOMID'],
						'ALERTTYPE'		=> 'Claims Summary'
					 ]
				  ];

		$this->pass->setTable(array('summary','SUMMARYID'));
		$this->pass->delete(array("where"=>array('NOMID' => $data['NOMID'], 'INVOICETYPE' => $invoice_type)));
				
		for($i=1;$i<=count($slave_data);$i++):
			$slave_data[$i]['ONDATE'] 	   	= !empty($slave_data[$i]['ONDATE']) ? formatedDate($slave_data[$i]['ONDATE']) : '0000-00-00';
			$slave_data[$i]['PAYMENTDATE'] 	= !empty($slave_data[$i]['PAYMENTDATE']) ? formatedDate($slave_data[$i]['PAYMENTDATE']) : '0000-00-00';
			$slave_data[$i]['AGREEDDATE'] 	= !empty($slave_data[$i]['AGREEDDATE']) ? formatedDate($slave_data[$i]['AGREEDDATE']) : '0000-00-00';
			$insertId = $this->pass->insert($slave_data[$i]);
		endfor;
		
		return self::_flashAndRedirectAllWithAlertArray($insertId,
									   $invoice_type.' Claims Summary ('.$data['NOMINATIONID'].') saved successfully.', 
									   'Sorry! there was an error while saving Claims Summary.',
									   'claims/'.(($gridStatus == 1) ? 'opsatglance' : 'postopsatglance'),$alerts);
	}

	public function insert_ffidate($gridStatus = 1)
	{
		$this->load->helper(['dateFormat','array']);
		$data = self::customized_ArrayByKey($this->input->post(),'m');

		$this->pass->setTable(array('summary_slave','FIID'));
		$this->pass->delete(array("where"=>array('NOMID' => $data['NOMID'])));

		$data['FI_RECEIVED']	= !empty($data['FI_RECEIVED']) ? formatedDate($data['FI_RECEIVED']) : '0000-00-00'; 
		$data['FI_PAID']		= !empty($data['FI_PAID']) ? formatedDate($data['FI_PAID']) : '0000-00-00';
		$data['FFI_RECEIVED'] 	= !empty($data['FFI_RECEIVED']) ? formatedDate($data['FFI_RECEIVED']) : '0000-00-00';
		$data['FFI_PAID']		= !empty($data['FFI_PAID']) ? formatedDate($data['FFI_PAID']) : '0000-00-00';	
		$nom_id = $this->pass->insert($data);

		return self::_flashAndRedirectAllWithAlertArray($insertId,
									   $invoice_type.' Claims Summary ('.$data['NOMINATIONID'].') saved successfully.', 
									   'Sorry! there was an error while saving Claims Summary.',
									   'claims/'.(($gridStatus == 1) ? 'opsatglance' : 'postopsatglance'),$alerts);


	}
	//..........................ends here ...........................................

	//..................report.............................
	public function invoice_detail_report($selinvoice=0,$startDate='',$endDate='')
	{

	    $this->load->helper('dateFormat');
	    $this->data['invoice_list'] 	 = $this->pass->getInvoiceList();
        $this->data['nav'] = 5;

	   $whereArr = (trim($startDate) != "" && trim($endDate) != "") ? array('INVOICEDATE >=' => trim($startDate),'INVOICEDATE <=' => trim($endDate)) : array(1 => 1);

	   if($selinvoice !=0) : $whereArr['INVOICETYPE'] = $selinvoice; endif;

		$this->data['dateRange'] = (trim($startDate) != "" && trim($endDate) != "") ? formatedDate($startDate, "d/m/Y")." - ".formatedDate($endDate, "d/m/Y") : '';

		$this->data['startdate'] = (trim($startDate) != "" && trim($endDate) != "") ? formatedDate($startDate, "Y-m-d"): '';

		$this->data['enddate']   = (trim($endDate) != "" && trim($startDate) != "") ? formatedDate($endDate, "Y-m-d"): '';

		$this->data['selinvoice'] = (trim($selinvoice) != 0) ? $selinvoice : '';
		 
		 $this->pass->setTable(array('invoice_master','INVOICEID'));
		// $nom = $this->pass->all(array("select"=>"* ", "where"=>$whereArr, "order_by"=>array('NOMID'=>'DESC') ));


		$nom = $this->pass->all(array("select"=>"invoice_master.NOMID, nom_details.FIXTURETYPE, (CASE WHEN FIXTURETYPE = 1 THEN 'Voyage Spot' WHEN FIXTURETYPE = 2 THEN 'Time Charter' ELSE 'COA'  END) as FIXTURETYPENAME, NOMINATIONID,ADDEDBY,INVOICETYPE, COMMISSIONVALUE, LAYCANSTART, LAYCANEND, ADDONDATE, LUMPSUMFREIGHT, BLFIG,INVOICEDATE, OWNER_CONTACT_DETAILS,ACTUALDAYS,OFFHIREDAY, nom_details.REMARKS as REMARKS2, NOMINATIONID, CHARTERER_CONTACT_DETAILS,CPQUNTITYMAX, CPQUNTITYMIN, COMMISSIONVALUE, nom_details.CPDATE, FIXTURE_STATUS,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Deviation' ELSE 'Other' END) as INVOICENOTENAME, (select VESSELNAME from vessel_imo_master where vessel_imo_master.VESSELIMOID=nom_details.FLEETID) as FLEETNAME, (select FI_RECEIVED from summary_slave where summary_slave.NOMID=nom_details.NOMID) as FIRECDATE,(select FI_PAID from summary_slave where summary_slave.NOMID=nom_details.NOMID) as FIPAIDDATE,(select FFI_RECEIVED from summary_slave where summary_slave.NOMID=nom_details.NOMID) as FFIRECV,(select FFI_PAID from summary_slave where summary_slave.NOMID=nom_details.NOMID) as FFIPAID, (select SUM(RCVDAMOUNT) as RCVDAMOUNT from payment_received where payment_received.NOMID=invoice_master.NOMID and payment_received.INVOICETYPE=invoice_master.INVOICETYPE) as PAYMENTAMT,(select VESSEL_ARRIVED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='LP') as LPVESSELARIVED, (select VESSEL_ARRIVED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='DP') as DPVESSELARIVED, (select LOAD_DIS_COMPLETED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='LP') as LPCOMPLITDATE, (select LOAD_DIS_COMPLETED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='DP') as DPCOMPLED, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMNAME  ,(select  GROUP_CONCAT(BROKERID SEPARATOR ', ') from nom_details_slave where nom_details_slave.NOMID = nom_details.NOMID ) as BROKERID, (case when (NOMSTATUS = 1) THEN '<small class=\"label label-warning\">Fixture Created</small>' when (NOMSTATUS = 2) THEN '<small class=\"label label-success\">Sent to Ops & Claims</small>' when (NOMSTATUS = 3) THEN '<small class=\"label label-danger\" >Freight Paid</small>' when (NOMSTATUS = 4) THEN '<small class=\"label label-danger\" >Demurrage Paid</small>' when (NOMSTATUS = 5) THEN '<small class=\"label label-primary\">Commission on Freight Received</small>' when (NOMSTATUS = 6) THEN '<small class=\"label label-primary\">Commission on Demurrage Received</small>' ELSE '' END) as NOMSTATUSNAME",'join'=>array('nom_details'=>'nom_details.NOMID = invoice_master.NOMID'),"where_str"=>$whereArr, 'order_by'=>array('NOMID'=>'DESC')));


	
		if( $nom ){
			foreach($nom as $nomData){




				$this->data['nom'][] = array(


					'PARTYNAME' => self::getNOMMasterData($nomData->NOMID,'OWNER'),

					'CHARTERPARY' =>self::getNOMMasterData($nomData->NOMID,'VENDORID'),

					'VESSELNAE' => self::getNOMMasterData($nomData->NOMID,'FLEETID'),

					'CARGO' => self::getNOMMasterData($nomData->NOMID,'CARGOID'),

					'INVOICENO' => $nomData->NOMINATIONID,					
					'INVOTYPE' => $nomData->FIXTURETYPENAME,
					'NOMSTATUSNAME' => $nomData->NOMSTATUSNAME,
					'ADDEDBY' => $nomData->ADDEDBY,
					'INVOICETYPE' => $nomData->INVOICETYPE,

					'ADDONDATE' => $nomData->ADDONDATE,
					'LAYCAN' => $nomData->LAYCANSTART,
					'LAYCANEND' => $nomData->LAYCANEND,
					'FIXTURE' => $nomData->FIXTUREDATE,
					'BLQTY' => $nomData->BLFIG,
					'ONERDETAIL' => $nomData->OWNER_CONTACT_DETAILS,
					'CHTERDATAIL' => $nomData->CHARTERER_CONTACT_DETAILS,
					'CPQTY' => $nomData->CPQUNTITYMIN,
					'CPMAX' => $nomData->CPQUNTITYMAX,
					'LUMPSUMFREIGHT' => $nomData->LUMPSUMFREIGHT,
					
					'CUNTRY' => self::getNOMMasterData($nomData->NOMID,'LPORT'),
					'CUNTRY' => self::getNOMMasterData($nomData->NOMID,'DPORT'),	

					'POSRTID' => self::getNOMMasterData($nomData->NOMID,'LPORT'),	
					'POSRTID' => self::getNOMMasterData($nomData->NOMID,'DPORT'),	

					'REMARKS' => $nomData->REMARKS2,

					'FIRECDATE' => $nomData->FIRECDATE,
					'FIPAIDDATE' => $nomData->FIPAIDDATE,
					'FFIRECV' => $nomData->FFIRECV,
					'FFIPAID' => $nomData->FFIPAID,

					'LPVESSELARIVED' => $nomData->LPVESSELARIVED,
					'DPVESSELARIVED' => $nomData->DPVESSELARIVED,
					'LPCOMPLITDATE' => $nomData->LPCOMPLITDATE,
					'DPCOMPLED' => $nomData->DPCOMPLED,

					$actday = $nomData->ACTUALDAYS,
					$offhir= $nomData->OFFHIREDAY,


					'OFFDAY' => $actday-$offhir,

                    'COMPANYNAME' => $nomData->COMNAME,
					//'FIRECIEDRECIV' => self::getNOMMasterData($nomData->NOMID,'FI_RECEIVED'),					

					 'PAIDPAYMENT' => $nomData->PAYMENTAMT,
                   
                     $totaldata = $nomData->COMMISSIONVALUE,
                     
					 'TOTALDATA' => $totaldata,

					$gstval = $nomData->GSTVALUE,
					$basicval= $nomData->COMMISSIONWITHOUTTAX,

                    'TOTELVALU' => $gstval+$basicval,					

					 'BROKERID' => self::GETbrokeridinthis($nomData->NOMID,'BROKERID'),
					// 'LAYCANSTART' => $nomData->LAYCANSTART
					// 'LAYCANEND' => $nomData->LAYCANEND


				);			

			}

		}else{$this->data['nom'] = array();}

		//print_r($this->data['nom']);

								 set_includes(array(DATATABLES, DATERANGEPICKER, TABLE_2_EXCEL));

		$this->data['include'] = include_file_batch();

								 view('claims/invoiceReport',$this->data);
	}

	private function getNOMMasterData($nomid,$field)

	{
	$this->pass->setTable(array('nom_details','NOMID'));

	return $this->pass->all(array("select"=>"(select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as VESSELNAME, (select VENDORNAME from vendor_master where VENDORID=OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as CARTERPARTY,(select NAME from cargo_master where cargo_master.CARGOID=nom_details.CARGOID) as NAME, (select PORTNAME from port_master where PORTID=LPORT) as LPPORTNAME, (select PORTNAME from port_master where PORTID=DPORT) as DPPORTNAME, (select COUNTRYNAME from port_master where PORTID=LPORT) as LPCOUNTRYNAME,(select COUNTRYNAME from port_master where PORTID=DPORT) as DPCOUNTRYNAME, CPDATE", "where"=>array('NOMID'=>$nomid) ));

	}
	private function GETbrokeridinthis($nomid,$field)

	{
	 $this->pass->setTable(array('nom_details_slave','SLAVEID'));



	return $this->pass->all(array("select"=>"(select GROUP_CONCAT(NAME SEPARATOR ', ')  from broker_master where broker_master.BROKERID=nom_details_slave.BROKERID) as NAME", "where"=>array('NOMID'=>$nomid) ));
	}



	//................... cp form type list details ...................................................
	public function voyage_status_report($status)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] 	   		= 5;
		$this->data['company_list'] = $this->pass->getCompanyList();
		$this->data['status'] 	    = $status;
		$this->data['label'] 	    = ($status == 1) ? 'Voyages in Book' : (($status == 2) ? 'Voyages in Progress' : 'Completed Voyages');
								 set_includes(array(DATATABLES, DT_BUTTONS, PRINTGRID, FIXED_COLUMN, DATERANGEPICKER, TABLE_2_EXCEL));
		$this->data['include'] = include_file_batch();
								 view('claims/voyage_status_report',$this->data);
	}
	//....................... ends here ........................................................

	public function detailed_annual_revenue_report($selCompanyid=0,$startDate='',$endDate='')
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] 	   		= 5;
		$this->data['company_list'] = $this->pass->getCompanyList();
		
		$whereArr = (trim($startDate) != "" && trim($endDate) != "") ? array('CPDATE >=' => trim($startDate),'CPDATE <=' => trim($endDate)) : array(1 => 1);
		if($selCompanyid !=0) : $whereArr['COMPANYID'] = $selCompanyid; endif;
		$this->data['dateRange'] = (trim($startDate) != "" && trim($endDate) != "") ? formatedDate($startDate, "d/m/Y")." - ".formatedDate($endDate, "d/m/Y") : '';
		$this->data['startdate'] = (trim($startDate) != "" && trim($endDate) != "") ? formatedDate($startDate, "Y-m-d"): '';
		$this->data['enddate']   = (trim($endDate) != "" && trim($startDate) != "") ? formatedDate($endDate, "Y-m-d"): '';
		$this->data['selCompanyid'] = (trim($selCompanyid) != 0) ? $selCompanyid : '';
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$nom = $this->pass->all(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' when (FIXTURETYPE = 2) THEN 'Time Charter' ELSE 'COA' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, ESTMINCOMMISSION, COMPANYID, (select VESSELTYPE from vessel_type_master where VESSELTYPEID=(select VESSELTYPE from vessel_imo_master where VESSELIMOID=FLEETID)) as VESSELTYPENAME, (select VENDORNAME from vendor_master where VENDORID=OWNER) as OWNERNAME, (case when (FIXTURETYPE = 1 or FIXTURETYPE = 2) THEN (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) ELSE '' END) as VENDORNAME, (select NAME from cargo_master where cargo_master.CARGOID=nom_details.CARGOID) as CARGONAME, (select CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) from port_master where PORTID=LPORT) as LPORTNAME, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) from port_master where PORTID=DPORT) as DPORTNAME, (select SUM(RCVDAMOUNT) from payment_received where payment_received.NOMID=nom_details.NOMID and INVOICETYPE='FREIGHT') as FRT_RCVD, (select SUM(RCVDAMOUNT) from payment_received where payment_received.NOMID=nom_details.NOMID and INVOICETYPE='DEMURRAGE') as DEM_RCVD, (select SUM(RCVDAMOUNT) from payment_received where payment_received.NOMID=nom_details.NOMID and INVOICETYPE='SNP') as SNP_RCVD", "where_in"=>array( 'NOMSTATUS'=> array(2,3,4,5,6,7,8), 'NOMGRIDSTATUS'=> array(1,2,3,4) ), "where"=>$whereArr, "order_by"=>array('NOMID'=>'DESC') ));
		
		if( $nom ){
			foreach($nom as $nomData){
				$this->data['nom'][] = array(
					'FIXTURETYPENAME' => $nomData->FIXTURETYPENAME,
					'NOMINATIONID' => $nomData->NOMINATIONID,	
					'ADDEDBY' => $nomData->ADDEDBY,				
					'CPDATE' => formatedDate($nomData->CPDATE, "d-m-Y"),	
					'FLEETNAME' => $nomData->FLEETNAME,
					'VESSELTYPENAME' => $nomData->VESSELTYPENAME,
					'OWNERNAME' => $nomData->OWNERNAME,
					'VENDORNAME' => $nomData->VENDORNAME,
					'LPORTNAME' => $nomData->LPORTNAME,
					'DPORTNAME' => $nomData->DPORTNAME,
					'ESTMA' => $nomData->ESTMINCOMMISSION,
					'f_invoice_list' => self::getInvoiceMasterData($nomData->NOMID,(($nomData->FIXTURETYPE == 3) ? 'SNP' : 'FREIGHT')),	
					'd_demu_list' => self::getInvoiceMasterData($nomData->NOMID,'DEMURRAGE'),
					'FRT_RCVD' => $nomData->FRT_RCVD,
					'DEM_RCVD' => $nomData->DEM_RCVD,	
					'SNP_RCVD' => $nomData->SNP_RCVD,	
					'FRT_RCVD_USD' => ($nomData->FRT_RCVD != 0 && $nomData->FRT_RCVD != "") ? (($nomData->CURRENCYCODE == 'USD') ? $nomData->FRT_RCVD : (number_format(($nomData->FRT_RCVD/$nomData->CONVERSIONRATE),2,'.',''))) : 0,
					'DEM_RCVD_USD' => ($nomData->DEM_RCVD != 0 && $nomData->DEM_RCVD != "") ? (($nomData->CURRENCYCODE == 'USD') ? $nomData->DEM_RCVD : (number_format(($nomData->DEM_RCVD/$nomData->CONVERSIONRATE),2,'.',''))) : 0,
					'SNP_RCVD_USD' => ($nomData->SNP_RCVD != 0 && $nomData->SNP_RCVD != "") ? (($nomData->CURRENCYCODE == 'USD') ? $nomData->SNP_RCVD : (number_format(($nomData->SNP_RCVD/$nomData->CONVERSIONRATE),2,'.',''))) : 0				
				);			
			}
		}else{$this->data['nom'] = array();}
		//print_r($this->data['nom']);
								 set_includes(array(DATATABLES, DATERANGEPICKER, TABLE_2_EXCEL));
		$this->data['include'] = include_file_batch();
								 view('claims/detailed_annual_revenue_report',$this->data);
	}
	
	private function getInvoiceMasterData($nomid, $invoiceType)
	{
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		return $this->pass->all(array("select"=>"INVOICENUMBER, INVOICEDATE, COMMISSIONVALUE, CONVERSION_RATE, EXCURRENCY", "where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>$invoiceType) ));
	}

}
?>