<?php

error_reporting(0);
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');
class Operation extends MY_controller {	

	private $header  = 'header';
	private $sidebar = 'sidebar';
	private $footer  = 'footer';

	public function __construct()
	{
		parent::__construct();
		if(!$this->session->has_userdata('uid'))
			return redirect('login');

		if( $this->session->has_userdata('atype') || $this->session->has_userdata('ctype'))
			return self::logout();
			
		$this->load->helper('form');
		//.....................set default css and js for output.........................
		set_includes(array(BASIC_CSS, BASIC_JS, NOTIFY, APP, TIMER, SESSION_TIMEOUT));		
		set_header($this->header); 	set_sidebar($this->sidebar); 	set_footer($this->footer);
	   //............................ends here.........................................
	}

	public function index()
	{
		self::dashboard();
	}

	public function dashboard() 
	{
		$this->data['nav'] = 1;
		$this->pass->setTable(array('login','LOGINID'));
		$invoiceduedata = $this->pass->first(array("select"=>"*","where"=>array("USERTYPE"=>'admin')));
		$arrdays = array();
		
		$arrdays[] = $freightdays = $invoiceduedata->FRTDUEDAYS + $invoiceduedata->FRTTHRESHOLDDAYS;
		$arrdays[] = $hiredays = $invoiceduedata->HIREDUEDAYS + $invoiceduedata->HIRETHRESHOLDDAYS;
		$arrdays[] = $demuragedays =  $invoiceduedata->DEMUDUEDAYS + $invoiceduedata->DEMUTHRESHOLDDAYS;
		
		rsort($arrdays);
		
		$duedate = date("Y-m-d", strtotime("-".$arrdays[0]." days"));
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		$invoicealerts = array();
		$invoice_list = $this->pass->all(array("select"=>"invoice_master.NOMID, nom_details.FIXTURETYPE, (CASE WHEN FIXTURETYPE = 1 THEN 'Voyage Spot' WHEN FIXTURETYPE = 2 THEN 'Time Charter' ELSE 'COA'  END) as FIXTURETYPENAME, INVOICEID, INVOICENUMBER, INVOICETYPE, INVOICEDATE, NOMINATIONID, COMMISSIONVALUE, nom_details.CPDATE, FIXTURE_STATUS,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Deviation' ELSE 'Other' END) as INVOICENOTENAME, (select VESSELNAME from vessel_imo_master where vessel_imo_master.VESSELIMOID=nom_details.FLEETID) as FLEETNAME, (select SUM(RCVDAMOUNT) as RCVDAMOUNT from payment_received where payment_received.NOMID=invoice_master.NOMID and payment_received.INVOICETYPE=invoice_master.INVOICETYPE) as PAYMENTAMT",'join'=>array('nom_details'=>'nom_details.NOMID = invoice_master.NOMID'),"where_str"=>"INVOICEDATE >='".$duedate."'", "group_by"=>"INVOICEID", 'order_by'=>array('INVOICEDATE'=>'ASC')));
		foreach($invoice_list as $invoice_list1):
		    $now = time(); 
			$inv_date = strtotime($invoice_list1->INVOICEDATE);
			$datediff = $now - $inv_date;
			$invdays = round($datediff / (60 * 60 * 24));
			
		    if($invoice_list1->PAYMENTAMT <= 0):
			    
				if($invoice_list1->INVOICETYPE == 'FREIGHT'):
				
				    $invtitle = ($invoice_list1->FIXTURETYPE == 1) ? 'Freight' : 'Hire';
					$detail = '<a href="'.base_url("operation/".(($invoice_list1->FIXTURETYPE == 1) ? 'invoiceVoyage' : 'invoiceTime')."/{$invoice_list1->FIXTURE_STATUS}/{$invoice_list1->NOMID}").'" title="" data-toggle="tooltip" data-original-title="Invoice/Payment Rcvd"  ><i class="fa fa-edit "></i></a>';
					
				    if($invoice_list1->FIXTURETYPE == 1):
					
						//if($invdays > $invoiceduedata->FRTDUEDAYS && $invdays <= $freightdays):
							
							$invoicealerts[]  = array('fixturetype'=>$invoice_list1->FIXTURETYPENAME, 'vslname'=>$invoice_list1->FLEETNAME, 'nomno'=>$invoice_list1->NOMINATIONID, 'nomno'=>$invoice_list1->NOMINATIONID, 'cpdate'=>date('d-m-Y',strtotime($invoice_list1->CPDATE)), 'invoicedate'=>date('d-m-Y',strtotime($invoice_list1->INVOICEDATE)), 'invoicetype'=>ucwords($invoice_list1->INVOICENOTENAME), 'invoicevalue'=>$invoice_list1->COMMISSIONVALUE, 'invoiceno'=>$invoice_list1->INVOICENUMBER, 'invoiceamt'=>$invoice_list1->COMMISSIONVALUE, 'details'=>$detail, 'invremarks'=>'<small class="label label-success">Commission Invoice – '.$invtitle.'</small>');
							
						//endif;
					else:
					    
						//if($invdays > $invoiceduedata->HIREDUEDAYS && $invdays <= $hiredays):
							
							$invoicealerts[]  = array('fixturetype'=>$invoice_list1->FIXTURETYPENAME, 'vslname'=>$invoice_list1->FLEETNAME, 'nomno'=>$invoice_list1->NOMINATIONID, 'nomno'=>$invoice_list1->NOMINATIONID, 'cpdate'=>date('d-m-Y',strtotime($invoice_list1->CPDATE)), 'invoicedate'=>date('d-m-Y',strtotime($invoice_list1->INVOICEDATE)), 'invoicetype'=>ucwords($invoice_list1->INVOICENOTENAME), 'invoicevalue'=>$invoice_list1->COMMISSIONVALUE, 'invoiceno'=>$invoice_list1->INVOICENUMBER, 'invoiceamt'=>$invoice_list1->COMMISSIONVALUE, 'details'=>$detail, 'invremarks'=>'<small class="label label-success">Commission Invoice – '.$invtitle.'</small>');
							
						//endif;
					
					endif;
				endif;
				
				if($invoice_list1->INVOICETYPE == 'DEMURRAGE'):
					//if($invdays > $invoiceduedata->DEMUDUEDAYS && $invdays <= $demuragedays):
					
					    $detail = '<a href="'.base_url("operation/".(($invoice_list1->FIXTURETYPE == 1) ? 'invoiceVoyage' : 'invoiceTime')."/{$invoice_list1->FIXTURE_STATUS}/{$invoice_list1->NOMID}").'" title="" data-toggle="tooltip" data-original-title="Invoice/Payment Rcvd"  ><i class="fa fa-edit "></i></a>';
						
						$invoicealerts[]  = array('fixturetype'=>$invoice_list1->FIXTURETYPENAME, 'vslname'=>$invoice_list1->FLEETNAME, 'nomno'=>$invoice_list1->NOMINATIONID, 'nomno'=>$invoice_list1->NOMINATIONID, 'cpdate'=>date('d-m-Y',strtotime($invoice_list1->CPDATE)), 'invoicedate'=>date('d-m-Y',strtotime($invoice_list1->INVOICEDATE)), 'invoicetype'=>ucwords($invoice_list1->INVOICENOTENAME), 'invoicevalue'=>$invoice_list1->COMMISSIONVALUE, 'invoiceno'=>$invoice_list1->INVOICENUMBER, 'invoiceamt'=>$invoice_list1->COMMISSIONVALUE, 'details'=>$detail, 'invremarks'=>'<small class="label label-warning">Commission Invoice – Demurrage</small>');
						
					//endif;
				endif;
				
			endif;
		endforeach;
		$this->data['invoicealerts'] = $invoicealerts;
		                          set_includes(array(DATATABLES));
		$this->data['include'] = include_file_batch();
								 view('operation/dashboard',$this->data);
	}
	
	//............for nomatglance............................
	public function nomatglance()
	{
	    $this->data['year_list'] 	 = $this->pass->getYearListForNominationGrid();
		unset($this->data['year_list']['']);
		$this->data['nav'] = 2;
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID,SWEET_ALERT));
		$this->data['include'] = include_file_batch();
								 view('operation/nomatglance',$this->data);
	}
	
	public function add_fixture()
	{
		$this->data['nav'] = 2;
		$this->data['fixture_type_list'] = $this->pass->getFixtureTypeList();
		$this->data['fleet_list'] 		 = $this->pass->getFleetlist();
		$this->data['vendor_list'] 		 = $this->pass->getVendorBasedOnVendorTypeID([1]);
		$this->data['owner_list'] 		 = $this->pass->getVendorBasedOnVendorTypeID([2]);
		$this->data['collect_comm_list'] = $this->pass->getVendorBasedOnVendorTypeID([1,2]);
		$this->data['cargo_list'] 		 = $this->pass->getCargoList('multiple');
		$this->data['user_list_claims']  = $this->pass->getUserList('claims');
		$this->data['broker_list'] 		 = $this->pass->getBrokerList();
		$this->data['cp_form_list'] 	 = $this->pass->getCPFormTypeList();
		$this->data['company_list'] 	 = $this->pass->getCompanyList();
		
		$this->data['companyjsondata'] = self::getCompanydataJson();
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nominationid'] = self::_getMaxNumber('MESSAGE_NO');

								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE,DATEPICKER,NUMERIC,SELECT2,DATETIMEPICKER,CALC));
		$this->data['include'] = include_file_batch();
								 view('operation/add_fixture',$this->data);
		
	}

	
	public function insert_fixture()
	{

		// echo 'dpk';
		// die();

		$this->load->library('form_validation'); 
		$this->load->helper(['dateFormat','array']);
		$this->form_validation->set_rules('m_NOMINATIONID', 
										 'Fixture No./ Nomination ID',
										 'is_unique[nom_details.NOMINATIONID]',
												array(
														'is_unique'     => 'This %s already exists.'
													)
										);
		if($this->form_validation->run())
		{
			$data 					= self::customized_ArrayByKey($this->input->post(),'m');

			$countOfOffHire = $this->input->post('m_LEMCR');

			
			




			// ECHO '<PRE>';
			// print_r($this->input->post('m_LEMCR'));

			// die();
			$slave1 				= self::customized_ArrayByKey_forArrayData($this->input->post(),'s1',$data['LREC']);unset($data['LREC']);
			
		
			$data['CPDATE'] 		= formatedDate($data['CPDATE']);
			$data['BL_DATE'] 		= formatedDate($data['BL_DATE']);
			$data['LAYCANSTART'] 	= formatedDate($data['LAYCANSTART'], 'Y-m-d H:i');
			$data['LAYCANEND'] 		= formatedDate($data['LAYCANEND'], 'Y-m-d H:i');
			$data['ESTDATE'] 		= '0000-00-00';
			$data['FIXTUREDATE'] 	= '0000-00-00';
			$data['ADDEDBYID'] 		= $this->session->uid;
			$data['ADDONDATE'] 		= date('Y-m-d');
			$data['ADDEDBY'] 		= $this->data['userData']->CONTACTPERSON;
			$nom_arr 				= explode("/",$data['NOMINATIONID']);
			$data['MESSAGE_NO'] 	= $nom_arr[1];			
			
			$data['LUMPSUMFREIGHTUSD'] 	= $data['LUMPSUMFREIGHT'];
			$data['HIRERATEUSD'] 		= $data['DAILYHIRERATE'];
			$data['DEMURRAGEUSD'] 		= $data['DEMURRAGE'];	
			
			if($_FILES['ATTACHMENT']['name'][0] != ''):
									$data['ATTACHMENT_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT']));
									$data['ATTACHMENT'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT']));
					else		:	$data['ATTACHMENT_NAME'] = $data['ATTACHMENT'] = '';	
					endif;
		    
			if($_FILES['ATTACHMENT1']['name'][0] != ''):
									$data['ATTACHMENT1_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT1']));
									$data['ATTACHMENT1'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT1']));
					else		:	$data['ATTACHMENT1_NAME'] = $data['ATTACHMENT1'] = '';	
					endif;
			
			if($_FILES['ATTACHMENT2']['name'][0] != ''):
									$data['ATTACHMENT2_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT2']));
									$data['ATTACHMENT2'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT2']));
					else		:	$data['ATTACHMENT2_NAME'] = $data['ATTACHMENT2'] = '';	
					endif;
					
			if($_FILES['ATTACHMENT3']['name'][0] != ''):
									$data['ATTACHMENT3_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT3']));
									$data['ATTACHMENT3'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT3']));
					else		:	$data['ATTACHMENT3_NAME'] = $data['ATTACHMENT3'] = '';	
					endif;
					
			if($_FILES['ATTACHMENT4']['name'][0] != ''):
									$data['ATTACHMENT4_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT4']));
									$data['ATTACHMENT4'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT4']));
					else		:	$data['ATTACHMENT4_NAME'] = $data['ATTACHMENT4'] = '';	
					endif;
			
			$this->pass->setTable(array('nom_details','NOMID'));
			$nom_id = $this->pass->insert($data);
			 
			foreach($slave1 as $element1) :
				if($element1['BROKERID'] != "" && $element1['PERCENTAGE'] != "" && $element1['COMMAMT'] != "") :
						$this->pass->setTable(array('nom_details_slave','SLAVEID'));
						$element1['NOMID']			=	$nom_id; 
						$this->pass->insert(elements(array('NOMID', 'BROKERID', 'PERCENTAGE', 'COMMAMT', 'LOCATION'), $element1));	
				endif;
			 endforeach;
			 $slave_nom_id=[];
			 $slave2 = self::customized_ArrayByKey($this->input->post(),'s2',$data['LEMCR']);unset($data['LEMCR']);

			//  echo '<pre>';
    // print_r($slave2);
	// die();


			 foreach($slave2 as $element2) :

				if($element2['DELIVERYDATE'] != "" && $element2['REDELIVERYDATE'] != "" && $element2['HIRERATE'] != "") 

				{
						

						$element21['NOMID']			=	$nom_id; 

						$element21['DELIVERYDATE'] 		 = ($element2['DELIVERYDATE']!='')?formatedDate($element2['DELIVERYDATE'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
						$element21['REDELIVERYDATE'] 	 = ($element2['REDELIVERYDATE']!='')?formatedDate($element2['REDELIVERYDATE'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
						
						
						$element21['HIRERATE'] 	 = $element2['HIRERATE'];
						$element21['DAY'] 	 = $element2['DAY'];
						$element21['OFFHIREDAY'] 	 = $element2['OFFHIREDAY'];
						$element21['BALANCEDAY'] 	 = $element2['BALANCEDAY'];


						// print_r($element21);
						// DIE();
						// $this->pass->setTable(array('nom_details_slave5','NOM_SLAVEID5'));
						// $this->pass->insert($element21);	


						$this->db->insert('nom_details_slave5',$element21);
						$slave_nom_id[]= $this->db->insert_id();
				}
			 endforeach;


			

			// die();


			//  print_r($slave_nom_id);

			//  die();

			 $slave3 = self::customized_ArrayByKey($this->input->post(),'s3',$data['HIORESDAY_1']);unset($data['HIORESDAY_1']);


			for($i=1 ; $i<=$countOfOffHire ;$i++)
			{
					$txtDELID = $this->input->post('s3_iden_'.$i);
					$iden = $this->input->post('s3_identity_'.$i);
					for($m=1 ; $m<=$txtDELID ;$m++)
					{

						if($this->input->post('s3_OFFHIREFROM_'.$i.'_'.$m) != "" && $this->input->post('s3_OFFHIRETO_'.$i.'_'.$m) != "")
						{

							$offHireFrom		 = ($this->input->post('s3_OFFHIREFROM_'.$i.'_'.$m)!='')?formatedDate($this->input->post('s3_OFFHIREFROM_'.$i.'_'.$m), 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$offHireto		 = ($this->input->post('s3_OFFHIRETO_'.$i.'_'.$m)!='')?formatedDate($this->input->post('s3_OFFHIRETO_'.$i.'_'.$m), 'Y-m-d H:i'):'0000-00-00 00:00:00';

							$offDays = $this->input->post('s3_OFFHIREDAYS_'.$i.'_'.$m);

							$nomid = $slave_nom_id[$iden];

							$offHireData = array(
								'OFFHIREFROM'=>$offHireFrom,
								'OFFHIRETO'=>$offHireto,
								'OFFHIREDAYS'=>$offDays,
								'NOMID'=>$nomid,
							);


							$this->db->insert('nom_details_slave6',$offHireData);
							$slave_nom_id_check[]= $this->db->insert_id();

						}
					}
			}



			

			//  echo '<pre>';
			// foreach($slave3 as $element3) :
			
			// 	print_r($element3);
				

			// 	if($element3['OFFHIREFROM'] != "" && $element3['OFFHIRETO'] != "" && $element3['OFFHIREDAYS'] != "") :

			// 			$iden = $element3['OFFHIREFROM'];
			// 			$element3['NOMID']			=	 $slave_nom_id[$iden]; 
			// 			$element3['OFFHIREFROM'] 		 = ($element3['OFFHIREFROM']!='')?formatedDate($element3['OFFHIREFROM'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
			// 			$element3['OFFHIRETO'] 	 = ($element3['OFFHIRETO']!='')?formatedDate($element3['OFFHIRETO'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
					

			// 			$this->pass->setTable(array('nom_details_slave6','IDHIRDAY'));

			// 			$this->pass->insert(elements(array('NOMID', 'OFFHIREFROM', 'OFFHIRETO', 'OFFHIREDAYS'), $element3));	
			// 	endif;
			//  endforeach;
			 
			//  die();

			
			 return self::_flashAndRedirectAllWithAlertArray($nom_id ,
									   'Fixture Slip added successfully.', 
									   'Sorry! there was an error while adding Fixture Slip.',
									   'operation/nomatglance');
		}
		else
		{
			self::add_fixture();
		}
	}
	
	public function edit_fixture($gridStatus = 0, $nomid)
	{
		

		// die('dpk');
		$this->load->helper('dateFormat');
		$this->data['gridStatus'] 		 = $gridStatus;
		$this->data['nav'] = ($gridStatus == 0) ? 2 : (($gridStatus == 1) ? 3 : (($gridStatus == 2) ? 4 : 5));
		$this->data['label1'] = ($gridStatus == 0) ? 'Fixtures' : (($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY'));

		
		
		$this->data['fixture_type_list'] = $this->pass->getFixtureTypeList();
		$this->data['fleet_list'] 		 = $this->pass->getFleetlist();
		$this->data['vendor_list'] 		 = $this->pass->getVendorBasedOnVendorTypeID([1]);
		$this->data['owner_list'] 		 = $this->pass->getVendorBasedOnVendorTypeID([2]);
		$this->data['collect_comm_list'] = $this->pass->getVendorBasedOnVendorTypeID([1,2]);
		$this->data['cargo_list'] 		 = $this->pass->getCargoList('multiple');
		$this->data['user_list_claims']  = $this->pass->getUserList('claims');
		$this->data['broker_list'] 		 = $this->pass->getBrokerList();
		$this->data['cp_form_list'] 	 = $this->pass->getCPFormTypeList();
		$this->data['fixturestatus_list']= $this->pass->getStatusMasterList();
		$this->data['porttype_list']     = $this->pass->getPortTypeList();
		$this->data['purposeofcall_list']     = $this->pass->getPurposeOfCallMasterList();
		$this->data['company_list'] 	 = $this->pass->getCompanyList();
		$this->data['companyjsondata'] = self::getCompanydataJson();
		
		$this->data['currency_list'] 	 = $this->pass->getCurrencyList();
		$this->data['invoice_status'] 	 = $this->pass->count_all('invoice_master',array('NOMID'=>$nomid));
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->find_by_pk($nomid);


		
		$this->db->where('NOMID', $nomid);
        $this->db->where('PORT', 'LP');
        $query = $this->db->get('laytime_master');
        $this->data['LAYtime'] = $query->row_array();

        $this->db->where('NOMID', $nomid);
        $this->db->where('PORT', 'DP');
        $query = $this->db->get('laytime_master');
        $this->data['laytimeDP'] = $query->row_array();
		
		$this->pass->setTable(array('port_master','PORTID'));
		$this->data['nom']->FPORTNAME = json_encode(($this->data['nom']->FPORT != '') ? array('id'=>$this->data['nom']->FPORT,'name'=>$this->pass->first(array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME","where"=>array('PORTID'=>$this->data['nom']->FPORT)))->PORTNAME) : array('id'=>'','name'=>'---Select from list---'));

		$this->data['nom']->TPORTNAME = json_encode(($this->data['nom']->TPORT != '') ? array('id'=>$this->data['nom']->TPORT,'name'=>$this->pass->first(array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME","where"=>array('PORTID'=>$this->data['nom']->TPORT)))->PORTNAME) : array('id'=>'','name'=>'---Select from list---'));
		
		$this->data['nom']->NEXTPORTNAME = json_encode(($this->data['nom']->ADD_NEXT_PORT != '') ? array('id'=>$this->data['nom']->ADD_NEXT_PORT,'name'=>$this->pass->first(array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME","where"=>array('PORTID'=>$this->data['nom']->ADD_NEXT_PORT)))->PORTNAME) : array('id'=>'','name'=>'---Select from list---'));

		$lp = explode(",",$this->data['nom']->LPORT);
		for($i=0; $i<count($lp); $i++):						
			$lp_arr[] = array('id'=>$lp[$i],'name'=>$this->pass->first(array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME","where"=>array('PORTID'=>$lp[$i])))->PORTNAME);
		endfor;

		$dp = explode(",",$this->data['nom']->DPORT);
		for($i=0; $i<count($dp); $i++):
			$dp_arr[] = array('id'=>$dp[$i],'name'=>$this->pass->first(array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME","where"=>array('PORTID'=>$dp[$i])))->PORTNAME);
		endfor;
		$this->data['nom']->LPORTNAME = json_encode($lp_arr);
		$this->data['nom']->DPORTNAME = json_encode($dp_arr);
		
		$this->pass->setTable(array('nom_details_slave','SLAVEID'));
		$this->data['slave'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid)));
		
		
		$this->pass->setTable(array('nom_details_slave2','NOM_SLAVE2ID'));
		$this->data['slave2'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave2.PORTID) as PORTNAME","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave3','NOM_SLAVE3ID'));
		$this->data['slave3'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave3.PORTID) as PORTNAME","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave4'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'BROKER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave5'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'VOYAGE')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave6'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'OWNER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave7'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'CHARTERER')));

		$this->pass->setTable(array('nom_details_slave5','NOM_SLAVEID5'));
		$this->data['slave8'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid)));



		// echo '<pre>';
		// print_r($this->data['slave8']);
			// die();


		// $value = (array) $object;
		// print_r($this->data['slave8'][0].['NOM_SLAVEID5']);

	
			// echo ;
		



		// die();

		// $this->data['slave9'] = [];
		// $this->data['slave9']=[];
		
		$this->pass->setTable(array('nom_details_slave6','IDHIRDAY'));
		foreach ($this->data['slave8'] as $key => $object) {

			$this->db->select('*');
			$this->db->from('nom_details_slave6');
			$this->db->where('NOMID',$object->NOM_SLAVEID5);
			$query = $this->db->get();

			if ( $query->num_rows() > 0 )
			{
				$this->data['slave9'][] =$this->pass->all(array("where"=>array('NOMID'=>$object->NOM_SLAVEID5)));
			}else{
				$this->data['slave9']=[];
			}
		
		}
		// echo '<pre>';
		// print_r($this->data['slave9']);
			// die();
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE,DATEPICKER,NUMERIC,SELECT2,DATETIMEPICKER,CALC));
		$this->data['include'] = include_file_batch();
								 view('operation/edit_fixture',$this->data);
	}
	
	public function update_fixture($gridStatus = 0, $nomid)
	{
		// die('dpk');


			$this->load->helper(['dateFormat','array']);
			$countOfOffHire = $this->input->post('m_LEMCR');
			$data 					= self::customized_ArrayByKey($this->input->post(),'m');

			$slave1 				= self::customized_ArrayByKey_forArrayData($this->input->post(),'s1',$data['LREC']);unset($data['LREC']);
			
			if(!empty($data['ADDDEl'])):
				$slave4 				= self::customized_ArrayByKey($this->input->post(),'s2',$data['ADDDEl']);unset($data['ADDDEl']);
				$slave5 				= self::customized_ArrayByKey($this->input->post(),'s3',$data['SOFDEl']);unset($data['SOFDEl']);
				$slave6 				= self::customized_ArrayByKey($this->input->post(),'s4',$data['BROKERDEl']);unset($data['BROKERDEl']);
				$slave7 				= self::customized_ArrayByKey($this->input->post(),'s5',$data['VOYAGEDEl']);unset($data['VOYAGEDEl']);
				$slave8 				= self::customized_ArrayByKey($this->input->post(),'s6',$data['OWNERDEl']);unset($data['OWNERDEl']);
				$slave9 				= self::customized_ArrayByKey($this->input->post(),'s7',$data['CHARTDEl']);unset($data['CHARTDEl']);
			endif;
			
			$data['CPDATE'] 		= formatedDate($data['CPDATE']);
			$data['BL_DATE'] 		= formatedDate($data['BL_DATE']);
			$data['LAYCANSTART'] 	= ($data['LAYCANSTART']!='')?formatedDate($data['LAYCANSTART'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
			$data['LAYCANEND'] 		= ($data['LAYCANEND']!='')?formatedDate($data['LAYCANEND'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
			$data['ETA_NEXT_PORT'] 	= ($data['ETA_NEXT_PORT']!='')?formatedDate($data['ETA_NEXT_PORT'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
			$data['ESTDATE'] 		= '0000-00-00';
			$data['FIXTUREDATE'] 	= '0000-00-00';
			$data['ADDEDBYID'] 		= $this->session->uid;
			$data['ADDONDATE'] 		= date('Y-m-d');
			$data['ADDEDBY'] 		= $this->data['userData']->CONTACTPERSON;
			
			$data['CRMFILE']	= addslashes(trim($data['CRMFILE']));
			$data['CRMNAME']	= addslashes(trim($data['CRMNAME']));
			
			if($gridStatus == 0):
				$data['NOMGRIDSTATUS'] = ($data['UPDATESTATUS'] == 0) ? 0 : 1;
			endif;
			
			if($_FILES['ATTACHMENT']['name'][0] != ''):
									$data['ATTACHMENT_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT']));
									$data['ATTACHMENT'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT']));
					else		:	$data['ATTACHMENT_NAME'] = $data['ATTACHMENT'] = '';	
					endif;
			if($data['CRMFILE'] != '' && $data['ATTACHMENT'] != ''){ $data['ATTACHMENT'] = $data['CRMFILE'].','.$data['ATTACHMENT'];}
			else if($data['CRMFILE'] == '' && $data['ATTACHMENT'] != ''){ $data['ATTACHMENT'] = $data['ATTACHMENT'];}
			else if($data['CRMFILE'] != '' && $data['ATTACHMENT'] == ''){ $data['ATTACHMENT'] = $data['CRMFILE'];}
			
			if($data['CRMNAME'] != '' && $data['ATTACHMENT_NAME'] != ''){ $data['ATTACHMENT_NAME'] = $data['CRMNAME'].','.$data['ATTACHMENT_NAME'];}
			else if($data['CRMNAME'] == '' && $data['ATTACHMENT_NAME'] != ''){ $data['ATTACHMENT_NAME'] = $data['ATTACHMENT_NAME'];}
			else if($data['CRMNAME'] != '' && $data['ATTACHMENT_NAME'] == ''){ $data['ATTACHMENT_NAME'] = $data['CRMNAME'];}
			unset($data['CRMFILE']);unset($data['CRMNAME']);
			
			if($_FILES['ATTACHMENT1']['name'][0] != ''):
									$data['ATTACHMENT1_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT1']));
									$data['ATTACHMENT1'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT1']));
					else		:	$data['ATTACHMENT1_NAME'] = $data['ATTACHMENT1'] = '';	
					endif;
			if($data['CRMFILE1'] != '' && $data['ATTACHMENT1'] != ''){ $data['ATTACHMENT1'] = $data['CRMFILE1'].','.$data['ATTACHMENT1'];}
			else if($data['CRMFILE1'] == '' && $data['ATTACHMENT1'] != ''){ $data['ATTACHMENT1'] = $data['ATTACHMENT1'];}
			else if($data['CRMFILE1'] != '' && $data['ATTACHMENT1'] == ''){ $data['ATTACHMENT1'] = $data['CRMFILE1'];}
			
			if($data['CRMNAME1'] != '' && $data['ATTACHMENT1_NAME'] != ''){ $data['ATTACHMENT1_NAME'] = $data['CRMNAME1'].','.$data['ATTACHMENT1_NAME'];}
			else if($data['CRMNAME1'] == '' && $data['ATTACHMENT1_NAME'] != ''){ $data['ATTACHMENT1_NAME'] = $data['ATTACHMENT1_NAME'];}
			else if($data['CRMNAME1'] != '' && $data['ATTACHMENT1_NAME'] == ''){ $data['ATTACHMENT1_NAME'] = $data['CRMNAME1'];}
			unset($data['CRMFILE1']);unset($data['CRMNAME1']);
			
			if($_FILES['ATTACHMENT2']['name'][0] != ''):
									$data['ATTACHMENT2_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT2']));
									$data['ATTACHMENT2'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT2']));
					else		:	$data['ATTACHMENT2_NAME'] = $data['ATTACHMENT2'] = '';	
					endif;
			if($data['CRMFILE2'] != '' && $data['ATTACHMENT2'] != ''){ $data['ATTACHMENT2'] = $data['CRMFILE2'].','.$data['ATTACHMENT2'];}
			else if($data['CRMFILE2'] == '' && $data['ATTACHMENT2'] != ''){ $data['ATTACHMENT2'] = $data['ATTACHMENT2'];}
			else if($data['CRMFILE2'] != '' && $data['ATTACHMENT2'] == ''){ $data['ATTACHMENT2'] = $data['CRMFILE2'];}
			
			if($data['CRMNAME2'] != '' && $data['ATTACHMENT2_NAME'] != ''){ $data['ATTACHMENT2_NAME'] = $data['CRMNAME2'].','.$data['ATTACHMENT2_NAME'];}
			else if($data['CRMNAME2'] == '' && $data['ATTACHMENT2_NAME'] != ''){ $data['ATTACHMENT2_NAME'] = $data['ATTACHMENT2_NAME'];}
			else if($data['CRMNAME2'] != '' && $data['ATTACHMENT2_NAME'] == ''){ $data['ATTACHMENT2_NAME'] = $data['CRMNAME2'];}
			unset($data['CRMFILE2']);unset($data['CRMNAME2']);
			
			
			if($_FILES['ATTACHMENT3']['name'][0] != ''):
									$data['ATTACHMENT3_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT3']));
									$data['ATTACHMENT3'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT3']));
					else		:	$data['ATTACHMENT3_NAME'] = $data['ATTACHMENT3'] = '';	
					endif;
			if($data['CRMFILE3'] != '' && $data['ATTACHMENT3'] != ''){ $data['ATTACHMENT3'] = $data['CRMFILE3'].','.$data['ATTACHMENT3'];}
			else if($data['CRMFILE3'] == '' && $data['ATTACHMENT3'] != ''){ $data['ATTACHMENT3'] = $data['ATTACHMENT3'];}
			else if($data['CRMFILE3'] != '' && $data['ATTACHMENT3'] == ''){ $data['ATTACHMENT3'] = $data['CRMFILE3'];}
			
			if($data['CRMNAME3'] != '' && $data['ATTACHMENT3_NAME'] != ''){ $data['ATTACHMENT3_NAME'] = $data['CRMNAME3'].','.$data['ATTACHMENT3_NAME'];}
			else if($data['CRMNAME3'] == '' && $data['ATTACHMENT3_NAME'] != ''){ $data['ATTACHMENT3_NAME'] = $data['ATTACHMENT3_NAME'];}
			else if($data['CRMNAME3'] != '' && $data['ATTACHMENT3_NAME'] == ''){ $data['ATTACHMENT3_NAME'] = $data['CRMNAME3'];}
			unset($data['CRMFILE3']);unset($data['CRMNAME3']);
			
			if($_FILES['ATTACHMENT4']['name'][0] != ''):
									$data['ATTACHMENT4_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT4']));
									$data['ATTACHMENT4'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT4']));
					else		:	$data['ATTACHMENT4_NAME'] = $data['ATTACHMENT4'] = '';	
					endif;
			if($data['CRMFILE4'] != '' && $data['ATTACHMENT4'] != ''){ $data['ATTACHMENT4'] = $data['CRMFILE4'].','.$data['ATTACHMENT4'];}
			else if($data['CRMFILE4'] == '' && $data['ATTACHMENT4'] != ''){ $data['ATTACHMENT4'] = $data['ATTACHMENT4'];}
			else if($data['CRMFILE4'] != '' && $data['ATTACHMENT4'] == ''){ $data['ATTACHMENT4'] = $data['CRMFILE4'];}
			
			if($data['CRMNAME4'] != '' && $data['ATTACHMENT4_NAME'] != ''){ $data['ATTACHMENT4_NAME'] = $data['CRMNAME4'].','.$data['ATTACHMENT4_NAME'];}
			else if($data['CRMNAME4'] == '' && $data['ATTACHMENT4_NAME'] != ''){ $data['ATTACHMENT4_NAME'] = $data['ATTACHMENT4_NAME'];}
			else if($data['CRMNAME4'] != '' && $data['ATTACHMENT4_NAME'] == ''){ $data['ATTACHMENT4_NAME'] = $data['CRMNAME4'];}
			unset($data['CRMFILE4']);unset($data['CRMNAME4']);
			
			$alerts = [
						 [
						 	'ALERTBY'		=> $this->session->uid,
						 	'ALERTTO'		=> $data['CLAIMSLOGINID'],
							'ALERTTEXT'		=> 'Fixture Slip sent by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $nomid,'ALERTLINK'=>'claims/view-fixture/1/'.$nomid,
							'ALERTTYPE'		=> 'Fixture Slip'
						 ],
						 [
						 	'ALERTBY'		=> $this->session->uid,
						 	'ALERTTO'		=> 1,
							'ALERTTEXT'		=> 'Fixture Slip sent to Claims by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $nomid,'ALERTLINK'=>'admin/view-fixture/1/'.$nomid,
							'ALERTTYPE'		=> 'Fixture Slip'
						]
					  ];
			
			$this->pass->setTable(array('nom_details','NOMID'));
			$nom_id = $this->pass->update($nomid,$data);
			$slave_nom_id=[];
			$slave2 = self::customized_ArrayByKey($this->input->post(),'s2',$data['LEMCR']);unset($data['LEMCR']);

			$this->db->select('NOM_SLAVEID5');
			$this->db->from('nom_details_slave5');
			$this->db->where('NOMID',$nomid);
			$query = $this->db->get();

			if ( $query->num_rows() > 0 )
			{
				$row = $query->result_array();
			}

			foreach($row as $r){

				$this->pass->setTable(array('nom_details_slave6','IDHIRDAY'));	
				$this->pass->delete(array("where"=>array('NOMID'=>$r['NOM_SLAVEID5'])));

			}
   
            if(!empty($slave2)):
				 $this->pass->setTable(array('nom_details_slave5','NOM_SLAVEID5'));
				 $this->pass->delete(array("where"=>array('NOMID'=>$nomid)));

				 foreach($slave2 as $element2) :

					if($element2['DELIVERYDATE'] != "" && $element2['REDELIVERYDATE'] != "" && $element2['HIRERATE'] != "") 
	
					{
							
	
							$element21['NOMID']			=	$nomid; 
	
							$element21['DELIVERYDATE'] 		 = ($element2['DELIVERYDATE']!='')?formatedDate($element2['DELIVERYDATE'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$element21['REDELIVERYDATE'] 	 = ($element2['REDELIVERYDATE']!='')?formatedDate($element2['REDELIVERYDATE'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							
							
							$element21['HIRERATE'] 	 = $element2['HIRERATE'];
							$element21['DAY'] 	 = $element2['DAY'];
							$element21['OFFHIREDAY'] 	 = $element2['OFFHIREDAY'];
							$element21['BALANCEDAY'] 	 = $element2['BALANCEDAY'];
	
	
							// print_r($element21);
							// DIE();
							// $this->pass->setTable(array('nom_details_slave5','NOM_SLAVEID5'));
							// $this->pass->insert($element21);	
	
	
							$this->db->insert('nom_details_slave5',$element21);
							$slave_nom_id[]= $this->db->insert_id();
					}
				 endforeach;
		 endif;

		//  print_r($countOfOffHire);

		//  die();



		 for($i=1 ; $i<=$countOfOffHire ;$i++)
			{
					$txtDELID = $this->input->post('s3_iden_'.$i);
					$iden = $this->input->post('s3_identity_'.$i);
					for($m=1 ; $m<=$txtDELID ;$m++)
					{

						if($this->input->post('s3_OFFHIREFROM_'.$i.'_'.$m) != "" && $this->input->post('s3_OFFHIRETO_'.$i.'_'.$m) != "")
						{

							$offHireFrom		 = ($this->input->post('s3_OFFHIREFROM_'.$i.'_'.$m)!='')?formatedDate($this->input->post('s3_OFFHIREFROM_'.$i.'_'.$m), 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$offHireto		 = ($this->input->post('s3_OFFHIRETO_'.$i.'_'.$m)!='')?formatedDate($this->input->post('s3_OFFHIRETO_'.$i.'_'.$m), 'Y-m-d H:i'):'0000-00-00 00:00:00';

							$offDays = $this->input->post('s3_OFFHIREDAYS_'.$i.'_'.$m);

							$nomid = $slave_nom_id[$iden];

							$offHireData = array(
								'OFFHIREFROM'=>$offHireFrom,
								'OFFHIRETO'=>$offHireto,
								'OFFHIREDAYS'=>$offDays,
								'NOMID'=>$nomid,
							);

							$this->db->insert('nom_details_slave6',$offHireData);
							$slave_nom_id_check[]= $this->db->insert_id();

						}
					}
			}

			 $this->pass->setTable(array('nom_details_slave','SLAVEID'));
			$this->pass->delete(array("where"=>array('NOMID'=>$nomid)));			 	

			
			foreach($slave1 as $element1) :
				if($element1['BROKERID'] != "" && $element1['PERCENTAGE'] != "" && $element1['COMMAMT'] != "") :						
						$element1['NOMID']			=	$nomid; 
						$this->pass->insert(elements(array('NOMID', 'BROKERID', 'PERCENTAGE', 'COMMAMT', 'LOCATION'), $element1));	
				endif;
			 endforeach;

			 
			
			 if(!empty($slave4)):
				 $this->pass->setTable(array('nom_details_slave2','NOM_SLAVE2ID'));
				 $this->pass->delete(array("where"=>array('NOMID'=>$nomid)));
					
				 foreach($slave4 as $element2) :
					if($element2['PORTID'] != "" && $element2['ITINERARY'] != "" && $element2['ETA'] != "") :						
							$element2['NOMID']			=	$nomid; 
							$element2['ETA'] 		= ($element2['ETA']!='')?formatedDate($element2['ETA'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$this->pass->insert(elements(array('NOMID', 'PORTTYPEID', 'PORTID', 'ITINERARY', 'ETA'), $element2));	
					endif;
				 endforeach;
			endif;
			
			if(!empty($slave5)):	 
				 $this->pass->setTable(array('nom_details_slave3','NOM_SLAVE3ID'));
				 $this->pass->delete(array("where"=>array('NOMID'=>$nomid)));
				 foreach($slave5 as $element3) :
					if($element3['PORTID'] != "") :						
							$element3['NOMID']			 = $nomid; 
							$element3['ETA'] 		     = ($element3['ETA']!='')?formatedDate($element3['ETA'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$element3['EOSP'] 		     = ($element3['EOSP']!='')?formatedDate($element3['EOSP'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$element3['CARGOCOMPLETE'] 	 = ($element3['CARGOCOMPLETE']!='')?formatedDate($element3['CARGOCOMPLETE'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$element3['COSP'] 		     = ($element3['COSP']!='')?formatedDate($element3['COSP'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$this->pass->insert(elements(array('NOMID', 'PURPOSEOFCALL', 'PORTID', 'ITINERARY', 'ETA', 'AGENT', 'CARGOQTY', 'EOSP', 'CARGOCOMPLETE', 'COSP'), $element3));	
					endif;
				 endforeach;
			 endif;
			 
			 $this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
			 $this->pass->delete(array("where"=>array('NOMID'=>$nomid)));
			 
			 if(!empty($slave6)):	 
				 foreach($slave6 as $element3) :
					if($element3['NOTES'] != "") :						
							$element3['NOMID']			 = $nomid; 
							$element3['IDENTIFY'] 		 = 'BROKER';
							$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
							$this->pass->insert(elements(array('NOMID', 'IDENTIFY', 'NOTES'), $element3));	
					endif;
				 endforeach;
			 endif;
			 
			 if(!empty($slave7)):	 
				 foreach($slave7 as $element3) :
					if($element3['NOTES'] != "") :						
							$element3['NOMID']			 = $nomid; 
							$element3['IDENTIFY'] 		 = 'VOYAGE';
							$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
							$this->pass->insert(elements(array('NOMID', 'IDENTIFY', 'NOTES'), $element3));	
					endif;
				 endforeach;
			 endif;
			 
			 if(!empty($slave8)):	 
				 foreach($slave8 as $element3) :
					if($element3['NOTES'] != "") :						
							$element3['NOMID']			 = $nomid; 
							$element3['IDENTIFY'] 		 = 'OWNER';
							$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
							$this->pass->insert(elements(array('NOMID', 'IDENTIFY', 'NOTES'), $element3));	
					endif;
				 endforeach;
			 endif;
			 
			 if(!empty($slave9)):	 
				 foreach($slave9 as $element3) :
					if($element3['NOTES'] != "") :						
							$element3['NOMID']			 = $nomid; 
							$element3['IDENTIFY'] 		 = 'CHARTERER';
							$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
							$this->pass->insert(elements(array('NOMID', 'IDENTIFY', 'NOTES'), $element3));	
					endif;
				 endforeach;
			 endif;
			  
			 if($gridStatus == 0):
			 	$alerts = ($data['UPDATESTATUS'] == 0) ? array() : $alerts;
			else:
				$alerts = array();
			endif;
			 
			 $this->pass->setTable(array('login','LOGINID'));
			 $msg = ($data['UPDATESTATUS'] == 0) ? "Fixture Slip updated successfully." : 'Fixture Slip ('.$data['NOMINATIONID'].') sent successfully.<br> Claims Handling Allocation : '.$this->pass->first(array("select"=>"CONTACTPERSON","where"=>array('LOGINID'=>$data['CLAIMSLOGINID'])))->CONTACTPERSON;
			 $msg = ($gridStatus == 0) ? $msg : "Fixture Slip updated successfully.";
			 return self::_flashAndRedirectAllWithAlertArray($nom_id ,
												   $msg, 
												   'Sorry! there was an error while updating Fixture Slip.',
												   'operation/'.(($gridStatus == 0) ? 'nomatglance' : (($gridStatus == 1) ? 'opsatglance' : 'postopsatglance')),
									   				$alerts);
	}
	//..........................ends here ...........................................
	//............for opsatglance............................
	public function opsatglance($gridStatus = 1)
	{
		$this->data['gridStatus'] =  $gridStatus;
		$this->data['year_list'] 	 = $this->pass->getYearListForNominationGrid();
		unset($this->data['year_list']['']);
		$this->data['nav'] = ($gridStatus == 1) ? 3 : (($gridStatus == 2) ? 4 : 5);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID,SWEET_ALERT,DATEPICKER,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('operation/opsatglance',$this->data);
	}

	public function sof($gridStatus = 1, $nomid)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] = ($gridStatus == 1) ? 3 : (($gridStatus == 2) ? 4 : 5);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');


		$this->data['gridStatus'] 		 = $gridStatus;
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->find_by_pk($nomid);

		$this->pass->setTable(array('sof_master','NOMID'));

		$this->db->where('NOMID', $nomid);
        $this->db->where('PORT', 'LP');
        $query = $this->db->get('sof_master');
        $this->data['sof'] = $query->row_array();

        $this->db->where('NOMID', $nomid);
        $this->db->where('PORT', 'DP');
        $query = $this->db->get('sof_master');
        $this->data['sofdp'] = $query->row_array();

		$this->data['fleet_list'] 		 = $this->pass->getFleetlist();
		$this->data['post_id'] 		 = $this->pass->getPortlist();
		$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
		$this->data['fleet'] = $this->pass->find_by_pk($this->data['nom']->FLEETID);

		$this->pass->setTable(array('sof_slave_1','NOMID'));
		$this->data['slavebl'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid,'PORT' => 'LP')));
		$this->pass->setTable(array('sof_slave_1','NOMID'));
		$this->data['slaveblDP'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid,'PORT' => 'DP')));

		$this->pass->setTable(array('sof_slave','NOMID'));
		$this->data['sofslave'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid,'PORT' => 'LP')));
		$this->pass->setTable(array('sof_slave','NOMID'));
		$this->data['sofslaveDP'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid,'PORT' => 'DP')));


		 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE,DATEPICKER,NUMERIC,SELECT2,DATETIMEPICKER,CALC));
										 
		$this->data['include'] = include_file_batch();
								 view('operation/sof',$this->data);
	}
	public function update_Sof($gridStatus = 1, $nomid)
	{
			$this->load->helper(['dateFormat','array']);
			$data 					= self::customized_ArrayByKey($this->input->post(),'m');
			$slave1 				= self::customized_ArrayByKey_forArrayData($this->input->post(),'s1',$data['LRECS']);unset($data['LRECS']);
			$slave2 				= self::customized_ArrayByKey_forArrayData($this->input->post(),'s1',$data['LRECSDP']);unset($data['LRECSDP']);
   
				
			$data['NOMID']				     =	$nomid; 			
			$data['VAPS_1'] 				 = formatedDate($data['VAPS_1'],'Y-m-d H:i');
			$data['NT_1'] 		 			 = formatedDate($data['NT_1'],'Y-m-d H:i');
			$data['ANCHOR_DROP'] 			 = formatedDate($data['ANCHOR_DROP'],'Y-m-d H:i');
			$data['ANCHOR_AWEIGH'] 			 = formatedDate($data['ANCHOR_AWEIGH'],'Y-m-d H:i');
			$data['ALL_BERTHERED'] 			 = formatedDate($data['ALL_BERTHERED'],'Y-m-d H:i');
			$data['GUNWAY_DOWN'] 			 = formatedDate($data['GUNWAY_DOWN'],'Y-m-d H:i');
			$data['HOSES_CONNECTED'] 		 = formatedDate($data['HOSES_CONNECTED'],'Y-m-d H:i');
			$data['OP_COMMENCED'] 			 = formatedDate($data['OP_COMMENCED'],'Y-m-d H:i');
			$data['OP_COMPLETED'] 			 = formatedDate($data['OP_COMPLETED'],'Y-m-d H:i');
			$data['HOSES_DISCONNECT'] 		 = formatedDate($data['HOSES_DISCONNECT'],'Y-m-d H:i');
			$data['POB_DEPARTURE'] 			 = formatedDate($data['POB_DEPARTURE'],'Y-m-d H:i');
			$data['CAST_OFF'] 				 = formatedDate($data['CAST_OFF'],'Y-m-d H:i');
			$data['COSP'] 					 = formatedDate($data['COSP'],'Y-m-d H:i');
			$data['REMARKS_1'] 				 = $data['REMARKS_1'];
			$data['ATTACHMENT'] 			 = $data['ATTACHMENT'];

			$data['LOGIN'] 		    = $this->session->uid;
			$data['LOGINID'] 		= $this->session->uid;
			$data['APPROVERS_2'] 		= $this->data['userData']->CONTACTPERSON;
			
			$data['CRMFILE']	= addslashes(trim($data['CRMFILE']));
			$data['CRMNAME']	= addslashes(trim($data['CRMNAME']));
			
			if($gridStatus == 0):
				$data['STATUS'] = ($data['UPDATESTATUS'] == 0) ? 0 : 1;
			endif;
			
			if($_FILES['ATTACHMENT']['name'][0] != ''):
								$data['ATTACHMENT_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT']));
								$data['ATTACHMENT'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT']));
				else		:	$data['ATTACHMENT_NAME'] = $data['ATTACHMENT'] = '';	
				endif;
			if($data['CRMFILE'] != '' && $data['ATTACHMENT'] != ''){ $data['ATTACHMENT'] = $data['CRMFILE'].','.$data['ATTACHMENT'];}
			else if($data['CRMFILE'] == '' && $data['ATTACHMENT'] != ''){ $data['ATTACHMENT'] = $data['ATTACHMENT'];}
			else if($data['CRMFILE'] != '' && $data['ATTACHMENT'] == ''){ $data['ATTACHMENT'] = $data['CRMFILE'];}

			if($data['CRMNAME'] != '' && $data['ATTACHMENT_NAME'] != ''){ $data['ATTACHMENT_NAME'] = $data['CRMNAME'].','.$data['ATTACHMENT_NAME'];}
			else if($data['CRMNAME'] == '' && $data['ATTACHMENT_NAME'] != ''){ $data['ATTACHMENT_NAME'] = $data['ATTACHMENT_NAME'];}
			else if($data['CRMNAME'] != '' && $data['ATTACHMENT_NAME'] == ''){ $data['ATTACHMENT_NAME'] = $data['CRMNAME'];}
			unset($data['CRMFILE']);unset($data['CRMNAME']);


			$this->pass->setTable(array('sof_master','NOMID'));
			$this->pass->delete(array("where"=>array('NOMID'=>$nomid,'PORT' => $data['PORT'])));


			$this->pass->setTable(array('sof_master','SOFID'));
			$nom_id = $this->pass->insert($data);
			

	
			if(!empty($slave1)):		  	
			 $this->pass->setTable(array('sof_slave_1','SOF_SLAVEID'));
			 $this->pass->delete(array("where"=>array('NOMID'=>$nomid,'PORT' => $data['PORT'])));					
			 foreach($slave1 as $element2) : 		
				if($element2['BL_DATE'] != "" && $element2['CARGO'] != "" && $element2['BL_QTY'] != "") :
					$element2['SOFID']           = $nom_id;
						$element2['NOMID']			=	$nomid; 
						$element2['BL_DATE'] 		= formatedDate($element2['BL_DATE']);
						$this->pass->insert(elements(array('SOFID','NOMID', 'BL_DATE', 'CARGO', 'BL_QTY','PORT','STATUS'), $element2));	
				endif;
			 endforeach;				 
			endif;

			if(!empty($slave2)):		  	
				 $this->pass->setTable(array('sof_slave_1','SOF_SLAVEID'));
				 $this->pass->delete(array("where"=>array('NOMID'=>$nomid,'PORT' => $data['PORT'])));			
				 foreach($slave2 as $element2) : 		
					if($element2['BL_DATE'] != "" && $element2['CARGO'] != "" && $element2['BL_QTY'] != "") :

						    $element2['SOFID']           = $nom_id;
							$element2['NOMID']			=	$nomid; 
							$element2['BL_DATE'] 		= formatedDate($element2['BL_DATE']);
							$this->pass->insert(elements(array('SOFID','NOMID', 'BL_DATE', 'CARGO', 'BL_QTY','PORT','STATUS'), $element2));	
					endif;
				 endforeach;				 
			endif;

				$this->db->where('NOMID', $nomid);
				$this->db->where('PORT', 'LP');
				$query = $this->db->get('sof_master');
				$this->data['sof'] = $query->row_array();

				$this->db->where('NOMID', $nomid);
				$this->db->where('PORT', 'DP');
				$query = $this->db->get('sof_master');
				$this->data['sofdp'] = $query->row_array();
			

				if(!empty($data['ADDDEl'])):
				    $mainslavedata = self::customized_ArrayByKey($this->input->post(),'s2',$data['ADDDEl']);unset($data['ADDDEl']);	
				    		    
				endif;			
				 if(!empty($mainslavedata)):
					  $this->pass->setTable(array('sof_slave','SOF_SLAVEID'));
					  $this->pass->delete(array("where"=>array('NOMID'=>$nomid,'PORT' => $data['PORT'])));	
						
					 foreach($mainslavedata as $element3) :

						if(!empty($element3['ACTIVITYID']) != "" && !empty($element3['START_DATETIME']) != "" && !empty($element3['FINISH_DATETIME']) != "") :
								$element3['SOFID']           = $nom_id;						
								$element3['NOMID']			=	$nomid; 
								$element3['STATUS']	 = $this->data['sof']['STATUS'];								
								$element3['START_DATETIME'] 	 = !empty($element3['START_DATETIME']!='')?formatedDate($element3['START_DATETIME'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
								$element3['FINISH_DATETIME'] 	 = !empty($element3['FINISH_DATETIME']!='')?formatedDate($element3['FINISH_DATETIME'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
								$this->pass->insert(elements(array('SOFID', 'NOMID', 'ACTIVITYID', 'START_DATETIME', 'FINISH_DATETIME', 'DURATION', 'NOTES', 'PORT','STATUS'), $element3));
						endif;
					 endforeach;
				endif;

				if(!empty($data['ADDDElDP'])):
				    $mainslaveDP = self::customized_ArrayByKey($this->input->post(),'s3',$data['ADDDElDP']);unset($data['ADDDElDP']);	

				endif;			
				 if(!empty($mainslaveDP)):
					  $this->pass->setTable(array('sof_slave','SOF_SLAVEID'));
					  $this->pass->delete(array("where"=>array('NOMID'=>$nomid,'PORT' => $data['PORT'])));	
						
					 foreach($mainslaveDP as $element3) :

						if(!empty($element3['ACTIVITYID']) != "" && !empty($element3['START_DATETIME']) != "" && !empty($element3['FINISH_DATETIME']) != "") :	
						$element3['SOFID']           = $nom_id;					
								$element3['NOMID']			=	$nomid; 
								$element3['STATUS']	 = $this->data['sofdp']['STATUS'];
								$element3['START_DATETIME'] 	 = !empty($element3['START_DATETIME']!='')?formatedDate($element3['START_DATETIME'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
								$element3['FINISH_DATETIME'] 	 = !empty($element3['FINISH_DATETIME']!='')?formatedDate($element3['FINISH_DATETIME'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
								$this->pass->insert(elements(array('SOFID', 'NOMID', 'ACTIVITYID', 'START_DATETIME', 'FINISH_DATETIME', 'DURATION', 'NOTES', 'PORT','STATUS'), $element3));
						endif;
					 endforeach;
				endif;

		



						 
			 // $this->pass->setTable(array('login','LOGINID'));
			 // $msg = ($data['UPDATESTATUS'] == 0) ? "Sof Add successfully." : 'Sof Slip ('.$data['NOMINATIONID'].') sent successfully.<br> Claims Handling Allocation : '.$this->pass->first(array("select"=>"CONTACTPERSON","where"=>array('LOGINID'=>$data['CLAIMSLOGINID'])))->CONTACTPERSON;
			 // $msg = ($gridStatus == 0) ? $msg : "Sof Add successfully.";

 

				$param1 = $gridStatus; 
				$param2 = $nomid;
             $msg = ($gridStatus == 1) ? $msg : "Sof updated successfully.";
				return self::_flashAndRedirectAllWithAlertArray(
				$nom_id,
				$msg,
				'Sorry! there was an error while updating Fixture Slip.',
				'operation/'.(($gridStatus == 0) ? 'sof/'.$param1.'/'.$param2 : (($gridStatus == 1) ? 'sof/'.$param1.'/'.$param2 : 'sof/'.$param1.'/'.$param2)),
				$alerts
				);
		
			    
				 					   				
			  		// $this->data['include'] = include_file_batch();
							// 	 view('operation/sof',$this->data);
	}

	public function laytime_calculation($gridStatus = 1, $nomid)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] = ($gridStatus == 1) ? 3 : (($gridStatus == 2) ? 4 : 5);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->find_by_pk($nomid);

		$this->pass->setTable(array('sof_master','NOMID'));

		$this->db->where('NOMID', $nomid);
        $this->db->where('PORT', 'LP');
         $this->db->where('STATUS', '2');
        $query = $this->db->get('sof_master');
        $this->data['sof'] = $query->row_array();

        $this->db->where('NOMID', $nomid);
        $this->db->where('PORT', 'DP');
         $this->db->where('STATUS', '2');
        $query = $this->db->get('sof_master');
        $this->data['sofdp'] = $query->row_array();


        $this->db->where('NOMID', $nomid);
        $this->db->where('PORT', 'LP');
        $query = $this->db->get('laytime_master');
        $this->data['LAYtime'] = $query->row_array();

        $this->db->where('NOMID', $nomid);
        $this->db->where('PORT', 'DP');
        $query = $this->db->get('laytime_master');
        $this->data['laytimeDP'] = $query->row_array();

		$this->data['fleet_list'] 		 = $this->pass->getFleetlist();
		$this->data['post_id'] 		 = $this->pass->getPortlist();
		$this->data['vendor_list'] 		 = $this->pass->getVendorBasedOnVendorTypeID([1]);
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('cargo_master','CARGOID')));

		
		$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));		
		$this->data['fleet'] = $this->pass->find_by_pk($this->data['nom']->FLEETID);

		$this->pass->setTable(array('laytime_slave','NOMID'));
		$this->data['laytimesave'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid,'PORT' => 'LP')));
		$this->pass->setTable(array('laytime_slave','NOMID'));
		$this->data['laytimesalvDP'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid,'PORT' => 'DP')));

		$this->pass->setTable(array('sof_slave','NOMID'));
		$this->data['sofslave'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid,'PORT' => 'LP','STATUS' => '2')));
		$this->pass->setTable(array('sof_slave','NOMID'));
		$this->data['sofslaveDP'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid,'PORT' => 'DP','STATUS' => '2')));


		 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE,DATEPICKER,NUMERIC,SELECT2,DATETIMEPICKER,CALC));								 
		$this->data['include'] = include_file_batch();
								 view('operation/laytime_calculation',$this->data);
	}
	
	public function update_laytime($gridStatus = 1, $nomid)
	{
			$this->load->helper(['dateFormat','array']);
			$data 					= self::customized_ArrayByKey($this->input->post(),'m');
			//$slave1 				= self::customized_ArrayByKey_forArrayData($this->input->post(),'s1',$data['LRECS']);unset($data['LRECS']);
			//$slave2 				= self::customized_ArrayByKey_forArrayData($this->input->post(),'s1',$data['LRECSDP']);unset($data['LRECSDP']);

   
			$data['NOMID']				     =	$nomid; 			
			
			$data['VESSEL_ARRIVED'] 		 = formatedDate($data['VESSEL_ARRIVED'],'Y-m-d H:i');
			$data['NOR_TENDERED'] 			 = formatedDate($data['NOR_TENDERED'],'Y-m-d H:i');
			$data['NOR_ACCEPTED'] 			 = formatedDate($data['NOR_ACCEPTED'],'Y-m-d H:i');
			$data['START_COUNTING'] 		 = formatedDate($data['START_COUNTING'],'Y-m-d H:i');
			$data['ANCHOR_AWEIGH'] 			 = formatedDate($data['ANCHOR_AWEIGH'],'Y-m-d H:i');
			$data['LOAD_DIS_COMMENCED'] 	 = formatedDate($data['LOAD_DIS_COMMENCED'],'Y-m-d H:i');
			$data['LOAD_DIS_COMPLETED'] 	 = formatedDate($data['LOAD_DIS_COMPLETED'],'Y-m-d H:i');
			$data['VESSEL_SAILED'] 			 = formatedDate($data['VESSEL_SAILED'],'Y-m-d H:i');

			$data['LOGIN'] 		    = $this->session->uid;
			$data['LOGINID'] 		= $this->session->uid;
			$data['APPROVERS_2'] 	= $this->data['userData']->CONTACTPERSON;
			
			$data['CRMFILE']	= addslashes(trim($data['CRMFILE']));
			$data['CRMNAME']	= addslashes(trim($data['CRMNAME']));
			
			if($gridStatus == 0):
				$data['STATUS'] = ($data['UPDATESTATUS'] == 0) ? 0 : 1;
			endif;

		   
			
			if($_FILES['ATTACHMENTS']['name'][0] != ''):
								$data['ATTACHMENTS_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENTS']));
								$data['ATTACHMENTS'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT']));
				else		:	$data['ATTACHMENTS_NAME'] = $data['ATTACHMENTS'] = '';	
				endif;
			if($data['CRMFILE'] != '' && $data['ATTACHMENTS'] != ''){ $data['ATTACHMENTS'] = $data['CRMFILE'].','.$data['ATTACHMENTS'];}
			else if($data['CRMFILE'] == '' && $data['ATTACHMENTS'] != ''){ $data['ATTACHMENTS'] = $data['ATTACHMENTS'];}
			else if($data['CRMFILE'] != '' && $data['ATTACHMENTS'] == ''){ $data['ATTACHMENTS'] = $data['CRMFILE'];}

			if($data['CRMNAME'] != '' && $data['ATTACHMENTS_NAME'] != ''){ $data['ATTACHMENTS_NAME'] = $data['CRMNAME'].','.$data['ATTACHMENTS_NAME'];}
			else if($data['CRMNAME'] == '' && $data['ATTACHMENTS_NAME'] != ''){ $data['ATTACHMENTS_NAME'] = $data['ATTACHMENTS_NAME'];}
			else if($data['CRMNAME'] != '' && $data['ATTACHMENTS_NAME'] == ''){ $data['ATTACHMENTS_NAME'] = $data['CRMNAME'];}
			unset($data['CRMFILE']);unset($data['CRMNAME']);


			$this->pass->setTable(array('laytime_master','NOMID'));
			$this->pass->delete(array("where"=>array('NOMID'=>$nomid,'PORT' => $data['PORT'])));


			$this->pass->setTable(array('laytime_master','LAYTIME_ID'));
			$nom_id = $this->pass->insert($data);
			

	
			// if(!empty($slave1)):		  	
			//  $this->pass->setTable(array('sof_slave_1','SOF_SLAVEID'));
			//  $this->pass->delete(array("where"=>array('NOMID'=>$nomid,'PORT' => $data['PORT'])));					
			//  foreach($slave1 as $element2) : 		
			// 	if($element2['BL_DATE'] != "" && $element2['CARGO'] != "" && $element2['BL_QTY'] != "") :
			// 		$element2['SOFID']           = $nom_id;
			// 			$element2['NOMID']			=	$nomid; 
			// 			$element2['BL_DATE'] 		= formatedDate($element2['BL_DATE']);
			// 			$this->pass->insert(elements(array('SOFID','NOMID', 'BL_DATE', 'CARGO', 'BL_QTY','PORT','STATUS'), $element2));	
			// 	endif;
			//  endforeach;				 
			// endif;

			// if(!empty($slave2)):		  	
			// 	 $this->pass->setTable(array('sof_slave_1','SOF_SLAVEID'));
			// 	 $this->pass->delete(array("where"=>array('NOMID'=>$nomid,'PORT' => $data['PORT'])));			
			// 	 foreach($slave2 as $element2) : 		
			// 		if($element2['BL_DATE'] != "" && $element2['CARGO'] != "" && $element2['BL_QTY'] != "") :

			// 			    $element2['SOFID']           = $nom_id;
			// 				$element2['NOMID']			=	$nomid; 
			// 				$element2['BL_DATE'] 		= formatedDate($element2['BL_DATE']);
			// 				$this->pass->insert(elements(array('SOFID','NOMID', 'BL_DATE', 'CARGO', 'BL_QTY','PORT','STATUS'), $element2));	
			// 		endif;
			// 	 endforeach;				 
			// endif;

			// 	$this->db->where('NOMID', $nomid);
			// 	$this->db->where('PORT', 'LP');
			// 	$query = $this->db->get('sof_master');
			// 	$this->data['sof'] = $query->row_array();

			// 	$this->db->where('NOMID', $nomid);
			// 	$this->db->where('PORT', 'DP');
			// 	$query = $this->db->get('sof_master');
			// 	$this->data['sofdp'] = $query->row_array();

			$this->db->where('NOMID', $nomid);
				$this->db->where('PORT', 'LP');
	        $query = $this->db->get('laytime_master');
	        $this->data['LAYtime'] = $query->row_array();

	        $this->db->where('NOMID', $nomid);
	        	$this->db->where('PORT', 'DP');
	        $query = $this->db->get('laytime_master');
	        $this->data['laytimeDP'] = $query->row_array();
			

				if(!empty($data['ADDDEl'])):
				    $mainslavedata = self::customized_ArrayByKey($this->input->post(),'s2',$data['ADDDEl']);unset($data['ADDDEl']);	



				endif;

				
				 if(!empty($mainslavedata)):
					  $this->pass->setTable(array('laytime_slave','LAYTIME_LP_SLAVEID'));
					  $this->pass->delete(array("where"=>array('NOMID'=>$nomid,'PORT' => $data['PORT'])));	
						
					 foreach($mainslavedata as $element3) :

						if(!empty($element3['ACTIVITYID']) != "" && !empty($element3['START_DATETIME']) != "" && !empty($element3['FINISH_DATETIME']) != "") :
								$element3['LAYTIME_ID']           = $nom_id;						
								$element3['NOMID']			=	$nomid; 

								$element3['STATUS']	 = $this->data['LAYtime']['STATUS'];								
								$element3['START_DATETIME'] 	 = !empty($element3['START_DATETIME']!='')?formatedDate($element3['START_DATETIME'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
								$element3['FINISH_DATETIME'] 	 = !empty($element3['FINISH_DATETIME']!='')?formatedDate($element3['FINISH_DATETIME'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
								$this->pass->insert(elements(array('LAYTIME_ID', 'NOMID', 'ACTIVITYID', 'START_DATETIME', 'FINISH_DATETIME', 'DURATION','LT_C' , 'LT_NC', 'LT_PARTIAL', 'CUMMULATIVE_TIME', 'NOTES', 'PORT','STATUS'), $element3));
						endif;
					 endforeach;
				endif;

				if(!empty($data['ADDDElDP'])):
				    $mainslaveDP = self::customized_ArrayByKey($this->input->post(),'s3',$data['ADDDElDP']);unset($data['ADDDElDP']);	

				  

				endif;			
				 if(!empty($mainslaveDP)):
					  $this->pass->setTable(array('laytime_slave','LAYTIME_LP_SLAVEID'));
					  $this->pass->delete(array("where"=>array('NOMID'=>$nomid,'PORT' => $data['PORT'])));		
						
					 foreach($mainslaveDP as $element3) :

						if(!empty($element3['ACTIVITYID']) != "" && !empty($element3['START_DATETIME']) != "" && !empty($element3['FINISH_DATETIME']) != "") :	
						$element3['LAYTIME_ID']           = $nom_id;					
								$element3['NOMID']			=	$nomid; 
								$element3['STATUS']	 = $this->data['laytimeDP']['STATUS'];
								$element3['START_DATETIME'] 	 = !empty($element3['START_DATETIME']!='')?formatedDate($element3['START_DATETIME'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
								$element3['FINISH_DATETIME'] 	 = !empty($element3['FINISH_DATETIME']!='')?formatedDate($element3['FINISH_DATETIME'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
								$this->pass->insert(elements(array('LAYTIME_ID', 'NOMID', 'ACTIVITYID', 'START_DATETIME', 'FINISH_DATETIME', 'DURATION','LT_C' , 'LT_NC', 'LT_PARTIAL', 'CUMMULATIVE_TIME', 'NOTES', 'PORT','STATUS'), $element3));
						endif;
					 endforeach;
				endif;

		



						 
			 // $this->pass->setTable(array('login','LOGINID'));
			 // $msg = ($data['UPDATESTATUS'] == 0) ? "Sof Add successfully." : 'Sof Slip ('.$data['NOMINATIONID'].') sent successfully.<br> Claims Handling Allocation : '.$this->pass->first(array("select"=>"CONTACTPERSON","where"=>array('LOGINID'=>$data['CLAIMSLOGINID'])))->CONTACTPERSON;
			 // $msg = ($gridStatus == 0) ? $msg : "Sof Add successfully.";

 

				$param1 = $gridStatus; 
				$param2 = $nomid;
             $msg = ($gridStatus == 1) ? $msg : "Laytime updated successfully.";
				return self::_flashAndRedirectAllWithAlertArray(
				$nom_id,
				$msg,
				'Sorry! there was an error while updating Laytime.',
				'operation/'.(($gridStatus == 0) ? 'laytime_calculation/'.$param1.'/'.$param2 : (($gridStatus == 1) ? 'laytime_calculation/'.$param1.'/'.$param2 : 'laytime_calculation/'.$param1.'/'.$param2)),
				$alerts
				);
		
			    
				 					   				
			  		// $this->data['include'] = include_file_batch();
							// 	 view('operation/sof',$this->data);
	}

	public function view_fixture($gridStatus = 1, $nomid)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] = ($gridStatus == 1) ? 3 : (($gridStatus == 2) ? 4 : 5);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (CASE WHEN FIXTURETYPE = 1 THEN 'Voyage Spot' WHEN FIXTURETYPE = 2 THEN 'Time Charter' ELSE 'COA'  END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME, (select STATUS_NAME from status_master where status_master.STATUSID=nom_details.FIXTURE_STATUS) as FIXTURESTATUSNAME","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('cargo_master','CARGOID')));
		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		
		$this->data['etanextPort'] = extractString($this->data['nom']->ADD_NEXT_PORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('nom_details_slave','SLAVEID'));
		$this->data['slave'] = $this->pass->all(array("select"=>"*, (select NAME from broker_master where broker_master.BROKERID=nom_details_slave.BROKERID) as BROKERNAME","where"=>array('NOMID'=>$nomid)));
		
		
		$this->pass->setTable(array('nom_details_slave2','NOM_SLAVE2ID'));
		$this->data['slave2'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave2.PORTID) as PORTNAME, (case when (PORTTYPEID = 1) THEN 'LP' ELSE 'DP' END) as PORTTYPE","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave3','NOM_SLAVE3ID'));
		$this->data['slave3'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave3.PORTID) as PORTNAME, (select PURPOSE_NAME from purposeofcall_master where purposeofcall_master.CALLID=nom_details_slave3.PURPOSEOFCALL) as PURPOSE_NAME","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave4'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'BROKER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave5'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'VOYAGE')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave6'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'OWNER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave7'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'CHARTERER')));
		$this->pass->setTable(array('nom_details_slave5','NOM_SLAVEID5'));
		$this->data['slave8'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid)));
								 
		$this->data['include'] = include_file_batch();
								 view('operation/view_fixture',$this->data);
	}
	
	public function editcompletiondate($gridStatus)
	{
		$this->load->helper('dateFormat');
		$data 					= self::customized_ArrayByKey($this->input->post(),'m');
		$data['CDDATE'] = ($data['CDDATE'] != "") ? formatedDate($data['CDDATE']) : '0000-00-00';
		$nomid = $data['NOMID']; unset($data['NOMID']);
		
		$this->pass->setTable(array('nom_details','NOMID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($nomid, $data) ,
									   'Estimated Completion Date (Frt) updated successfully.', 
									   'Sorry! there was an error while updating Estimated Completion Date (Frt).',
									   'operation/'.(($gridStatus == 1) ? 'opsatglance' : 'postopsatglance'));
	}

	public function edit_initialized_fixture($fixtureid, $gridStatus = 1, $nomid)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] = ($gridStatus == 1) ? 3 : (($gridStatus == 2) ? 4 : 5);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'History');
		$this->data['gridStatus'] 		 = $gridStatus;
				
		$this->data['fixtureid'] 		 	= $fixtureid;
		$this->data['fixtureName'] 		 	= $this->pass->getFixtureTypeList()[$fixtureid];
		$this->data['fleet_list'] 		 	= $this->pass->getFleetlist();
		$this->data['vendor_list'] 		 	= $this->pass->getVendorBasedOnVendorTypeID([1]);
		$this->data['owner_list'] 		 	= $this->pass->getVendorBasedOnVendorTypeID([2]);
		$this->data['collect_comm_list'] 	= $this->pass->getVendorBasedOnVendorTypeID([1,2]);
		$this->data['cargo_list'] 		 	= $this->pass->getCargoList();
		$this->data['user_list_claims']  	= $this->pass->getUserList('claims');
		$this->data['user_list_operation']  = $this->pass->getUserList('operation');
		
		$this->data['currency_list'] 	 = $this->pass->getCurrencyList();
		$this->data['bank_list'] 		 = $this->pass->getBankList();
		$this->data['invoice_status_freight'] 	     = $this->pass->count_all('invoice_master',array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT'));
		$this->data['invoice_status_demurrage'] 	 = $this->pass->count_all('invoice_master',array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE'));
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (select CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) from port_master where PORTID=LPORT) as LPORTNAME, (select CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) from port_master where PORTID=DPORT) as DPORTNAME","where"=>array('NOMID'=>$nomid)));
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE,DATEPICKER,NUMERIC,SELECT2,CALC));
		$this->data['include'] = include_file_batch();
								 view("operation/".(($fixtureid == 1) ? 'edit_voyage_fixture' : (($fixtureid == 2) ? 'edit_time_fixture' : 'edit_snp_fixture')),$this->data);
	}
	
	public function update_initialized_fixture($fixtureid, $gridStatus = 1, $nomid)
	{
			$this->load->helper(['dateFormat','array']);
			$data 					= self::customized_ArrayByKey($this->input->post(),'m');
			
			$data['FIXTURETYPE'] 	= $fixtureid;
			$data['CPDATE'] 		= formatedDate($data['CPDATE']);
			$data['LAYCANSTART'] 	= !empty($data['LAYCANSTART']) ? formatedDate($data['LAYCANSTART']) : '0000-00-00';
			$data['LAYCANEND'] 		= !empty($data['LAYCANEND']) ? formatedDate($data['LAYCANEND']) : '0000-00-00';
			$data['MOADATE'] 		= !empty($data['MOADATE']) ? formatedDate($data['MOADATE']) : '0000-00-00';
			$data['DELIVERYDATE'] 	= !empty($data['DELIVERYDATE']) ? formatedDate($data['DELIVERYDATE']) : '0000-00-00';
			$data['COMPLETIONDATE'] = !empty($data['COMPLETIONDATE']) ? formatedDate($data['COMPLETIONDATE']) : '0000-00-00';
			$data['ESTDATE'] 		= '0000-00-00';
			$data['FIXTUREDATE'] 	= '0000-00-00';		
			
			$data['CRMFILE']	= addslashes(trim($data['CRMFILE']));
			$data['CRMNAME']	= addslashes(trim($data['CRMNAME']));
			
			if($_FILES['ATTACHMENT']['name'][0] != ''):
									$data['ATTACHMENT_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT']));
									$data['ATTACHMENT'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT']));
					else		:	$data['ATTACHMENT_NAME'] = $data['ATTACHMENT'] = '';	
					endif;
					
			if($data['CRMFILE'] != '' && $data['ATTACHMENT'] != ''){ $data['ATTACHMENT'] = $data['CRMFILE'].','.$data['ATTACHMENT'];}
			else if($data['CRMFILE'] == '' && $data['ATTACHMENT'] != ''){ $data['ATTACHMENT'] = $data['ATTACHMENT'];}
			else if($data['CRMFILE'] != '' && $data['ATTACHMENT'] == ''){ $data['ATTACHMENT'] = $data['CRMFILE'];}
			
			if($data['CRMNAME'] != '' && $data['ATTACHMENT_NAME'] != ''){ $data['ATTACHMENT_NAME'] = $data['CRMNAME'].','.$data['ATTACHMENT_NAME'];}
			else if($data['CRMNAME'] == '' && $data['ATTACHMENT_NAME'] != ''){ $data['ATTACHMENT_NAME'] = $data['ATTACHMENT_NAME'];}
			else if($data['CRMNAME'] != '' && $data['ATTACHMENT_NAME'] == ''){ $data['ATTACHMENT_NAME'] = $data['CRMNAME'];}
			
			unset($data['CRMFILE']);unset($data['CRMNAME']);unset($data['LUMPSUMFREIGHTUSD']);unset($data['HIRERATEUSD']);unset($data['DEMURRAGEUSD']);
			 
			 $this->pass->setTable(array('nom_details','NOMID'));
			 return self::_flashAndRedirectAllWithAlertArray($this->pass->update($nomid,$data) ,
												   "Fixture Slip updated successfully.", 
												   'Sorry! there was an error while updating Fixture Slip.',
												   'operation/'.(($gridStatus == 1) ? 'opsatglance' : (($gridStatus == 2) ? 'postopsatglance' : 'history'))
												  );
	}
	
	
	public function editcompletiondatedem($gridStatus)
	{
		$this->load->helper('dateFormat');
		$data 					= self::customized_ArrayByKey($this->input->post(),'m');
		$data['DEMCDDATE'] = ($data['DEMCDDATE'] != "") ? formatedDate($data['DEMCDDATE']) : '0000-00-00';
		$nomid = $data['NOMID']; unset($data['NOMID']);
		
		$this->pass->setTable(array('nom_details','NOMID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($nomid, $data) ,
									   'Estimated Completion Date (Dem) updated successfully.', 
									   'Sorry! there was an error while updating Estimated Completion Date (Dem).',
									   'operation/'.(($gridStatus == 1) ? 'opsatglance' : 'postopsatglance'));
	}
	
	public function invoice_time($gridStatus = 1, $nomid, $fixtureType)
	{
		$this->load->helper(['dateFormat','array']);
		$this->load->library("numbertowordconversion");
		
		$this->data['currency_list'] 	 = $this->pass->getCurrencyList();
		$this->data['gstno_list'] 	     = $this->pass->getGSTInMasterList();
		
		$this->data['nav'] = ($gridStatus == 1) ? 3 : (($gridStatus == 2) ? 4 : 5);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (CASE WHEN FIXTURETYPE = 1 THEN 'Voyage Spot' WHEN FIXTURETYPE = 2 THEN 'Time Charter' ELSE 'COA'  END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME, (select VENDORADDRESS1 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS1, (select VENDORADDRESS2 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS2, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select TAXTYPE from company_master where company_master.COMPANYID=nom_details.COMPANYID) as TAXTYPENAME, (select VENDORADDRESS3 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS3 , (select VENDORADDRESS4 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS4, (select SUM(HIRERATE) from nom_details_slave5 where nom_details_slave5.NOMID=nom_details.NOMID) as DAILYHIRERATE, (select SUM(DAY) from nom_details_slave5 where nom_details_slave5.NOMID=nom_details.NOMID) as ACTUALDAYS, (select SUM(OFFHIREDAY) from nom_details_slave5 where nom_details_slave5.NOMID=nom_details.NOMID) as OFFHIREDAYS, (select SUM(BALANCEDAY) from nom_details_slave5 where nom_details_slave5.NOMID=nom_details.NOMID) as HIREDAYS","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>" , ","table"=>array('cargo_master','CARGOID')));
		


		$this->data['note_list'] = $this->pass->getInvoiceNoteList();
		$this->data['bank_list'] = $this->pass->getBankList();
		
		$this->pass->setTable(array('company_master','COMPANYID'));
		$this->data['companydata'] = $this->pass->first(array("select"=>"*", "where"=>array('COMPANYID'=>$this->data['nom']->COMPANYID)));
		
		$this->pass->setTable(array('bank_master','BANKID'));
		$result = $this->pass->all(array("where"=>array('STATUS'=>1))); 
		$arr = array();
		foreach($result as $val):
			$arr[$val->BANKID][] = array('bank_address' => $val->BANK_ADDRESS, 'account_name' => $val->ACCOUNT_NAME, 'account_number' => $val->ACCOUNT_NUMBER, 'aed' => $val->AED, 'euro' => $val->EURO, 'usd' => $val->USD);
		endforeach;
		
		$this->data['bank_details'] = json_encode($arr);
		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));		
		if($fixtureType == 'time'):		
			$this->data['hire_days_value'] = number_format($this->pass->first(array("select"=>"SUM(HIREDAYS) AS HIREDAYS","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')))->HIREDAYS,4,'.','');
		else:
			$this->data['sum_comm_value'] =  number_format($this->pass->first(array("select"=>"SUM(COMMISSIONWITHOUTTAX) AS COMMISSIONVALUE","where"=>array('NOMID'=>$nomid, 'INVOICENOTE'=>3, 'INVOICETYPE'=>'FREIGHT')))->COMMISSIONVALUE,2,'.','');
			$this->data['sum_dem_value2'] = number_format($this->pass->first(array("select"=>"SUM(COMMISSIONWITHOUTTAX) AS COMMISSIONVALUE","where"=>array('NOMID'=>$nomid, 'INVOICENOTE'=>3, 'INVOICETYPE'=>'DEMURRAGE')))->COMMISSIONVALUE,2,'.','');		
		endif;
        $this->pass->setTable(array('invoice_master','INVOICEID'));
		$this->data['f_invoice_lists'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid,'STATUS <='=> 1, 'REMOVEID !='=> 0, 'INVOICETYPE'=>'FREIGHT')));
		
		$this->data['f_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Invoice' ELSE '' END) as INVOICENOTENAME", 'NOMSTATUS',"where"=>array('NOMID'=>$nomid,'INVOICETYPE'=>'FREIGHT'),"where_str" => "(STATUS <= 2)"));
		if($fixtureType == 'voyage'):
		$this->data['d_demu_list2'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid,'STATUS <='=> 1, 'REMOVEID !='=> 0, 'INVOICETYPE'=>'DEMURRAGE')));

			$this->data['d_demu_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Invoice'ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE'),"where_str" => "(STATUS <= 2)"));		
		endif;		
		$this->data['o_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Invoice' WHEN (INVOICENOTE = 4) THEN 'Deviation' WHEN (INVOICENOTE = 5) THEN CONCAT('Others ( ', INVOICENOTEOTHER, ' )') ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('payment_received','PAYMENTID'));
		$this->data['f_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		if($fixtureType == 'voyage'):	
		$this->data['d_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));	
		endif;		
		$this->data['o_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('summary','SUMMARYID'));
		$this->data['f_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		if($fixtureType == 'voyage'):
		$this->data['d_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));
		endif;	
		$this->data['o_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));

		$this->pass->setTable(array('nom_details_slave5','NOM_SLAVEID5'));
		$this->data['slave8'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid)));
		
		
								 set_includes(array(SELECT2,SWEET_ALERT,DATEPICKER,VALIDATE,AUTOSIZE,NUMERIC,CALC,NO_2_WORD));
		$this->data['include'] = include_file_batch();
								 view('operation/'.(($fixtureType == 'time') ? 'invoice_time' : 'invoice'),$this->data);
	}
	
	public function insert_invoice_time($gridStatus = 1, $invoice_type, $fixtureType)
	{

		$this->load->helper(['dateFormat','array']);
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		
		$data['INVOICEDATE'] 		= formatedDate($data['INVOICEDATE']);
		$data['FROMDATE'] 			= !empty($data['FROMDATE']) ? formatedDate($data['FROMDATE']) : '0000-00-00';
		$data['ENDDATE'] 			= !empty($data['ENDDATE']) ? formatedDate($data['ENDDATE']) : '0000-00-00';	
		$data['CONVERSION_DATE']    = !empty($data['CONVERSION_DATE']) ? formatedDate($data['CONVERSION_DATE']) : '0000-00-00';		
		
		$alerts = [
						[
							'ALERTBY' 		=> $this->session->uid,
							'ALERTTO' 		=> 1,
							'ALERTTEXT'		=> $invoice_type.' Invoice created by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'admin/invoice/'.$gridStatus.'/'.$data['NOMID'],
							'ALERTTYPE'		=> 'Invoice Slip'
						 ],
						 [
						 	'ALERTBY'		=> $this->session->uid,
						 	'ALERTTO'		=> $data['CLAIMSLOGINID'],
							'ALERTTEXT'		=> $invoice_type.' Invoice created by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'claims/invoice/'.$gridStatus.'/'.$data['NOMID'],
							'ALERTTYPE'		=> 'Invoice Slip'
						 ]
					  ];
			
			
			$nomination = $data['NOMINATIONID']; $nomid = $data['NOMID'];   unset($data['NOMINATIONID']);unset($data['CLAIMSLOGINID']);

			

			$this->pass->setTable(array('invoice_master','INVOICEID'));
			
			   $newStatus = 1;
		       $removeid = 0;
			
			$this->db->set('REMOVEID', $removeid);
			$this->db->where('NOMID', $nomid);
			$this->db->where('STATUS', $newStatus);
			if($this->db->update('invoice_master')) {
			    echo "Record updated successfully";
			} else {
			    echo "Error updating record: " . $this->db->error();
			}


			$this->pass->setTable(array('invoice_master','INVOICEID'));
			$insert = $this->pass->insert($data);
			if($insert):		
				
				$fixture_status_arr = (strtoupper($invoice_type) === strtoupper('Freight')) ? array('NOMSTATUS' => 3) : array('NOMSTATUS' => 4);
				
				$this->pass->setTable(array('nom_details','NOMID'));
				return self::_flashAndRedirectAllWithAlertArray( 
										(strtoupper($invoice_type) === strtoupper('Others')) 
												? $insert
												: $this->pass->update($nomid, $fixture_status_arr) ,
									   'Invoice ('.$nomination.') created successfully.', 
									   'Sorry! there was an error while creating Invoice.',
									   'operation/'.(($gridStatus == 1) ? 'opsatglance' : 'postopsatglance'),$alerts);
			else:
				self::invoice_time($gridStatus, $nomid, $fixtureType);
			endif;
	}

	public function Update_invoice($redirect, $gridStatus, $nomid, $type, $invoiceid)
	{	$newStatus = 1;
		$removeid = 3;
	 // The new status value
				
		$this->pass->setTable(array('invoice_master','INVOICEID'));
			$data = array(
			    'status' => $newStatus,
			     'REMOVEID' => $removeid
			);
			$this->db->where('NOMID', $nomid);
			$this->db->where('INVOICETYPE', $type);
			$this->db->where('INVOICEID', $invoiceid);
			if($this->db->update('invoice_master', $data)) {
			    echo "Record updated successfully";
			} else {
			    echo "Error updating record: " . $this->db->error();
			}
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		$noofincoice = $this->pass->first(array("select"=>"count(*) as COUNT1","where"=>array('NOMID' => $nomid, 'INVOICETYPE' => $type)));	
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$fixture_status_arr = (strtoupper($type) === strtoupper('Freight') && $noofincoice->COUNT1==0) ? array('NOMSTATUS' => 2) : array('NOMSTATUS' => 3);
		return self::_flashAndRedirectAllWithAlertArray(
										(strtoupper($type) === strtoupper('Others') || $noofincoice->COUNT1!=0) 
												? TRUE
												: $this->pass->updateWhere($fixture_status_arr, array("where"=>array('NOMID'=>$nomid))) ,
									   "$type Invoice removed successfully.", 
									   "Sorry! there was an error while changing $type Invoice",
									   "operation/$redirect/{$gridStatus}/{$nomid}");
	}

	
	public function delete_invoice($redirect, $gridStatus, $nomid, $type, $invoiceid)
	{
				
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		$this->pass->delete(array("where"=>array('NOMID' => $nomid, 'INVOICETYPE' => $type, 'INVOICEID' => $invoiceid)));
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		$noofincoice = $this->pass->first(array("select"=>"count(*) as COUNT1","where"=>array('NOMID' => $nomid, 'INVOICETYPE' => $type)));	
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$fixture_status_arr = (strtoupper($type) === strtoupper('Freight') && $noofincoice->COUNT1==0) ? array('NOMSTATUS' => 2) : array('NOMSTATUS' => 3);
		return self::_flashAndRedirectAllWithAlertArray(
										(strtoupper($type) === strtoupper('Others') || $noofincoice->COUNT1!=0) 
												? TRUE
												: $this->pass->updateWhere($fixture_status_arr, array("where"=>array('NOMID'=>$nomid))) ,
									   "$type Invoice removed successfully.", 
									   "Sorry! there was an error while changing $type Invoice",
									   "operation/$redirect/{$gridStatus}/{$nomid}");
	}
	
	public function editcommissioninvoice($redirect, $gridStatus, $nomid)
	{
		$this->load->helper('dateFormat');
		$data 					= self::customized_ArrayByKey($this->input->post(),'m');
		$data['INVOICEDATE'] 	= formatedDate($data['INVOICEDATE1']);
		$data['ATTN'] 			= $data['ATTN1'];
		$data['INVOICENUMBER'] 	= $data['INVOICENUMBER1'];
		$data['TOTALCARGO'] 	= $data['TOTALCARGO1'];
		
		$invoiceID 				= $data['INVOICEID'];
		
		unset($data['INVOICEID']);unset($data['INVOICEDATE1']);unset($data['ATTN1']);unset($data['INVOICENUMBER1']);unset($data['TOTALCARGO1']);
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($invoiceID, $data) ,
									   'Invoice Details updated successfully.', 
									   'Sorry! there was an error while updating Invoice.',
									   "operation/$redirect/{$gridStatus}/{$nomid}");
		
	}
	
	public function editcommissioninvoiceothers($redirect, $gridStatus, $nomid)
	{
		$this->load->helper('dateFormat');
		$data 					= self::customized_ArrayByKey($this->input->post(),'m');
		$data['INVOICEDATE'] 	          = formatedDate($data['INVOICEDATE2']);
		$data['ATTN'] 			          = $data['ATTN2'];
		$data['INVOICENUMBER'] 	          = $data['INVOICENUMBER2'];
		$data['TAXRATE'] 	              = $data['TAXRATE2'];
		$data['GSTVALUE'] 	              = $data['GSTVALUE2'];
		$data['COMMISSIONWITHOUTTAX']     = $data['COMMISSIONVALUEWITHOUT2'];
		$data['COMMISSIONVALUE'] 	      = $data['COMMISSIONVALUE2'];
		
		$invoiceID 				          = $data['INVOICEID2'];
		
		unset($data['INVOICEID2']);unset($data['INVOICEDATE2']);unset($data['ATTN2']);unset($data['INVOICENUMBER2']);unset($data['COMMISSIONVALUE2']);unset($data['TAXRATE2']);unset($data['GSTVALUE2']);unset($data['COMMISSIONVALUEWITHOUT2']);
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($invoiceID, $data) ,
									   'Invoice Details updated successfully.', 
									   'Sorry! there was an error while updating Invoice.',
									   "operation/$redirect/{$gridStatus}/{$nomid}");
		
	}
	
	public function insert_payment($gridStatus, $invoice_type)
	{
		$this->load->helper('dateFormat');
		$data 			= self::customized_ArrayByKey($this->input->post(),'m');	
		
		if($invoice_type == 'Freight'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s1',$data['PID']);}
		if($invoice_type == 'Demurrage'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s2',$data['DID']);}
		if($invoice_type == 'Others'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s3',$data['OID']);}
		
		$alerts = [
						[
							'ALERTBY' 		=> $this->session->uid,
							'ALERTTO' 		=> 1,
							'ALERTTEXT'		=> $invoice_type.' Payment Received by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'admin/invoice/'.$gridStatus.'/'.$data['NOMID'],
							'ALERTTYPE'		=> 'Payment Received'
						 ],
						 [
						 	'ALERTBY'		=> $this->session->uid,
						 	'ALERTTO'		=> $data['CLAIMSLOGINID'],
							'ALERTTEXT'		=> $invoice_type.' Payment Received by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'claims/invoice/'.$gridStatus.'/'.$data['NOMID'],
							'ALERTTYPE'		=> 'Payment Received'
						 ]
					  ];

		$this->pass->setTable(array('payment_received','PAYMENTID'));
		$this->pass->delete(array("where"=>array('NOMID' => $data['NOMID'], 'INVOICETYPE' => $invoice_type)));
		
		for($i=1;$i<=count($slave_data);$i++):
			if($slave_data[$i]['PAYMENTDATE'] != "" && $slave_data[$i]['RCVDAMOUNT'] != ""):
				$slave_data[$i]['PAYMENTDATE'] = formatedDate($slave_data[$i]['PAYMENTDATE']);
				$this->pass->insert($slave_data[$i]);
			endif;
		endfor;
		
		$fixture_status_arr = (strtoupper($invoice_type) === strtoupper('Freight')) ? array('NOMSTATUS' => 5) : array('NOMSTATUS' => 6);
		
		$this->pass->setTable(array('nom_details','NOMID'));
		return self::_flashAndRedirectAllWithAlertArray(
										(strtoupper($invoice_type) === strtoupper('Others')) 
												? TRUE
												: $this->pass->update($data['NOMID'], $fixture_status_arr),
									   $invoice_type.' Payment Received ('.$data['NOMINATIONID'].') successfully.', 
									   'Sorry! there was an error while receiving Payment.',
									   'operation/'.(($gridStatus == 1) ? 'opsatglance' : 'postopsatglance'),$alerts);

	}
	//..........................ends here ...........................................
	
	
	//............for fleet............................
	public function fleet()
	{
		$this->data['nav'] = 6;
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('operation/fleet',$this->data);
	}

	public function add_fleet()
	{
		$this->data['nav'] = 6;

		$this->data['vessel_type_list'] 	= $this->pass->getVesselTypeList();
		$this->data['hull_type_list'] 		= $this->pass->getHullTypeList();

								 set_includes(array(DATEPICKER,NUMERIC,SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('operation/add_fleet',$this->data);
	}
	
	public function insert_fleet()
	{
		$this->load->library('form_validation');
		$this->load->helper('dateFormat');
		$this->form_validation->set_rules('m_VESSELNAME', 'Vessel Name','is_unique[vessel_imo_master.VESSELNAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');

			$data['ADDONDATE'] 	    = date("Y-m-d",time());	
			$data['REGISTERYDATE']  = !empty($data['REGISTERYDATE']) ? formatedDate($data['REGISTERYDATE'],'Y-m-d') : '0000-00-00';
			$data['KEELLAIDDATE']   = !empty($data['KEELLAIDDATE']) ? formatedDate($data['KEELLAIDDATE'],'Y-m-d') : '0000-00-00';

			$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Fleet added successfully.', 
									   'Sorry! there was an error while adding Fleet.',
									   'operation/fleet');			
		}
		else
		{
			self::add_fleet();
		}
	}

	public function edit_fleet($id)
	{
		$this->data['nav'] = 6;
		$this->load->helper('dateFormat');

		$this->data['vessel_type_list'] 	= $this->pass->getVesselTypeList();
		$this->data['hull_type_list'] 		= $this->pass->getHullTypeList();

		$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
		$this->data['fleet'] = $this->pass->find_by_pk($id);

								 set_includes(array(DATEPICKER,NUMERIC,SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('operation/edit_fleet',$this->data);		
	}

	public function update_fleet($id)
	{
		$this->load->helper('dateFormat');
		
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		$data['REGISTERYDATE']  = !empty($data['REGISTERYDATE']) ? formatedDate($data['REGISTERYDATE'],'Y-m-d') : '0000-00-00';
		$data['KEELLAIDDATE']   = !empty($data['KEELLAIDDATE']) ? formatedDate($data['KEELLAIDDATE'],'Y-m-d') : '0000-00-00';	
		
		$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Fleet updated successfully.', 
									   'Sorry! there was an error while updating Fleet.',
									   'operation/fleet');		
	}
	//..................ends here.......................


	//..................report.............................
	public function invoice_detail_report($selinvoice=0,$startDate='',$endDate='')
	{

	    $this->load->helper('dateFormat');
	    $this->data['invoice_list'] 	 = $this->pass->getInvoiceList();
        $this->data['nav'] = 5;

	   $whereArr = (trim($startDate) != "" && trim($endDate) != "") ? array('INVOICEDATE >=' => trim($startDate),'INVOICEDATE <=' => trim($endDate)) : array(1 => 1);

	   if($selinvoice !=0) : $whereArr['INVOICETYPE'] = $selinvoice; endif;

		$this->data['dateRange'] = (trim($startDate) != "" && trim($endDate) != "") ? formatedDate($startDate, "d/m/Y")." - ".formatedDate($endDate, "d/m/Y") : '';

		$this->data['startdate'] = (trim($startDate) != "" && trim($endDate) != "") ? formatedDate($startDate, "Y-m-d"): '';

		$this->data['enddate']   = (trim($endDate) != "" && trim($startDate) != "") ? formatedDate($endDate, "Y-m-d"): '';

		$this->data['selinvoice'] = (trim($selinvoice) != 0) ? $selinvoice : '';
		 
		 $this->pass->setTable(array('invoice_master','INVOICEID'));
		// $nom = $this->pass->all(array("select"=>"* ", "where"=>$whereArr, "order_by"=>array('NOMID'=>'DESC') ));


		$nom = $this->pass->all(array("select"=>"invoice_master.NOMID, nom_details.FIXTURETYPE, (CASE WHEN FIXTURETYPE = 1 THEN 'Voyage Spot' WHEN FIXTURETYPE = 2 THEN 'Time Charter' ELSE 'COA'  END) as FIXTURETYPENAME, NOMINATIONID,ADDEDBY,INVOICETYPE, RESPONSIBLE, ESTMINCOMMISSION,COMMISSIONVALUE, LAYCANSTART, LAYCANEND, ADDONDATE, LUMPSUMFREIGHT, BLFIG,INVOICEDATE, OWNER_CONTACT_DETAILS,ACTUALDAYS,OFFHIREDAY, nom_details.REMARKS as REMARKS2, NOMINATIONID, CHARTERER_CONTACT_DETAILS,CPQUNTITYMAX, CPQUNTITYMIN, COMMISSIONVALUE, nom_details.CPDATE, FIXTURE_STATUS,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Deviation' ELSE 'Other' END) as INVOICENOTENAME, (select VESSELNAME from vessel_imo_master where vessel_imo_master.VESSELIMOID=nom_details.FLEETID) as FLEETNAME, (select FI_RECEIVED from summary where summary.NOMID=nom_details.NOMID) as FIRECDATE,(select FI_PAID from summary where summary.NOMID=nom_details.NOMID) as FIPAIDDATE,(select FFI_RECEIVED from summary where summary.NOMID=nom_details.NOMID) as FFIRECV,(select FFI_PAID from summary where summary.NOMID=nom_details.NOMID) as FFIPAID, (select SUM(RCVDAMOUNT) as RCVDAMOUNT from payment_received where payment_received.NOMID=invoice_master.NOMID and payment_received.INVOICETYPE=invoice_master.INVOICETYPE) as PAYMENTAMT,(select VESSEL_ARRIVED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='LP') as LPVESSELARIVED, (select VESSEL_ARRIVED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='DP') as DPVESSELARIVED, (select LOAD_DIS_COMPLETED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='LP') as LPCOMPLITDATE, (select LOAD_DIS_COMPLETED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='DP') as DPCOMPLED, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMNAME  ,(select  GROUP_CONCAT(BROKERID SEPARATOR ', ') from nom_details_slave where nom_details_slave.NOMID = nom_details.NOMID ) as BROKERID, (case when (NOMSTATUS = 1) THEN '<small class=\"label label-warning\">Fixture Created</small>' when (NOMSTATUS = 2) THEN '<small class=\"label label-success\">Sent to Ops & Claims</small>' when (NOMSTATUS = 3) THEN '<small class=\"label label-danger\" >Freight Paid</small>' when (NOMSTATUS = 4) THEN '<small class=\"label label-danger\" >Demurrage Paid</small>' when (NOMSTATUS = 5) THEN '<small class=\"label label-primary\">Commission on Freight Received</small>' when (NOMSTATUS = 6) THEN '<small class=\"label label-primary\">Commission on Demurrage Received</small>' ELSE '' END) as NOMSTATUSNAME",'join'=>array('nom_details'=>'nom_details.NOMID = invoice_master.NOMID'),"where_str"=>$whereArr, 'order_by'=>array('NOMID'=>'DESC')));

		 $this->pass->setTable(array('nom_details','NOMID'));

		$nom2 = $this->pass->all(array("select"=>"nom_details.NOMID, nom_details.FIXTURETYPE, (CASE WHEN FIXTURETYPE = 1 THEN 'Voyage Spot' WHEN FIXTURETYPE = 2 THEN 'Time Charter' ELSE 'COA'  END) as FIXTURETYPENAME, NOMINATIONID,ADDEDBY,RESPONSIBLE,NOMSTATUS,  ESTMINCOMMISSION, LAYCANSTART, LAYCANEND, ADDONDATE, LUMPSUMFREIGHT, BLFIG, OWNER_CONTACT_DETAILS,ACTUALDAYS,OFFHIREDAY, nom_details.REMARKS as REMARKS2, NOMINATIONID, CHARTERER_CONTACT_DETAILS,CPQUNTITYMAX, CPQUNTITYMIN,  nom_details.CPDATE, FIXTURE_STATUS, (select VESSELNAME from vessel_imo_master where vessel_imo_master.VESSELIMOID=nom_details.FLEETID) as FLEETNAME, (select FI_RECEIVED from summary_slave where summary_slave.NOMID=nom_details.NOMID) as FIRECDATE,(select FI_PAID from summary_slave where summary_slave.NOMID=nom_details.NOMID) as FIPAIDDATE,(select FFI_RECEIVED from summary_slave where summary_slave.NOMID=nom_details.NOMID) as FFIRECV,(select FFI_PAID from summary_slave where summary_slave.NOMID=nom_details.NOMID) as FFIPAID, (select VESSEL_ARRIVED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='LP') as LPVESSELARIVED, (select VESSEL_ARRIVED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='DP') as DPVESSELARIVED, (select LOAD_DIS_COMPLETED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='LP') as LPCOMPLITDATE, (select LOAD_DIS_COMPLETED from laytime_master where laytime_master.NOMID=nom_details.NOMID AND laytime_master.PORT='DP') as DPCOMPLED, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMNAME  ,(select  GROUP_CONCAT(BROKERID SEPARATOR ', ') from nom_details_slave where nom_details_slave.NOMID = nom_details.NOMID ) as BROKERID, (case when (NOMSTATUS = 1) THEN '<small class=\"label label-warning\">Fixture Created</small>' when (NOMSTATUS = 2) THEN '<small class=\"label label-success\">Sent to Ops & Claims</small>' when (NOMSTATUS = 3) THEN '<small class=\"label label-danger\" >Freight Paid</small>' when (NOMSTATUS = 4) THEN '<small class=\"label label-danger\" >Demurrage Paid</small>' when (NOMSTATUS = 5) THEN '<small class=\"label label-primary\">Commission on Freight Received</small>' when (NOMSTATUS = 6) THEN '<small class=\"label label-primary\">Commission on Demurrage Received</small>' ELSE '' END) as NOMSTATUSNAME","where_str"=>$whereArr, 'order_by'=>array('NOMID'=>'DESC')));


	
		if( $nom ){

			foreach($nom as $nomData){


				$this->data['nom'][] = array(


					'PARTYNAME' => self::getNOMMasterData($nomData->NOMID,'OWNER'),

					'CHARTERPARY' =>self::getNOMMasterData($nomData->NOMID,'VENDORID'),

					'VESSELNAE' => self::getNOMMasterData($nomData->NOMID,'FLEETID'),

					'CARGO' => self::getNOMMasterData($nomData->NOMID,'CARGOID'),

					'INVOICENO' => $nomData->NOMINATIONID,					
					'INVOTYPE' => $nomData->FIXTURETYPENAME,
					'NOMSTATUSNAME' => $nomData->NOMSTATUSNAME,
					'ADDEDBY' => $nomData->ADDEDBY,
					'INVOICETYPE' => $nomData->INVOICETYPE,
					'RESPONSIBLE' => $nomData->RESPONSIBLE,
					'NOMSTATUS' => $nomData->NOMSTATUS,

					'ADDONDATE' => $nomData->ADDONDATE,
					'LAYCAN' => $nomData->LAYCANSTART,
					'LAYCANEND' => $nomData->LAYCANEND,
					'FIXTURE' => $nomData->FIXTUREDATE,
					'BLQTY' => $nomData->BLFIG,
					'ONERDETAIL' => $nomData->OWNER_CONTACT_DETAILS,
					'CHTERDATAIL' => $nomData->CHARTERER_CONTACT_DETAILS,
					'CPQTY' => $nomData->CPQUNTITYMIN,
					'CPMAX' => $nomData->CPQUNTITYMAX,
					'LUMPSUMFREIGHT' => $nomData->LUMPSUMFREIGHT,
					
					'CUNTRY' => self::getNOMMasterData($nomData->NOMID,'LPORT'),
					'CUNTRY' => self::getNOMMasterData($nomData->NOMID,'DPORT'),	

					'POSRTID' => self::getNOMMasterData($nomData->NOMID,'LPORT'),	
					'POSRTID' => self::getNOMMasterData($nomData->NOMID,'DPORT'),	

					'REMARKS' => $nomData->REMARKS2,

					'FIRECDATE' => $nomData->FIRECDATE,
					'FIPAIDDATE' => $nomData->FIPAIDDATE,
					'FFIRECV' => $nomData->FFIRECV,
					'FFIPAID' => $nomData->FFIPAID,

					'LPVESSELARIVED' => $nomData->LPVESSELARIVED,
					'DPVESSELARIVED' => $nomData->DPVESSELARIVED,
					'LPCOMPLITDATE' => $nomData->LPCOMPLITDATE,
					'DPCOMPLED' => $nomData->DPCOMPLED,

					$actday = $nomData->ACTUALDAYS,
					$offhir= $nomData->OFFHIREDAY,


					'OFFDAY' => $actday-$offhir,

                    'COMPANYNAME' => $nomData->COMNAME,
					//'FIRECIEDRECIV' => self::getNOMMasterData($nomData->NOMID,'FI_RECEIVED'),					

					 'PAIDPAYMENT' => $nomData->PAYMENTAMT,
                   
                     $totaldata = $nomData->COMMISSIONVALUE,
                     
					 'TOTALDATA' => $totaldata,

					$gstval = $nomData->GSTVALUE,
					$basicval= $nomData->COMMISSIONWITHOUTTAX,

                    'TOTELVALU' => $gstval+$basicval,

                     'BROKERID' => self::GETbrokeridinthis($nomData->NOMID,'BROKERID'),	

                      

					// 'LAYCANSTART' => $nomData->LAYCANSTART
					// 'LAYCANEND' => $nomData->LAYCANEND


				);			

			}

			foreach($nom2 as $nomData){


				$this->data['nom'][] = array(


					'PARTYNAME' => self::getNOMMasterData($nomData->NOMID,'OWNER'),

					'CHARTERPARY' =>self::getNOMMasterData($nomData->NOMID,'VENDORID'),

					'VESSELNAE' => self::getNOMMasterData($nomData->NOMID,'FLEETID'),

					'CARGO' => self::getNOMMasterData($nomData->NOMID,'CARGOID'),
					'RESPONSIBLE' => $nomData->RESPONSIBLE,

					'INVOICENO' => $nomData->NOMINATIONID,					
					'INVOTYPE' => $nomData->FIXTURETYPENAME,
					'NOMSTATUSNAME' => $nomData->NOMSTATUSNAME,
					'ADDEDBY' => $nomData->ADDEDBY,
					'NOMSTATUS' => $nomData->NOMSTATUS,
					'INVOICETYPE' => $nomData->INVOICETYPE,

					'ADDONDATE' => $nomData->ADDONDATE,
					'LAYCAN' => $nomData->LAYCANSTART,
					'LAYCANEND' => $nomData->LAYCANEND,
					'FIXTURE' => $nomData->FIXTUREDATE,
					'BLQTY' => $nomData->BLFIG,
					'ONERDETAIL' => $nomData->OWNER_CONTACT_DETAILS,
					'CHTERDATAIL' => $nomData->CHARTERER_CONTACT_DETAILS,
					'CPQTY' => $nomData->CPQUNTITYMIN,
					'CPMAX' => $nomData->CPQUNTITYMAX,
					'LUMPSUMFREIGHT' => $nomData->LUMPSUMFREIGHT,
					
					'CUNTRY' => self::getNOMMasterData($nomData->NOMID,'LPORT'),
					'CUNTRY' => self::getNOMMasterData($nomData->NOMID,'DPORT'),	

					'POSRTID' => self::getNOMMasterData($nomData->NOMID,'LPORT'),	
					'POSRTID' => self::getNOMMasterData($nomData->NOMID,'DPORT'),	

					'REMARKS' => $nomData->REMARKS2,

					'FIRECDATE' => $nomData->FIRECDATE,
					'FIPAIDDATE' => $nomData->FIPAIDDATE,
					'FFIRECV' => $nomData->FFIRECV,
					'FFIPAID' => $nomData->FFIPAID,

					'LPVESSELARIVED' => $nomData->LPVESSELARIVED,
					'DPVESSELARIVED' => $nomData->DPVESSELARIVED,
					'LPCOMPLITDATE' => $nomData->LPCOMPLITDATE,
					'DPCOMPLED' => $nomData->DPCOMPLED,

					$actday = $nomData->ACTUALDAYS,
					$offhir= $nomData->OFFHIREDAY,


					'OFFDAY' => $actday-$offhir,

                    'COMPANYNAME' => $nomData->COMNAME,
					//'FIRECIEDRECIV' => self::getNOMMasterData($nomData->NOMID,'FI_RECEIVED'),					

					 'PAIDPAYMENT' => $nomData->PAYMENTAMT,
                   
                     $totaldata = $nomData->COMMISSIONVALUE,
                     
					 'TOTALDATA' => $totaldata,

					$gstval = $nomData->GSTVALUE,
					$basicval= $nomData->COMMISSIONWITHOUTTAX,

                    'TOTELVALU' => $gstval+$basicval,

                     'BROKERID' => self::GETbrokeridinthis($nomData->NOMID,'BROKERID'),	
                     'ESTMAT' => $nomData->ESTMINCOMMISSION,

					// 'LAYCANSTART' => $nomData->LAYCANSTART
					// 'LAYCANEND' => $nomData->LAYCANEND


				);			

			}

		}else{$this->data['nom'] = array();}

		//print_r($this->data['nom']);

								 set_includes(array(DATATABLES, DATERANGEPICKER, TABLE_2_EXCEL));

		$this->data['include'] = include_file_batch();

								 view('operation/invoiceReport',$this->data);
	}

private function getNOMMasterData($nomid,$field)

	{
	$this->pass->setTable(array('nom_details','NOMID'));

	return $this->pass->all(array("select"=>"(select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as VESSELNAME, (select VENDORNAME from vendor_master where VENDORID=OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as CARTERPARTY,(select NAME from cargo_master where cargo_master.CARGOID=nom_details.CARGOID) as NAME, (select PORTNAME from port_master where PORTID=LPORT) as LPPORTNAME, (select PORTNAME from port_master where PORTID=DPORT) as DPPORTNAME, (select COUNTRYNAME from port_master where PORTID=LPORT) as LPCOUNTRYNAME,(select COUNTRYNAME from port_master where PORTID=DPORT) as DPCOUNTRYNAME, CPDATE", "where"=>array('NOMID'=>$nomid) ));

	}
	private function GETbrokeridinthis($nomid,$field)

	{
	 $this->pass->setTable(array('nom_details_slave','SLAVEID'));

	

	return $this->pass->all(array("select"=>"(select GROUP_CONCAT(NAME SEPARATOR ', ')  from broker_master where broker_master.BROKERID=nom_details_slave.BROKERID) as NAME", "where"=>array('NOMID'=>$nomid) ));

	}
		

}
?>