<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/
$route['default_controller'] = 'login';
$route['404_override'] = 'errors';
$route['translate_uri_dashes'] = TRUE;

$route['operation/opsatglance'] = 'operation/opsatglance/1';
$route['operation/postopsatglance'] = 'operation/opsatglance/2';
$route['operation/history'] = 'operation/opsatglance/3';

$route['admin/opsatglance'] = 'admin/opsatglance/1';
$route['admin/postopsatglance'] = 'admin/opsatglance/2';
$route['admin/history'] = 'admin/opsatglance/3';

$route['claims/opsatglance'] = 'claims/opsatglance/1';
$route['claims/postopsatglance'] = 'claims/opsatglance/2';
$route['claims/history'] = 'claims/opsatglance/3';

$route['operation/invoiceVoyage/(:num)/(:num)'] = 'operation/invoice-time/$1/$2/voyage';
$route['operation/invoiceTime/(:num)/(:num)'] = 'operation/invoice-time/$1/$2/time';
$route['operation/insert-invoiceVoyage/(:num)/(:any)'] = 'operation/insert-invoice-time/$1/$2/voyage';
$route['operation/insert-invoiceTime/(:num)/(:any)'] = 'operation/insert-invoice-time/$1/$2/time';

$route['admin/voyages-in-book'] = 'admin/voyage-status-report/1';
$route['admin/voyages-in-progress'] = 'admin/voyage-status-report/2';
$route['admin/completed-voyages'] = 'admin/voyage-status-report/3';


$route['claims/voyages-in-book'] = 'claims/voyage-status-report/1';
$route['claims/voyages-in-progress'] = 'claims/voyage-status-report/2';
$route['claims/completed-voyages'] = 'claims/voyage-status-report/3';