<?php
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');
class Admin extends MY_controller {	

	private $header  = 'header';
	private $sidebar = 'sidebar';
	private $footer  = 'footer';

	public function __construct()
	{
		parent::__construct();
		if(!$this->session->has_userdata('uid'))
			return redirect('login');

		if( $this->session->has_userdata('otype') || $this->session->has_userdata('ctype'))
			return self::logout();
			
		$this->load->helper('form');
		//.....................set default css and js for output.........................
		set_includes(array(BASIC_CSS, BASIC_JS, NOTIFY, APP, TIMER, SESSION_TIMEOUT));		
		set_header($this->header); 	set_sidebar($this->sidebar); 	set_footer($this->footer);
	   //............................ends here.........................................
	}

	public function index()
	{
		self::dashboard();
	}

	public function dashboard() 
	{
		$this->data['nav'] = 1;
								 set_includes(array(NUMERIC,SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/dashboard',$this->data);
	}
	
	public function insert_invoice_due()
	{
			$data = self::customized_ArrayByKey($this->input->post(),'m');
			$this->pass->setTable(array('login','LOGINID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->update($this->session->uid, $data) ,
									   'Invoice Due and Threshold Days updated successfully.', 
									   'Sorry! there was an error while updated Invoice Days.',
									   'admin/dashboard');			
	}
	//............for fleet............................
	public function fleet()
	{
		$this->data['nav'] = 2;
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/fleet',$this->data);
	}

	public function add_fleet()
	{
		$this->data['nav'] = 2;

		$this->data['vessel_type_list'] 	= $this->pass->getVesselTypeList();
		$this->data['hull_type_list'] 		= $this->pass->getHullTypeList();

								 set_includes(array(DATEPICKER,NUMERIC,SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_fleet',$this->data);
	}
	
	public function insert_fleet()
	{
		$this->load->library('form_validation');
		$this->load->helper('dateFormat');
		$this->form_validation->set_rules('m_VESSELNAME', 'Vessel Name','is_unique[vessel_imo_master.VESSELNAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');

			$data['ADDONDATE'] 	    = date("Y-m-d",time());	
			$data['REGISTERYDATE']  = !empty($data['REGISTERYDATE']) ? formatedDate($data['REGISTERYDATE'],'Y-m-d') : '0000-00-00';
			$data['KEELLAIDDATE']   = !empty($data['KEELLAIDDATE']) ? formatedDate($data['KEELLAIDDATE'],'Y-m-d') : '0000-00-00';

			$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Fleet added successfully.', 
									   'Sorry! there was an error while adding Fleet.',
									   'admin/fleet');			
		}
		else
		{
			self::add_fleet();
		}
	}

	public function edit_fleet($id)
	{
		$this->data['nav'] = 2;
		$this->load->helper('dateFormat');

		$this->data['vessel_type_list'] 	= $this->pass->getVesselTypeList();
		$this->data['hull_type_list'] 		= $this->pass->getHullTypeList();

		$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
		$this->data['fleet'] = $this->pass->find_by_pk($id);

								 set_includes(array(DATEPICKER,NUMERIC,SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_fleet',$this->data);		
	}

	public function update_fleet($id)
	{
		$this->load->helper('dateFormat');
		
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		$data['REGISTERYDATE']  = !empty($data['REGISTERYDATE']) ? formatedDate($data['REGISTERYDATE'],'Y-m-d') : '0000-00-00';
		$data['KEELLAIDDATE']   = !empty($data['KEELLAIDDATE']) ? formatedDate($data['KEELLAIDDATE'],'Y-m-d') : '0000-00-00';	
		
		$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Fleet updated successfully.', 
									   'Sorry! there was an error while updating Fleet.',
									   'admin/fleet');		
	}
	//..................ends here.......................
	//............for user creation............................
	
	public function user()
	{
		$this->data['nav'] = 3;
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/user_list',$this->data);
	}

	public function add_user()
	{
		$this->data['nav'] = 3;

		$this->data['user_type_list'] = $this->pass->getUserTypeList();
		$this->data['status_list'] = $this->pass->getUserStatusList();
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_user',$this->data);
	}

	public function insert_user()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_USERNAME', 'Username','is_unique[login.USERNAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');				
			unset($data['CPASSWORD']);

			$this->pass->setTable(array('login','LOGINID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'User added successfully.', 
									   'Sorry! there was an error while adding User.',
									   'admin/user');			
		}
		else
		{
			self::add_user();
		}
	}

	public function edit_user($id)
	{
		$this->data['nav'] = 3;

		$this->data['user_type_list'] = $this->pass->getUserTypeList();
		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('login','LOGINID'));
		$this->data['user_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_user',$this->data);
	}

	public function update_user($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		unset($data['CPASSWORD']);	
		
		$this->pass->setTable(array('login','LOGINID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'User updated successfully.', 
									   'Sorry! there was an error while updating User.',
									   'admin/user');		
	}
	//.......................ends here .......................................................
	//................... banking details ...................................................
	public function banking_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/banking_list',$this->data);
	}

	public function add_bank()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_bank',$this->data);		
	}

	public function insert_bank()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_ACCOUNT_NUMBER', 'Account Number','is_unique[bank_master.ACCOUNT_NUMBER]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');
			$this->pass->setTable(array('bank_master','BANKID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Bank Details added successfully.', 
									   'Sorry! there was an error while adding Bank Details.',
									   'admin/banking-list');			
		}
		else
		{
			self::add_bank();
		}
	}

	public function edit_bank($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('bank_master','BANKID'));
		$this->data['bank_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_bank',$this->data);			
	}

	public function update_bank($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		$this->pass->setTable(array('bank_master','BANKID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Bank Details updated successfully.', 
									   'Sorry! there was an error while updating Bank Details.',
									   'admin/banking-list');		
	}

	//....................... ends here ........................................................

	//................... cargo details ...................................................
	public function cargo_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/cargo_list',$this->data);
	}

	public function add_cargo()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_cargo',$this->data);
		
	}

	public function insert_cargo()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_NAME', 'Cargo Name','is_unique[cargo_master.NAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');

			$this->pass->setTable(array('cargo_master','CARGOID'));	
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Cargo added successfully.', 
									   'Sorry! there was an error while adding Cargo.',
									   'admin/cargo-list');			
		}
		else
		{
			self::add_cargo();
		}
	}

	public function edit_cargo($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('cargo_master','CARGOID'));	
		$this->data['cargo_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_cargo',$this->data);		
	}

	public function update_cargo($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('cargo_master','CARGOID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Cargo updated successfully.', 
									   'Sorry! there was an error while updating Cargo.',
									   'admin/cargo-list');		
	}
	//....................... ends here ........................................................

	//................... port details ...................................................
	public function port_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/port_list',$this->data);
	}
	
	public function add_port()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,NUMERIC,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_port',$this->data);
		
	}
	
	public function insert_port()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('port_master','PORTID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Port added successfully.', 
									   'Sorry! there was an error while adding Port.',
									   'admin/port-list');	
	}
	
	public function edit_port($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('port_master','PORTID'));
		$this->data['port_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,NUMERIC,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_port',$this->data);		
	}
	
	public function update_port($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('port_master','PORTID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Port updated successfully.', 
									   'Sorry! there was an error while updating Port.',
									   'admin/port-list');			
	}
	//....................... ends here ........................................................

	//................... vendor details ...................................................
	public function vendor_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/vendor_list',$this->data);
	}
	
	public function add_vendor()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();
		$this->data['vendor_type_list'] = $this->pass->getVendorTypeList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_vendor',$this->data);
		
	}
	
	public function insert_vendor()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vendor_master','VENDORID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Vendor added successfully.', 
									   'Sorry! there was an error while adding Vendor.',
									   'admin/vendor-list');	
	}
	
	public function edit_vendor($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();
		$this->data['vendor_type_list'] = $this->pass->getVendorTypeList();

		$this->pass->setTable(array('vendor_master','VENDORID'));
		$this->data['vendor_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_vendor',$this->data);		
	}
	
	public function update_vendor($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vendor_master','VENDORID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									    'Vendor updated successfully.', 
									   'Sorry! there was an error while updating Vendor.',
									   'admin/vendor-list');			
	}
	
	//....................... ends here ........................................................

	//................... vendor type details ...................................................
	public function vendor_type_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/vendor_type_list',$this->data);
	}
	
	public function add_vendor_type()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_vendor_type',$this->data);
		
	}
	
	public function insert_vendor_type()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vendor_type_master','VENDOR_TYPEID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Vendor Type added successfully.', 
									   'Sorry! there was an error while adding Vendor Type.',
									   'admin/vendor-type-list');	
	}
	
	public function edit_vendor_type($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('vendor_type_master','VENDOR_TYPEID'));	
		$this->data['vtype_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_vendor_type',$this->data);		
	}
	
	public function update_vendor_type($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vendor_type_master','VENDOR_TYPEID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Vendor Type updated successfully.', 
									   'Sorry! there was an error while updating Vendor Type.',
									   'admin/vendor-type-list');			
	}
	
	//....................... ends here ........................................................

	//................... vessel type details ...................................................
	public function vessel_type_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/vessel_type_list',$this->data);
	}
	
	public function add_vessel_type()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_vessel_type',$this->data);
		
	}
	
	public function insert_vessel_type()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vessel_type_master','VESSELTYPEID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Vessel Type added successfully.', 
									   'Sorry! there was an error while adding Vessel Type.',
									   'admin/vessel-type-list');		
	}
	
	public function edit_vessel_type($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('vessel_type_master','VESSELTYPEID'));
		$this->data['vtype_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_vessel_type',$this->data);		
	}
	
	public function update_vessel_type($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vessel_type_master','VESSELTYPEID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Vessel Type updated successfully.', 
									   'Sorry! there was an error while updating Vessel Type.',
									   'admin/vessel-type-list');			
	}
	//....................... ends here ........................................................

	//................... broker details ...................................................
	public function broker_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/broker_list',$this->data);
	}
	
	public function add_broker()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_broker',$this->data);
		
	}
	
	public function insert_broker()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_NAME', 'Broker Name','is_unique[broker_master.NAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');

			$this->pass->setTable(array('broker_master','BROKERID'));	
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Broker added successfully.', 
									   'Sorry! there was an error while adding Broker.',
									   'admin/broker-list');			
		}
		else
		{
			self::add_broker();
		}
	}
	
	public function edit_broker($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('broker_master','BROKERID'));	
		$this->data['broker'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_broker',$this->data);		
	}
	
	public function update_broker($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('broker_master','BROKERID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Broker updated successfully.', 
									   'Sorry! there was an error while updating Broker.',
									   'admin/broker-list');			
	}
	//....................... ends here ........................................................
	//............for opsatglance............................
	public function opsatglance($gridStatus = 1)
	{
		$this->data['gridStatus'] =  $gridStatus;
		$this->data['nav'] = ($gridStatus == 1) ? 5 : (($gridStatus == 2) ? 6 : 7);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID,SWEET_ALERT,DATEPICKER,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/opsatglance',$this->data);
	}
	
	public function view_fixture($gridStatus = 1, $nomid)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] = ($gridStatus == 1) ? 5 : (($gridStatus == 2) ? 6 : 7);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' ELSE 'Time Charter' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('cargo_master','CARGOID')));
		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('nom_details_slave','SLAVEID'));
		$this->data['slave'] = $this->pass->all(array("select"=>"*, (select NAME from broker_master where broker_master.BROKERID=nom_details_slave.BROKERID) as BROKERNAME","where"=>array('NOMID'=>$nomid)));
								 
		$this->data['include'] = include_file_batch();
								 view('admin/view_fixture',$this->data);
	}
	
	public function invoice($gridStatus = 1, $nomid)
	{
		$this->load->helper(['dateFormat','array']);
		$this->load->library("numbertowordconversion");
		$this->data['nav'] = ($gridStatus == 1) ? 5 : (($gridStatus == 2) ? 6 : 7);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' ELSE 'Time Charter' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME, (select VENDORADDRESS1 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS1, (select VENDORADDRESS2 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS2, (select VENDORADDRESS3 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS3 , (select VENDORADDRESS4 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS4","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>" , ","table"=>array('cargo_master','CARGOID')));
		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>", ","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>", ","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));	
		$this->data['f_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_demu_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));		
		$this->data['o_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Deviation' WHEN (INVOICENOTE = 4) THEN CONCAT('Others ( ', INVOICENOTEOTHER, ' )') ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('payment_received','PAYMENTID'));
		$this->data['f_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));	
		$this->data['o_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('summary','SUMMARYID'));
		$this->data['f_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));
		$this->data['o_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
								 set_includes(array(CALC)); 
		$this->data['include'] = include_file_batch();
								 view('admin/invoice',$this->data);
	}
	//....................... ends here ........................................................
	//................... cp form type list details ...................................................
	public function cp_form_type_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/cp_form_type_list',$this->data);
	}

	public function add_cp_form_type()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_cp_form_type',$this->data);		
	}

	public function insert_cp_form_type()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_NAME', 'CP Form Type Name','is_unique[cp_form_type_master.NAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');
			$this->pass->setTable(array('cp_form_type_master','CPID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'CP Form Type added successfully.', 
									   'Sorry! there was an error while adding CP Form Type.',
									   'admin/cp-form-type-list');			
		}
		else
		{
			self::add_cp_form_type();
		}
	}

	public function edit_cp_form_type($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('cp_form_type_master','CPID'));
		$this->data['cp_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_cp_form_type',$this->data);			
	}

	public function update_cp_form_type($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		$this->pass->setTable(array('cp_form_type_master','CPID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'CP Form Type updated successfully.', 
									   'Sorry! there was an error while updating CP Form Type.',
									   'admin/cp-form-type-list');		
	}
	//....................... ends here ........................................................
	//................... cp form type list details ...................................................
	public function voyage_status_report($status)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] 	   		= 9;
		$this->data['status'] 	    = $status;
		$this->data['label'] 	    = ($status == 1) ? 'Voyages in Book' : (($status == 2) ? 'Voyages in Progress' : 'Completed Voyages');
								 set_includes(array(DATATABLES, DT_BUTTONS, PRINTGRID, FIXED_COLUMN));
		$this->data['include'] = include_file_batch();
								 view('admin/voyage_status_report',$this->data);
	}
	//....................... ends here ........................................................
	
	
	//................... vendor type details ...................................................
	/*public function status_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/status_list',$this->data);
	}
	
	public function add_status()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_status',$this->data);
		
	}
	
	public function insert_status()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('status_master','STATUSID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Status added successfully.', 
									   'Sorry! there was an error while adding Status.',
									   'admin/status-list');	
	}
	
	public function edit_status($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('status_master','STATUSID'));	
		$this->data['statusdata'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_status',$this->data);		
	}
	
	public function update_status($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('status_master','STATUSID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Status updated successfully.', 
									   'Sorry! there was an error while updating Status.',
									   'admin/status-list');			
	}*/
	
	//....................... ends here ........................................................

}
?>