<?php
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');
class Operation extends MY_controller {	

	private $header  = 'header';
	private $sidebar = 'sidebar';
	private $footer  = 'footer';

	public function __construct()
	{
		parent::__construct();
		if(!$this->session->has_userdata('uid'))
			return redirect('login');

		if( $this->session->has_userdata('atype') || $this->session->has_userdata('ctype'))
			return self::logout();
			
		$this->load->helper('form');
		//.....................set default css and js for output.........................
		set_includes(array(BASIC_CSS, BASIC_JS, NOTIFY, APP, TIMER, SESSION_TIMEOUT));		
		set_header($this->header); 	set_sidebar($this->sidebar); 	set_footer($this->footer);
	   //............................ends here.........................................
	}

	public function index()
	{
		self::dashboard();
	}

	public function dashboard() 
	{
		$this->data['nav'] = 1;
		$this->pass->setTable(array('login','LOGINID'));
		$invoiceduedata = $this->pass->first(array("select"=>"*","where"=>array("USERTYPE"=>'admin')));
		$arrdays = array();
		
		$arrdays[] = $freightdays = $invoiceduedata->FRTDUEDAYS + $invoiceduedata->FRTTHRESHOLDDAYS;
		$arrdays[] = $hiredays = $invoiceduedata->HIREDUEDAYS + $invoiceduedata->HIRETHRESHOLDDAYS;
		$arrdays[] = $demuragedays =  $invoiceduedata->DEMUDUEDAYS + $invoiceduedata->DEMUTHRESHOLDDAYS;
		
		rsort($arrdays);
		
		$duedate = date("Y-m-d", strtotime("-".$arrdays[0]." days"));
		//echo $duedate;die;
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		$invoicealerts = array();
		$invoice_list = $this->pass->all(array("select"=>"invoice_master.NOMID, nom_details.FIXTURETYPE, (case when (nom_details.FIXTURETYPE = 1) THEN 'Voyage Spot' ELSE 'Time Charter' END) as FIXTURETYPENAME, INVOICEID, INVOICENUMBER, INVOICETYPE, INVOICEDATE, NOMINATIONID, COMMISSIONVALUE, nom_details.CPDATE, FIXTURE_STATUS,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Deviation' ELSE 'Other' END) as INVOICENOTENAME, (select VESSELNAME from vessel_imo_master where vessel_imo_master.VESSELIMOID=nom_details.FLEETID) as FLEETNAME, (select SUM(RCVDAMOUNT) as RCVDAMOUNT from payment_received where payment_received.NOMID=invoice_master.NOMID and payment_received.INVOICETYPE=invoice_master.INVOICETYPE) as PAYMENTAMT",'join'=>array('nom_details'=>'nom_details.NOMID = invoice_master.NOMID'),'where'=>array('OPERATIONLOGINID'=>$this->session->uid),"where_str"=>"INVOICEDATE >='".$duedate."'", "group_by"=>"INVOICEID", 'order_by'=>array('INVOICEDATE'=>'ASC')));
		foreach($invoice_list as $invoice_list1):
		    $now = time(); 
			$inv_date = strtotime($invoice_list1->INVOICEDATE);
			$datediff = $now - $inv_date;
			$invdays = round($datediff / (60 * 60 * 24));
			
		    if($invoice_list1->PAYMENTAMT <= 0):
			    
				if($invoice_list1->INVOICETYPE == 'FREIGHT'):
				
				    $invtitle = ($invoice_list1->FIXTURETYPE == 1) ? 'Freight' : 'Hire';
					$detail = '<a href="'.base_url("operation/".(($invoice_list1->FIXTURETYPE == 1) ? 'invoiceVoyage' : 'invoiceTime')."/{$invoice_list1->FIXTURE_STATUS}/{$invoice_list1->NOMID}").'" title="" data-toggle="tooltip" data-original-title="Invoice/Payment Rcvd"  ><i class="fa fa-edit "></i></a>';
					
				    if($invoice_list1->FIXTURETYPE == 1):
					
						if($invdays > $invoiceduedata->FRTDUEDAYS && $invdays <= $freightdays):
							
							$invoicealerts[]  = array('fixturetype'=>$invoice_list1->FIXTURETYPENAME, 'vslname'=>$invoice_list1->FLEETNAME, 'nomno'=>$invoice_list1->NOMINATIONID, 'nomno'=>$invoice_list1->NOMINATIONID, 'cpdate'=>date('d-m-Y',strtotime($invoice_list1->CPDATE)), 'invoicedate'=>date('d-m-Y',strtotime($invoice_list1->INVOICEDATE)), 'invoicetype'=>ucwords($invoice_list1->INVOICENOTENAME), 'invoicevalue'=>$invoice_list1->COMMISSIONVALUE, 'invoiceno'=>$invoice_list1->INVOICENUMBER, 'invoiceamt'=>$invoice_list1->COMMISSIONVALUE, 'details'=>$detail, 'invremarks'=>'<small class="label label-success">Commission Invoice – '.$invtitle.'</small>');
							
						endif;
					else:
					    
						if($invdays > $invoiceduedata->HIREDUEDAYS && $invdays <= $hiredays):
							
							$invoicealerts[]  = array('fixturetype'=>$invoice_list1->FIXTURETYPENAME, 'vslname'=>$invoice_list1->FLEETNAME, 'nomno'=>$invoice_list1->NOMINATIONID, 'nomno'=>$invoice_list1->NOMINATIONID, 'cpdate'=>date('d-m-Y',strtotime($invoice_list1->CPDATE)), 'invoicedate'=>date('d-m-Y',strtotime($invoice_list1->INVOICEDATE)), 'invoicetype'=>ucwords($invoice_list1->INVOICENOTENAME), 'invoicevalue'=>$invoice_list1->COMMISSIONVALUE, 'invoiceno'=>$invoice_list1->INVOICENUMBER, 'invoiceamt'=>$invoice_list1->COMMISSIONVALUE, 'details'=>$detail, 'invremarks'=>'<small class="label label-success">Commission Invoice – '.$invtitle.'</small>');
							
						endif;
					
					endif;
				endif;
				
				if($invoice_list1->INVOICETYPE == 'DEMURRAGE'):
					if($invdays > $invoiceduedata->DEMUDUEDAYS && $invdays <= $demuragedays):
					
					    $detail = '<a href="'.base_url("operation/".(($invoice_list1->FIXTURETYPE == 1) ? 'invoiceVoyage' : 'invoiceTime')."/{$invoice_list1->FIXTURE_STATUS}/{$invoice_list1->NOMID}").'" title="" data-toggle="tooltip" data-original-title="Invoice/Payment Rcvd"  ><i class="fa fa-edit "></i></a>';
						
						$invoicealerts[]  = array('fixturetype'=>$invoice_list1->FIXTURETYPENAME, 'vslname'=>$invoice_list1->FLEETNAME, 'nomno'=>$invoice_list1->NOMINATIONID, 'nomno'=>$invoice_list1->NOMINATIONID, 'cpdate'=>date('d-m-Y',strtotime($invoice_list1->CPDATE)), 'invoicedate'=>date('d-m-Y',strtotime($invoice_list1->INVOICEDATE)), 'invoicetype'=>ucwords($invoice_list1->INVOICENOTENAME), 'invoicevalue'=>$invoice_list1->COMMISSIONVALUE, 'invoiceno'=>$invoice_list1->INVOICENUMBER, 'invoiceamt'=>$invoice_list1->COMMISSIONVALUE, 'details'=>$detail, 'invremarks'=>'<small class="label label-warning">Commission Invoice – Demurrage</small>');
						
					endif;
				endif;
				
			endif;
		endforeach;
		$this->data['invoicealerts'] = $invoicealerts;
		                          set_includes(array(DATATABLES));
		$this->data['include'] = include_file_batch();
								 view('operation/dashboard',$this->data);
	}
	
	//............for nomatglance............................
	public function nomatglance()
	{
		$this->data['nav'] = 2;
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID,SWEET_ALERT));
		$this->data['include'] = include_file_batch();
								 view('operation/nomatglance',$this->data);
	}
	
	public function add_fixture()
	{
		$this->data['nav'] = 2;
		$this->data['fixture_type_list'] = $this->pass->getFixtureTypeList();
		$this->data['fleet_list'] 		 = $this->pass->getFleetlist();
		$this->data['vendor_list'] 		 = $this->pass->getVendorBasedOnVendorTypeID([1]);
		$this->data['owner_list'] 		 = $this->pass->getVendorBasedOnVendorTypeID([2]);
		$this->data['collect_comm_list'] = $this->pass->getVendorBasedOnVendorTypeID([1,2]);
		$this->data['cargo_list'] 		 = $this->pass->getCargoList('multiple');
		$this->data['user_list_claims']  = $this->pass->getUserList('claims');
		$this->data['broker_list'] 		 = $this->pass->getBrokerList();
		$this->data['cp_form_list'] 	 = $this->pass->getCPFormTypeList();
		$this->data['company_list'] 	 = $this->pass->getCompanyList();
		
		$this->data['companyjsondata'] = self::getCompanydataJson();
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nominationid'] = self::_getMaxNumber('MESSAGE_NO');

								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE,DATEPICKER,NUMERIC,SELECT2,DATETIMEPICKER,CALC));
		$this->data['include'] = include_file_batch();
								 view('operation/add_fixture',$this->data);
		
	}
	
	public function insert_fixture()
	{
		$this->load->library('form_validation'); 
		$this->load->helper(['dateFormat','array']);
		$this->form_validation->set_rules('m_NOMINATIONID', 
										 'Fixture No./ Nomination ID',
										 'is_unique[nom_details.NOMINATIONID]',
												array(
														'is_unique'     => 'This %s already exists.'
													)
										);
		if($this->form_validation->run())
		{
			$data 					= self::customized_ArrayByKey($this->input->post(),'m');
			$slave1 				= self::customized_ArrayByKey_forArrayData($this->input->post(),'s1',$data['LREC']);unset($data['LREC']);
			
			$data['CPDATE'] 		= formatedDate($data['CPDATE']);
			$data['BL_DATE'] 		= formatedDate($data['BL_DATE']);
			$data['LAYCANSTART'] 	= formatedDate($data['LAYCANSTART'], 'Y-m-d H:i');
			$data['LAYCANEND'] 		= formatedDate($data['LAYCANEND'], 'Y-m-d H:i');
			$data['ESTDATE'] 		= '0000-00-00';
			$data['FIXTUREDATE'] 	= '0000-00-00';
			$data['ADDEDBYID'] 		= $this->session->uid;
			$data['ADDONDATE'] 		= date('Y-m-d');
			$data['ADDEDBY'] 		= $this->data['userData']->CONTACTPERSON;
			$nom_arr 				= explode("/",$data['NOMINATIONID']);
			$data['MESSAGE_NO'] 	= $nom_arr[1];			
			
			$data['LUMPSUMFREIGHTUSD'] 	= $data['LUMPSUMFREIGHT'];
			$data['HIRERATEUSD'] 		= $data['DAILYHIRERATE'];
			$data['DEMURRAGEUSD'] 		= $data['DEMURRAGE'];	
			
			if($_FILES['ATTACHMENT']['name'][0] != ''):
									$data['ATTACHMENT_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT']));
									$data['ATTACHMENT'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT']));
					else		:	$data['ATTACHMENT_NAME'] = $data['ATTACHMENT'] = '';	
					endif;
			
			$this->pass->setTable(array('nom_details','NOMID'));
			$nom_id = $this->pass->insert($data);
			 
			foreach($slave1 as $element1) :
				if($element1['BROKERID'] != "" && $element1['PERCENTAGE'] != "" && $element1['COMMAMT'] != "") :
						$this->pass->setTable(array('nom_details_slave','SLAVEID'));
						$element1['NOMID']			=	$nom_id; 
						$this->pass->insert(elements(array('NOMID', 'BROKERID', 'PERCENTAGE', 'COMMAMT'), $element1));	
				endif;
			 endforeach;
			 
			 return self::_flashAndRedirectAllWithAlertArray($nom_id ,
									   'Fixture Slip added successfully.', 
									   'Sorry! there was an error while adding Fixture Slip.',
									   'operation/nomatglance');
		}
		else
		{
			self::add_fixture();
		}
	}
	
	public function edit_fixture($gridStatus = 0, $nomid)
	{
		
		$this->load->helper('dateFormat');
		$this->data['gridStatus'] 		 = $gridStatus;
		$this->data['nav'] = ($gridStatus == 0) ? 2 : (($gridStatus == 1) ? 3 : (($gridStatus == 2) ? 4 : 5));
		$this->data['label1'] = ($gridStatus == 0) ? 'Nomination at a glance' : (($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY'));
		
		$this->data['fixture_type_list'] = $this->pass->getFixtureTypeList();
		$this->data['fleet_list'] 		 = $this->pass->getFleetlist();
		$this->data['vendor_list'] 		 = $this->pass->getVendorBasedOnVendorTypeID([1]);
		$this->data['owner_list'] 		 = $this->pass->getVendorBasedOnVendorTypeID([2]);
		$this->data['collect_comm_list'] = $this->pass->getVendorBasedOnVendorTypeID([1,2]);
		$this->data['cargo_list'] 		 = $this->pass->getCargoList('multiple');
		$this->data['user_list_claims']  = $this->pass->getUserList('claims');
		$this->data['broker_list'] 		 = $this->pass->getBrokerList();
		$this->data['cp_form_list'] 	 = $this->pass->getCPFormTypeList();
		$this->data['fixturestatus_list']= $this->pass->getStatusMasterList();
		$this->data['porttype_list']     = $this->pass->getPortTypeList();
		$this->data['purposeofcall_list']     = $this->pass->getPurposeOfCallMasterList();
		$this->data['company_list'] 	 = $this->pass->getCompanyList();
		$this->data['companyjsondata'] = self::getCompanydataJson();
		
		$this->data['currency_list'] 	 = $this->pass->getCurrencyList();
		$this->data['invoice_status'] 	 = $this->pass->count_all('invoice_master',array('NOMID'=>$nomid));
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->find_by_pk($nomid);
		
		$this->pass->setTable(array('port_master','PORTID'));
		$this->data['nom']->FPORTNAME = json_encode(($this->data['nom']->FPORT != '') ? array('id'=>$this->data['nom']->FPORT,'name'=>$this->pass->first(array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME","where"=>array('PORTID'=>$this->data['nom']->FPORT)))->PORTNAME) : array('id'=>'','name'=>'---Select from list---'));

		$this->data['nom']->TPORTNAME = json_encode(($this->data['nom']->TPORT != '') ? array('id'=>$this->data['nom']->TPORT,'name'=>$this->pass->first(array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME","where"=>array('PORTID'=>$this->data['nom']->TPORT)))->PORTNAME) : array('id'=>'','name'=>'---Select from list---'));
		
		$this->data['nom']->NEXTPORTNAME = json_encode(($this->data['nom']->ADD_NEXT_PORT != '') ? array('id'=>$this->data['nom']->ADD_NEXT_PORT,'name'=>$this->pass->first(array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME","where"=>array('PORTID'=>$this->data['nom']->ADD_NEXT_PORT)))->PORTNAME) : array('id'=>'','name'=>'---Select from list---'));

		$lp = explode(",",$this->data['nom']->LPORT);
		for($i=0; $i<count($lp); $i++):						
			$lp_arr[] = array('id'=>$lp[$i],'name'=>$this->pass->first(array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME","where"=>array('PORTID'=>$lp[$i])))->PORTNAME);
		endfor;

		$dp = explode(",",$this->data['nom']->DPORT);
		for($i=0; $i<count($dp); $i++):
			$dp_arr[] = array('id'=>$dp[$i],'name'=>$this->pass->first(array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME","where"=>array('PORTID'=>$dp[$i])))->PORTNAME);
		endfor;
		$this->data['nom']->LPORTNAME = json_encode($lp_arr);
		$this->data['nom']->DPORTNAME = json_encode($dp_arr);
		
		$this->pass->setTable(array('nom_details_slave','SLAVEID'));
		$this->data['slave'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid)));
		
		
		$this->pass->setTable(array('nom_details_slave2','NOM_SLAVE2ID'));
		$this->data['slave2'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave2.PORTID) as PORTNAME","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave3','NOM_SLAVE3ID'));
		$this->data['slave3'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave3.PORTID) as PORTNAME","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave4'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'BROKER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave5'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'VOYAGE')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave6'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'OWNER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave7'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'CHARTERER')));
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE,DATEPICKER,NUMERIC,SELECT2,DATETIMEPICKER,CALC));
		$this->data['include'] = include_file_batch();
								 view('operation/edit_fixture',$this->data);
	}
	
	public function update_fixture($gridStatus = 0, $nomid)
	{
			$this->load->helper(['dateFormat','array']);
			$data 					= self::customized_ArrayByKey($this->input->post(),'m');
			$slave1 				= self::customized_ArrayByKey_forArrayData($this->input->post(),'s1',$data['LREC']);unset($data['LREC']);
			
			if(!empty($data['ADDDEl'])):
				$slave4 				= self::customized_ArrayByKey($this->input->post(),'s2',$data['ADDDEl']);unset($data['ADDDEl']);
				$slave5 				= self::customized_ArrayByKey($this->input->post(),'s3',$data['SOFDEl']);unset($data['SOFDEl']);
				$slave6 				= self::customized_ArrayByKey($this->input->post(),'s4',$data['BROKERDEl']);unset($data['BROKERDEl']);
				$slave7 				= self::customized_ArrayByKey($this->input->post(),'s5',$data['VOYAGEDEl']);unset($data['VOYAGEDEl']);
				$slave8 				= self::customized_ArrayByKey($this->input->post(),'s6',$data['OWNERDEl']);unset($data['OWNERDEl']);
				$slave9 				= self::customized_ArrayByKey($this->input->post(),'s7',$data['CHARTDEl']);unset($data['CHARTDEl']);
			endif;
			
			$data['CPDATE'] 		= formatedDate($data['CPDATE']);
			$data['BL_DATE'] 		= formatedDate($data['BL_DATE']);
			$data['LAYCANSTART'] 	= ($data['LAYCANSTART']!='')?formatedDate($data['LAYCANSTART'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
			$data['LAYCANEND'] 		= ($data['LAYCANEND']!='')?formatedDate($data['LAYCANEND'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
			$data['ETA_NEXT_PORT'] 	= ($data['ETA_NEXT_PORT']!='')?formatedDate($data['ETA_NEXT_PORT'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
			$data['ESTDATE'] 		= '0000-00-00';
			$data['FIXTUREDATE'] 	= '0000-00-00';
			$data['ADDEDBYID'] 		= $this->session->uid;
			$data['ADDONDATE'] 		= date('Y-m-d');
			$data['ADDEDBY'] 		= $this->data['userData']->CONTACTPERSON;
			
			$data['CRMFILE']	= addslashes(trim($data['CRMFILE']));
			$data['CRMNAME']	= addslashes(trim($data['CRMNAME']));
			
			if($gridStatus == 0):
				$data['NOMGRIDSTATUS'] = ($data['UPDATESTATUS'] == 0) ? 0 : 1;
			endif;
			
			if($_FILES['ATTACHMENT']['name'][0] != ''):
									$data['ATTACHMENT_NAME'] 	= implode(",",self::getUploadName($_FILES['ATTACHMENT']));
									$data['ATTACHMENT'] 		= implode(",",self::getUpload('./upload/',$_FILES['ATTACHMENT']));
					else		:	$data['ATTACHMENT_NAME'] = $data['ATTACHMENT'] = '';	
					endif;
					
			if($data['CRMFILE'] != '' && $data['ATTACHMENT'] != ''){ $data['ATTACHMENT'] = $data['CRMFILE'].','.$data['ATTACHMENT'];}
			else if($data['CRMFILE'] == '' && $data['ATTACHMENT'] != ''){ $data['ATTACHMENT'] = $data['ATTACHMENT'];}
			else if($data['CRMFILE'] != '' && $data['ATTACHMENT'] == ''){ $data['ATTACHMENT'] = $data['CRMFILE'];}
			
			if($data['CRMNAME'] != '' && $data['ATTACHMENT_NAME'] != ''){ $data['ATTACHMENT_NAME'] = $data['CRMNAME'].','.$data['ATTACHMENT_NAME'];}
			else if($data['CRMNAME'] == '' && $data['ATTACHMENT_NAME'] != ''){ $data['ATTACHMENT_NAME'] = $data['ATTACHMENT_NAME'];}
			else if($data['CRMNAME'] != '' && $data['ATTACHMENT_NAME'] == ''){ $data['ATTACHMENT_NAME'] = $data['CRMNAME'];}
			
			unset($data['CRMFILE']);unset($data['CRMNAME']);
			
			$alerts = [
						 [
						 	'ALERTBY'		=> $this->session->uid,
						 	'ALERTTO'		=> $data['CLAIMSLOGINID'],
							'ALERTTEXT'		=> 'Fixture Slip sent by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $nomid,'ALERTLINK'=>'claims/view-fixture/1/'.$nomid,
							'ALERTTYPE'		=> 'Fixture Slip'
						 ],
						 [
						 	'ALERTBY'		=> $this->session->uid,
						 	'ALERTTO'		=> 1,
							'ALERTTEXT'		=> 'Fixture Slip sent to Claims by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $nomid,'ALERTLINK'=>'admin/view-fixture/1/'.$nomid,
							'ALERTTYPE'		=> 'Fixture Slip'
						]
					  ];
			
			$this->pass->setTable(array('nom_details','NOMID'));
			$nom_id = $this->pass->update($nomid,$data);
			
			$this->pass->setTable(array('nom_details_slave','SLAVEID'));
			$this->pass->delete(array("where"=>array('NOMID'=>$nomid)));
			
			foreach($slave1 as $element1) :
				if($element1['BROKERID'] != "" && $element1['PERCENTAGE'] != "" && $element1['COMMAMT'] != "") :						
						$element1['NOMID']			=	$nomid; 
						$this->pass->insert(elements(array('NOMID', 'BROKERID', 'PERCENTAGE', 'COMMAMT'), $element1));	
				endif;
			 endforeach;
			 
			
			 if(!empty($slave4)):
				 $this->pass->setTable(array('nom_details_slave2','NOM_SLAVE2ID'));
				 $this->pass->delete(array("where"=>array('NOMID'=>$nomid)));
					
				 foreach($slave4 as $element2) :
					if($element2['PORTID'] != "" && $element2['ITINERARY'] != "" && $element2['ETA'] != "") :						
							$element2['NOMID']			=	$nomid; 
							$element2['ETA'] 		= ($element2['ETA']!='')?formatedDate($element2['ETA'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$this->pass->insert(elements(array('NOMID', 'PORTTYPEID', 'PORTID', 'ITINERARY', 'ETA'), $element2));	
					endif;
				 endforeach;
			endif;
			
			if(!empty($slave5)):	 
				 $this->pass->setTable(array('nom_details_slave3','NOM_SLAVE3ID'));
				 $this->pass->delete(array("where"=>array('NOMID'=>$nomid)));
				 foreach($slave5 as $element3) :
					if($element3['PORTID'] != "") :						
							$element3['NOMID']			 = $nomid; 
							$element3['ETA'] 		     = ($element3['ETA']!='')?formatedDate($element3['ETA'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$element3['EOSP'] 		     = ($element3['EOSP']!='')?formatedDate($element3['EOSP'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$element3['CARGOCOMPLETE'] 	 = ($element3['CARGOCOMPLETE']!='')?formatedDate($element3['CARGOCOMPLETE'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$element3['COSP'] 		     = ($element3['COSP']!='')?formatedDate($element3['COSP'], 'Y-m-d H:i'):'0000-00-00 00:00:00';
							$this->pass->insert(elements(array('NOMID', 'PURPOSEOFCALL', 'PORTID', 'ITINERARY', 'ETA', 'AGENT', 'CARGOQTY', 'EOSP', 'CARGOCOMPLETE', 'COSP'), $element3));	
					endif;
				 endforeach;
			 endif;
			 
			 $this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
			 $this->pass->delete(array("where"=>array('NOMID'=>$nomid)));
			 
			 if(!empty($slave6)):	 
				 foreach($slave6 as $element3) :
					if($element3['NOTES'] != "") :						
							$element3['NOMID']			 = $nomid; 
							$element3['IDENTIFY'] 		 = 'BROKER';
							$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
							$this->pass->insert(elements(array('NOMID', 'IDENTIFY', 'NOTES'), $element3));	
					endif;
				 endforeach;
			 endif;
			 
			 if(!empty($slave7)):	 
				 foreach($slave7 as $element3) :
					if($element3['NOTES'] != "") :						
							$element3['NOMID']			 = $nomid; 
							$element3['IDENTIFY'] 		 = 'VOYAGE';
							$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
							$this->pass->insert(elements(array('NOMID', 'IDENTIFY', 'NOTES'), $element3));	
					endif;
				 endforeach;
			 endif;
			 
			 if(!empty($slave8)):	 
				 foreach($slave8 as $element3) :
					if($element3['NOTES'] != "") :						
							$element3['NOMID']			 = $nomid; 
							$element3['IDENTIFY'] 		 = 'OWNER';
							$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
							$this->pass->insert(elements(array('NOMID', 'IDENTIFY', 'NOTES'), $element3));	
					endif;
				 endforeach;
			 endif;
			 
			 if(!empty($slave9)):	 
				 foreach($slave9 as $element3) :
					if($element3['NOTES'] != "") :						
							$element3['NOMID']			 = $nomid; 
							$element3['IDENTIFY'] 		 = 'CHARTERER';
							$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
							$this->pass->insert(elements(array('NOMID', 'IDENTIFY', 'NOTES'), $element3));	
					endif;
				 endforeach;
			 endif;
			  
			 if($gridStatus == 0):
			 	$alerts = ($data['UPDATESTATUS'] == 0) ? array() : $alerts;
			else:
				$alerts = array();
			endif;
			 
			 $this->pass->setTable(array('login','LOGINID'));
			 $msg = ($data['UPDATESTATUS'] == 0) ? "Fixture Slip updated successfully." : 'Fixture Slip ('.$data['NOMINATIONID'].') sent successfully.<br> Claims Handling Allocation : '.$this->pass->first(array("select"=>"CONTACTPERSON","where"=>array('LOGINID'=>$data['CLAIMSLOGINID'])))->CONTACTPERSON;
			 $msg = ($gridStatus == 0) ? $msg : "Fixture Slip updated successfully.";
			 return self::_flashAndRedirectAllWithAlertArray($nom_id ,
												   $msg, 
												   'Sorry! there was an error while updating Fixture Slip.',
												   'operation/'.(($gridStatus == 0) ? 'nomatglance' : (($gridStatus == 1) ? 'opsatglance' : 'postopsatglance')),
									   				$alerts);
	}
	//..........................ends here ...........................................
	//............for opsatglance............................
	public function opsatglance($gridStatus = 1)
	{
		$this->data['gridStatus'] =  $gridStatus;
		$this->data['nav'] = ($gridStatus == 1) ? 3 : (($gridStatus == 2) ? 4 : 5);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID,SWEET_ALERT,DATEPICKER,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('operation/opsatglance',$this->data);
	}
	
	public function view_fixture($gridStatus = 1, $nomid)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] = ($gridStatus == 1) ? 3 : (($gridStatus == 2) ? 4 : 5);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' ELSE 'Time Charter' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME, (select STATUS_NAME from status_master where status_master.STATUSID=nom_details.FIXTURE_STATUS) as FIXTURESTATUSNAME","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('cargo_master','CARGOID')));
		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		
		$this->data['etanextPort'] = extractString($this->data['nom']->ADD_NEXT_PORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('nom_details_slave','SLAVEID'));
		$this->data['slave'] = $this->pass->all(array("select"=>"*, (select NAME from broker_master where broker_master.BROKERID=nom_details_slave.BROKERID) as BROKERNAME","where"=>array('NOMID'=>$nomid)));
		
		
		$this->pass->setTable(array('nom_details_slave2','NOM_SLAVE2ID'));
		$this->data['slave2'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave2.PORTID) as PORTNAME, (case when (PORTTYPEID = 1) THEN 'LP' ELSE 'DP' END) as PORTTYPE","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave3','NOM_SLAVE3ID'));
		$this->data['slave3'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave3.PORTID) as PORTNAME, (select PURPOSE_NAME from purposeofcall_master where purposeofcall_master.CALLID=nom_details_slave3.PURPOSEOFCALL) as PURPOSE_NAME","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave4'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'BROKER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave5'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'VOYAGE')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave6'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'OWNER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave7'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'CHARTERER')));
								 
		$this->data['include'] = include_file_batch();
								 view('operation/view_fixture',$this->data);
	}
	
	public function editcompletiondate($gridStatus)
	{
		$this->load->helper('dateFormat');
		$data 					= self::customized_ArrayByKey($this->input->post(),'m');
		$data['CDDATE'] = ($data['CDDATE'] != "") ? formatedDate($data['CDDATE']) : '0000-00-00';
		$nomid = $data['NOMID']; unset($data['NOMID']);
		
		$this->pass->setTable(array('nom_details','NOMID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($nomid, $data) ,
									   'Estimated Completion Date (Frt) updated successfully.', 
									   'Sorry! there was an error while updating Estimated Completion Date (Frt).',
									   'operation/'.(($gridStatus == 1) ? 'opsatglance' : 'postopsatglance'));
	}
	
	public function editcompletiondatedem($gridStatus)
	{
		$this->load->helper('dateFormat');
		$data 					= self::customized_ArrayByKey($this->input->post(),'m');
		$data['DEMCDDATE'] = ($data['DEMCDDATE'] != "") ? formatedDate($data['DEMCDDATE']) : '0000-00-00';
		$nomid = $data['NOMID']; unset($data['NOMID']);
		
		$this->pass->setTable(array('nom_details','NOMID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($nomid, $data) ,
									   'Estimated Completion Date (Dem) updated successfully.', 
									   'Sorry! there was an error while updating Estimated Completion Date (Dem).',
									   'operation/'.(($gridStatus == 1) ? 'opsatglance' : 'postopsatglance'));
	}
	
	public function invoice_time($gridStatus = 1, $nomid, $fixtureType)
	{
		$this->load->helper(['dateFormat','array']);
		$this->load->library("numbertowordconversion");
		
		$this->data['currency_list'] 	 = $this->pass->getCurrencyList();
		$this->data['gstno_list'] 	     = $this->pass->getGSTInMasterList();
		
		$this->data['nav'] = ($gridStatus == 1) ? 3 : (($gridStatus == 2) ? 4 : 5);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' ELSE 'Time Charter' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME, (select VENDORADDRESS1 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS1, (select VENDORADDRESS2 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS2, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select TAXTYPE from company_master where company_master.COMPANYID=nom_details.COMPANYID) as TAXTYPENAME, (select VENDORADDRESS3 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS3 , (select VENDORADDRESS4 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS4","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>" , ","table"=>array('cargo_master','CARGOID')));
		
		$this->data['note_list'] = $this->pass->getInvoiceNoteList();
		$this->data['bank_list'] = $this->pass->getBankList();
		
		$this->pass->setTable(array('company_master','COMPANYID'));
		$this->data['companydata'] = $this->pass->first(array("select"=>"*", "where"=>array('COMPANYID'=>$this->data['nom']->COMPANYID)));
		
		$this->pass->setTable(array('bank_master','BANKID'));
		$result = $this->pass->all(array("where"=>array('STATUS'=>1))); 
		$arr = array();
		foreach($result as $val):
			$arr[$val->BANKID][] = array('bank_address' => $val->BANK_ADDRESS, 'account_name' => $val->ACCOUNT_NAME, 'account_number' => $val->ACCOUNT_NUMBER, 'aed' => $val->AED, 'euro' => $val->EURO, 'usd' => $val->USD);
		endforeach;
		
		$this->data['bank_details'] = json_encode($arr);
		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));		
		if($fixtureType == 'time'):		
			$this->data['hire_days_value'] = number_format($this->pass->first(array("select"=>"SUM(HIREDAYS) AS HIREDAYS","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')))->HIREDAYS,4,'.','');
		else:
			$this->data['sum_comm_value'] =  number_format($this->pass->first(array("select"=>"SUM(COMMISSIONWITHOUTTAX) AS COMMISSIONVALUE","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')))->COMMISSIONVALUE,2,'.','');
			$this->data['sum_dem_value'] = number_format($this->pass->first(array("select"=>"SUM(COMMISSIONWITHOUTTAX) AS COMMISSIONVALUE","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')))->COMMISSIONVALUE,2,'.','');		
		endif;
		
		$this->data['f_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		if($fixtureType == 'voyage'):	
			$this->data['d_demu_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));		
		endif;		
		$this->data['o_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Deviation' WHEN (INVOICENOTE = 4) THEN CONCAT('Others ( ', INVOICENOTEOTHER, ' )') ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('payment_received','PAYMENTID'));
		$this->data['f_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		if($fixtureType == 'voyage'):	
		$this->data['d_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));	
		endif;		
		$this->data['o_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('summary','SUMMARYID'));
		$this->data['f_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		if($fixtureType == 'voyage'):
		$this->data['d_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));
		endif;	
		$this->data['o_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
								 set_includes(array(SELECT2,SWEET_ALERT,DATEPICKER,VALIDATE,AUTOSIZE,NUMERIC,CALC,NO_2_WORD));
		$this->data['include'] = include_file_batch();
								 view('operation/'.(($fixtureType == 'time') ? 'invoice_time' : 'invoice'),$this->data);
	}
	
	public function insert_invoice_time($gridStatus = 1, $invoice_type, $fixtureType)
	{
		$this->load->helper(['dateFormat','array']);
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		
		$data['INVOICEDATE'] 		= formatedDate($data['INVOICEDATE']);
		$data['FROMDATE'] 			= !empty($data['FROMDATE']) ? formatedDate($data['FROMDATE']) : '0000-00-00';
		$data['ENDDATE'] 			= !empty($data['ENDDATE']) ? formatedDate($data['ENDDATE']) : '0000-00-00';	
		$data['CONVERSION_DATE']    = !empty($data['CONVERSION_DATE']) ? formatedDate($data['CONVERSION_DATE']) : '0000-00-00';		
		
		$alerts = [
						[
							'ALERTBY' 		=> $this->session->uid,
							'ALERTTO' 		=> 1,
							'ALERTTEXT'		=> $invoice_type.' Invoice created by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'admin/invoice/'.$gridStatus.'/'.$data['NOMID'],
							'ALERTTYPE'		=> 'Invoice Slip'
						 ],
						 [
						 	'ALERTBY'		=> $this->session->uid,
						 	'ALERTTO'		=> $data['CLAIMSLOGINID'],
							'ALERTTEXT'		=> $invoice_type.' Invoice created by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'claims/invoice/'.$gridStatus.'/'.$data['NOMID'],
							'ALERTTYPE'		=> 'Invoice Slip'
						 ]
					  ];
			
			
			$nomination = $data['NOMINATIONID']; $nomid = $data['NOMID']; unset($data['NOMINATIONID']);unset($data['CLAIMSLOGINID']);
			
			$this->pass->setTable(array('invoice_master','INVOICEID'));
			$insert = $this->pass->insert($data);
			if($insert):		
				
				$fixture_status_arr = (strtoupper($invoice_type) === strtoupper('Freight')) ? array('NOMSTATUS' => 3) : array('NOMSTATUS' => 4);
				
				$this->pass->setTable(array('nom_details','NOMID'));
				return self::_flashAndRedirectAllWithAlertArray( 
										(strtoupper($invoice_type) === strtoupper('Others')) 
												? $insert
												: $this->pass->update($nomid, $fixture_status_arr) ,
									   'Invoice ('.$nomination.') created successfully.', 
									   'Sorry! there was an error while creating Invoice.',
									   'operation/'.(($gridStatus == 1) ? 'opsatglance' : 'postopsatglance'),$alerts);
			else:
				self::invoice_time($gridStatus, $nomid, $fixtureType);
			endif;
	}
	
	public function delete_invoice($redirect, $gridStatus, $nomid, $type, $invoiceid)
	{
				
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		$this->pass->delete(array("where"=>array('NOMID' => $nomid, 'INVOICETYPE' => $type, 'INVOICEID' => $invoiceid)));
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		$noofincoice = $this->pass->first(array("select"=>"count(*) as COUNT1","where"=>array('NOMID' => $nomid, 'INVOICETYPE' => $type)));	
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$fixture_status_arr = (strtoupper($type) === strtoupper('Freight') && $noofincoice->COUNT1==0) ? array('NOMSTATUS' => 2) : array('NOMSTATUS' => 3);
		return self::_flashAndRedirectAllWithAlertArray(
										(strtoupper($type) === strtoupper('Others') || $noofincoice->COUNT1!=0) 
												? TRUE
												: $this->pass->updateWhere($fixture_status_arr, array("where"=>array('NOMID'=>$nomid))) ,
									   "$type Invoice removed successfully.", 
									   "Sorry! there was an error while changing $type Invoice",
									   "operation/$redirect/{$gridStatus}/{$nomid}");
	}
	
	public function editcommissioninvoice($redirect, $gridStatus, $nomid)
	{
		$this->load->helper('dateFormat');
		$data 					= self::customized_ArrayByKey($this->input->post(),'m');
		$data['INVOICEDATE'] 	= formatedDate($data['INVOICEDATE1']);
		$data['ATTN'] 			= $data['ATTN1'];
		$data['INVOICENUMBER'] 	= $data['INVOICENUMBER1'];
		$data['TOTALCARGO'] 	= $data['TOTALCARGO1'];
		
		$invoiceID 				= $data['INVOICEID'];
		
		unset($data['INVOICEID']);unset($data['INVOICEDATE1']);unset($data['ATTN1']);unset($data['INVOICENUMBER1']);unset($data['TOTALCARGO1']);
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($invoiceID, $data) ,
									   'Invoice Details updated successfully.', 
									   'Sorry! there was an error while updating Invoice.',
									   "operation/$redirect/{$gridStatus}/{$nomid}");
		
	}
	
	public function editcommissioninvoiceothers($redirect, $gridStatus, $nomid)
	{
		$this->load->helper('dateFormat');
		$data 					= self::customized_ArrayByKey($this->input->post(),'m');
		$data['INVOICEDATE'] 	          = formatedDate($data['INVOICEDATE2']);
		$data['ATTN'] 			          = $data['ATTN2'];
		$data['INVOICENUMBER'] 	          = $data['INVOICENUMBER2'];
		$data['TAXRATE'] 	              = $data['TAXRATE2'];
		$data['GSTVALUE'] 	              = $data['GSTVALUE2'];
		$data['COMMISSIONWITHOUTTAX']     = $data['COMMISSIONVALUEWITHOUT2'];
		$data['COMMISSIONVALUE'] 	      = $data['COMMISSIONVALUE2'];
		
		$invoiceID 				          = $data['INVOICEID2'];
		
		unset($data['INVOICEID2']);unset($data['INVOICEDATE2']);unset($data['ATTN2']);unset($data['INVOICENUMBER2']);unset($data['COMMISSIONVALUE2']);unset($data['TAXRATE2']);unset($data['GSTVALUE2']);unset($data['COMMISSIONVALUEWITHOUT2']);
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($invoiceID, $data) ,
									   'Invoice Details updated successfully.', 
									   'Sorry! there was an error while updating Invoice.',
									   "operation/$redirect/{$gridStatus}/{$nomid}");
		
	}
	
	public function insert_payment($gridStatus, $invoice_type)
	{
		$this->load->helper('dateFormat');
		$data 			= self::customized_ArrayByKey($this->input->post(),'m');	
		
		if($invoice_type == 'Freight'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s1',$data['PID']);}
		if($invoice_type == 'Demurrage'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s2',$data['DID']);}
		if($invoice_type == 'Others'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s3',$data['OID']);}
		
		$alerts = [
						[
							'ALERTBY' 		=> $this->session->uid,
							'ALERTTO' 		=> 1,
							'ALERTTEXT'		=> $invoice_type.' Payment Received by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'admin/invoice/'.$gridStatus.'/'.$data['NOMID'],
							'ALERTTYPE'		=> 'Payment Received'
						 ],
						 [
						 	'ALERTBY'		=> $this->session->uid,
						 	'ALERTTO'		=> $data['CLAIMSLOGINID'],
							'ALERTTEXT'		=> $invoice_type.' Payment Received by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
							'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'claims/invoice/'.$gridStatus.'/'.$data['NOMID'],
							'ALERTTYPE'		=> 'Payment Received'
						 ]
					  ];

		$this->pass->setTable(array('payment_received','PAYMENTID'));
		$this->pass->delete(array("where"=>array('NOMID' => $data['NOMID'], 'INVOICETYPE' => $invoice_type)));
		
		for($i=1;$i<=count($slave_data);$i++):
			if($slave_data[$i]['PAYMENTDATE'] != "" && $slave_data[$i]['RCVDAMOUNT'] != ""):
				$slave_data[$i]['PAYMENTDATE'] = formatedDate($slave_data[$i]['PAYMENTDATE']);
				$this->pass->insert($slave_data[$i]);
			endif;
		endfor;
		
		$fixture_status_arr = (strtoupper($invoice_type) === strtoupper('Freight')) ? array('NOMSTATUS' => 5) : array('NOMSTATUS' => 6);
		
		$this->pass->setTable(array('nom_details','NOMID'));
		return self::_flashAndRedirectAllWithAlertArray(
										(strtoupper($invoice_type) === strtoupper('Others')) 
												? TRUE
												: $this->pass->update($data['NOMID'], $fixture_status_arr),
									   $invoice_type.' Payment Received ('.$data['NOMINATIONID'].') successfully.', 
									   'Sorry! there was an error while receiving Payment.',
									   'operation/'.(($gridStatus == 1) ? 'opsatglance' : 'postopsatglance'),$alerts);

	}
	//..........................ends here ...........................................
	
	
	//............for fleet............................
	public function fleet()
	{
		$this->data['nav'] = 6;
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('operation/fleet',$this->data);
	}

	public function add_fleet()
	{
		$this->data['nav'] = 6;

		$this->data['vessel_type_list'] 	= $this->pass->getVesselTypeList();
		$this->data['hull_type_list'] 		= $this->pass->getHullTypeList();

								 set_includes(array(DATEPICKER,NUMERIC,SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('operation/add_fleet',$this->data);
	}
	
	public function insert_fleet()
	{
		$this->load->library('form_validation');
		$this->load->helper('dateFormat');
		$this->form_validation->set_rules('m_VESSELNAME', 'Vessel Name','is_unique[vessel_imo_master.VESSELNAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');

			$data['ADDONDATE'] 	    = date("Y-m-d",time());	
			$data['REGISTERYDATE']  = !empty($data['REGISTERYDATE']) ? formatedDate($data['REGISTERYDATE'],'Y-m-d') : '0000-00-00';
			$data['KEELLAIDDATE']   = !empty($data['KEELLAIDDATE']) ? formatedDate($data['KEELLAIDDATE'],'Y-m-d') : '0000-00-00';

			$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Fleet added successfully.', 
									   'Sorry! there was an error while adding Fleet.',
									   'operation/fleet');			
		}
		else
		{
			self::add_fleet();
		}
	}

	public function edit_fleet($id)
	{
		$this->data['nav'] = 6;
		$this->load->helper('dateFormat');

		$this->data['vessel_type_list'] 	= $this->pass->getVesselTypeList();
		$this->data['hull_type_list'] 		= $this->pass->getHullTypeList();

		$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
		$this->data['fleet'] = $this->pass->find_by_pk($id);

								 set_includes(array(DATEPICKER,NUMERIC,SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('operation/edit_fleet',$this->data);		
	}

	public function update_fleet($id)
	{
		$this->load->helper('dateFormat');
		
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		$data['REGISTERYDATE']  = !empty($data['REGISTERYDATE']) ? formatedDate($data['REGISTERYDATE'],'Y-m-d') : '0000-00-00';
		$data['KEELLAIDDATE']   = !empty($data['KEELLAIDDATE']) ? formatedDate($data['KEELLAIDDATE'],'Y-m-d') : '0000-00-00';	
		
		$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Fleet updated successfully.', 
									   'Sorry! there was an error while updating Fleet.',
									   'operation/fleet');		
	}
	//..................ends here.......................
	

}
?>