<?php
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');
class Admin extends MY_controller {	

	private $header  = 'header';
	private $sidebar = 'sidebar';
	private $footer  = 'footer';

	public function __construct()
	{
		parent::__construct();
		if(!$this->session->has_userdata('uid'))
			return redirect('login');

		if( $this->session->has_userdata('otype') || $this->session->has_userdata('ctype'))
			return self::logout();
			
		$this->load->helper('form');
		//.....................set default css and js for output.........................
		set_includes(array(BASIC_CSS, BASIC_JS, NOTIFY, APP, TIMER, SESSION_TIMEOUT));		
		set_header($this->header); 	set_sidebar($this->sidebar); 	set_footer($this->footer);
	   //............................ends here.........................................
	}

	public function index()
	{
		self::dashboard();
	}

	public function dashboard() 
	{
		$this->data['nav'] = 1;
								 set_includes(array(NUMERIC,SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/dashboard',$this->data);
	}
	
	public function insert_invoice_due()
	{
			$data = self::customized_ArrayByKey($this->input->post(),'m');
			$this->pass->setTable(array('login','LOGINID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->update($this->session->uid, $data) ,
									   'Invoice Due and Threshold Days updated successfully.', 
									   'Sorry! there was an error while updated Invoice Days.',
									   'admin/dashboard');			
	}
	//............for fleet............................
	public function fleet()
	{
		$this->data['nav'] = 2;
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/fleet',$this->data);
	}

	public function add_fleet()
	{
		$this->data['nav'] = 2;

		$this->data['vessel_type_list'] 	= $this->pass->getVesselTypeList();
		$this->data['hull_type_list'] 		= $this->pass->getHullTypeList();

								 set_includes(array(DATEPICKER,NUMERIC,SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_fleet',$this->data);
	}
	
	public function insert_fleet()
	{
		$this->load->library('form_validation');
		$this->load->helper('dateFormat');
		$this->form_validation->set_rules('m_VESSELNAME', 'Vessel Name','is_unique[vessel_imo_master.VESSELNAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');

			$data['ADDONDATE'] 	    = date("Y-m-d",time());	
			$data['REGISTERYDATE']  = !empty($data['REGISTERYDATE']) ? formatedDate($data['REGISTERYDATE'],'Y-m-d') : '0000-00-00';
			$data['KEELLAIDDATE']   = !empty($data['KEELLAIDDATE']) ? formatedDate($data['KEELLAIDDATE'],'Y-m-d') : '0000-00-00';

			$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Fleet added successfully.', 
									   'Sorry! there was an error while adding Fleet.',
									   'admin/fleet');			
		}
		else
		{
			self::add_fleet();
		}
	}

	public function edit_fleet($id)
	{
		$this->data['nav'] = 2;
		$this->load->helper('dateFormat');

		$this->data['vessel_type_list'] 	= $this->pass->getVesselTypeList();
		$this->data['hull_type_list'] 		= $this->pass->getHullTypeList();

		$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
		$this->data['fleet'] = $this->pass->find_by_pk($id);

								 set_includes(array(DATEPICKER,NUMERIC,SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_fleet',$this->data);		
	}

	public function update_fleet($id)
	{
		$this->load->helper('dateFormat');
		
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		$data['REGISTERYDATE']  = !empty($data['REGISTERYDATE']) ? formatedDate($data['REGISTERYDATE'],'Y-m-d') : '0000-00-00';
		$data['KEELLAIDDATE']   = !empty($data['KEELLAIDDATE']) ? formatedDate($data['KEELLAIDDATE'],'Y-m-d') : '0000-00-00';	
		
		$this->pass->setTable(array('vessel_imo_master','VESSELIMOID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Fleet updated successfully.', 
									   'Sorry! there was an error while updating Fleet.',
									   'admin/fleet');		
	}
	//..................ends here.......................
	//............for user creation............................
	
	public function user()
	{
		$this->data['nav'] = 3;
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/user_list',$this->data);
	}

	public function add_user()
	{
		$this->data['nav'] = 3;

		$this->data['user_type_list'] = $this->pass->getUserTypeList();
		$this->data['status_list'] = $this->pass->getUserStatusList();
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_user',$this->data);
	}

	public function insert_user()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_USERNAME', 'Username','is_unique[login.USERNAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');				
			unset($data['CPASSWORD']);

			$this->pass->setTable(array('login','LOGINID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'User added successfully.', 
									   'Sorry! there was an error while adding User.',
									   'admin/user');			
		}
		else
		{
			self::add_user();
		}
	}

	public function edit_user($id)
	{
		$this->data['nav'] = 3;

		$this->data['user_type_list'] = $this->pass->getUserTypeList();
		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('login','LOGINID'));
		$this->data['user_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_user',$this->data);
	}

	public function update_user($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		unset($data['CPASSWORD']);	
		
		$this->pass->setTable(array('login','LOGINID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'User updated successfully.', 
									   'Sorry! there was an error while updating User.',
									   'admin/user');		
	}
	//.......................ends here .......................................................
	
	
	//................... GST NO. details ...................................................
	public function gstinno_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/gstinno_list',$this->data);
	}

	public function add_gstinno()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_gstinno',$this->data);		
	}

	public function insert_gstinno()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_GSTIN', 'GSTIN','is_unique[gstin_master.GSTIN]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');
			$this->pass->setTable(array('gstin_master','GSTNOID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'GST No. Details added successfully.', 
									   'Sorry! there was an error while adding GST No. Details.',
									   'admin/gstinno-list');			
		}
		else
		{
			self::add_gstinno();
		}
	}

	public function edit_gstinno($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('gstin_master','GSTNOID'));
		$this->data['gstindata'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_gstinno',$this->data);			
	}

	public function update_gstinno($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		$this->pass->setTable(array('gstin_master','GSTNOID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'GST No. Details updated successfully.', 
									   'Sorry! there was an error while updating GST No. Details.',
									   'admin/gstinno-list');		
	}

	//....................... ends here ........................................................

	
	
	//................... banking details ...................................................
	public function banking_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/banking_list',$this->data);
	}

	public function add_bank()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_bank',$this->data);		
	}

	public function insert_bank()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_ACCOUNT_NUMBER', 'Account Number','is_unique[bank_master.ACCOUNT_NUMBER]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');
			$this->pass->setTable(array('bank_master','BANKID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Bank Details added successfully.', 
									   'Sorry! there was an error while adding Bank Details.',
									   'admin/banking-list');			
		}
		else
		{
			self::add_bank();
		}
	}

	public function edit_bank($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('bank_master','BANKID'));
		$this->data['bank_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_bank',$this->data);			
	}

	public function update_bank($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		$this->pass->setTable(array('bank_master','BANKID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Bank Details updated successfully.', 
									   'Sorry! there was an error while updating Bank Details.',
									   'admin/banking-list');		
	}

	//....................... ends here ........................................................

	//................... cargo details ...................................................
	public function cargo_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/cargo_list',$this->data);
	}

	public function add_cargo()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_cargo',$this->data);
		
	}

	public function insert_cargo()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_NAME', 'Cargo Name','is_unique[cargo_master.NAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');

			$this->pass->setTable(array('cargo_master','CARGOID'));	
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Cargo added successfully.', 
									   'Sorry! there was an error while adding Cargo.',
									   'admin/cargo-list');			
		}
		else
		{
			self::add_cargo();
		}
	}

	public function edit_cargo($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('cargo_master','CARGOID'));	
		$this->data['cargo_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_cargo',$this->data);		
	}

	public function update_cargo($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('cargo_master','CARGOID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Cargo updated successfully.', 
									   'Sorry! there was an error while updating Cargo.',
									   'admin/cargo-list');		
	}
	//....................... ends here ........................................................
	
	
	
	
	
	
	//................... Company details ...................................................
	public function company_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/company_list',$this->data);
	}

	public function add_company()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_company',$this->data);
		
	}

	public function insert_company()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_COMPANY_NAME', 'Company Name','is_unique[company_master.COMPANY_NAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');

			$this->pass->setTable(array('company_master','COMPANYID'));	
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Company added successfully.', 
									   'Sorry! there was an error while adding Company.',
									   'admin/company-list');			
		}
		else
		{
			self::add_company();
		}
	}

	public function edit_company($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('company_master','COMPANYID'));	
		$this->data['company_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_company',$this->data);		
	}

	public function update_company($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('company_master','COMPANYID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Company updated successfully.', 
									   'Sorry! there was an error while updating Company.',
									   'admin/company-list');		
	}
	//....................... ends here ........................................................

	//................... port details ...................................................
	public function port_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/port_list',$this->data);
	}
	
	public function add_port()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,NUMERIC,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_port',$this->data);
		
	}
	
	public function insert_port()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('port_master','PORTID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Port added successfully.', 
									   'Sorry! there was an error while adding Port.',
									   'admin/port-list');	
	}
	
	public function edit_port($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('port_master','PORTID'));
		$this->data['port_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,NUMERIC,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_port',$this->data);		
	}
	
	public function update_port($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('port_master','PORTID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Port updated successfully.', 
									   'Sorry! there was an error while updating Port.',
									   'admin/port-list');			
	}
	//....................... ends here ........................................................

	//................... vendor details ...................................................
	public function vendor_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/vendor_list',$this->data);
	}
	
	public function add_vendor()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();
		$this->data['vendor_type_list'] = $this->pass->getVendorTypeList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_vendor',$this->data);
		
	}
	
	public function insert_vendor()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vendor_master','VENDORID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Vendor added successfully.', 
									   'Sorry! there was an error while adding Vendor.',
									   'admin/vendor-list');	
	}
	
	public function edit_vendor($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();
		$this->data['vendor_type_list'] = $this->pass->getVendorTypeList();

		$this->pass->setTable(array('vendor_master','VENDORID'));
		$this->data['vendor_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_vendor',$this->data);		
	}
	
	public function update_vendor($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vendor_master','VENDORID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									    'Vendor updated successfully.', 
									   'Sorry! there was an error while updating Vendor.',
									   'admin/vendor-list');			
	}
	
	//....................... ends here ........................................................

	//................... vendor type details ...................................................
	public function vendor_type_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/vendor_type_list',$this->data);
	}
	
	public function add_vendor_type()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_vendor_type',$this->data);
		
	}
	
	public function insert_vendor_type()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vendor_type_master','VENDOR_TYPEID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Vendor Type added successfully.', 
									   'Sorry! there was an error while adding Vendor Type.',
									   'admin/vendor-type-list');	
	}
	
	public function edit_vendor_type($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('vendor_type_master','VENDOR_TYPEID'));	
		$this->data['vtype_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_vendor_type',$this->data);		
	}
	
	public function update_vendor_type($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vendor_type_master','VENDOR_TYPEID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Vendor Type updated successfully.', 
									   'Sorry! there was an error while updating Vendor Type.',
									   'admin/vendor-type-list');			
	}
	
	//....................... ends here ........................................................

	//................... vessel type details ...................................................
	public function vessel_type_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/vessel_type_list',$this->data);
	}
	
	public function add_vessel_type()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_vessel_type',$this->data);
		
	}
	
	public function insert_vessel_type()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vessel_type_master','VESSELTYPEID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Vessel Type added successfully.', 
									   'Sorry! there was an error while adding Vessel Type.',
									   'admin/vessel-type-list');		
	}
	
	public function edit_vessel_type($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('vessel_type_master','VESSELTYPEID'));
		$this->data['vtype_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_vessel_type',$this->data);		
	}
	
	public function update_vessel_type($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('vessel_type_master','VESSELTYPEID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Vessel Type updated successfully.', 
									   'Sorry! there was an error while updating Vessel Type.',
									   'admin/vessel-type-list');			
	}
	//....................... ends here ........................................................

	//................... broker details ...................................................
	public function broker_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/broker_list',$this->data);
	}
	
	public function add_broker()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_broker',$this->data);
		
	}
	
	public function insert_broker()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_NAME', 'Broker Name','is_unique[broker_master.NAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');

			$this->pass->setTable(array('broker_master','BROKERID'));	
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Broker added successfully.', 
									   'Sorry! there was an error while adding Broker.',
									   'admin/broker-list');			
		}
		else
		{
			self::add_broker();
		}
	}
	
	public function edit_broker($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('broker_master','BROKERID'));	
		$this->data['broker'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_broker',$this->data);		
	}
	
	public function update_broker($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('broker_master','BROKERID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Broker updated successfully.', 
									   'Sorry! there was an error while updating Broker.',
									   'admin/broker-list');			
	}
	//....................... ends here ........................................................
	//............for opsatglance............................
	public function opsatglance($gridStatus = 1)
	{
		$this->data['gridStatus'] =  $gridStatus;
		$this->data['nav'] = ($gridStatus == 1) ? 5 : (($gridStatus == 2) ? 6 : 7);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID,SWEET_ALERT,DATEPICKER,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/opsatglance',$this->data);
	}
	
	public function view_fixture($gridStatus = 1, $nomid)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] = ($gridStatus == 1) ? 5 : (($gridStatus == 2) ? 6 : 7);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		$this->data['user_list_operation']  = $this->pass->getUserList('operation');
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' ELSE 'Time Charter' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME, (select STATUS_NAME from status_master where status_master.STATUSID=nom_details.FIXTURE_STATUS) as FIXTURESTATUSNAME","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('cargo_master','CARGOID')));
		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		
		$this->data['etanextPort'] = extractString($this->data['nom']->ADD_NEXT_PORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('nom_details_slave','SLAVEID'));
		$this->data['slave'] = $this->pass->all(array("select"=>"*, (select NAME from broker_master where broker_master.BROKERID=nom_details_slave.BROKERID) as BROKERNAME","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave2','NOM_SLAVE2ID'));
		$this->data['slave2'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave2.PORTID) as PORTNAME, (case when (PORTTYPEID = 1) THEN 'LP' ELSE 'DP' END) as PORTTYPE","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave3','NOM_SLAVE3ID'));
		$this->data['slave3'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave3.PORTID) as PORTNAME, (select PURPOSE_NAME from purposeofcall_master where purposeofcall_master.CALLID=nom_details_slave3.PURPOSEOFCALL) as PURPOSE_NAME","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave4'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'BROKER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave5'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'VOYAGE')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave6'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'OWNER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave7'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'CHARTERER')));
		
								 set_includes(array(SWEET_ALERT,CALC,VALIDATE)); 
		$this->data['include'] = include_file_batch();
								 view('admin/view_fixture',$this->data);
	}
	
	public function invoice($gridStatus = 1, $nomid)
	{
		$this->load->helper(['dateFormat','array']);
		$this->load->library("numbertowordconversion");
		$this->data['nav'] = ($gridStatus == 1) ? 5 : (($gridStatus == 2) ? 6 : 7);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' ELSE 'Time Charter' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select VENDORADDRESS1 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS1, (select VENDORADDRESS2 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS2, (select VENDORADDRESS3 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS3 , (select VENDORADDRESS4 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS4, ADDEDBYID","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>" , ","table"=>array('cargo_master','CARGOID')));
		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('company_master','COMPANYID'));
		$this->data['companydata'] = $this->pass->all(array("where"=>array('COMPANYID'=>$this->data['nom']->COMPANYID)));
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));	
		$this->data['f_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_demu_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));		
		$this->data['o_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Deviation' WHEN (INVOICENOTE = 4) THEN CONCAT('Others ( ', INVOICENOTEOTHER, ' )') ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('payment_received','PAYMENTID'));
		$this->data['f_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));	
		$this->data['o_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('summary','SUMMARYID'));
		$this->data['f_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));
		$this->data['o_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
								 set_includes(array(SELECT2,SWEET_ALERT,DATEPICKER,VALIDATE,AUTOSIZE,NUMERIC,CALC,NO_2_WORD)); 
		$this->data['include'] = include_file_batch();
								 view('admin/invoice',$this->data);
	}
	//....................... ends here ........................................................
	//................... cp form type list details ...................................................
	public function cp_form_type_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/cp_form_type_list',$this->data);
	}

	public function add_cp_form_type()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_cp_form_type',$this->data);		
	}

	public function insert_cp_form_type()
	{
		$this->load->library('form_validation');
		$this->form_validation->set_rules('m_NAME', 'CP Form Type Name','is_unique[cp_form_type_master.NAME]',
																			array(
																					'is_unique'     => 'This %s already exists.'
																			)
																	);
		if($this->form_validation->run())
		{
			$data = self::customized_ArrayByKey($this->input->post(),'m');
			$this->pass->setTable(array('cp_form_type_master','CPID'));
			return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'CP Form Type added successfully.', 
									   'Sorry! there was an error while adding CP Form Type.',
									   'admin/cp-form-type-list');			
		}
		else
		{
			self::add_cp_form_type();
		}
	}

	public function edit_cp_form_type($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('cp_form_type_master','CPID'));
		$this->data['cp_data'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_cp_form_type',$this->data);			
	}

	public function update_cp_form_type($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		$this->pass->setTable(array('cp_form_type_master','CPID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'CP Form Type updated successfully.', 
									   'Sorry! there was an error while updating CP Form Type.',
									   'admin/cp-form-type-list');		
	}
	//....................... ends here ........................................................
	
	
	//................... cp form type list details ...................................................
	public function voyage_status_report($status)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] 	   		= 9;
		$this->data['status'] 	    = $status;
		$this->data['label'] 	    = ($status == 1) ? 'Voyages in Book' : (($status == 2) ? 'Voyages in Progress' : 'Completed Voyages');
								 set_includes(array(DATATABLES, DT_BUTTONS, PRINTGRID, FIXED_COLUMN, DATERANGEPICKER, TABLE_2_EXCEL));
		$this->data['include'] = include_file_batch();
								 view('admin/voyage_status_report',$this->data);
	}
	//....................... ends here ........................................................
    
	//................... status  starts here...................................................
	public function status_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/status_list',$this->data);
	}
	
	public function add_status()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_status',$this->data);
		
	}
	
	public function insert_status()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('status_master','STATUSID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Status added successfully.', 
									   'Sorry! there was an error while adding Status.',
									   'admin/status-list');	
	}
	
	public function edit_status($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('status_master','STATUSID'));	
		$this->data['statusdata'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_status',$this->data);		
	}
	
	public function update_status($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('status_master','STATUSID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Status updated successfully.', 
									   'Sorry! there was an error while updating Status.',
									   'admin/status-list');			
	}
	//....................... ends here ........................................................
	
	
	//................... purposeofcall  starts here...................................................
	public function purposeofcall_list()
	{
		$this->data['nav'] = 8;

								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID));
		$this->data['include'] = include_file_batch();
								 view('admin/purposeofcall_list',$this->data);
	}
	
	public function add_purposeofcall()
	{
		$this->data['nav'] = 8;
		$this->data['status_list'] = $this->pass->getUserStatusList();

								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/add_purposeofcall',$this->data);
		
	}
	
	public function insert_purposeofcall()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('purposeofcall_master','CALLID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->insert($data) ,
									   'Purpose Of Call added successfully.', 
									   'Sorry! there was an error while adding Purpose Of Call.',
									   'admin/purposeofcall-list');	
	}
	
	public function edit_purposeofcall($id)
	{
		$this->data['nav'] = 8;

		$this->data['status_list'] = $this->pass->getUserStatusList();

		$this->pass->setTable(array('purposeofcall_master','CALLID'));	
		$this->data['purposeofcalldata'] = $this->pass->find_by_pk($id);
		
								 set_includes(array(SWEET_ALERT,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('admin/edit_purposeofcall',$this->data);		
	}
	
	public function update_purposeofcall($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	

		$this->pass->setTable(array('purposeofcall_master','CALLID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Purpose Of Call updated successfully.', 
									   'Sorry! there was an error while updating Purpose Of Call.',
									   'admin/purposeofcall-list');			
	}
	//....................... ends here ........................................................
	
	public function delegateNom($id)
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');	
        
		$this->pass->setTable(array('nom_details','NOMID'));	
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($id,$data) ,
									   'Ops user updated successfully.', 
									   'Sorry! there was an error while updating Ops user.',
									   'admin/opsatglance');			
	}
	
	
	public function detailed_annual_revenue_report($startDate='',$endDate='')
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] 	   		= 9;
		
		$whereArr = (trim($startDate) != "" && trim($endDate) != "") ? array('CPDATE >=' => trim($startDate),'CPDATE <=' => trim($endDate)) : array(1 => 1);
		$this->data['dateRange'] = (trim($startDate) != "" && trim($endDate) != "") ? formatedDate($startDate, "d/m/Y")." - ".formatedDate($endDate, "d/m/Y") : '';
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$nom = $this->pass->all(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' when (FIXTURETYPE = 2) THEN 'Time Charter' ELSE 'SNP Business' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VESSELTYPE from vessel_type_master where VESSELTYPEID=(select VESSELTYPE from vessel_imo_master where VESSELIMOID=FLEETID)) as VESSELTYPENAME, (select VENDORNAME from vendor_master where VENDORID=OWNER) as OWNERNAME, (case when (FIXTURETYPE = 1 or FIXTURETYPE = 2) THEN (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) ELSE '' END) as VENDORNAME, (select NAME from cargo_master where cargo_master.CARGOID=nom_details.CARGOID) as CARGONAME, (select CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) from port_master where PORTID=LPORT) as LPORTNAME, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) from port_master where PORTID=DPORT) as DPORTNAME, (select SUM(RCVDAMOUNT) from payment_received where payment_received.NOMID=nom_details.NOMID and INVOICETYPE='FREIGHT') as FRT_RCVD, (select SUM(RCVDAMOUNT) from payment_received where payment_received.NOMID=nom_details.NOMID and INVOICETYPE='DEMURRAGE') as DEM_RCVD, (select SUM(RCVDAMOUNT) from payment_received where payment_received.NOMID=nom_details.NOMID and INVOICETYPE='SNP') as SNP_RCVD", "where_in"=>array( 'NOMSTATUS'=> array(2,3,4,5,6,7,8), 'NOMGRIDSTATUS'=> array(1,2,3,4) ), "where"=>$whereArr, "order_by"=>array('NOMID'=>'DESC') ));
		
		if( $nom ){
			foreach($nom as $nomData){
				$this->data['nom'][] = array(
					'FIXTURETYPENAME' => $nomData->FIXTURETYPENAME,
					'NOMINATIONID' => $nomData->NOMINATIONID,	
					'ADDEDBY' => $nomData->ADDEDBY,				
					'CPDATE' => formatedDate($nomData->CPDATE, "d-m-Y"),	
					'FLEETNAME' => $nomData->FLEETNAME,
					'VESSELTYPENAME' => $nomData->VESSELTYPENAME,
					'OWNERNAME' => $nomData->OWNERNAME,
					'VENDORNAME' => $nomData->VENDORNAME,
					'LPORTNAME' => $nomData->LPORTNAME,
					'DPORTNAME' => $nomData->DPORTNAME,
					'CURRENCYCODE' => $nomData->CURRENCYCODE."<br><small>".$nomData->CONVERSIONRATE."</small>",
					'f_invoice_list' => self::getInvoiceMasterData($nomData->NOMID,(($nomData->FIXTURETYPE == 3) ? 'SNP' : 'FREIGHT')),	
					'd_demu_list' => self::getInvoiceMasterData($nomData->NOMID,'DEMURRAGE'),
					'FRT_RCVD' => $nomData->FRT_RCVD,
					'DEM_RCVD' => $nomData->DEM_RCVD,	
					'SNP_RCVD' => $nomData->SNP_RCVD,	
					'FRT_RCVD_USD' => ($nomData->FRT_RCVD != 0 && $nomData->FRT_RCVD != "") ? (($nomData->CURRENCYCODE == 'USD') ? $nomData->FRT_RCVD : (number_format(($nomData->FRT_RCVD/$nomData->CONVERSIONRATE),2,'.',''))) : 0,
					'DEM_RCVD_USD' => ($nomData->DEM_RCVD != 0 && $nomData->DEM_RCVD != "") ? (($nomData->CURRENCYCODE == 'USD') ? $nomData->DEM_RCVD : (number_format(($nomData->DEM_RCVD/$nomData->CONVERSIONRATE),2,'.',''))) : 0,
					'SNP_RCVD_USD' => ($nomData->SNP_RCVD != 0 && $nomData->SNP_RCVD != "") ? (($nomData->CURRENCYCODE == 'USD') ? $nomData->SNP_RCVD : (number_format(($nomData->SNP_RCVD/$nomData->CONVERSIONRATE),2,'.',''))) : 0				
				);			
			}
		}else{$this->data['nom'] = array();}
		//print_r($this->data['nom']);
								 set_includes(array(DATATABLES, DATERANGEPICKER, TABLE_2_EXCEL));
		$this->data['include'] = include_file_batch();
								 view('admin/detailed_annual_revenue_report',$this->data);
	}
	
	public function editcommissioninvoice($gridStatus, $nomid)
	{
		$this->load->helper('dateFormat');
		$data 					= self::customized_ArrayByKey($this->input->post(),'m');
		$data['INVOICEDATE'] 	= formatedDate($data['INVOICEDATE1']);
		$data['ATTN'] 			= $data['ATTN1'];
		$data['INVOICENUMBER'] 	= $data['INVOICENUMBER1'];
		
		$invoiceID 				= $data['INVOICEID'];
		
		unset($data['INVOICEID']);unset($data['INVOICEDATE1']);unset($data['ATTN1']);unset($data['INVOICENUMBER1']);
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($invoiceID, $data) ,
									   'Invoice Details updated successfully.', 
									   'Sorry! there was an error while updating Invoice.',
									   "admin/invoice/{$gridStatus}/{$nomid}");
		
	}
	
	private function getInvoiceMasterData($nomid, $invoiceType)
	{
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		return $this->pass->all(array("select"=>"INVOICENUMBER, INVOICEDATE, COMMISSIONVALUE", "where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>$invoiceType) ));
	}
}
?>