<?php
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');
class Claims extends MY_controller {	

	private $header  = 'header';
	private $sidebar = 'sidebar';
	private $footer  = 'footer';

	public function __construct()
	{
		parent::__construct();
		if(!$this->session->has_userdata('uid'))
			return redirect('login');

		if( $this->session->has_userdata('atype') || $this->session->has_userdata('otype'))
			return self::logout();
			
		$this->load->helper('form');
		//.....................set default css and js for output.........................
		set_includes(array(BASIC_CSS, BASIC_JS, NOTIFY, APP, TIMER, SESSION_TIMEOUT));		
		set_header($this->header); 	set_sidebar($this->sidebar); 	set_footer($this->footer);
	   //............................ends here.........................................
	}

	public function index()
	{
		self::dashboard();
	}

	public function dashboard() 
	{
		$this->data['nav'] = 1;
		$this->data['include'] = include_file_batch();
								 view('claims/dashboard',$this->data);
	}
	
	//............for opsatglance............................
	public function opsatglance($gridStatus = 1)
	{
		$this->data['gridStatus'] =  $gridStatus;
		$this->data['nav'] = ($gridStatus == 1) ? 2 : (($gridStatus == 2) ? 3 : 4);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		
								 set_includes(array(DATATABLES,DT_BUTTONS,PRINTGRID,SWEET_ALERT,DATEPICKER,VALIDATE));
		$this->data['include'] = include_file_batch();
								 view('claims/opsatglance',$this->data);
	}
	
	public function view_fixture($gridStatus = 1, $nomid)
	{
		$this->load->helper('dateFormat');
		$this->data['nav'] = ($gridStatus == 1) ? 2 : (($gridStatus == 2) ? 3 : 4);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' ELSE 'Time Charter' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select STATUS_NAME from status_master where status_master.STATUSID=nom_details.FIXTURE_STATUS) as FIXTURESTATUSNAME","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('cargo_master','CARGOID')));
		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>"<br>&nbsp;&nbsp;&nbsp;&nbsp;","table"=>array('port_master','PORTID')));
		$this->data['etanextPort'] = extractString($this->data['nom']->ADD_NEXT_PORT,array("select"=>"CONCAT(PORTNAME, ',', COUNTRYNAME) ","where"=>"PORTID",'implode'=>",  ","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('nom_details_slave2','NOM_SLAVE2ID'));
		$this->data['slave2'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave2.PORTID) as PORTNAME, (case when (PORTTYPEID = 1) THEN 'LP' ELSE 'DP' END) as PORTTYPE","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave3','NOM_SLAVE3ID'));
		$this->data['slave3'] = $this->pass->all(array("select"=>"*,(select CONCAT(PORTNAME, ',', COUNTRYNAME)  AS PORTNAME from port_master where port_master.PORTID=nom_details_slave3.PORTID) as PORTNAME, (select PURPOSE_NAME from purposeofcall_master where purposeofcall_master.CALLID=nom_details_slave3.PURPOSEOFCALL) as PURPOSE_NAME","where"=>array('NOMID'=>$nomid)));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave4'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'BROKER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave5'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'VOYAGE')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave6'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'OWNER')));
		
		$this->pass->setTable(array('nom_details_slave4','NOM_SLAVE4ID'));
		$this->data['slave7'] = $this->pass->all(array("select"=>"NOTES","where"=>array('NOMID'=>$nomid,'IDENTIFY'=>'CHARTERER')));
		
		$this->pass->setTable(array('nom_details_slave','SLAVEID'));
		$this->data['slave'] = $this->pass->all(array("select"=>"*, (select NAME from broker_master where broker_master.BROKERID=nom_details_slave.BROKERID) as BROKERNAME","where"=>array('NOMID'=>$nomid)));
								 
		$this->data['include'] = include_file_batch();
								 view('claims/view_fixture',$this->data);
	}
	
	
	
	public function invoice($gridStatus = 1, $nomid)
	{
		$this->load->helper(['dateFormat','array']);
		$this->load->library("numbertowordconversion");
		$this->data['nav'] = ($gridStatus == 1) ? 2 : (($gridStatus == 2) ? 3 : 4);
		$this->data['label1'] = ($gridStatus == 1) ? 'In Ops at a glance' : (($gridStatus == 2) ? 'Post Ops at a glance' : 'HISTORY');
		$this->data['gridStatus'] 		 = $gridStatus;
		
		$this->pass->setTable(array('nom_details','NOMID'));
		$this->data['nom'] = $this->pass->first(array("select"=>"*, (case when (FIXTURETYPE = 1) THEN 'Voyage Spot' ELSE 'Time Charter' END) as FIXTURETYPENAME, (select VESSELNAME from vessel_imo_master where VESSELIMOID=FLEETID) as FLEETNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.OWNER) as OWNERNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as CCOMMNAME, (select VENDORNAME from vendor_master where vendor_master.VENDORID=nom_details.VENDORID) as VENDORNAME, (select CONTACTPERSON from login where LOGINID=CLAIMSLOGINID) as CLAIMSLOGINNAME, (select VENDORADDRESS1 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS1, (select VENDORADDRESS2 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS2, (select COMPANY_NAME from company_master where company_master.COMPANYID=nom_details.COMPANYID) as COMPANYNAME, (select VENDORADDRESS3 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS3 , (select VENDORADDRESS4 from vendor_master where vendor_master.VENDORID=nom_details.CCOMMISSIONFROM) as VENDORADDRESS4","where"=>array("NOMID"=>$nomid)));
		
		$this->data['nom']->CURRENCYCODENAME = $this->pass->getCurrencyList()[$this->data['nom']->CURRENCYCODE];
		
		$this->data['cargo'] = extractString($this->data['nom']->CARGOID,array("select"=>"NAME","where"=>"CARGOID",'implode'=>" , ","table"=>array('cargo_master','CARGOID')));
		
		$this->data['loadPort'] = extractString($this->data['nom']->LPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>"\n","table"=>array('port_master','PORTID')));
		$this->data['dischargePort'] = extractString($this->data['nom']->DPORT,array("select"=>"CONCAT(PORTNAME, '  ,  ', COUNTRYNAME) ","where"=>"PORTID",'implode'=>"\n","table"=>array('port_master','PORTID')));
		
		$this->pass->setTable(array('company_master','COMPANYID'));
		$this->data['companydata'] = $this->pass->all(array("where"=>array('COMPANYID'=>$this->data['nom']->COMPANYID)));
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));	
		$this->data['f_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_demu_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));		
		$this->data['o_invoice_list'] = $this->pass->all(array("select"=>"*,( CASE WHEN (INVOICENOTE = '') THEN '' WHEN (INVOICENOTE = 1) THEN 'Credit Note' WHEN (INVOICENOTE = 2) THEN 'Debit Note' WHEN (INVOICENOTE = 3) THEN 'Deviation' WHEN (INVOICENOTE = 4) THEN CONCAT('Others ( ', INVOICENOTEOTHER, ' )') ELSE '' END) as INVOICENOTENAME","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('payment_received','PAYMENTID'));
		$this->data['f_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));	
		$this->data['o_payment_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->pass->setTable(array('summary','SUMMARYID'));
		$this->data['f_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'FREIGHT')));
		$this->data['d_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'DEMURRAGE')));
		$this->data['o_summary_list'] = $this->pass->all(array("where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>'OTHERS')));
		
		$this->data['owner_list'] = $this->pass->getOwnerChartererList();
		$this->data['invoice_list'] = $this->pass->getInvoiceStatusList();
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE,DATEPICKER,NUMERIC,CALC));
		$this->data['include'] = include_file_batch();
								 view('claims/invoice',$this->data);
	}
	
	public function insert_summary($gridStatus = 1, $invoice_type, $fixtureType)
	{
		$this->load->helper(['dateFormat','array']);
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		
		if($invoice_type == 'Freight'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s1',$data['PID']);}
		if($invoice_type == 'Demurrage'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s2',$data['DID']);}
		if($invoice_type == 'Others'){	$slave_data = self::customized_ArrayByKey($this->input->post(),'s3',$data['OID']);}
		
		$alerts = [
					[
						'ALERTBY' 		=> $this->session->uid,
						'ALERTTO' 		=> 1,
						'ALERTTEXT'		=> $invoice_type.'  Claims Summary saved by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
						'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'admin/invoice/'.$gridStatus.'/'.$data['NOMID'],
						'ALERTTYPE'		=> 'Claims Summary'
					 ],
					 [
						'ALERTBY'		=> $this->session->uid,
						'ALERTTO'		=> $data['OPERATIONLOGINID'],
						'ALERTTEXT'		=> $invoice_type.'  Claims Summary saved by '.$this->data['userData']->CONTACTPERSON.' - '.$data['NOMINATIONID'],
						'NOMID'			=> $data['NOMID'],'ALERTLINK'=>'operation/'.(($fixtureType == 1) ? 'invoiceVoyage' : 'invoiceTime').'/'.$gridStatus.'/'.$data['NOMID'],
						'ALERTTYPE'		=> 'Claims Summary'
					 ]
				  ];
				  
		$this->pass->setTable(array('summary','SUMMARYID'));
		$this->pass->delete(array("where"=>array('NOMID' => $data['NOMID'], 'INVOICETYPE' => $invoice_type)));
				
		for($i=1;$i<=count($slave_data);$i++):
			$slave_data[$i]['ONDATE'] 	   	= !empty($slave_data[$i]['ONDATE']) ? formatedDate($slave_data[$i]['ONDATE']) : '0000-00-00';
			$slave_data[$i]['PAYMENTDATE'] 	= !empty($slave_data[$i]['PAYMENTDATE']) ? formatedDate($slave_data[$i]['PAYMENTDATE']) : '0000-00-00';
			$slave_data[$i]['AGREEDDATE'] 	= !empty($slave_data[$i]['AGREEDDATE']) ? formatedDate($slave_data[$i]['AGREEDDATE']) : '0000-00-00';
			$insertId = $this->pass->insert($slave_data[$i]);
		endfor;
		
		return self::_flashAndRedirectAllWithAlertArray($insertId,
									   $invoice_type.' Claims Summary ('.$data['NOMINATIONID'].') saved successfully.', 
									   'Sorry! there was an error while saving Claims Summary.',
									   'claims/'.(($gridStatus == 1) ? 'opsatglance' : 'postopsatglance'),$alerts);
	}
	//..........................ends here ...........................................
	

}
?>