<?php
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');

class MY_controller extends CI_Controller {
	public $data = array();
	public function __construct()
	{
		parent::__construct();
		if($this->session->uid):
			 date_default_timezone_set('UTC');
			 $this->pass->setTable(array('login','LOGINID'));
			 $this->data['userData'] 	= $this->pass->find_by_pk($this->session->uid);	
			 //...........................alert msg ...............................
			 self::getAlertMsgList();
			 //........................ ends here ...........................
		endif;
	}

	public function index() 
	{
		//.........................
	}
	
	public function getAlertMsgList()
	{
		$this->pass->setTable(array('alert_master','ALERTID'));
		if(uri_string() != ''):
			$this->pass->updateWhere(['ALERTSTATUS'=>1], array("where"=>array('ALERTLINK'=>uri_string())));
		endif;
		$this->data['alert_msg'] = $this->pass->all(array("where"=>array('ALERTTO'=>$this->session->uid, 'ALERTSTATUS'=>'0'),"order_by"=>array('ALERTDATE'=>'desc')));
	}
	//..................for current user profile...........................
	public function profile()
	{
		$this->data['nav'] = 1;
		$this->data['status_list'] = $this->pass->getUserStatusList();
		
								 set_includes(array(SWEET_ALERT,VALIDATE,AUTOSIZE));
		$this->data['include'] = include_file_batch();
								 view('profile',$this->data);
	}
	
	public function updateprofile()
	{
		$data = self::customized_ArrayByKey($this->input->post(),'m');
		unset($data['CPASSWORD']);
		
		$this->pass->setTable(array('login','LOGINID'));
		return self::_flashAndRedirectAllWithAlertArray($this->pass->update($this->session->uid, $data) ,
									   'Profile updated successfully.', 
									   'Sorry! there was an error while updating Profile.',
									   $this->session->user_type.'/profile');
	}
	//.......................ends here .......................................................
	public function logout()
	{
		$this->session->sess_destroy();
		return redirect('login','refresh');
	}
	
	public function _getMaxNumber($field, $params = array())
	{
		return $this->pass->getMaxNumberBasedOnCondition("$field");
	}

	public function _flashAndRedirectAllWithAlertArray($successful, $successMessage, $failureMessage ,$redirection, $alerts = array())
	{
		if($successful):
			if(!empty($alerts)):
				$this->pass->setTable(array('alert_master','ALERTID'));
				$this->pass->insertBatch($alerts);
			endif;
			$this->session->set_flashdata('alert',$successMessage);
			$this->session->set_flashdata('class','success');
			$this->session->set_flashdata('icon','zmdi zmdi-check-all');
		else:
			$this->session->set_flashdata('alert',$failureMessage);
			$this->session->set_flashdata('class','danger');
			$this->session->set_flashdata('icon','zmdi zmdi-alert-triangle');
		endif;		
		return redirect($redirection);
	}

	public function customized_ArrayByKey($array,$prefix,$chunk_val = '',$escape=true,$valArr = array())
	 {
		foreach($array as $key=>$value) :
			$value = ($escape) ? escape($value) : $value;
			$newkey = explode("_",$key);
			if(current($newkey) == $prefix):
				if(current($newkey) == 'm'):
						unset($newkey[0]);
						$newArray[$prefix][implode("_",$newkey)] = (is_array($value)) ? implode(",",$value) : trim($value);
				else:
						if($chunk_val == ''): $newArray = array();
						else:
							$index = $newkey[count($newkey)-1];
							unset($newkey[count($newkey)-1]);unset($newkey[0]);
							if(!empty($valArr)):
								foreach($valArr as $valKey=>$newValue) :
									$newArray[$prefix][$index][$valKey] = (is_array($newValue)) ? implode(",",$newValue) : trim($newValue);		
								endforeach;	
							endif;
							$newArray[$prefix][$index][implode("_",$newkey)] = (is_array($value)) ? implode(",",$value) : trim($value);	
						endif;	
				endif;
			endif;		
		endforeach;	
		if($prefix == 'm'):
				return $newArray[$prefix];
		else:
				if($chunk_val != ''):
					$data = array_chunk($newArray[$prefix],$chunk_val,true)[0];
					return array_combine(range(1, count($data)), array_values($data));
				else : 
					return array();
				endif;
		endif;
	 }
	 
	 public function customized_ArrayByKey_forArrayData($array,$prefix,$chunk_val = '',$escape=true)
	 {
		foreach($array as $key=>$value) :
			$newkey = explode("_",$key); 
			if(current($newkey) == 's1'):
				unset($newkey[0]);
				$currArray[implode("_",$newkey)] = $value;	
			endif;		
		endforeach;	
		for($i=0; $i<$chunk_val; $i++):$arr = array();
			foreach($currArray as $forkey=>$forvalue):				
				$arr[] = array($forkey=>$forvalue[$i]);
			endforeach;
			$newArray[$i] = array_reduce($arr, 'array_merge', array());
		endfor;
		return $newArray;
	 }

	 public function getUploadName($upload)
	{
		if(gettype($upload['name']) == 'array')
		{
			foreach($upload['name'] as $key=>$value)
			{
				if(trim($upload['name'][$key]) != '')
				{
					$ext_arr = explode(".", $upload['name'][$key]);
					list($txt, $ext) = explode(".", $upload['name'][$key]);
					$filename = $upload['name'][$key];
					$name[$key] = $filename;
				}
			}
		}
		else
		{
			if(trim($upload['name'] ) != '')
			{
				$ext_arr = explode(".", $upload['name']);
				list($txt, $ext) = explode(".", $upload['name']);
				$filename = $upload['name'];
				$name = $filename;
			}
		}
		return $name;
	}
	
	public function getUpload($path, $files)
	{
			//you need enable in php.ini ;extension=php_fileinfo.dll   to extension=php_fileinfo.dll
			$config = array(
				'upload_path'   => $path,
				'allowed_types' => '*',
				'overwrite'     => FALSE                      
			);
			
			$this->load->library('upload', $config);
			$images = array();
			foreach ($files['name'] as $key => $image) {
				$_FILES['images[]']['name']= $files['name'][$key];
				$_FILES['images[]']['type']= $files['type'][$key];
				$_FILES['images[]']['tmp_name']= $files['tmp_name'][$key];
				$_FILES['images[]']['error']= $files['error'][$key];
				$_FILES['images[]']['size']= $files['size'][$key];
	
				$ext_arr = explode(".", $files['name'][$key]);
				$fileName = substr(number_format(time() * rand(),0,'',''),0,10).'.'.$ext_arr[count($ext_arr) - 1];
				
				$images[] = $fileName;	
				$config['file_name'] = $fileName;
					
				$this->upload->initialize($config);	
				if ($this->upload->do_upload('images[]')) {
					$this->upload->data();
				} else {
					return false;
				}
			}
			return $images;
	}

	public function _returnJsonData($totalData,$totalFiltered,$data)
	{
		$json_data = array( "draw" => intval( $_POST['draw'] ), 
						    "recordsTotal" => intval( $totalData ), 
							"recordsFiltered" => intval( $totalFiltered ), 
							"csrf_token_name" => $this->security->get_csrf_hash(),
							"records" => $data
						  );
		$this->output->set_header("Pragma: no-cache");
        $this->output->set_header("Cache-Control: no-store, no-cache");
		$this->output->set_content_type('application/json')->set_output(json_encode($json_data));
	}
	
	public function getAlertBasedOnDays($days,$nomid,$nomstatus,$invoiceType)
	{
		$countTable = $this->pass->count_all('payment_received',array('NOMID'=>$nomid,'INVOICETYPE'=>$invoiceType));
		if($countTable == 0):
			$this->pass->setTable(array('invoice_master','INVOICEID'));
			$invoice = $this->pass->first(array("select"=>"INVOICEDATE","where"=>array('NOMID'=>$nomid, 'INVOICETYPE'=>$invoiceType)));
			if(!empty($invoice)):
				return (strtotime($invoice->INVOICEDATE) + (86400 * $days) <= strtotime(date("Y-m-d"))) ? ucfirst(strtolower($invoiceType)).' Commission Due' : '';
			else: return '';
			endif;
		else: return '';
		endif;
	}
	
	
	public function getCompanydataJson()
	{
		$this->pass->setTable(array('company_master','COMPANYID'));
		return json_encode($this->pass->all(array("select"=>"*", "where"=>array('STATUS'=>1))));
	}
	
	public function getInvoiceDueDateAlert($obj = array(), $invoiceType)
	{
		$this->pass->setTable(array('login','LOGINID'));
		$admin = $this->pass->first(array("where"=>array('USERTYPE'=>'admin'),"order_by"=>array('LOGINID'=>'asc')));
		
		$this->pass->setTable(array('invoice_master','INVOICEID'));
		$invoicecount = count($this->pass->all(array("where"=>array('NOMID'=>$obj->NOMID,'INVOICETYPE'=>$invoiceType))));
		
		$this->pass->setTable(array('payment_received','PAYMENTID'));
		$paymentcount = count($this->pass->all(array("where"=>array('NOMID'=>$obj->NOMID,'INVOICETYPE'=>$invoiceType))));
		$date = ($invoiceType == 'FREIGHT') ? formatedDate($obj->CDDATE) : formatedDate($obj->DEMCDDATE);
		$days = ($invoiceType == 'FREIGHT') ? (($obj->FIXTURETYPE == 1) ? ($admin->FRTDUEDAYS - $admin->FRTTHRESHOLDDAYS) : ($admin->HIREDUEDAYS - $admin->HIRETHRESHOLDDAYS)) : ($admin->DEMUDUEDAYS - $admin->DEMUTHRESHOLDDAYS);
		$label = (($invoiceType == 'FREIGHT') ? (($obj->FIXTURETYPE == 1) ? 'Freight' : 'Hire') : 'Demurrage').' Payment Due';
		
		if($invoicecount > 0 && $paymentcount == '' && $date != "" && $days != 0):
			return (strtotime($date) + (86400 * $days) <= strtotime(date("Y-m-d"))) ? $label : '';
		else:
			return '';
		endif;	
	}
}
?>