<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

if ( ! function_exists('textile_sanitize'))
{
    function textile_sanitize($string)
    {
        $whitelist = '/[^a-zA-Z0-9?-??-?��???????????????? \.\*\+\\n\/(),\'"&|#;:!"%@{} _-]/';
		return preg_replace($whitelist, '', $string);
    }   
}

function escape($string)
{
	return textile_sanitize($string);
}

if ( ! function_exists('secure'))
{
    function secure() {
		if(SECURE):
			$CI = get_instance();
			if($CI->config->item('valid_date') > security_decrypt(SECURITY_KEY, $CI->config->item('encryption_key'))):
				if($CI->router->class == 'error'):	return;
				else : $CI->session->sess_destroy(); return redirect(site_url('error/login'),'refresh');
				endif;
			endif;	
		else: return;
		endif;	
	}  
}

if ( ! function_exists('security_decrypt'))
{
    function security_decrypt($decrypt, $key)
    {
		error_reporting(E_ALL ^ E_DEPRECATED);
        $decrypt = explode('|', $decrypt.'|');
		$decoded = base64_decode($decrypt[0]);
		$iv = base64_decode($decrypt[1]);
		if(strlen($iv)!==mcrypt_get_iv_size(MCRYPT_SOH_256, MCRYPT_MODE_CBC)){ return false; }
		$key = pack('H*', $key);
		$decrypted = trim(mcrypt_decrypt(MCRYPT_SOH_256, $key, $decoded, MCRYPT_MODE_CBC, $iv));
		$mac = substr($decrypted, -64);
		$decrypted = substr($decrypted, 0, -64);
		$calcmac = hash_hmac('sha256', $decrypted, substr(bin2hex($key), -32));
		if($calcmac!==$mac){ return false; }
		$decrypted = unserialize($decrypted);
		return $decrypted;
    }   
}