<?php 
defined('SECURITY_KEY') OR exit('No direct script access allowed');
class Layouts
{

  // hold codeigniter instance
	private $CI;

	// hold layout header
	private $layout_header = null;

	// hold layout sidebar
	private $layout_sidebar = null;
	
	// hold layout footer
	private $layout_footer = null;

	//final include output
	private $final_includes = '';

	// hold includes like css and js files
	private $includes = array();	

	public function __construct()
	{
		$this->CI =& get_instance();
	}

	// set layout header
	public function header($header)
	{
		$this->layout_header = $header;
	}

	// set layout sidebar
	public function sidebar($sidebar)
	{
		$this->layout_sidebar = $sidebar;
	}
	
	// set layout footer
	public function footer($footer)
	{
		$this->layout_footer = $footer;
	}

	// set includes
	public function set_includes($includes= array())
	{
		$this->includes = array_merge($this->includes,$includes);
	}

	// add includes like css and js
	public function include_file_batch()
	{
		$this->CI->load->helper('url');
		
		foreach($this->includes as $include):
			foreach($include as $inKey => $inValue):
				if (preg_match('/js$/', $inValue)):			
					$this->final_includes .= '<script src="'.site_url('assets/'.$inValue).'"></script>' . "\n\r";
				elseif (preg_match('/css$/', $inValue) || preg_match('/fonts./', $inValue)):
					$this->final_includes .= '<link href="'.((preg_match('/fonts./', $inValue)) ? $inValue : site_url('assets/'.$inValue)).'" rel="stylesheet"/>' . "\n\r";
				endif;
			endforeach;
		endforeach;

		return $this->final_includes;
	}

	// call the layouts view from the controller
	public function view($view_name, $pagedata = array(), $layouts = array())
	{
		if (is_array($layouts) && count($layouts) >= 1):
			foreach ($layouts as $layout_key => $layout):
				$pagedata[$layout_key] = $this->CI->load->view($layout, $pagedata, true);
			endforeach;
		endif;
		
		$page = ($this->CI->router->class == 'login') ? $this->CI->load->view($view_name, $pagedata, true) : $this->CI->load->view(substr(LAYOUTS,6,8).$this->layout_header, $pagedata, true);
	
		$patternjs = '/<script src="/';
		$patterncss = '/rel="stylesheet"/';
		
		$result = preg_match_all($patternjs, $page, $matches) + preg_match_all($patterncss, $page, $matches);
		
		(!empty($this->layout_header) && trim($this->layout_header) != null && is_file(APPPATH.LAYOUTS.$this->layout_header.EXT)) 
			? 	$this->CI->load->view(substr(LAYOUTS,6,8).$this->layout_header, $pagedata) 	: 	'';

		(!empty($this->layout_sidebar) && trim($this->layout_sidebar) != null && is_file(APPPATH.LAYOUTS.$this->layout_sidebar.EXT)) 
			? 	$this->CI->load->view(substr(LAYOUTS,6,8).$this->layout_sidebar, $pagedata) 	: 	'';
		
		(!empty($view_name) && trim($view_name) != '' && is_file(APPPATH.substr(LAYOUTS,0,6).$view_name.EXT)) 
			? 	( ($result == (count($this->includes,1) - count($this->includes))) ? $this->CI->load->view($view_name, $pagedata) : exit('illegal declaration of script!') ) 	: 	'';

		(!empty($this->layout_footer) && trim($this->layout_footer) != null && is_file(APPPATH.LAYOUTS.$this->layout_footer.EXT)) 
			? 	$this->CI->load->view(substr(LAYOUTS,6,8).$this->layout_footer, $pagedata) 	: 	'';
	}

}

?>