<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class App_model extends CI_Model {

	public function __construct()
	{
		parent::__construct();
		secure();
	}
	
	public function setTable($tableConfig = array(), $object = true)
	{
		$this->table 		= current($tableConfig);
		$this->primary_key  = end($tableConfig);
		$this->Object		= $object;
	}

	public function insert($data = array())
	{
			secure();
			$this->db->insert($this->table, $data);
			return $this->db->insert_id();
	}
	
	public function save($data = array())
	{
			/*if (in_array('ADDONDATE', array_keys($data))) {
					$data['ADDONDATE'] = date('Y-m-d H:i:s');
			}
			
			if (in_array('UPDATEONDATE', array_keys($data))) {
					$data['UPDATEONDATE'] = date('Y-m-d H:i:s');
			}*/
		
			$this->db->insert($this->table, $data);
			return $this->db->insert_id();
	}
	
	public function insertBatch($data = array())
	{
			secure();
			$this->db->insert_batch($this->table, $data);
			return $this->db->affected_rows();
	}

	public function find_by_pk($id)
	{
			if ($id == NULL): return NULL; endif;

			$query = $this->db->where($this->primary_key, $id)
							  ->get($this->table);
			return ($this->Object == true) ? $query->row() : $query->row_array();
	}

	public function find( $param = 'all', $options = array() )
	{
		if ($param == 'all' || $param == 'first' || $param == 'last') :
		   switch ($param):
				case   'all':
					$result = self::all($options);
					break;
				
				case 'first':
					$result = self::first($options);
					break;
				
				case  'last':
					$result = self::last($options);
					break;
			endswitch;
			return $result;	
		endif;
	}
	
	public function call_method( $options = array() )
	{
		secure();
		if (isset($options['select'])) 	  : $this->db->select($options["select"]); endif;
		if (isset($options['limit'])) 	  : $this->db->limit($options["limit"]); endif;
		if (isset($options['where_str'])) : $this->db->where($options["where_str"]); endif;
		if (isset($options['like'])) :			
			foreach($options['like'] as $field => $value):
				if(!empty($value)):
					$this->db->like($field, $value); 
				endif;
			endforeach;
		endif;
		if (isset($options['or_like'])) :
			$this->db->or_group_start();			
			foreach($options['or_like'] as $field => $value):
				$this->db->or_like($field, $value); 
			endforeach;
			$this->db->group_end();
		endif;
		if (isset($options['join'])) :			
			foreach($options['join'] as $field => $value):
				$this->db->join($field, $value); 
			endforeach;
		endif;
		if (isset($options['where'])) :			
			foreach($options['where'] as $field => $value):
				$this->db->where($field, $value); 
			endforeach;
		endif;	
		if (isset($options['where_in'])) :
			foreach($options['where_in'] as $field => $value):
				if(!empty($value)):	
					$this->db->where_in($field, $value); 
				endif;
			endforeach;
		endif;
		if (isset($options['where_not_in'])) :
			foreach($options['where_not_in'] as $field => $value):
				if(!empty($value)):	
					$this->db->where_not_in($field, $value); 
				endif;
			endforeach;
		endif;
		if (isset($options['group_by'])) :			
			if(!empty($options['group_by'])):
				$this->db->group_by($options['group_by']); 
			endif;
		endif;		
		if (isset($options['order_by'])) : 
			foreach($options['order_by'] as $order_by_field => $order_by_value):
				$this->db->order_by($order_by_field, $order_by_value); 
			endforeach;
		endif;
		if (isset($options['union'])) :			
			if(!empty($options['union'])):  
				return $this->db->query($options['union']);
			endif;
		endif;
	}

	public function last_query( $tablename, $options = array() )
	{
		self::call_method($options);
		$query = $this->db->get($tablename);
		$LastQuery = $this->db->last_query();
		
		return $LastQuery;
	}
	
	public function all( $options = array() )
	{
				  self::call_method($options);		
		$query = $this->db->get($this->table);
		return ($this->Object == true) ? $query->result() : $query->result_array();
	}	
	
	public function first( $options = array() )
	{
				  self::call_method($options);	
		$query = $this->db->get($this->table,1);
		return ($this->Object == true) ? $query->row() : $query->row_array();
	}
	
	public function last( $options = array() )
	{
				  self::call_method($options);
		$query = $this->db->order_by($this->primary_key,"desc")
						  ->get($this->table,1);								   
		return ($this->Object == true) ? $query->row() : $query->row_array();
	}

	public function update($id, $data)
	{
		secure();
		return $this->db->where($this->primary_key, $id)
					    ->update($this->table, $data);
	}
	
	public function updateBatch($data, $key)
	{
			$this->db->update_batch($this->table, $data, $key);
			return $this->db->affected_rows();
	}
	
	public function updateWhere($data, $options = array())
	{
				self::call_method($options);
				$this->db->update($this->table, $data);
		 return $this->db->affected_rows();
	}

	public function delete($options = array())
	{
				self::call_method($options);
				$this->db->delete($this->table);
		 return $this->db->affected_rows();
	} 
	
	public function getJsonTable($columns,$requestData,$q = ' ')
	{
		$searchArr = array();
		if( !empty($requestData['search']['value']) ):				
					  $x = 0; 
					  foreach($columns as $column) :
					  		$searchArr[] = '%'.$this->db->escape_like_str($requestData['search']['value']).'%';
					  		if($x == 0){$q .= " AND ( ".$columns[$x]." LIKE ? ";}
								  else {$q .= " OR ".$columns[$x]." LIKE ? ";if($x == count($columns)-1){$q .= " ) ";}}
					  		$x++;					
					  endforeach;
		endif;
		$num_rows = $this->db->query($q,$searchArr)->num_rows();
		$q .= " ORDER BY ". $columns[$requestData['order'][0]['column']]."   ".$requestData['order'][0]['dir']."  LIMIT ".$requestData['start']." ,".$requestData['length']."   ";
		return array('numRows'=>$num_rows,'result'=>$this->db->query($q,$searchArr)->result());
	}
	
	public function count_all($tableName,$whereArr)
	{
		$q = $this->db->from($tableName)
					  ->where($whereArr);
		return $q->count_all_results();
	}
	
	public function getMaxID($field, $param)
	{
			  self::call_method($param);
		$q = $this->db->select_max("$field", "LATESTNUMBER")
		              ->get($this->table);
		return $q->row();
	}
	
}