<?php
class Pass extends App_model {

	public $varpass = array();

	public function __construct()
	{
		parent::__construct();
	}
	
	public function getSelectList($tableName, $options = array(), $type='')
	{
		$arr[''] = ($type == 'multiple') ? '' : '---Select from list---';		
			  self::call_method($options);
		$q = $this->db->get($tableName);
		if($q->result()):
			foreach($q->result() as $result):
				$arr[current($result)] = end($result);
			endforeach;				
		endif;
		return $arr;
	}
	
	public function getResultArray($result)
	{
		if($result):
			foreach($result as $result):
				$arr[current($result)] = end($result);
			endforeach;				
		endif;
		return $arr;
	}

	public function getUserTypeList() 
	{
		return ['operation'=>'Operations','claims'=>'Claims'];
	}
	
	public function getvesselstatusList()
	{
	 return [''=>'---Select from list---','1'=>'Operations','2'=>'Discussion','3'=>'Laytimes','4'=>'Arrivals','5'=>'FFI','6'=>'PFHS','7'=>'FHS','8'=>'Cancelled','9'=>'Settled'];
	}

	public function getvcStatusList()
	{
	 return [''=>'---Select from list---','1'=>'Pending Laytimes','2'=>'Laytime Received from owners','3'=>'Comments from Charterer','4'=>'Under discussion','5'=>'LC Agreed'];
	}


	public function getInvoiceNoteList()
	{
		return [''=>'---Select from list---','1'=>'Credit Note','2'=>'Debit Note','3'=>'Invoice','4'=>'Deviation','5'=>'Other'];
	}
	
	public function getInvoiceMOLOOFUN()
	{
		return [''=>'---Select from list---','1'=>'MOLOO','2'=>'MOLCHOP'];
	}
	
	
	public function getOwnerChartererList()
	{
		return ['Owner'=>'Owner','Charterer'=>'Charterer'];
	}
	
	public function getInvoiceStatusList()
	{
		return [''=>'---Select from list---','Agreed'=>'Agreed','Disputed'=>'Disputed','Original'=>'Original','Outstanding'=>'Outstanding','Received'=>'Received','Un-paid'=>'Un-paid','Under legal'=>'Under legal','Under negotiation'=>'Under negotiation'];
	}
	
	public function getNOMStatus()
	{
		return ['1'=>'<small class="label label-warning">Fixture Created</small>','2'=>'<small class="label label-success">Sent to Ops & Claims</small>','3'=>'<small class="label label-danger">Freight Paid</small>','4'=>'<small class="label label-danger">Demurrage Paid</small>','5'=>'<small class="label label-primary">Commission on Freight Received</small>','6'=>'<small class="label label-primary">Commission on Demurrage Received</small>'];
	}
	
	public function getFixtureTypeList()
	{
		return ['1'=>'Voyage Spot','2'=>'Time Charter','3'=>'COA'];
	}

	public function getComissionDataList()
	{
		return ['1'=>'Owner','2'=>'Charterer','3'=>'Broker'];
	}

	public function getUserStatusList()
	{
		return ['1'=>'Active','2'=>'In-Active'];
	}
	
	public function getCurrencyList()
	{
		return [''=>'---Select from list---','AED'=>'United Arab Emirates dirham (AED)','EUR'=>'Euro (EUR)','GBP'=>'British pound (GBP)','SGD'=>'Singapore dollar (SGD)','USD'=>'United States dollar (USD)','INR'=>'Indian Rupee (INR)'];
	}
	
	public function getYearListForNominationGrid()
	{
	    $arr_year = array();
	    for($year = date('Y',time());$year >= 2018;$year--)
		{
			$arr_year[$year] = $year;
		}
		return $arr_year ;
		//return self::getSelectList("nom_details",array("select"=>"YEAR(ADDONDATE), YEAR(ADDONDATE)",'order_by'=>array('YEAR(ADDONDATE)'=>'DESC'),"group_by"=>"YEAR(ADDONDATE)"),"multiple");
	}

	public function getVesselTypeList($type = '')
	{
		return self::getSelectList("vessel_type_master",array("select"=>"VESSELTYPEID, VESSELTYPE","where"=>array('STATUS'=>1),"order_by"=>array('VESSELTYPE'=>'asc')),$type);	
	}
	
	public function getCompanyList()
	{
		return self::getSelectList("company_master",array("select"=>"COMPANYID, COMPANY_NAME","where"=>array('STATUS'=>1),"order_by"=>array('COMPANY_NAME'=>'asc')));	
	}
	
	public function getBankList($type = '')
	{
		return self::getSelectList("bank_master",array("select"=>"BANKID, BANK_NAME","where"=>array('STATUS'=>1),"order_by"=>array('BANK_NAME'=>'asc')),$type);	
	}

	public function getCPFormTypeList($type = '')
	{
		return self::getSelectList("cp_form_type_master",array("select"=>"CPID, NAME","where"=>array('STATUS'=>1),"order_by"=>array('NAME'=>'asc')),$type);	
	}

	public function getHullTypeList($type = '')
	{
		return self::getSelectList("hull_type_master",array("select"=>"HULLTYPEID, HULLTYPE","where"=>array('STATUS'=>0),"order_by"=>array('HULLTYPE'=>'asc')),$type);	
	}
	public function getflagTypeList($type = '')
	{
		return self::getSelectList("country_master",array("select"=>"COUNTRYID, COUNTRY_NAME","where"=>array('STATUS'=>1),"order_by"=>array('COUNTRY_NAME'=>'asc')),$type);	
	}
	
	public function getVendorTypeList($type = '')
	{
		return self::getSelectList("vendor_type_master",array("select"=>"VENDOR_TYPEID, NAME","where"=>array('STATUS'=>1),"order_by"=>array('NAME'=>'asc')),$type);	
	}
	
	public function getFleetlist($type = '')
	{
		return self::getSelectList("vessel_imo_master",array("select"=>"VESSELIMOID, VESSELNAME,","order_by"=>array('VESSELNAME'=>'asc')),$type);	
	}

	public function getPortlist($type = '')
	{
		return self::getSelectList("port_master",array("select"=>"PORTID, CONCAT(PORTNAME, ',', COUNTRYNAME)","order_by"=>array('PORTNAME'=>'asc')),$type);	
	}
	
	public function getVendorBasedOnVendorTypeID($vendor_typeid = array(), $type = '')
	{
		return self::getSelectList("vendor_master",array("select"=>"VENDORID, VENDORNAME","where"=>array('STATUS'=>1),"where_in"=>array('VENDORTYPE'=>$vendor_typeid),"order_by"=>array('VENDORNAME'=>'asc')),$type);	
	}
	
	public function getCargoList($type = '')
	{
		return self::getSelectList("cargo_master",array("select"=>"CARGOID, NAME","where"=>array('STATUS'=>1),"order_by"=>array('NAME'=>'asc')),$type);	
	}
	
	public function getUserList($userType = '', $type = '')
	{
		return self::getSelectList("login",array("select"=>"LOGINID, CONTACTPERSON","where"=>array('USERTYPE'=>$userType),"order_by"=>array('CONTACTPERSON'=>'asc')),$type);	
	}
	

	public function getUserListData($type = '')
	{
		return self::getSelectList("login",array("select"=>"LOGINID, CONTACTPERSON","order_by"=>array('CONTACTPERSON'=>'asc')),$type);	
	}
	public function getBrokerList($type = '')
	{
		return self::getSelectList("broker_master",array("select"=>"BROKERID, NAME","where"=>array('STATUS'=>1),"order_by"=>array('NAME'=>'asc')),$type);	
	}
	
	public function getMaxNumberBasedOnCondition($field, $param = array())
	{


		$data  = self::getMaxID($field, $param);
		if($data->LATESTNUMBER != "" || $data->LATESTNUMBER != NULL)
		{
			$msgcode = $data->LATESTNUMBER + 1;
			if(strlen($msgcode)<=4)
			{
				$x = 4 - strlen($msgcode);
				for($i = 1; $i<=$x;$i++)
					{
						$msgcode = "0".$msgcode;
					}
			}
			return $msgcode;
		}
		else{return '0001';}
	}

	public function getMaxNumberBasedOnConditionCOA($field, $param = array()) 
{
    // Ensure $param is not empty
    if (empty($param)) {
        return '01';
    }

    // Fetch max value based on COAIDNOM condition
    $data = self::getMaxIDdd($field, $param);
    
    if (!empty($data) && isset($data->LATESTNUMBER)) {
        $msgcode = intval($data->LATESTNUMBER) + 1; // Convert to int to avoid errors

        // Ensure 2-digit formatting
        return str_pad($msgcode, 2, '0', STR_PAD_LEFT);
    } 
    
    return '01'; // Default to 01 if no data found
}


public function getMaxIDdd($field, $param = array())
{
    $this->db->select("MAX($field) as LATESTNUMBER");
    $this->db->from('nom_details');

    // Apply conditions dynamically
    if (!empty($param)) {
        $this->db->where($param);
    }

    $query = $this->db->get();
    return $query->row(); // Return single row result
}

	public function getVendorBasedOnVendorTypeIDinAgent($vendor_typeid = array(), $type = '')
	{
		return self::getSelectList("vendor_master",array("select"=>"VENDORID, VENDORNAME","where"=>array('STATUS'=>1),"where_in"=>array('VENDORTYPE'=>$vendor_typeid),"order_by"=>array('VENDORNAME'=>'asc')),$type);	
	}
	
	
	
	public function getStatusMasterList()
	{
		return self::getSelectList("status_master",array("select"=>"STATUSID, STATUS_NAME","where"=>array('STATUS'=>1),"order_by"=>array('STATUS_NAME'=>'asc')));	
	}
	
	public function getPurposeOfCallMasterList()
	{
		return self::getSelectList("purposeofcall_master",array("select"=>"CALLID, PURPOSE_NAME","where"=>array('STATUS'=>1),"order_by"=>array('PURPOSE_NAME'=>'asc')));	
	}
	
	public function getGSTInMasterList()
	{
		return self::getSelectList("gstin_master",array("select"=>"GSTNOID, CONCAT(SHORTNAME, ' - ', GSTIN)","where"=>array('STATUS'=>1),"order_by"=>array('SHORTNAME'=>'asc')));	
	}
	
	public function getPortTypeList()
	{
		return ['1'=>'LP','2'=>'DP'];
	}

	public function getInvoiceList($type='')
	{
		return self::getSelectList("invoice_master",array("select"=>"INVOICETYPE","order_by"=>array('INVOICETYPE'=>'asc')),$type);	
	}

	public function getZoneMasterList()
	{
		return self::getSelectList("zone_master",array("select"=>"ZONEID, ZONENAME ","where"=>array('STATUS'=>1),"order_by"=>array('ZONENAME'=>'asc')));	
	}
		public function getLatestCostSheetID() 
	{
       return self::getSelectList("nom_details",array("select"=>"NOMID","where"=>array('STATUS'=>1),"order_by"=>array('NOMID'=>'asc')));	
    }

public function getLoadPortAndDischargePortArr($nomid) {
    $this->db->select('n8.LORTPORT, n9.DISPORT , n8.LOTPOTID, n9.DISPORID');
    $this->db->from('nom_details_slave8 n8');
    $this->db->join('nom_details_slave9 n9', 'n8.NOMID = n9.NOMID');
    $this->db->where('n8.NOMID', $nomid);
    $query = $this->db->get();
    
    $arr = [];
    foreach ($query->result_array() as $row) {
        // Check if the ports are not "TBN"
        if ($this->getPortlist($row['LORTPORT']) != "TBN") {
            $arr[] = $row['LORTPORT'];
        }
        if ($this->getPortlist($row['DISPORT']) != "TBN") {
            $arr[] = $row['DISPORT'];
        }
    }
    
    return $arr;
}

public function getAgentDataByNomID($nomid) {
    // Combined query for both agent names and LP/DP details
    $sql = "
        SELECT 
            CONCAT(vm.VENDORNAME, ' (', vm.VENDORSORTNAME, ')') as AGENT_NAME,
            s.LOTPOTID,
            sc.DISPORID
        FROM 
            (
                SELECT AGENTLIST, NOMID FROM nom_details_slave8
                UNION ALL
                SELECT AGENTLIST, NOMID FROM nom_details_slave9
            ) AS combined
        LEFT JOIN vendor_master vm ON vm.VENDORID = combined.AGENTLIST
        LEFT JOIN nom_details_slave8 s ON s.NOMID = combined.NOMID
        LEFT JOIN nom_details_slave9 sc ON sc.NOMID = combined.NOMID
        WHERE combined.NOMID = ?
    ";

    // Execute the query with parameter binding
    $query = $this->db->query($sql, [$nomid]);

    // Return the result
    return $query->result_array();
}

public function getAgentNamesByNomIDLPDP($nomid) {
     $sql1 = "SELECT s.LOTPOTID, sc.DISPORID
FROM nom_details_slave8 s
JOIN nom_details_slave9 sc ON s.NOMID = sc.NOMID
        WHERE s.NOMID = ?
    ";

    $query = $this->db->query($sql1, [$nomid]);

   return $query->result_array();
}

public function getPortCostOnVendorTypeID($vendor_typeid = array(), $type = '')
	{
		return self::getSelectList("port_cost_type_master",array("select"=>"PC_TYPE_ID, NAME","where"=>array('STATUS'=>1),"where_in"=>array('PARENT_CAT'=>$vendor_typeid),"order_by"=>array('NAME'=>'asc')),$type);	
	}
}