<?php
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');
?>               
<!-- Content Header (Page header) -->
<section class="content-header">
	<h1>
		<i class="fa fa-dashboard"></i>&nbsp;Dashboard&nbsp;&nbsp;&nbsp;&nbsp;<small><div class="headline text-center" id="time" style="color:#000; font-weight:bold; font-size:12px;"></div></small>
	</h1>
	<ol class="breadcrumb">
		<li><a href="<?= base_url('admin/dashboard');?>"><i class="fa fa-home"></i> Home</a></li>
		<li class="active">Dashboard</li>
	</ol>
</section>

<!-- Main content -->
<section class="content">
<!--   content put here..................-->
	<div class="row">
		<section class="col-lg-4"> 
			<!-- Box (with bar chart) -->
			<div class="box box-info">
				<div class="box-header">
					<!-- tools box -->
					<div class="pull-right box-tools">
						<button class="btn btn-primary btn-sm" data-widget='collapse' data-toggle="tooltip" title="Collapse"><i class="fa fa-minus"></i></button>
						<button class="btn btn-primary btn-sm" data-widget='remove'  style="margin-left: 5px;" data-toggle="tooltip" title="Remove"><i class="fa fa-times"></i></button>
					</div><!-- /. tools -->
					<h3 class="box-title"> INVOICE DUE / THRESHOLD DAYS</h3>
				</div><!-- /.box-header -->
				<?=form_open_multipart('admin/insert-invoice-due',['name'=>'frm1','id'=>'frm1']);?>	
				<div class="box-body no-padding">
					<div class="table-responsive">
						<!-- .table - Uses sparkline charts-->
						<table class="table table-striped">
							<tr>
								<th width="40%">Invoice Name</th>
								<th width="30%" style="text-align:center">Due Days*</th>
								<th width="30%" style="text-align:center">Threshold Days*</th>
							</tr>
							<tr>
								<td>Freight Invoice</td>
								<td><?=form_input(['type'=>'number', 'name'=>'m_FRTDUEDAYS','id'=>'m_FRTDUEDAYS','class'=>'form-control nemuric','placeholder'=>'Freight Due Days','autocomplete'=>'off','value'=>$userData->FRTDUEDAYS]);?></td>
								<td><?=form_input(['type'=>'number', 'name'=>'m_FRTTHRESHOLDDAYS','id'=>'m_FRTTHRESHOLDDAYS','class'=>'form-control nemuric','placeholder'=>'Freight Threshold Days','autocomplete'=>'off','value'=>$userData->FRTTHRESHOLDDAYS]);?></td>
							</tr>
							<tr>
								<td>Hire Invoice</td>
								<td><?=form_input(['type'=>'number', 'name'=>'m_HIREDUEDAYS','id'=>'m_HIREDUEDAYS','class'=>'form-control nemuric','placeholder'=>'Hire Due Days','autocomplete'=>'off','value'=>$userData->HIREDUEDAYS]);?></td>
								<td><?=form_input(['type'=>'number', 'name'=>'m_HIRETHRESHOLDDAYS','id'=>'m_HIRETHRESHOLDDAYS','class'=>'form-control nemuric','placeholder'=>'Hire Threshold Days','autocomplete'=>'off','value'=>$userData->HIRETHRESHOLDDAYS]);?></td>
							</tr>
							<tr>
								<td>Demurrage Invoice</td>
								<td><?=form_input(['type'=>'number', 'name'=>'m_DEMUDUEDAYS','id'=>'m_DEMUDUEDAYS','class'=>'form-control nemuric','placeholder'=>'Demurrage Due Days','autocomplete'=>'off','value'=>$userData->DEMUDUEDAYS]);?></td>
								<td><?=form_input(['type'=>'number', 'name'=>'m_DEMUTHRESHOLDDAYS','id'=>'m_DEMUTHRESHOLDDAYS','class'=>'form-control nemuric','placeholder'=>'Demurrage Threshold Days','autocomplete'=>'off','value'=>$userData->DEMUTHRESHOLDDAYS]);?></td>
							</tr>
						</table><!-- /.table -->						
					</div>
				</div><!-- /.box-body -->
				<div class="box-footer">
					<div class="col-xs-8" ><small class="text-danger">* Fill the days only in digits.</small></div>
					<div class="row">
						<div class="col-xs-4 text-right" style="border-right: 1px solid #f4f4f4">
							<?= form_submit(['name'=>'submit','value'=>'Save','class'=>'btn btn-primary btn-flat']);?>
						</div><!-- ./col -->
					</div><!-- /.row -->
				</div><!-- /.box-footer -->
			<?=form_close();?>
			</div><!-- /.box -->  
		</section>
	</div>
<!--   content ends here..................-->
</section><!-- /.content -->
<script type="text/javascript">
$(document).ready(function(){
	$(".nemuric").numeric();
	
    $("#frm1").validate({
		rules: {
			m_FRTDUEDAYS:{required: true, digits: true},
			m_FRTTHRESHOLDDAYS:{required: true, digits: true},
			m_HIREDUEDAYS:{required: true, digits: true},
			m_HIRETHRESHOLDDAYS:{required: true, digits: true},
			m_DEMUDUEDAYS:{required: true, digits: true},
			m_DEMUTHRESHOLDDAYS:{required: true, digits: true}
			},
	submitHandler: function(form)  {
				var diff1 = diff2 = diff3 = "";var arr = Array();
					arr[0] = (parseInt($("#m_FRTDUEDAYS").val()) < parseInt($("#m_FRTTHRESHOLDDAYS").val())) ? false : true;
					arr[1] = (parseInt($("#m_HIREDUEDAYS").val()) < parseInt($("#m_HIRETHRESHOLDDAYS").val())) ? false : true;
					arr[2] = (parseInt($("#m_DEMUDUEDAYS").val()) < parseInt($("#m_DEMUTHRESHOLDDAYS").val())) ? false : true;
					
				if(jQuery.inArray(false ,arr)  !== -1){
					swal({title: 'Notice!',text: 'Threshold Days are more than Due Days.',type: 'info',buttonsStyling: false,confirmButtonClass: 'btn btn-primary',allowOutsideClick:false});
				}else{
					$("button[type='submit']").attr("disabled","disabled").removeClass("btn-primary").addClass("btn-default disabled");
					swal({title: '<h1>Please Wait...</h1>',showCancelButton: false,type: 'warning',showConfirmButton: false,allowOutsideClick:false,animation: false,customClass: 'animated tada'}).catch(swal.noop);
					form.submit();
				}
		}
	});
});
</script>