<?php
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');

?> 	

<link rel="stylesheet" href="https://unpkg.com/leaflet@1.9.4/dist/leaflet.css"  crossorigin="">
<script src="https://cdn.ckeditor.com/ckeditor5/24.0.0/classic/ckeditor.js"></script>

<script type="text/javascript">
$(document).ready(function () {
		document.querySelectorAll('#m_RECAPREMARKS, #m_REMARKS').forEach(textarea => {
			ClassicEditor
				.create(textarea)
				.then(editor => {
					console.log("CKEditor initialized for:", textarea.id);
				})
				.catch(error => {
					console.error("CKEditor failed for:", textarea.id, error);
				});
		});
	});
</script>             
<!-- Content Header (Page header) -->
<section class="content-header">
	<h1>
		<i class="fa fa-pagelines"></i>&nbsp;COA Master&nbsp;&nbsp;&nbsp;&nbsp;<small><div class="headline text-center" id="time" style="color:#000; font-weight:bold; font-size:12px;"></div></small>
	</h1>
	<ol class="breadcrumb">
		<li><a href="<?= base_url('operation/dashboard');?>"><i class="fa fa-home"></i> Home</a></li>
		<li class="active">COA Master</li>
	</ol>
</section>

<!-- Main content -->
<section class="content">
			<div class="box box-primary">
				<div class="box-header">
					<!-- tools box -->
					<div class="pull-right box-tools">
						<a href="<?= base_url('operation/coamaster');?>" data-toggle="tooltip" title="" data-original-title="Back"><button class="btn btn-info btn-flat">Back</button></a>
					</div><!-- /. tools -->
					<h3 class="box-title"><b>ADD COA Master</b></h3>
				</div>	
				<!-- form start -->
				<?= form_open_multipart('operation/insert-coa',['name'=>'frm1','id'=>'frm1']);?>				
					<div class="box-body">
						<div class="row invoice-info">	
							<div class="col-sm-4 invoice-col">
							 	CP Date
								<address>
									<?= form_input(['name'=>'m_CPDATE','id'=>'m_CPDATE','class'=>'form-control','placeholder'=>'dd-mm-yyyy','autocomplete'=>'off','value'=>set_value('m_CPDATE')]);?>
									<input type="hidden" name="COAID" id="COAID" value=<?=$coaname;?>>					   
								</address>
							</div><!-- /.col -->

							<?php	$filtered_fixture_type_list = array_filter($fixture_type_list, function($key) {
								return in_array($key, [3]);
								}, ARRAY_FILTER_USE_KEY); ?>
							<div class="col-sm-4 invoice-col">
								Type
								<address>
									<?= form_dropdown(['name'=>'m_FIXTURETYPE','id'=>'m_FIXTURETYPE','class'=>'form-control', 'onchange'=>'getRelativeData();'],$filtered_fixture_type_list);?>									
								</address>
							</div><!-- /.col -->
							<div class="col-sm-4 invoice-col">
                                <div class="row invoice-info">	
									<div class="col-sm-6 invoice-col">
                                        COA ID
                                        <address>
                                            <?= form_input(['name'=>'m_NOMINATIONID','id'=>'m_NOMINATIONID','class'=>'form-control','placeholder'=>'Fixture No./ Nomination ID','readonly'=>'true','value'=>date("y").'-C-'.$nominationid]);?>	
                                            <?= form_error('m_NOMINATIONID','<span style="color:#ff0000; font-size:12px;">','</span>');?>					   
                                        </address>
                                    </div>
                                    <div class="col-sm-6 invoice-col">
                                        Office
                                        <address>
                                            <?= form_dropdown(['name'=>'m_COMPANYID','id'=>'m_COMPANYID','class'=>'form-control'],$company_list);?>				   
                                        </address>
                                    </div>
                                </div>
							</div><!-- /.col -->
							
						</div>
						<div class="row invoice-info">	
							<div class="col-sm-4 invoice-col">
							 	IMO number/Vessel Name/MMSI NO/Call Sign
								<address>
									<?= form_dropdown(['name'=>'m_FLEETID','id'=>'m_FLEETID','class'=>'form-control'],$fleet_list);?>
									<!-- <input type="text" class="form-control" id="FLEETID12121" name="FLEETID121"  data-toggle="modal" data-target="#compose-modal2" onkeydown="getVesseldataByImo(this)" placeholder="IMO No./Vessel Name/MMSI No./Call Sign" autocomplete="off"> -->					   
								</address>
							</div><!-- /.col -->
							<div class="col-sm-2 invoice-col">
								 Owner
								<address>
									<?php
									    echo form_dropdown(
									        'm_OWNER',  // Name
									        $vendor_list,  // Data (ID => Name)
									        isset($nom->OWNER) ? $nom->OWNER : '',  // Selected value
									        'class="form-control" id="m_OWNER"' // Extra attributes
									    );
									?>	
									</address>
								</div><!-- /.col -->

							<div class="col-sm-2 invoice-col">
							 	
								<address>
									</br>
									<button class="btn btn-info btn-flat" data-toggle="modal"  data-target="#edit-modal-dem-owner">Add Owner</button>
				   
								</address>
								
							</div><!-- /.col -->
							<div class="col-sm-2 invoice-col">
							 	Collect From
								<address>
									<?= form_dropdown(['name'=>'m_CCOMMISSIONFROM','id'=>'m_CCOMMISSIONFROM','class'=>'form-control'],$collect_comm_list);?>				   
								</address>
							</div><!-- /.col -->
							<div class="col-sm-2 invoice-col">
							 	Responsible Person
								<address>	
								 <?= form_dropdown(['name'=>'m_RESPONSIBLE','id'=>'m_RESPONSIBLE','placeholder'=>'Responsible Person','class'=>'form-control'],$logindata);?>		   
								</address>
							</div><!-- /.col -->
							
						</div>
						
						<div class="row invoice-info">	
							
							<div class="col-sm-2 invoice-col">
								 Charterer
								<address>
									<?php
									    echo form_dropdown(
									        'm_VENDORID',  // Name
									        $vendor_list,  // Data (ID => Name)
									        isset($nom->VENDORID) ? $nom->VENDORID : '',  // Selected value
									        'class="form-control" id="m_VENDORID"' // Extra attributes
									    );
									?>		
									</address>
								</div><!-- /.col -->
							<div class="col-sm-2 invoice-col">
							 	
								<address>
									</br>
									<button class="btn btn-info btn-flat" data-toggle="modal"  data-target="#edit-modal-dem">Add Charterer</button>
				   
								</address>
								
							</div><!-- /.col -->					
							
							
							<div class="col-sm-4 invoice-col">								
								<div class="row invoice-info">	
									<div class="col-sm-6 invoice-col">
									Laycan Start
									<address>
										<?= form_input(['name'=>'m_LAYCANSTART','id'=>'m_LAYCANSTART','class'=>'form-control','placeholder'=>'dd-mm-yyyy','autocomplete'=>'off','value'=>set_value('m_LAYCANSTART')]);?>
									</address>
									</div>
									<div class="col-sm-6 invoice-col">
									Laycan End
									<address>
										<?= form_input(['name'=>'m_LAYCANEND','id'=>'m_LAYCANEND','class'=>'form-control','placeholder'=>'dd-mm-yyyy','autocomplete'=>'off','value'=>set_value('m_LAYCANEND')]);?>
									</address>
									</div>
								</div>
							</div>
							<!-- <div class="col-sm-4 invoice-col">
							 	Vessel Status
								<address>
									<?= form_dropdown(['name'=>'m_VESSELATATUS','id'=>'m_VESSELATATUS','class'=>'form-control'],$vesselStatus,4);?>				   
								</address>
							</div>/.col --> 

						
						</div>


					<div class="row invoice-info" id="voy_3">							
					
					<div class="col-sm-4 invoice-col">
					 	Vessel Nomination
						<address>
							<?= form_input(['name'=>'m_VESSEL_NOMINATION','id'=>'m_VESSEL_NOMINATION','class'=>'form-control','placeholder'=>'dd-mm-yyyy','autocomplete'=>'off','value'=>set_value('m_VESSEL_NOMINATION')]);?>			   
						</address>
					</div><!-- /.col -->
					<!-- <div class="col-sm-4 invoice-col">
					 	Vessel Substitution
						<address>
							<?= form_input(['name'=>'m_VESSEL_SUBSTITUTION','id'=>'m_VESSEL_SUBSTITUTION','class'=>'form-control','placeholder'=>'dd-mm-yyyy','autocomplete'=>'off','value'=>set_value('m_VESSEL_SUBSTITUTION')]);?>			   
						</address>
					</div> --><!-- /.col -->
				<!-- 	<div class="col-sm-4 invoice-col">
						 	Nomination Terms
							<address>
								<?= form_input(['name'=>'m_NOMINATION_TERMS','id'=>'m_NOMINATION_TERMS','class'=>'form-control','placeholder'=>'Nomination Terms','autocomplete'=>'off','value'=>set_value('m_NOMINATION_TERMS')]);?>			   
							</address>
						</div> --><!-- /.col -->
						
						
					</div>


					<div class="row invoice-info">
						<div class="col-sm-12 invoice-col">
									<h3 class="box-title">Broker Details</h3>	
									<table class="table">
										<thead>
											<tr>
												<th style="width: 10px">#</th>
												<th style="width:60%;">Broker<?= form_dropdown(['name'=>'BROKERID','id'=>'BROKERID','class' =>'form-control','style'=>'display:none;'], $broker_list);?></th>

												<th style="width:40%;">Location<?= form_dropdown(['name'=>'LOCATION','id'=>'LOCATION','class' =>'form-control','style'=>'display:none;'], $company_list);?></th>
											</tr>
										</thead>
										<tbody  id="broker_body">
											<tr id="row_offhire_1">
												<td><a href="#Cancel Details" title="" data-toggle="tooltip" data-original-title="Cancel Details" onclick="cancelDetails(1);"  ><i class="fa fa-times " style="color:red;"></i></a></td>
												<td><select name="s1_BROKERID[]" id="s1_BROKERID_1" class="form-control" ></select>
												<script>$("#s1_BROKERID_1").html($("#BROKERID").html());</script></td>
												<td><select name="s1_LOCATION[]" id="s1_LOCATION_1" class="form-control" ></select>
												<script>$("#s1_LOCATION_1").html($("#LOCATION").html());</script></td>
											</tr>
										</tbody>
										<tfoot>
											<td valign="top" class="input-text" align="left" colspan="4" >
												<button type="button" class="btn btn-primary btn-flat" data-toggle="tooltip" data-original-title="Add Broker Detail" onClick="addBroker()"><i class="zmdi zmdi-plus"></i></button>
												<?= form_hidden('m_LREC',1);?>
											</td>
									    </tfoot>
									</table>									
						</div>
					</div>
					<?php	if($_SESSION['typeuser']==2){ ?>	

					<div class="row invoice-info" id="time_3" style="display:none;">

											
							<div class="col-sm-3 invoice-col">
							 	On Hire Survery Date
								<address>
									<?= form_input(['name'=>'m_ON_HIRE_SURVERY_DATE','id'=>'m_ON_HIRE_SURVERY_DATE','class'=>'form-control','placeholder'=>'dd-mm-yyyy','autocomplete'=>'off','value'=>set_value('m_ON_HIRE_SURVERY_DATE')]);?>			   
								</address>
							</div><!-- /.col -->
							<div class="col-sm-3 invoice-col">
							 	Off Hire Survey Date
								<address>
									<?= form_input(['name'=>'m_OFF_HIRE_SURVEY_DATE','id'=>'m_OFF_HIRE_SURVEY_DATE','class'=>'form-control','placeholder'=>'dd-mm-yyyy','autocomplete'=>'off','value'=>set_value('m_OFF_HIRE_SURVEY_DATE')]);?>			   
								</address>
							</div><!-- /.col -->

							<div class="col-sm-3 invoice-col">
							 	Cargo
								<address>
									<?= form_dropdown(['name'=>'m_CARGOID[]','id'=>'m_CARGOID','class'=>'form-control','data-placeholder'=>"Choose Cargo here...",'multiple'=>'multiple'],$cargo_list);?>				   
								</address>
							</div><!-- /.col -->
							<div class="col-sm-3 invoice-col">
							 	Zone
								<address>
									<?= form_dropdown(['name'=>'m_ZONENAME','id'=>'m_ZONENAME','class'=>'form-control'],$zonelist);?>					   
								</address>
							</div><!-- /.col -->

					</div><!-- /.col -->	
					<?php }?>			

					<div class="row invoice-info" id="maxmin_1" >
							<div class="col-sm-2 invoice-col">
							 	 COA Duration (Month)
								<address>
									<?= form_input(['name'=>'m_COA_DURATION','id'=>'m_COA_DURATION','class'=>'form-control','placeholder'=>'COA Duration','autocomplete'=>'off','value'=>set_value('m_COA_DURATION'), 'type' => 'number','min' => '0','max' => '12']);?>					   
								</address>
							</div><!-- /.col -->
							<div class="col-sm-2 invoice-col">
							 	Min/Max Voyages
								<address>
									<?= form_input(['name'=>'m_BAF_FREIGHT_CREDIT','id'=>'m_BAF_FREIGHT_CREDIT','class'=>'form-control','placeholder'=>'Min/Max Voyages','autocomplete'=>'off','value'=>set_value('m_BAF_FREIGHT_CREDIT')]);?>					   
								</address>
							</div><!-- /.col -->	
							<div class="col-sm-2 invoice-col">
							 	On Account
								<address>								
									<?= form_dropdown(['name'=>'m_ONACCOUNT','id'=>'m_ONACCOUNT','class'=>'form-control'],$ONERCHTER);?>					   
								</address>
							</div><!-- /.col -->
							<div class="col-sm-2 invoice-col">
							 	Variance (-)
								<address>
									<?= form_input(['name'=>'m_VARIANCE','id'=>'m_VARIANCE','class'=>'form-control','placeholder'=>'Variance','autocomplete'=>'off','value'=>set_value('m_VARIANCE')]);?>					   
								</address>
							</div><!-- /.col -->
							<div class="col-sm-2 invoice-col">
							 	Variance(+)
								<address>
									<?= form_input(['name'=>'m_VARIANCEPLUS','id'=>'m_VARIANCEPLUS','class'=>'form-control','placeholder'=>'Variance','autocomplete'=>'off','value'=>set_value('m_VARIANCEPLUS')]);?>					   
								</address>
							</div><!-- /.col -->

							<div class="col-sm-2 invoice-col">
							 	Start Date
								<address>
									<?= form_input(['name'=>'m_STARTDATE','id'=>'m_STARTDATE','class'=>'form-control','placeholder'=>'dd-mm-yyyy','autocomplete'=>'off','value'=>set_value('m_STARTDATE')]);?>					   
								</address>
							</div><!-- /.col -->
					</div><!-- /.col -->

					<div class="row invoice-info" id="voy_3">
							<div class="col-sm-12 invoice-col">
										<h3 class="box-title">Cargo Details</h3>	
										<table class="table" style="display: block; overflow-x: auto; white-space: nowrap;">
											<thead>
												<tr>
													<th  align="left" valign="top">#</th>
													<th align="left" valign="top">Cargo       <?= form_dropdown(['name'=>'CARGOID','id'=>'CARGOID','class' =>'form-control','style'=>'display:none;'], $cargolist_add);?></th>
													<th  align="left" valign="top">Quantity (MT)</th>
													<th  align="left" valign="top">Freight (USD/MT)</th>													
													
													<th  align="left" valign="top">Total Freight(USD/MT)</th>
													<th  align="left" valign="top">Tolerance +(%)</th>
													<th align="left" valign="top">Tolerance -(%)</th>
													<th style="display:none;" align="left" valign="top">Commission (%)</th>
													<th align="left" valign="top">Cargo Option <?= form_dropdown(['name'=>'OPTION','id'=>'OPTION','class'=>'form-control' ,'style'=>'display:none;'],$MOLOLIST);?></th>
													<th  align="left" valign="top">Demurrage POL(USD/DAY)</th>
													<th align="left" valign="top">Demurrage POD(USD/DAY)</th>
													<th  align="left" valign="top">Estimated Minimum Commission (USD)</th>
											</thead>
											<tbody  id="cargo_body">
												<tr id="row_Cargo_1">
													<td><a href="#Cancel Details" title="" data-toggle="tooltip" data-original-title="Cancel Details" onclick="cancelDetails(1);"  ><i class="fa fa-times " style="color:red;"></i></a></td>
													<td><select name="e1_CARGOID_1" id="e1_CARGOID_1" class="form-control" style="width: 130px;" ></select>
													<script>$("#e1_CARGOID_1").html($("#CARGOID").html());</script></td>
													<td><input type="text" name="e1_QUANTITY_1" value="" id="e1_QUANTITY_1" autocomplete="off" style="width: 113px;"  class="form-control" placeholder="Quantity (MT)" onkeyup="getCalculatefunctiontotal(1);" ></td>
													<td><input type="text" name="e1_FREIGHT_1" value="" id="e1_FREIGHT_1" style="width: 113px;"  autocomplete="off" class="form-control" placeholder="Freight (USD/MT)" onkeyup="getCalculatefunctiontotal(1);"></td>												
													<td><input type="text" name="e1_TOTAL_FREIGHT_1" value=""  onkeyup="getCalculatefunctiontotal(1);" id="e1_TOTAL_FREIGHT_1" autocomplete="off" class="form-control" placeholder="Total Freight" ></td>													
													<td><input type="text" name="e1_TOLERANCEPLUSE_1" value="" id="e1_TOLERANCEPLUSE_1" onkeyup="getCalculatefunctiontotal(1);" autocomplete="off" class="form-control" placeholder="Tolerance +(%)"></td>
													<td><input type="text" name="e1_TOLERANCENIG_1" value="" id="e1_TOLERANCENIG_1" onkeyup="getCalculatefunctiontotal(1);" autocomplete="off" class="form-control" placeholder="Tolerance -(%)" ></td>													
													<td style="display:none;"><input type="text" name="e1_COMMISSION_1" value="" id="e1_COMMISSION_1" onkeyup="getCalculatefunctiontotal(1);" autocomplete="off" style="width: 113px;"  class="form-control" placeholder="Commission %"></td>
													<td><select name="e1_OPTION_1" id="e1_OPTION_1" class="form-control" style="width: 130px;" ></select>
													<script>$("#e1_OPTION_1").html($("#OPTION").html());</script></td>
													<td><input type="text" name="e1_DEMURRAGEPOL_1" value="" id="e1_DEMURRAGEPOL_1" autocomplete="off" class="form-control" placeholder="Demurrage POL(USD/MT)"></td>
													<td><input type="text" name="e1_DEMURRAGEPOD_1" value="" id="e1_DEMURRAGEPOD_1" autocomplete="off" class="form-control" placeholder="Demurrage POD(USD/MT)"></td>
													<td><input type="text" name="e1_ESTIMATED_MINIMUM_1" value="" id="e1_ESTIMATED_MINIMUM_1" autocomplete="off" class="form-control" placeholder="Estimated Minimum Commission (USD)"></td>
													<td><input type="hidden" name="e1_TOTAL_PLUSE_1" value="" id="e1_TOTAL_PLUSE_1" autocomplete="off" class="form-control" placeholder=""  onkeyup="getCalculatefunctiontotal(1);" ></td>
													<td><input type="hidden" name="e1_TOTAL_NEGITV_1" value="" id="e1_TOTAL_NEGITV_1" autocomplete="off" class="form-control" placeholder=""  onkeyup="getCalculatefunctiontotal(1);" ></td>
													
												</tr>
											</tbody>
											<tfoot>
												<td valign="top" class="input-text" align="left" colspan="15" >
													<button type="button" class="btn btn-primary btn-flat" data-toggle="tooltip" data-original-title="Add Cargo Detail" onClick="addPortQtyaa()">Add Cargo</i></button>
													<?= form_hidden('m_CARGO',1);?>
												</td>
										    </tfoot>
										</table>									
							</div>
						</div>							


					
					<div id="toggleDiv" title="Lumpsum Show" style="cursor: pointer; padding: 10px; display: none;">
					 <img style="width: 28px; height: 26px;" src="<?= base_url('assets/img/plus.png') ?>" />

					</div>

						<div class="row invoice-info "  id="hiddenDiv" style="display: none; padding: 10px;margin-top: 10px;">
							<div  id="voy_3">	
								<div class="col-sm-1 invoice-col">
								&nbsp;
								<address>
								Lumpsum <span style="font-size:10px; font-style:italic;">(USD)</span>
								</address>
								</div><!-- /.col -->
								<div class="col-sm-1 invoice-col">
								&nbsp;
								<address>
								&nbsp;&nbsp;:&nbsp;&nbsp;
								<?= form_input(['type'=>'radio','name'=>'m_VOAYGERADIO','id'=>'voyageRadio_1','class'=>'minimal','value'=>'1','onClick'=>'getShow(1)']);?>					
								</address>
								</div><!-- /.col -->	

								<div class="col-sm-3 invoice-col">
								Lumpsum Freight <span style="font-size:10px; font-style:italic;">(USD)</span>
								<address>
								<?= form_input(['name'=>'m_LUMPSUM','id'=>'m_LUMPSUM','class'=>'form-control numeric','onkeyup' => 'getCalculatefunctiontotal();','placeholder'=>'Lumpsum.','autocomplete'=>'off','value'=>set_value('m_LUMPSUM')]);?>								
								</address>
								</div><!-- /.col -->
							</div>	
							<div class="col-sm-1 invoice-col">
								&nbsp;
								<address>
									Lumpsum <span style="font-size:10px; font-style:italic;"></span>
								</address>
							</div><!-- /.col -->
							<div class="col-sm-1 invoice-col">
								&nbsp;
								<address>
									&nbsp;&nbsp;:&nbsp;&nbsp;
									<?= form_input(['type'=>'radio','name'=>'m_VOAYGERADIOBUTTON','id'=>'voyageRadioBUTTon_11','class'=>'minimal','value'=>'11','checked'=>'checked','onClick'=>'getShowlumsum(11)']);?>					
								</address>
							</div><!-- /.col -->	

							<div class="col-sm-3 invoice-col">
								Lumpsum Comm.(USD) <span style="font-size:10px; font-style:italic;"></span>
								<address>
									<?= form_input(['name'=>'m_LUMPSUMDATA','id'=>'m_LUMPSUMDATA','class'=>'form-control numeric','onkeyup' => 'getcalculatecumission(),getCalculatefunctiontotal();','placeholder'=>'Lumpsum','autocomplete'=>'off','value'=>set_value('m_LUMPSUM')]);?>								
								</address>
							</div><!-- /.col -->

						  		
						</div>

						<div class="row invoice-info" style="margin-top: 22px; " >						    

						 <span id="voy_3">
							 <div class="col-sm-3 invoice-col"  id="maxmin_1" style="display:none;">
								CP Quantity Min
								<address>
									<?= form_input(['name'=>'m_CPQUNTITYMIN','id'=>'m_CPQUNTITYMIN','class'=>'form-control numeric','placeholder'=>'CP Quantity Min.','autocomplete'=>'off','value'=>set_value('m_CPQUNTITYMIN')]);?>								
								</address>
							</div><!-- /.col -->	

							<div class="col-sm-3 invoice-col"  id="maxmin_1" style="display:none;">
								CP Quantity Max
								<address>
									<?= form_input(['name'=>'m_CPQUNTITYMAX','id'=>'m_CPQUNTITYMAX','class'=>'form-control numeric','placeholder'=>'CP Quantity Max.','autocomplete'=>'off','value'=>set_value('m_CPQUNTITYMAX')]);?>								
								</address>
							</div><!-- /.col -->
						  </span>

							
							<div class="col-sm-3 invoice-col" style="display:none;">
							 	CP Form Type
								<address>
									<?= form_dropdown(['name'=>'m_CPID','id'=>'m_CPID','class'=>'form-control'],$cp_form_list);?>					   
								</address>
							</div><!-- /.col --> 

						</div>



						
						<?php	if($_SESSION['typeuser']==2){ ?>

						<div class="row invoice-info"  id="voy_4" style="display:none;">	
							<div class="col-sm-1 invoice-col">""
								&nbsp;
								<address>
									WS 				
								</address>
							</div><!-- /.col -->
							<div class="col-sm-1 invoice-col">
								&nbsp;
								<address>
									&nbsp;&nbsp;:&nbsp;&nbsp;
									<?= form_input(['type'=>'radio','name'=>'m_VOAYGERADIO','id'=>'voyageRadio_2','class'=>'minimal','value'=>'2','onClick'=>'getShow(2)']);?>					
								</address>
							</div><!-- /.col -->	
							<div class="col-sm-2 invoice-col">
								WS
								<address>
									<?= form_input(['name'=>'m_WS','id'=>'m_WS','class'=>'form-control numeric','placeholder'=>'WS','autocomplete'=>'off','disabled'=>'disabled','onkeyup'=>'calculateMinCargo(),calculateOverage()','value'=>set_value('m_WS')]);?>								
								</address>
							</div><!-- /.col -->	
							<div class="col-sm-2 invoice-col">
								From Port
								<address>
									<script type="text/javascript">
									var url="<?= base_url();?>";
									jQuery(document).ready(function($)
									{
										$("#m_FPORT, #m_TPORT").select2({
											minimumInputLength: 1,
											placeholder: '---Select from list---',
											allowClear: true,
											ajax: {
												url: url+"json/JsonPortList",
												dataType: 'json',
												quietMillis: 100,
												data: function(term, page) {
													return {
														limit: -1,
														q: term
													};
												},
												results: function(data, page ) {
													return { results: data }
												}
											},
											formatResult: function(port) { 
												return "<div class='select2-user-result'>" + port.name + "</div>"; 
											},
											formatSelection: function(port) { 
												return  port.name; 
											}
											
										});
										
										$("#select2-chosen-1,#select2-chosen-2").css("fontSize", "14px");
										$("#select2-chosen-1,#select2-chosen-2").css("color", "#555");
									});
								</script>
								<?= form_input(['name'=>'m_FPORT','id'=>'m_FPORT','class'=>'form-control','value'=>set_value('m_FPORT'),'disabled'=>'disabled']);?>								
								</address>
							</div><!-- /.col -->
							<div class="col-sm-2 invoice-col">
								To Port
								<address>
									<?= form_input(['name'=>'m_TPORT','id'=>'m_TPORT','class'=>'form-control','value'=>set_value('m_TPORT'),'disabled'=>'disabled']);?>								
								</address>
							</div><!-- /.col -->
							<div class="col-sm-2 invoice-col">
								Flat Rate 
								<address>
									<?= form_input(['name'=>'m_WSFLATRATE','id'=>'m_WSFLATRATE','class'=>'form-control numeric','placeholder'=>'WS Flat Rate','autocomplete'=>'off','disabled'=>'disabled','onkeyup'=>'calculateMinCargo(),calculateOverage()','value'=>set_value('m_WSFLATRATE')]);?>								
								</address>
							</div><!-- /.col -->
                            <div class="col-sm-2 invoice-col">
								BL Actual Cargo Qty Loaded <span style="font-size:10px; font-style:italic;">(MT)</span>
								<address>
									<?= form_input(['name'=>'m_ACTUALQTY','id'=>'m_ACTUALQTY','class'=>'form-control numeric','placeholder'=>'BL Actual Cargo Qty Loaded','autocomplete'=>'off','disabled'=>'disabled','onkeyup'=>'calculateMinCargo(),calculateOverage()','value'=>set_value('m_ACTUALQTY')]);?>								
								</address>
							</div><!-- /.col -->				
						</div>

						<div class="row invoice-info"  id="voy_5"style="display:none;">
							
                            
							<div class="col-sm-2 invoice-col">
								Min Cargo Qty. <span style="font-size:10px; font-style:italic;">(MT)</span>
								<address>
									<?= form_input(['name'=>'m_WSMINCARGOQTY','id'=>'m_WSMINCARGOQTY','class'=>'form-control numeric','placeholder'=>'Min Cargo Qty.','disabled'=>'disabled','autocomplete'=>'off','onkeyup'=>'calculateMinCargo()','value'=>set_value('m_WSMINCARGOQTY')]);?>								
								</address>
							</div><!-- /.col -->	
							<div class="col-sm-2 invoice-col">
								Amount <span style="font-size:10px; font-style:italic;">(USD)</span>
								<address>
									<?= form_input(['name'=>'m_MINAMOUNT','id'=>'m_MINAMOUNT','class'=>'form-control numeric','placeholder'=>'Amount','disabled'=>'disabled','readonly'=>'true','value'=>set_value('m_MINAMOUNT')]);?>								
								</address>
							</div><!-- /.col -->
							<div class="col-sm-2 invoice-col">
								Overage <span style="font-size:10px; font-style:italic;">(MT)</span>
								<address>
									<?= form_input(['name'=>'m_OVERAGE','id'=>'m_OVERAGE','class'=>'form-control numeric','placeholder'=>'Overage','disabled'=>'disabled','onkeyup'=>'calculateOverage()','autocomplete'=>'off','value'=>set_value('m_OVERAGE')]);?>								
								</address>
							</div><!-- /.col -->	
							<div class="col-sm-2 invoice-col">
								Amount <span style="font-size:10px; font-style:italic;">(USD)</span>
								<address>
									<?= form_input(['name'=>'m_OVERAMOUNT','id'=>'m_OVERAMOUNT','class'=>'form-control numeric','placeholder'=>'Amount','disabled'=>'disabled','readonly'=>'true','value'=>set_value('m_OVERAMOUNT')]);?>								
								</address>
							</div><!-- /.col -->
                            
                            <div class="col-sm-2 invoice-col">
                               Fixed Differential Rate(%)
								<address>
									<?= form_input(['name'=>'m_FIXEDDIFFERENTIAL','id'=>'m_FIXEDDIFFERENTIAL','class'=>'form-control numeric','placeholder'=>'Fixed Differential Rate','disabled'=>'disabled','autocomplete'=>'off','onkeyup'=>'calculateMinCargo()','value'=>'0.27']);?>								
								</address>
                            </div>
                            <div class="col-sm-2 invoice-col">
                               Differential Amount(USD)
								<address>
									<?= form_input(['name'=>'m_FIXEDDIFFERENTIALAMT','id'=>'m_FIXEDDIFFERENTIALAMT','class'=>'form-control numeric','placeholder'=>'Fixed Differential Amount(USD)','disabled'=>'disabled','readonly'=>'true','autocomplete'=>'off','onkeyup'=>'calculateMinCargo()','value'=>set_value('m_FIXEDDIFFERENTIALAMT')]);?>								
								</address>
                            </div>						
						</div>
						<?php }?>	
						
						<div class="row invoice-info" id="time_3" style="display:none;">	
						<div class="col-sm-6 invoice-col">
								Delivery Terms 
								<address>
									<?= form_input(['name'=>'m_DELIVERYNO','id'=>'m_DELIVERYNO','class'=>'form-control','placeholder'=>'Delivery Terms','autocomplete'=>'off','value'=>set_value('m_DELIVERYNO')]);?>								
								</address>
							</div><!-- /.col -->
							<div class="col-sm-6 invoice-col">
								Redelivery Terms 
								<address>
									<?= form_input(['name'=>'m_REDELIVERYNO','id'=>'m_REDELIVERYNO','class'=>'form-control','placeholder'=>'Redelivery Terms','autocomplete'=>'off','value'=>set_value('m_REDELIVERYNO')]);?>								
								</address>
							</div><!-- /.col -->					
						</div>
						
						<div class="row invoice-info" >	
							<div class="col-sm-6 invoice-col">
								 <span id="time_2" style="display:none;"> Delivery Place</span><span id="voy_3"> Load Port</span>
								<address>
									<script type="text/javascript">
									var url="<?= base_url();?>";
									jQuery(document).ready(function($)
									{
										$("#m_LPORT,#m_DPORT").select2({
											minimumInputLength: 1,
											placeholder: 'Type for search...',
											tokenSeparators: [','],
											allowClear: true,
											multiple: true,
											ajax: {
												url: url+"json/JsonPortList",
												dataType: 'json',
												quietMillis: 100,
												data: function(term, page) {
													return {
														limit: -1,
														q: term
													};
												},
												results: function(data, page ) {
													return { results: data }
												}
											},
											formatResult: function(port) { 
												return "<div class='select2-user-result'>" + port.name + "</div>"; 
											},
											formatSelection: function(port) { 
												return  port.name; 
											}
											
										});
										
										$("#select2-chosen-1,#select2-chosen-2").css("fontSize", "14px");
										$("#select2-chosen-1,#select2-chosen-2").css("color", "#555");
									});
								</script>
								<?= form_input(['name'=>'m_LPORT','id'=>'m_LPORT','class'=>'form-control','value'=>set_value('m_LPORT')]);?>	
									</address>
								</div><!-- /.col -->							
							
							<div class="col-sm-6 invoice-col">
								  <span id="time_2" style="display:none;">Redelivery Place</span><span id="voy_3"> Discharge  Port</span>

								<address>
									<?= form_input(['name'=>'m_DPORT','id'=>'m_DPORT','class'=>'form-control','value'=>set_value('m_DPORT')]);?>											
								 </address>
							</div><!-- /.col -->
						  </div><!-- /.col -->

						
					

						<div class="row invoice-info" id="time_1" style="display:none;">
							<div class="col-sm-12 invoice-col">
								<table class="table">
									<thead>
										<tr>
											<th style="width:4px;">#</th>
											<th style="width:20%;">Delivery Date</th>
											<th style="width:20%;">Redelivery Date</th>
											<th style="width:14%;">Hire Rate</th>
											<th style="width:14%;">Days</th>
											<th style="width:14%;">Off Hire</th>
											<th style="width:14%;">Average Duration </th>
											<th style="width:14%;">Minimum Duration (Days)</th>
											<th style="width:14%;">Maximum Duration (Days)</th>											
											<th style="width:14%;">Commission (%)</th>											
											<th style="width:14%;">Balance Days</th>

											<!-- <th style="width:8%;">Balance Days</th> -->
										</tr>
									</thead>
									<tbody  id="Hire_body">
										<tr id="row_offhiredate_1">
											<td><a href="#Cancel Details" title="" data-toggle="tooltip" data-original-title="Cancel Details" onclick="cancelDetailshire(1);"  ></a></td>
											<td><input type="text" name="s2_DELIVERYDATE_1" value="" id="s2_DELIVERYDATE_1" class="form-control"   onchange="getTimeDiff(1);" placeholder="Delivery Date" autocomplete="off"></td>
											<td><input type="text" name="s2_REDELIVERYDATE_1" value="" id="s2_REDELIVERYDATE_1" class="form-control" placeholder="Redelivery Date" onchange="getTimeDiff();"></td>
											<td><input type="text" name="s2_HIRERATE_1" value="" id="s2_HIRERATE_1" class="form-control" placeholder="Hire Rate" onkeyup="getCalculatetchageinthisfunctio(1); getcalculateDaycalet(1);"></td>
											<td><input type="text" name="s2_DAY_1" value="" id="s2_DAY_1" class="form-control" placeholder="Days Rate" onkeyup="getcalculateDaycalet();" readonly="true"></td>
											<td><input type="text" name="s2_OFFHIREDAY_1" value="0.00" id="s2_OFFHIREDAY_1"  readonly="true" class="form-control" onkeyup="getcalculateDaycalet(1);" placeholder="Off Hire" ></td>
											<td><input type="text" name="s2_AVERAGEDURATION_1" value="0.00" id="s2_AVERAGEDURATION_1" class="form-control" onkeyup="getCalculatetchageinthisfunctio(1); getcalculateDaycalet(1);" placeholder="Average Duration" >
												<input type="hidden" name="s2_TOTALHIRATE_1" value="0.00" id="s2_TOTALHIRATE_1" class="form-control" onkeyup="getCalculatetchageinthisfunctio(1);"  ></td>
											<td><input type="text" name="s2_MINIMUMDURATION_1" value="0.00" id="s2_MINIMUMDURATION_1"  class="form-control"  placeholder="Minimum Duration" ></td>
											<td><input type="text" name="s2_MAXDURATION_1" value="0.00" id="s2_MAXDURATION_1" class="form-control"  placeholder="Maximum Duration" ></td>
											<td><input type="text" name="s2_COMMISSION_1" value="0.00" id="s2_COMMISSION_1"  class="form-control" onkeyup="getCalculatetchageinthisfunctio(1); getcalculateDaycalet();" placeholder="Commission" >
												<input type="hidden" name="s2_TOTALCOMMISSION_1" value="0.00" id="s2_TOTALCOMMISSION_1"  class="form-control" onkeyup="getCalculatetchageinthisfunctio(1);"></td>
											<td><input type="text" name="s2_BALANCEDAY_1" value="" id="s2_BALANCEDAY_1" class="form-control" onkeyup="getcalculateDaycalet();" placeholder="Balance Days" readonly="true"></td>
											<td><input type="hidden" name="s2_BTOTAL_1" value="" id="s2_BTOTAL_1" class="form-control" onkeyup="getcalculateDaycalet();" placeholder="Balance Days" readonly="true"></td>											
										</tr>
									
								</tbody>
								<tbody>	
									
										<td valign="top" class="input-text" align="left" colspan="11" >
										
											<button type="button" class="btn btn-primary btn-flat" data-toggle="tooltip" data-original-title="Add Hire Detail" onClick="addDAYCALGU()"><i class="zmdi zmdi-plus"></i></button><input type="hidden" name="m_LEMCR" id="m_LEMCR" value="1"/>
										
										</td>
								   
								</tbody>
							</table>									
						  </div>
						</div>
				

						<div class="row invoice-info" >								
							<div class="col-sm-4 invoice-col" id="time_2"style="display:none;">
								Ballast Bonus
								<address>
									<?= form_input(['name'=>'m_BALLASTBONUS','id'=>'m_BALLASTBONUS','class'=>'form-control','placeholder'=>'Ballast Bonus','autocomplete'=>'off','value'=>0.00, 'onkeyup' => 'getcalculateTimeballbons(), getcalculateDaycalet(); ']);?>
								</address>
							</div><!-- /.col -->

							<div class="col-sm-4 invoice-col"  id="time_2" style="display:none;">
								Ad Comm % (Ballast Bonus)
								<address>
									<?= form_input(['name'=>'m_ADCOMM','id'=>'m_ADCOMM','class'=>'form-control','placeholder'=>'Ad Comm % (Ballast Bonus)','value'=>set_value('m_ADCOMM'), 'onkeyup' => 'getcalculateTimeballbons()']);?>
								</address>
							</div><!-- /.col -->							
						
							<div class="col-sm-4 invoice-col" id="time_2"style="display:none;">
								Net Ballast Bonus
								<address>
									<?= form_input(['name'=>'m_NETBALLAST','id'=>'m_NETBALLAST','class'=>'form-control','placeholder'=>'Net Ballast Bonus','autocomplete'=>'off','value'=>set_value('m_NETBALLAST'), 'onkeyup' => 'getcalculateTimeballbons()']);?>
								</address>
							</div><!-- /.col -->													
						</div>

																							
						<div class="row invoice-info" >
										
							<div class="col-sm-4 invoice-col" id="voy_2"style="display:none;">
								 Freight <span style="font-size:10px; font-style:italic;">(USD)</span>
								<address>
									<?= form_input(['name'=>'m_LUMPSUMFREIGHT','id'=>'m_LUMPSUMFREIGHT','class'=>'form-control','placeholder'=>'Freight','autocomplete'=>'off','value'=>set_value('m_LUMPSUMFREIGHT'), 'onkeyup' => 'getcalculate(); ']);?>

								</address>
							</div><!-- /.col -->

							<div class="col-sm-4 invoice-col"  id="time_2" style="display:none;">
								 Total Hire Due <span style="font-size:10px; font-style:italic;">(USD)</span>
								<address>
									<?= form_input(['name'=>'m_HIRERATE','id'=>'m_HIRERATE','class'=>'form-control','placeholder'=>'Total Hire Due','readonly'=>'true','value'=>0.00, 'onkeyup' => 'getcalculateTime()']);?>
									
									<input type="hidden" name="TTHIRE" value="0.00" id="TTHIRE" class="form-control" placeholder="Freight" readonly="true"  onkeyup="getcalculateTime();">
								</address>
							</div><!-- /.col -->
							<div class="col-sm-4 invoice-col"  style="display:none;">
								 Estimated Minimum Commission <span style="font-size:10px; font-style:italic;">(USD)</span>

								
								  <address>
									<?= form_input(['name'=>'m_ESTMINCOMMISSION','id'=>'m_ESTMINCOMMISSION','class'=>'form-control','placeholder'=>'Estimated Minimum Commission','readonly'=>'true','value'=>set_value('m_ESTMINCOMMISSION')]);?>
								  
									
									<input type="hidden" name="ESTMINCOMMISSIONHIDEN" value="0.00" id="ESTMINCOMMISSIONHIDEN" class="form-control" placeholder="Estimated Minimum Commission" readonly="true"  onkeyup="getcalculatecumission();">
									</address>
								
							</div><!-- /.col -->							
						</div>
						

						<div class="row invoice-info" id="voy_1"style="display:none;">								
							<div class="col-sm-4 invoice-col" style="display:none;">
								 Demurrage <span style="font-size:10px; font-style:italic;">(USD)</span>
								<address>
									<?= form_input(['name'=>'m_DEMURRAGE','id'=>'m_DEMURRAGE','class'=>'form-control','placeholder'=>'Demurrage','autocomplete'=>'off','value'=>set_value('m_DEMURRAGE'), 'onkeyup' => 'getcalculateDEM();']);?>
								</address>
							</div><!-- /.col -->							
						
							<div class="col-sm-4 invoice-col" style="display:none;">
								Commission on Demurrage<span style="font-size:10px; font-style:italic;">(%)</span>
								<address>
									<?= form_input(['name'=>'m_COMMISSIONONDEMURRAGE','id'=>'m_COMMISSIONONDEMURRAGE','class'=>'form-control','placeholder'=>'Commission on Demurrage','autocomplete'=>'off','value'=>set_value('m_COMMISSIONONDEMURRAGE'), 'onkeyup' => 'getcalculateDEM();']);?>
								</address>
							</div><!-- /.col -->
							<div class="col-sm-4 invoice-col" style="display:none;">
								 Commission on Demurrage Amt <span style="font-size:10px; font-style:italic;">(USD)</span>
								<address>
									<?= form_input(['name'=>'m_COMMISSIONONDEMURRAGEAMT','id'=>'m_COMMISSIONONDEMURRAGEAMT','class'=>'form-control','placeholder'=>'Commission on Demurrage Amt','readonly'=>'true','value'=>set_value('m_COMMISSIONONDEMURRAGEAMT')]);?>
								</address>
							</div><!-- /.col -->							
						</div>


						<div class="row invoice-info">	
							<div class="col-sm-12 invoice-col">
								Recap Remarks
								<address>
									<?= form_textarea(['name'=>'m_RECAPREMARKS','id'=>'m_RECAPREMARKS','class'=>'form-control', 'placeholder'=>'Recap Remarks','rows'=>'5','value'=>set_value('m_RECAPREMARKS')]);?>									
								</address>
							</div><!-- /.col -->
						</div>	

						

	

						<div class="row invoice-info">	
							<div class="col-sm-12 invoice-col">
								Remarks
								<address>
									<?= form_textarea(['name'=>'m_REMARKS','id'=>'m_REMARKS','class'=>'form-control','placeholder'=>'Remarks','rows'=>'5','value'=>set_value('m_REMARKS')]);?>									
								</address>
							</div><!-- /.col -->
						</div>	
						
						<div class="row invoice-info" style="display:none;">	
							<div class="col-sm-4 invoice-col">
							  a). Fixture Note/Charter Party
								<address>											
								   <div class="btn btn-success btn-file btn-flat" data-toggle="tooltip" data-original-title="For multiple file select [Windows : Ctrl + Click], [Mac : Command + Click]">
										<i class="fa fa-paperclip"></i> Attachment
										<input type="file" class="form-control" name="ATTACHMENT[]" id="ATTACHMENT" multiple title=""/>
									</div>											
								</address>
							</div>	
							<div class="col-sm-4 invoice-col">
                              b). Load Port Documents
								<address>											
								   <div class="btn btn-success btn-file btn-flat" data-toggle="tooltip" data-original-title="For multiple file select [Windows : Ctrl + Click], [Mac : Command + Click]">
										<i class="fa fa-paperclip"></i> Attachment
										<input type="file" class="form-control" name="ATTACHMENT1[]" id="ATTACHMENT1" multiple title=""/>
									</div>											
								</address>
                            </div>
                            <div class="col-sm-4 invoice-col">
                              c). Discharge Port Documents
								<address>											
								   <div class="btn btn-success btn-file btn-flat" data-toggle="tooltip" data-original-title="For multiple file select [Windows : Ctrl + Click], [Mac : Command + Click]">
										<i class="fa fa-paperclip"></i> Attachment
										<input type="file" class="form-control" name="ATTACHMENT2[]" id="ATTACHMENT2" multiple title=""/>
									</div>											
								</address>
                            </div>
                            
                         </div>
                         <div class="row invoice-info" style="display:none;">
                            <div class="col-sm-4 invoice-col">
                              d). Freight documents
								<address>											
								   <div class="btn btn-success btn-file btn-flat" data-toggle="tooltip" data-original-title="For multiple file select [Windows : Ctrl + Click], [Mac : Command + Click]">
										<i class="fa fa-paperclip"></i> Attachment
										<input type="file" class="form-control" name="ATTACHMENT3[]" id="ATTACHMENT3" multiple title=""/>
									</div>											
								</address>
                            </div>
                            <div class="col-sm-4 invoice-col">
                              e). Claim/Demurrage
								<address>											
								   <div class="btn btn-success btn-file btn-flat" data-toggle="tooltip" data-original-title="For multiple file select [Windows : Ctrl + Click], [Mac : Command + Click]">
										<i class="fa fa-paperclip"></i> Attachment
										<input type="file" class="form-control" name="ATTACHMENT4[]" id="ATTACHMENT4" multiple title=""/>
									</div>											
								</address>
                            </div>
							<div class="col-sm-4 invoice-col">
							  Claims Handling Allocation
								<address>
									<?= form_dropdown(['name' => 'm_CLAIMSLOGINID', 'id' => 'm_CLAIMSLOGINID', 'class' => 'form-control'], $user_list_claims);?>
									<?= form_hidden('m_NOMSTATUS');?>
									<?= form_hidden('m_UPDATESTATUS');?>
									<?= form_hidden('m_OPERATIONLOGINID', $this->session->uid);?>
								</address>								
							</div><!-- /.col -->
						</div>
						
						
						
					</div><!-- /.box-body -->

					


					<div class="modal fade" id="compose-modal2" tabindex="-1" role="dialog" aria-hidden="true">
				    <div class="modal-dialog" style="width:90%">
				        <div class="modal-content">
				            <div class="modal-header">
				                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
				                <h4 class="modal-title"><i class="fa fa-file-text-o"></i>&nbsp;&nbsp;VESSEL DETAILS</h4>
				            </div>
				            <div class="modal-body" style="overflow:auto;">
				                <div class="box-body table-responsive">
				                    <div id="headingFfaDet">
				                        <table class="table table-bordered table-striped">
				                            <thead>
				                                <tr>
				                                    <th>Name</th>
				                                    <th>IMO No.</th>
				                                    <th>MMSI No.</th>
				                                    <th>Call Sign</th>
				                                    <th>Ship Owner</th>
				                                    <th>Ship Manager</th>
				                                    <th>Ship Type</th>
				                                    <th>Dead Weight</th>
				                                    <th>Gross Tonnage</th>
				                                    <th>Operation Status</th>
				                                    <th>Year Of Built</th>
				                                </tr>
				                            </thead>
				                            <tbody id="FfaDetailHedgeVsl">
				                                <!-- Data will be populated here -->
				                            </tbody>
				                        </table>
				                    </div>
				                </div>
				            </div>
				        </div>
				    </div>
				</div>

<div class="modal fade" id="compose_modal_distance" tabindex="-1" role="dialog" aria-hidden="true">
					<div class="modal-dialog" style="width:80%;">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
								<h4 class="modal-title"><i class="fa fa-file-text-o"></i>&nbsp;&nbsp;Last Position</h4>
								<input type="hidden" id="portDistanceRowid" name="portDistanceRowid" value="" />
							</div>

							<div class="modal-body">
								<table class='tablesorter' width="100%" border="1px">
									<tr>
										<td width="20%"><b>Name: </b><span id="spanForName"></span></td>
										<td width="20%"><b>Call sign: </b><span id="call_sign"></span></td>
										<td width="15%"><b>Destination: </b><span id="destination"></span></td>
										<td width="15%"><b>ETA datetime: </b><span id="etaDateTime"></span></td>
										<td width="15%"><b>Max draught: </b><span id="max_draught"></span></td>
										<td width="15%"><b>Ship type: </b><span id="shipType"></span></td>
										<td width="20%"><b>Navigational status : </b><span id="navigational_status"></span></td>

									</tr>

									<tr>
										<td><b>Origin: </b><span id="spanForOrigin"></span></td>
										<td><span id="spanToPort"></span></td>

										<td></td>
										<td><span id="spanGreatCircle2"></span></td>
										<td>
										
										</td>
										<td>
										
										</td>
										<td>
										</td>

									</tr>
									<tr>
										<td colspan="2"><b>LAT/LONG</b></td>
										<td></td>
										<td></td>
										<td></td>
										<td></td>
										<td></td>
									</tr>
									<tr>
										<td colspan="8">
											<!-- <div id="map" style="width:100%; height:500px; vertical-align:middle; text-align:center; border:1px solid #D6D6D6; margin-bottom:10px;"> -->
												<!-- <div id="distancemap" style="width:100%; height:500px; vertical-align:middle; text-align:center; border:1px solid #D6D6D6; margin-bottom:10px;">Show Map Here</div> -->


												<div  id="map" style="width:100%; height:500px; vertical-align:middle; text-align:center; border:1px solid #D6D6D6; margin-bottom:10px;"></div>
												<div id="info">
													<div id="coordinates">N/A</div>
													<div id="zoom-level">Zoom Level: 3</div>
												</div>
												<!-- <div id="logo">
													<img src="http://navapis.com/wp-content/uploads/2024/08/1024coloredblue.svg" alt="Logo" width="150" />
												</div> -->
										</td>
										
									
									</tr>
									</tbody>
								</table>

								<div class="row">
								
					
									<div class="col-xs-2" style="text-align:left;">
									Dimension_a_m
										<address>
											<span id="Dimension_a_m">0.00</span>
										</address>
									</div>
									<div class="col-xs-2" style="text-align:left;">
									Dimension_b_m
										<address>
											<span id="Dimension_b_m">0.00</span>
										</address>
									</div>
									<div class="col-xs-2" style="text-align:left;">
									Dimension_c_m
										<address>
											<span id="Dimension_c_m">0.00</span>
										</address>
									</div>

									<div class="col-xs-2" style="text-align:left;">
									Dimension_d_m
										<address>
											<span id="Dimension_d_m">0.00</span>
										</address>
									</div>
							
								
								</div>
							</div>

						</div>
					</div>
				</div>
					

					<div class="box-footer" align="right">
						<?= form_submit(['name'=>'submitNew','value'=>'Save as Draft','class'=>'btn btn-primary btn-flat','onclick'=>'getValidate(1,0);']);?>
					</div>
				<?= form_close();?>
			</div>


			<div class="modal fade" id="edit-modal-dem" tabindex="-1" role="dialog" aria-labelledby="edit-modal-label">
						  <div class="modal-dialog" role="document">
							<div class="modal-content">
								
								  <div class="modal-header">
									<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
									<h4 class="modal-title" id="edit-modal-label">&nbsp;</h4>
								  </div>

								  <?= form_open_multipart('operation/insert-vendorCharterer', ['name'=>'frm2', 'id'=>'frm2', 'method'=>'post']); ?>
								 
								 <div class="box-body">
											<div class="row invoice-info" style="margin-right: 3px; margin-left: 1px;">	
												<div class="col-sm-4 invoice-col">
												 Vendor Name
													<address>
														<?= form_input(['name'=>'m_VENDORNAME','id'=>'m_VENDORNAME','class'=>'form-control','placeholder'=>'Vendor Name','autocomplete'=>'off','value'=>set_value('m_VENDORNAME')]);?>	
																			   
													</address>
												</div><!-- /.col -->
												<div class="col-sm-4 invoice-col">
													Vendor Type
													<address>
														<?= form_dropdown(['name'=>'m_VENDORTYPE','id'=>'m_VENDORTYPE','class'=>'form-control'],$vendor_type_list);?>									
													</address>
												</div><!-- /.col -->
												<div class="col-sm-4 invoice-col">
													Status
													<address>
														<?= form_dropdown(['name'=>'m_STATUS','id'=>'m_STATUS','class'=>'form-control'],$status_list);?>									
													</address>
												</div><!-- /.col -->
											</div>	
											<div class="row invoice-info" style="margin-right: 3px; margin-left: 1px;">	
												
												<div class="col-sm-4 invoice-col">
													Vendor Short Name
													<address>
														<?= form_input(['name'=>'m_VENDORSORTNAME','id'=>'m_VENDORSORTNAME','class'=>'form-control','placeholder'=>'Vendor Short Name','autocomplete'=>'off','value'=>set_value('m_VENDORSORTNAME')]);?>	
													</address>
												</div><!-- /.col -->
					                            <div class="col-sm-4 invoice-col">
													VAT, RUT, TAX ID
													<address>
														<?= form_input(['name'=>'m_GSTIN','id'=>'m_GSTIN','class'=>'form-control','placeholder'=>'VAT, RUT, TAX ID','autocomplete'=>'off','value'=>set_value('m_GSTIN')]);?>	
													</address>
												</div><!-- /.col -->
												<div class="col-sm-4 invoice-col">
													Vendor Address 1
													<address>
														<?= form_input(['name'=>'m_VENDORADDRESS1','id'=>'m_VENDORADDRESS1','class'=>'form-control','placeholder'=>'Vendor Address 1','autocomplete'=>'off','value'=>set_value('m_VENDORADDRESS1')]);?>							
													</address>
												</div><!-- /.col -->
											</div>
											
											<div class="row invoice-info" style="margin-right: 3px; margin-left: 1px;">	
												
												<div class="col-sm-4 invoice-col">
													Vendor Address 2
													<address>
														<?= form_input(['name'=>'m_VENDORADDRESS2','id'=>'m_VENDORADDRESS2','class'=>'form-control','placeholder'=>'Vendor Address 2','autocomplete'=>'off','value'=>set_value('m_VENDORADDRESS2')]);?>							
													</address>
												</div><!-- /.col -->
												<div class="col-sm-4 invoice-col">
													Vendor Address 3
													<address>
														<?= form_input(['name'=>'m_VENDORADDRESS3','id'=>'m_VENDORADDRESS3','class'=>'form-control','placeholder'=>'Vendor Address 3','autocomplete'=>'off','value'=>set_value('m_VENDORADDRESS3')]);?>							
													</address>
												</div><!-- /.col -->
												 <div class="col-sm-4 invoice-col">
													Vendor Address 4
													<address>
														<?= form_input(['name'=>'m_VENDORADDRESS4','id'=>'m_VENDORADDRESS4','class'=>'form-control','placeholder'=>'Vendor Address 4','autocomplete'=>'off','value'=>set_value('m_VENDORADDRESS4')]);?>							
													</address>
												</div><!-- /.col -->
											</div>	
					                        
					                        <div class="row invoice-info" style="margin-right: 3px; margin-left: 1px;">	
					                           
												<div class="col-sm-4 invoice-col">
													Phone
													<address>
														<?= form_input(['name'=>'m_PHONE','id'=>'m_PHONE','class'=>'form-control','placeholder'=>'Phone','autocomplete'=>'off','value'=>set_value('m_PHONE')]);?>							
													</address>
												</div><!-- /.col -->
												<div class="col-sm-4 invoice-col">
													Email
													<address>
														<?= form_input(['name'=>'m_EMAIL','id'=>'m_EMAIL','class'=>'form-control','placeholder'=>'Email','autocomplete'=>'off','value'=>set_value('m_EMAIL')]);?>							
													</address>
												</div><!-- /.col -->
											</div>	
										</div><!-- /.box-body -->
									  <div class="modal-footer">									
										<button type="button" id="saveAddAnother" class="btn btn-primary">Save Charterer</button>
									  </div>
								<?= form_close();?>
							</div>
						  </div>
						</div>



						<div class="modal fade" id="edit-modal-dem-owner" tabindex="-1" role="dialog" aria-labelledby="edit-modal-label">
						  <div class="modal-dialog" role="document">
							<div class="modal-content">
								
								  <div class="modal-header">
									<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
									<h4 class="modal-title" id="edit-modal-label">&nbsp;</h4>
								  </div>

								  <?= form_open_multipart('operation/insert-vendorowner', ['name'=>'frm3', 'id'=>'frm3', 'method'=>'post']); ?>
								 
								 <div class="box-body">
											<div class="row invoice-info" style="margin-right: 3px; margin-left: 1px;">	
												<div class="col-sm-4 invoice-col">
												 Vendor Name
													<address>
														<?= form_input(['name'=>'m_VENDORNAME','id'=>'m_VENDORNAME',  'required' => 'required', 'class'=>'form-control','placeholder'=>'Vendor Name','autocomplete'=>'off','value'=>set_value('m_VENDORNAME')]);?>	
																			   
													</address>
												</div><!-- /.col -->
												<div class="col-sm-4 invoice-col">
													Vendor Type
													<address>
														<?= form_dropdown(['name'=>'m_VENDORTYPE','id'=>'m_VENDORTYPE',  'class'=>'form-control'],$vendor_type_list);?>									
													</address>
												</div><!-- /.col -->
												<div class="col-sm-4 invoice-col">
													Status
													<address>
														<?= form_dropdown(['name'=>'m_STATUS','id'=>'m_STATUS','class'=>'form-control'],$status_list);?>									
													</address>
												</div><!-- /.col -->
											</div>	
											<div class="row invoice-info" style="margin-right: 3px; margin-left: 1px;">	
												
												<div class="col-sm-4 invoice-col">
													Vendor Short Name
													<address>
														<?= form_input(['name'=>'m_VENDORSORTNAME','id'=>'m_VENDORSORTNAME','class'=>'form-control','placeholder'=>'Vendor Short Name','autocomplete'=>'off','value'=>set_value('m_VENDORSORTNAME')]);?>	
													</address>
												</div><!-- /.col -->
					                            <div class="col-sm-4 invoice-col">
													VAT, RUT, TAX ID
													<address>
														<?= form_input(['name'=>'m_GSTIN','id'=>'m_GSTIN','class'=>'form-control','placeholder'=>'VAT, RUT, TAX ID','autocomplete'=>'off','value'=>set_value('m_GSTIN')]);?>	
													</address>
												</div><!-- /.col -->
												<div class="col-sm-4 invoice-col">
													Vendor Address 1
													<address>
														<?= form_input(['name'=>'m_VENDORADDRESS1','id'=>'m_VENDORADDRESS1','class'=>'form-control','placeholder'=>'Vendor Address 1','autocomplete'=>'off','value'=>set_value('m_VENDORADDRESS1')]);?>							
													</address>
												</div><!-- /.col -->
											</div>
											
											<div class="row invoice-info" style="margin-right: 3px; margin-left: 1px;">	
												
												<div class="col-sm-4 invoice-col">
													Vendor Address 2
													<address>
														<?= form_input(['name'=>'m_VENDORADDRESS2','id'=>'m_VENDORADDRESS2','class'=>'form-control','placeholder'=>'Vendor Address 2','autocomplete'=>'off','value'=>set_value('m_VENDORADDRESS2')]);?>							
													</address>
												</div><!-- /.col -->
												<div class="col-sm-4 invoice-col">
													Vendor Address 3
													<address>
														<?= form_input(['name'=>'m_VENDORADDRESS3','id'=>'m_VENDORADDRESS3','class'=>'form-control','placeholder'=>'Vendor Address 3','autocomplete'=>'off','value'=>set_value('m_VENDORADDRESS3')]);?>							
													</address>
												</div><!-- /.col -->
												<div class="col-sm-4 invoice-col">
													Vendor Address 4
													<address>
														<?= form_input(['name'=>'m_VENDORADDRESS4','id'=>'m_VENDORADDRESS4','class'=>'form-control','placeholder'=>'Vendor Address 4','autocomplete'=>'off','value'=>set_value('m_VENDORADDRESS4')]);?>							
													</address>
												</div><!-- /.col -->
											</div>	
					                        
					                        <div class="row invoice-info" style="margin-right: 3px; margin-left: 1px;">						                            
												<div class="col-sm-4 invoice-col">
													Phone
													<address>
														<?= form_input(['name'=>'m_PHONE','id'=>'m_PHONE','class'=>'form-control','placeholder'=>'Phone','autocomplete'=>'off','value'=>set_value('m_PHONE')]);?>							
													</address>
												</div><!-- /.col -->
												<div class="col-sm-4 invoice-col">
													Email
													<address>
														<?= form_input(['name'=>'m_EMAIL','id'=>'m_EMAIL','class'=>'form-control','placeholder'=>'Email','autocomplete'=>'off','value'=>set_value('m_EMAIL')]);?>							
													</address>
												</div><!-- /.col -->
											</div>	
										</div><!-- /.box-body -->
									  <div class="modal-footer">									
										<button type="button" id="saveAddAnotherowner" class="btn btn-primary">Save Owner</button>
									  </div>
								<?= form_close();?>
							</div>
						  </div>
						</div>
			
<!--   content ends here..................-->
</section><!-- /.content -->

 <script src="https://unpkg.com/leaflet@1.9.4/dist/leaflet.js"></script>


<script type="text/javascript">
$(document).ready(function(){
$('#m_CARGOID').select2();

$('#m_CPDATE,#m_BL_DATE,#m_ON_HIRE_SURVERY_DATE,#m_OFF_HIRE_SURVEY_DATE,#m_VESSEL_NOMINATION,#m_VESSEL_SUBSTITUTION,#m_STARTDATE, [id^=e1_BL_DATE_]').datepicker({
   		 format: 'dd-mm-yyyy',
		 autoclose: true

	

});



	$('#s2_DELIVERYDATE_1,#s2_REDELIVERYDATE_1,#s3_OFFHIREFROM_1_1,#s3_OFFHIRETO_1_1').datetimepicker({
	format: 'dd-mm-yyyy hh:ii',
	autoclose: true,
	minuteStep: 1
});

$('#m_LAYCANSTART').datepicker({
	format: 'dd-mm-yyyy',
	autoclose: true,
	minuteStep: 1	
}).on('changeDate', function(){ 
	$("#m_LAYCANEND").datepicker('setStartDate',new Date(getString($(this).val())));
  });

$('#m_LAYCANEND').datepicker({
	format: 'dd-mm-yyyy',
	autoclose: true,
	minuteStep: 1
}).on('changeDate', function(){ 
	$("#m_LAYCANSTART").datepicker('setEndDate',new Date(getString($(this).val())));
  });
	
	$("#m_MINCARGOQTY, #m_MINFLATRATE, #m_LUMPSUMFREIGHT, #m_COMMISSION, #m_DEMURRAGE, #m_COMMISSIONONDEMURRAGE, #m_MINDURATION, #m_HIRERATE, #m_MAXDURATION, #m_DAILYHIRERATE, #m_ACTUALDAYS, [id^=s1_PERCENTAGE_], [id^=s1_COMMAMT_]").numeric();
	$('.numeric').numeric();
	$('#m_REMARKS').autosize({append: "\n"});

	$("#frm1").validate({
		ignore: [],
		rules: {
			m_NOMINATIONID:{required: true},
			m_VENDORID:"required",
			m_OWNER:"required",
			m_CPDATE:"required",
			m_FLEETID:"required",
			m_LAYCANSTART:"required",
			m_LAYCANEND: "required",
			m_COMPANYID: "required",

			m_CCOMMISSIONFROM:"required",
			m_LPORT:{required: function(element) {if($('#m_LPORT').val() != ""){$("#s2id_m_LPORT").removeClass('error');return false;}else{$("#s2id_m_LPORT").addClass('error');return true;}}},	
			m_DPORT:{required: function(element) {if($('#m_DPORT').val() != ""){$("#s2id_m_DPORT").removeClass('error');return false;}else{$("#s2id_m_DPORT").addClass('error');return true;}}},	
			m_CLAIMSLOGINID:{required: function(element) {if($('input[name="m_NOMSTATUS"]').val() == "2"){return true;}else{return false;}}},
			m_LUMPSUMFREIGHT:{required: function(element) {if($('input[name="m_NOMSTATUS"]').val() == "2"){return true;}else{return false;}}},
			m_COMMISSION:{required: function(element) {if($('input[name="m_NOMSTATUS"]').val() == "2"){return true;}else{return false;}}},
			m_HIRERATE:{required: function(element) {if($('input[name="m_NOMSTATUS"]').val() == "2"){return true;}else{return false;}}}
			},
	submitHandler: function(form)  {
				
			if($('input[name="m_NOMSTATUS"]').val() == "2"){
				var comm = ($("#m_COMMISSION").val() != "") ? $("#m_COMMISSION").val() : 0;
				var sum_comm = $("[id^=s1_PERCENTAGE_]").sum();
				if(comm > 0 || sum_comm > 0){
					if(comm == sum_comm){
						$("button[type='submit']").attr("disabled","disabled").removeClass("btn-primary").addClass("btn-default disabled");
						swal({title: '<h1>Please Wait...</h1>',showCancelButton: false,type: 'warning',showConfirmButton: false,allowOutsideClick:false,animation: false,customClass: 'animated tada'}).catch(swal.noop);
						form.submit();
					}else{
						swal({title: 'Notice!',text: 'Broker Commission is not equal to total Commission',type: 'info',buttonsStyling: false,confirmButtonClass: 'btn btn-primary',allowOutsideClick:false});
					}
				}else{
					swal({title: 'Notice!',text: 'Commission should not be Zero(0).',type: 'info',buttonsStyling: false,confirmButtonClass: 'btn btn-primary',allowOutsideClick:false});
				}
			}else{
				$("button[type='submit']").attr("disabled","disabled").removeClass("btn-primary").addClass("btn-default disabled");
				swal({title: '<h1>Please Wait...</h1>',showCancelButton: false,type: 'warning',showConfirmButton: false,allowOutsideClick:false,animation: false,customClass: 'animated tada'}).catch(swal.noop);
				form.submit();
			}
			
		}
	});	


	
    $('#toggleDiv').click(function() {
        $('#hiddenDiv').toggle();
    });


	getRelativeData();
	getShow();
	getShowlumsum();
	

});


function getValidate(var1,var2)
{
	$('input[name="m_NOMSTATUS"]').val(var1);
	$('input[name="m_UPDATESTATUS"]').val(var2);
}





function addDAYCALGU()
{
	var pid = $("#m_LEMCR").val();
	var iden=0;
		pid = (pid - 1) + 2;
		iden = pid - 1;
		$('<tr id="row_offhiredate_'+pid+'"><td><a href="#Cancel Details" title="" data-toggle="tooltip" data-original-title="Cancel Details" onclick="cancelDetailshire('+pid+');"></a></td><td><input type="text" name="s2_DELIVERYDATE_'+pid+'" onchange="getTimeDiff('+pid+');" autocomplete="off" value="" id="s2_DELIVERYDATE_'+pid+'" class="form-control" placeholder="Delivery Date"></td><td><input type="text" name="s2_REDELIVERYDATE_'+pid+'" onchange="getTimeDiff('+pid+');" value="" id="s2_REDELIVERYDATE_'+pid+'" class="form-control" placeholder="Redelivery Date" autocomplete="off"></td><td><input type="text" name="s2_HIRERATE_'+pid+'" onkeyup="getcalculateDaycalet('+pid+'); getCalculatetchageinthisfunctio('+pid+');" value="" id="s2_HIRERATE_'+pid+'" class="form-control" placeholder="Hire Rate"></td><td><input type="text" name="s2_DAY_'+pid+'" value="" onkeyup="getcalculateDaycalet('+pid+');" id="s2_DAY_'+pid+'" class="form-control" placeholder="Days Rate" onkeyup="getCalculateCommAmt('+pid+');" readonly="true"></td><td><input type="text" name="s2_OFFHIREDAY_'+pid+'" readonly="true" value="0.00" id="s2_OFFHIREDAY_'+pid+'" class="form-control" placeholder="Off Hire" onkeyup="getcalculateDaycalet('+pid+');"></td><td><input type="text" name="s2_AVERAGEDURATION_'+pid+'" value="0.00" id="s2_AVERAGEDURATION_'+pid+'" class="form-control" onkeyup="getcalculateDaycalet('+pid+');getCalculatetchageinthisfunctio('+pid+');" placeholder="Average Duration" >   <input type="hidden" name="s2_TOTALHIRATE_'+pid+'" value="0.00" id="s2_TOTALHIRATE_'+pid+'" class="form-control" onkeyup="getCalculatetchageinthisfunctio('+pid+');" placeholder="Average Duration" ></td><td><input type="text" name="s2_MINIMUMDURATION_'+pid+'" value="0.00" id="s2_MINIMUMDURATION_'+pid+'"  class="form-control"  placeholder="Minimum Duration" ></td><td><input type="text" name="s2_MAXDURATION_'+pid+'" value="0.00" id="s2_MAXDURATION_'+pid+'" class="form-control"  placeholder="Maximum Duration" ></td><td><input type="text" name="s2_COMMISSION_'+pid+'" value="0.00" id="s2_COMMISSION_'+pid+'"  class="form-control" onkeyup="getcalculateDaycalet('+pid+');getCalculatetchageinthisfunctio('+pid+');" placeholder="Commission" ><input type="hidden" name="s2_TOTALCOMMISSION_'+pid+'" value="0.00" id="s2_TOTALCOMMISSION_'+pid+'"  class="form-control" onkeyup="getCalculatetchageinthisfunctio('+pid+');" placeholder="Commission" ></td><td><input type="text" name="s2_BALANCEDAY_'+pid+'" value="" id="s2_BALANCEDAY_'+pid+'" onkeyup="getcalculateDaycalet('+pid+');" class="form-control" placeholder="Balance Days" readonly="true"></td><td><input type="hidden" name="s2_BTOTAL_'+pid+'" value="" id="s2_BTOTAL_'+pid+'" onkeyup="getcalculateDaycalet('+pid+');" class="form-control" placeholder="Balance Days" readonly="true"></td></tr').appendTo("#Hire_body");

		$("#m_LEMCR").val(pid);


		
		$("[id^=s2_DAY_],[id^=s2_OFFHIREDAY_]").numeric();
		$('[id^=s2_DELIVERYDATE_],[id^=s2_REDELIVERYDATE_],[id^=s3_OFFHIREFROM_],[id^=s3_OFFHIRETO_]').datetimepicker({
			format: 'dd-mm-yyyy hh:ii',
			autoclose: true,
			minuteStep: 1	
		});



		
	}

	function getCalculatetchageinthisfunctio(offhireid) {
	if ($('#m_FIXTURETYPE').val() == 2 ) {  

	var hirnewrate = parseFloat($('#s2_HIRERATE_' + offhireid).val()) || 0;
	var avernerate = parseFloat($('#s2_AVERAGEDURATION_' + offhireid).val()) || 0; 

	var commissonrate = parseFloat($('#s2_COMMISSION_' + offhireid).val()) || 0;

	  var totalhisrate =parseFloat(hirnewrate)*parseFloat(avernerate);  


	  $('#s2_TOTALHIRATE_'+ offhireid).val(totalhisrate);

         var commissontotal =parseFloat(totalhisrate)*parseFloat(commissonrate)/100;

         $("#s2_TOTALCOMMISSION_" + offhireid).val(commissontotal);

         var sumtotalhirerate = sumElements("[id^=s2_TOTALHIRATE_]");
        var yotalcommisn = sumElements("[id^=s2_TOTALCOMMISSION_]");

        $('#TTHIRE').val(sumtotalhirerate);
        $('#m_HIRERATE').val(sumtotalhirerate);
        $('#m_ESTMINCOMMISSION').val(yotalcommisn);


	}

	} 
	

 function addoffhiredate(val)
{
	var pid = $("#m_HIORESDAY_"+val).val();
	var iden=0;
	

	if($("#s3_OFFHIREFROM_"+val+"_"+pid).val() && $("#s3_OFFHIRETO_"+val+"_"+pid).val() && $("#s3_OFFHIREDAYS_"+val+"_"+pid).val())
	{
		pid = (pid - 1) + 2;
		iden= (val-1);
		

		$('<tr id="DivTCConBunkeractual_'+val+'_'+pid+'"><td><a href="#Cancel Details" title="" data-toggle="tooltip" data-original-title="Cancel Details" onclick="cancelDetailshire('+val+','+pid+');"><i class="fa fa-times " style="color:red;"></i></a></td><td><input type="text" name="s3_OFFHIREFROM_'+val+'_'+pid+'" onchange="getHIREOFDAYDiff('+val+','+pid+');" autocomplete="off" value="" id="s3_OFFHIREFROM_'+val+'_'+pid+'" class="form-control" placeholder="Delivery Date"></td><td><input type="text" name="s3_OFFHIRETO_'+val+'_'+pid+'" onchange="getHIREOFDAYDiff('+val+','+pid+');" value="" id="s3_OFFHIRETO_'+val+'_'+pid+'" class="form-control" placeholder="Redelivery Date" autocomplete="off"></td><td><input type="text" name="s3_OFFHIREDAYS_'+val+'_'+pid+'" readonly="true" value="" id="s3_OFFHIREDAYS_'+val+'_'+pid+'" class="form-control" placeholder="Hire Days"></td></tr>').appendTo("#TCConbunkerTBody_"+val);

		$("#m_HIORESDAY_"+val).val(pid);		
		$("#s3_iden_"+val+"").val(pid);		
		$("[id^=s3_OFFHIREDAYS_]").numeric();
		
		$('[id^=s3_OFFHIREFROM_],[id^=s3_OFFHIRETO_]').datetimepicker({
			format: 'dd-mm-yyyy hh:ii',
			autoclose: true,
			minuteStep: 1	
		});
	}
	else
	{
		swal({title: 'Notice!',text: 'Please fill OFF Hire From, OFF Hire To and Off Hire Days.',type: 'info',buttonsStyling: false,confirmButtonClass: 'btn btn-primary',allowOutsideClick:false});
	}
}





function parseDateString(dateString) {

    if (typeof dateString !== 'string') return null;

    var parts = dateString.split(' ');
    if (parts.length < 2) return null;

    var dateParts = parts[0].split('-');
    var timeParts = parts[1].split(':');
    if (dateParts.length < 3 || timeParts.length < 2) return null;

    var isoString = dateParts[2] + '-' + dateParts[1] + '-' + dateParts[0] + 'T' + timeParts[0] + ':' + timeParts[1] + ':00';
    return new Date(isoString);
}

function getTimeDiff() {
      var tt = parseInt($("input[name='m_LEMCR']").val());   

    for (var i = 1; i <= tt; i++) {
        var startdate = $("#s2_DELIVERYDATE_" + i).val();
        var enddate = $("#s2_REDELIVERYDATE_" + i).val();

        console.log('Row', i, 'Start date:', startdate, 'End date:', enddate);  

        if (!startdate || !enddate) {
            console.error('Start date or end date is not provided for row', i);
             var newval = $("#s2_DAY_" + i).val();

            $("#s2_DAY_"+i).val(newval);
            continue;
        }

        var start_actual_time = parseDateString(startdate);
        var end_actual_time = parseDateString(enddate);

        if (isNaN(start_actual_time) || isNaN(end_actual_time)) {
            console.error('Invalid date for row', i, 'Start date:', startdate, 'End date:', enddate);
            $("#s2_DAY_"+i).val("0.0");
            continue;
        }

        var diff = (end_actual_time - start_actual_time) / (1000 * 60 * 60 * 24);

        console.log(diff);
        
        
       $("#s2_DAY_"+i).val(diff.toFixed(2));

    }
}

function getHIREOFDAYDiffcheck(val,row) {
      var hire = $("#m_HIORESDAY_"+val).val(); 

     
    for (var i = 1; i <= hire; i++) {
        var startdatehire = $("#s3_OFFHIREFROM_"+val+"_"+hire).val();
        var enddatehire = $("#s3_OFFHIRETO_"+val+"_"+hire).val();

        console.log('Row', i, 'Start date:', startdatehire, 'End date:', enddatehire);  

        if (!startdatehire || !enddatehire) {
            console.error('Start date or end date is not provided for row', i);
             var newvalhire = $("#s3_OFFHIREDAYS_"+val+"_"+hire).val();

            $("#s3_OFFHIREDAYS_"+val+"_"+hire).val(newvalhire);
            continue;
        }

        var start_actual_timehire = parseDateString(startdatehire);
        var end_actual_timehire = parseDateString(enddatehire);

        if (isNaN(start_actual_timehire) || isNaN(end_actual_timehire)) {
            console.error('Invalid date for row', i, 'Start date:', startdatehire, 'End date:', enddatehire);
            $("#s3_OFFHIREDAYS_"+val+"_"+hire).val("0.0");
            continue;
        }

        var diffhire = (end_actual_timehire - start_actual_timehire) / (1000 * 60 * 60 * 24);

      
       $("#s3_OFFHIREDAYS_"+val+"_"+hire).val(diffhire);
      

      var totalSum = 0;
		$("[id^=s3_OFFHIREDAYS_]").each(function() {
			var value = parseFloat($(this).val()) || 0;
			totalSum += value;
		});

		$("#s2_OFFHIREDAY_"+i).val(totalSum);


		console.log("Total sum:", totalSum);


      

    }
}






function getHIREOFDAYDiff(val,row) {
      var hire = $("#m_HIORESDAY_"+val).val(); 

        var startdatehire = $("#s3_OFFHIREFROM_"+val+"_"+row).val();
        var enddatehire = $("#s3_OFFHIRETO_"+val+"_"+row).val();


        var start_actual_timehire = parseDateString(startdatehire);
        var end_actual_timehire = parseDateString(enddatehire);
		

		
	

        if (isNaN(start_actual_timehire) || isNaN(end_actual_timehire)) {
          
            $("#s3_OFFHIREDAYS_"+val+"_"+row).val("0.0");
			
			return false;
        }

        var diffhire = (end_actual_timehire - start_actual_timehire) / (1000 * 60 * 60 * 24);

        console.log(diffhire);
        
        
       $("#s3_OFFHIREDAYS_"+val+"_"+row).val(diffhire.toFixed(2));
      

      var totalSum = 0;
	$("[id^=s3_OFFHIREDAYS_"+val+"_]").each(function() {
		var value = parseFloat($(this).val()) || 0;
		totalSum += value;if (isNaN(totalSum) || totalSum < 0) {
    totalSum = 0;
	}
	});

 	 


	console.log("Total sum:", totalSum);
	$("#s2_OFFHIREDAY_"+val).val(totalSum.toFixed(2));
	
	




	if(end_actual_timehire==null){
		$("#s3_OFFHIREDAYS_"+val+"_"+row).val("0.0");
	}else{
		getcalculateDaycalet();
		
	}
    
}




function getcalculateDaycalet()
{

	var totadrate = parseInt($("input[name='m_LEMCR']").val());  
	var check = 0;

    for (var i = 1; i <= totadrate; i++) {

    	 var daytime = $("#s2_DAY_" + i).val();
        var hirday = $("#s2_OFFHIREDAY_" + i).val();
         var hirdayrate = $("#s2_HIRERATE_" + i).val();

        var totalsub = (parseFloat(daytime) - parseFloat(hirday));if(isNaN(totalsub)){totalsub = 0;}

        $("#s2_BALANCEDAY_"+i).val(totalsub.toFixed(2));

         var totalhireday = (parseFloat(totalsub) * parseFloat(hirdayrate));if(isNaN(totalhireday)){totalhireday = 0;}

         $("#s2_BTOTAL_"+i).val(totalhireday);

        
			var s2_BALANCEDAY=$("#s2_BALANCEDAY_"+i).val();
			if(isNaN(s2_BALANCEDAY)){s2_BALANCEDAY = 0;}

			var s2_HIRERATE=$("#s2_HIRERATE_"+i).val();

			if(isNaN(s2_HIRERATE)){s2_HIRERATE = 0;}

			var tthire = $("#TTHIRE").val();
			if(isNaN(tthire)){tthire = 0;}

			check = parseFloat(check)+(parseFloat(s2_BALANCEDAY)*parseFloat(s2_HIRERATE));
		



         

         var hirdayrate = $("#TTHIRE").val();

       }

	  
	

}


function addBroker()
{
	var pid = parseInt($("input[name='m_LREC']").val());
	if($("#s1_BROKERID_"+pid).val() != "")
	{
		pid++;


		$('<tr id="row_'+pid+'"><td><a href="#Cancel Details" title="" data-toggle="tooltip" data-original-title="Cancel Details" onclick="cancelDetails('+pid+');"><i class="fa fa-times " style="color:red;"></i></a></td><td><select name="s1_BROKERID[]" id="s1_BROKERID_'+pid+'" class="form-control"></select></td><td><?= form_dropdown(['name'=>'s1_LOCATION[]','id'=>"s1_LOCATION_'+pid+'",'class'=>'form-control'],$company_list);?></td></tr>').appendTo("#broker_body");

		$("#s1_BROKERID_"+pid).html($("#BROKERID").html());		
		$("input[name='m_LREC']").val(pid);
	
	}
	else
	{

		swal({title: 'Notice!',text: 'Please fill Broker.',type: 'info',buttonsStyling: false,confirmButtonClass: 'btn btn-primary',allowOutsideClick:false});
	}
}




function getCalculateCommAmt(rowid)
{
	var freight_hire = ($("#m_FIXTURETYPE").val() == 1 || $("#m_FIXTURETYPE").val() == 3) ? (($("#m_LUMPSUMFREIGHT").val() != "") ? $("#m_LUMPSUMFREIGHT").val() : 0) : (($("#m_HIRERATE").val() != "") ? $("#m_HIRERATE").val() : 0);
	var broker_percent = ($("#s1_PERCENTAGE_"+rowid).val() != "") ? $("#s1_PERCENTAGE_"+rowid).val() : 0;
	if(broker_percent != 0){
		var calc = (parseFloat(freight_hire) * parseFloat(broker_percent)) / 100;
		$("#s1_COMMAMT_"+rowid).val(calc.toFixed(2));
	}else{
		$("#s1_COMMAMT_"+rowid).val();
	}
	
	

	var totalPercentage = $("[id^=s1_PERCENTAGE_]").sum().toFixed(3);
    var commissionValue = parseFloat($("#m_COMMISSION").val());

	if(totalPercentage <= commissionValue)
	{
	   if(isNaN(totalPercentage)) { totalPercentage = 0.00; }
        var remainingBalance = (commissionValue - totalPercentage).toFixed(2);
        if(isNaN(remainingBalance)) { remainingBalance = 0.00;}

       var comvale = $("#s1_PERCENTAGE_"+(rowid+1)).val(remainingBalance);    

	}
	else
	{
		$("#s1_PERCENTAGE_" + rowid).val('0.00');
		$("#s1_COMMAMT_" + rowid).val('0.00');
		swal({title: 'Notice!',text: 'The broker percentage is greater than the total commission percentage.',type: 'info',buttonsStyling: false,confirmButtonClass: 'btn btn-primary',allowOutsideClick:false});
	}
}

function getString(var1)
{
	var var3 = var1.split('-');
	var var2 = var3[2].split(' ');
	return var2[0]+'/'+var3[1]+'/'+var3[0]+' '+var2[1];
}

function getcalculate()
{
	if($('#m_FIXTURETYPE').val() == 1 || $('#m_FIXTURETYPE').val() == 3 )
	{
		if($('#m_LUMPSUMFREIGHT').val() != '' && $('#m_COMMISSION').val() != '')
		{
			var ttl = ($('#m_LUMPSUMFREIGHT').val())*(($('#m_COMMISSION').val())/100);
			$('#m_ESTMINCOMMISSION').val(ttl.toFixed(2));
			$('#ESTMINCOMMISSIONHIDEN').val(ttl.toFixed(2));
		}
		else
		{
			$('#m_ESTMINCOMMISSION').val(0);
		}
	}
	
	
}
function getcalculateDEM()
{
	if($('#m_FIXTURETYPE').val() == 1 || $('#m_FIXTURETYPE').val() == 3 )
	{
		if($('#m_DEMURRAGE').val() != '' && $('#m_COMMISSIONONDEMURRAGE').val() != '')
		{
			var ttl = ($('#m_DEMURRAGE').val())*(($('#m_COMMISSIONONDEMURRAGE').val())/100);
			$('#m_COMMISSIONONDEMURRAGEAMT').val(ttl.toFixed(2));
		}
		else
		{
			$('#m_COMMISSIONONDEMURRAGEAMT').val(0);
		}
	}
}



function getcalculateTimeballbons()
{
	if($('#m_FIXTURETYPE').val() == 2){
	
    	var BALLASRBOUNS = ($('#m_BALLASTBONUS').val())*(($('#m_ADCOMM').val())/100).toFixed(2);

        totalballbons = $('#m_BALLASTBONUS').val();

        var NETAMOU = (totalballbons-BALLASRBOUNS).toFixed(2);if(isNaN(NETAMOU)){NETAMOU = 0;}
        $('#m_NETBALLAST').val(NETAMOU);

        var totalhire = $('#TTHIRE').val();if(isNaN(totalhire)){totalhire = 0;}

        console.log(totalhire);
       var totaladdbaln =  (parseFloat(totalhire)+parseFloat(NETAMOU)).toFixed(2);if(isNaN(totaladdbaln)){totaladdbaln = 0;}

         if($('#m_BALLASTBONUS').val() != 0){
        
           $('#m_HIRERATE').val(totaladdbaln);

       }
   }
}

function getcalculateTime()
{
	if($('#m_FIXTURETYPE').val() == 2)
	{
		var ttl = ($('#m_HIRERATE').val())*(($('#m_COMMISSION').val())/100);
			$('#m_ESTMINCOMMISSION').val(ttl.toFixed(2));
			$('#ESTMINCOMMISSIONHIDEN').val(ttl.toFixed(2));

	   

 
	}	else{


		var ttl = ($('#m_LUMPSUMFREIGHT').val())*(($('#m_COMMISSION').val())/100);
			$('#m_ESTMINCOMMISSION').val(ttl.toFixed(2));
			$('#ESTMINCOMMISSIONHIDEN').val(ttl.toFixed(2));
	}

 
	
}

function getcalculateTimemycode()
{
if($('#m_LUMPSUM').val()!='' ){
   var total = $('#m_LUMPSUM').val();
  
}else{
	 var total = $('#m_FREIGHTRATEY').val()*$('#m_LSMINCARGOQTY').val();

}
$('#m_LUMPSUMFREIGHT').val(total);

}

const currentYear = new Date().getFullYear().toString().slice(-2);

    $('#m_FIXTURETYPE').on('change', function() {
      
        const fixtureType = $(this).val();
        let letter = '';

        if (fixtureType == 1) {
            letter = 'V';
        } else if (fixtureType == 2) {
            letter = 'T';
        } else if (fixtureType == 3) {
            letter = 'C';
        }
        var addsum =  $('#COAID').val();

       
        $.ajax({
            url: url+'operation/getNextNominationId', 
            method: 'POST',
            data: { fixtureType: fixtureType }, 
            success: function(response) {

            	if(letter == 'C'){             
                var nomid = currentYear + '-' + letter + '-' + response + '-' + addsum;
                }else{
                var nomid = currentYear + '-' + letter + '-' + response;
                }
                $('#m_NOMINATIONID').val(nomid); 
            },
            error: function() {
                console.error('Error fetching the next nomination ID.');
            }
        });
    });


function getRelativeData()
{
	$('#m_ESTMINCOMMISSION').val(0.00);
	if($('#m_FIXTURETYPE').val() == 1){$('[id^=time_]').hide();$('[id^=voy_],[name^=submit]').show();}
	if($('#m_FIXTURETYPE').val() == 2){$('[id^=voy_]').hide();$('[id^=time_],[name^=submit]').show();}
	if($('#m_FIXTURETYPE').val() == 3){$('[id^=time_]').hide();$('[id^=voy_],[name^=submit]').show();}

 if ($('#m_FIXTURETYPE').val() == 3)
      {
        $("#maxmin_1").show();
        $("#maxmin_2").show();
      }
      else
      {
        $("#maxmin_1").hide();
        $("#maxmin_2").hide();
      }



}

function addvcdata(id) {
    const element = document.getElementById(id);
    if (element.style.display === "none" || element.style.display === "") {
      element.style.display = "block"; 
    } else {
      element.style.display = "none"; 
    }
  }

function getcalculatecumission()
{
	if ($('#m_FIXTURETYPE').val() == 2)
	{		

		var totalcummison = parseFloat($('#m_LUMPSUMDATA').val()) || 0;
		var addcenelcummison = parseFloat($('#m_ADDITIONALCOMM').val()) || 0;
		var addcmmison = parseFloat($('#ESTMINCOMMISSIONHIDEN').val()) || 0;

		var dumtotal = addcenelcummison + addcmmison + totalcummison;if(isNaN(dumtotal)){dumtotal = 0;}

		$('#m_ESTMINCOMMISSION').val(dumtotal);
		} 

}



function getShow(status)
{
	if(status == 1){
		$("#m_WS, #m_FPORT, #m_TPORT, #m_WSFLATRATE, #m_ACTUALQTY, #m_WSMINCARGOQTY, #m_MINAMOUNT, #m_OVERAGE, #m_OVERAMOUNT,#m_FIXEDDIFFERENTIAL,#m_FIXEDDIFFERENTIALAMT").attr('disabled',true);
		$('#m_FPORT, #m_TPORT').select2("enable",false);
		$("#m_LSMINCARGOQTY").attr('disabled',false);
		$("#m_FREIGHTRATEY").attr('disabled',true);
		$("#m_LUMPSUMFREIGHT").attr('readonly',false);
		$("#m_LUMPSUM").attr('disabled',false);

	}else if(status == 3){
		$("#m_LUMPSUM").attr('disabled',true);
		$("#m_FREIGHTRATEY").attr('disabled',false);
		$("#m_FREIGHTRATEY").val("0");
	}else{
		$("#m_WS, #m_FPORT, #m_TPORT, #m_WSFLATRATE, #m_ACTUALQTY, #m_WSMINCARGOQTY, #m_MINAMOUNT, #m_OVERAGE, #m_OVERAMOUNT,#m_FIXEDDIFFERENTIAL,#m_FIXEDDIFFERENTIALAMT").attr('disabled',false);
		$('#m_FPORT, #m_TPORT').select2("enable",true);
		$("#m_LUMPSUMFREIGHT").attr('readonly',false);
		$("#m_FREIGHTRATEY").val("0");
		$("#m_FREIGHTRATEY").attr('disabled',true);

	}
}

function getShowlumsum(status)
{
	if ($('#m_FIXTURETYPE').val() == 2)
	{
		if(status == 11)
		{
		$('#m_COMMISSION').attr("disabled",true);
		$('#m_LUMPSUMDATA').attr("disabled",false);
		}
		else if(status == 12)
		{
		$('#m_LUMPSUMDATA').attr("disabled",true);		
		$('#m_COMMISSION').attr("disabled",false);		
		}else{
		$("#m_LUMPSUMDATA").attr('disabled',true);
		}
	}
	
		}




function calculateMinCargo(){
	var ws = $("#m_WS").val() || 0;
	var wsflatrate = $("#m_WSFLATRATE").val() || 0;
	var fixeddiff = $("#m_FIXEDDIFFERENTIAL").val() || 0;
	var minCargo = $("#m_WSMINCARGOQTY").val() || 0;
	var actualCargo = $("#m_ACTUALQTY").val() || 0;
	var calc = (parseFloat(ws) * parseFloat(wsflatrate) * parseFloat(minCargo))/100;
	$("#m_MINAMOUNT").val(calc.toFixed(2));
	var freight = $("#m_MINAMOUNT, #m_OVERAMOUNT").sum();
	var fixeddiffamt = parseFloat(actualCargo)*parseFloat(fixeddiff);
	$("#m_FIXEDDIFFERENTIALAMT").val(fixeddiffamt.toFixed(2));
	var total_freight = parseFloat(freight) + parseFloat(fixeddiffamt);
	$("#m_LUMPSUMFREIGHT").val(total_freight.toFixed(2));
	getcalculate();
}

function calculateOverage(){
	var ws = $("#m_WS").val() || 0;
	var wsflatrate = $("#m_WSFLATRATE").val() || 0;
	var overage = $("#m_OVERAGE").val() || 0;
	var calc = (parseFloat(ws/2) * parseFloat(wsflatrate) * parseFloat(overage))/100;
	$("#m_OVERAMOUNT").val(calc.toFixed(2));
	$("#m_LUMPSUMFREIGHT").val($("#m_MINAMOUNT, #m_OVERAMOUNT, #m_FIXEDDIFFERENTIALAMT").sum().toFixed(2));
	getcalculate();
}

function cancelDetails(value)
{		
	swal({
			title: 'Are you sure?',
			text: 'You will not be able to recover this entry!',
			type: 'warning',
			showCancelButton: true,
			buttonsStyling: false,
			confirmButtonClass: 'btn btn-danger',
			confirmButtonText: 'Yes, delete it!',
			cancelButtonClass: 'btn btn-secondary',
			allowOutsideClick:false,
		}).then(function(){
			$('#row_'+value).remove();
			swal({title: 'Successfully deleted.',text: 'You will not be able to recover this entry!',type: 'success',buttonsStyling: false,allowOutsideClick:false,confirmButtonClass: 'btn btn-primary'});
		}).catch(swal.noop);
}


function cancelDetailshire(value)
{		
	swal({
			title: 'Are you sure?',
			text: 'You will not be able to recover this entry!',
			type: 'warning',
			showCancelButton: true,
			buttonsStyling: false,
			confirmButtonClass: 'btn btn-danger',
			confirmButtonText: 'Yes, delete it!',
			cancelButtonClass: 'btn btn-secondary',
			allowOutsideClick:false,
		}).then(function(){
			$('#row_'+value).remove();
			swal({title: 'Successfully deleted.',text: 'You will not be able to recover this entry!',type: 'success',buttonsStyling: false,allowOutsideClick:false,confirmButtonClass: 'btn btn-primary'});
		}).catch(swal.noop);
}


function getVesseldataByImo(ele) {
    $('#FfaDetailHedgeVsl').html('<tr><td align="center" colspan="11"><img src="../../lighthouse/assets/img/loading.gif" /></td></tr>');

    setTimeout(() => {
    	 $.post("<?= base_url('operation/getVesselDataByImotext'); ?>", {
            m_FLEETID: $(ele).val(),
            txtToDate: $("#txtToDate").val(),
            txtFromDate: $("#txtFromDate").val()
        }, function(response) {
            $('#FfaDetailHedgeVsl').empty();

            let html = JSON.parse(response);
            if (html.ApiResults && html.ApiResults.length > 0) {
                $.each(html.ApiResults, function(index, array) {
                    $('<tr><td><a href="#" class="column1link" style="display:block;" data-toggle="modal" data-target="#compose_modal_distance" data-id="' + array['ShipName'] + '" onclick="getLastPositionOfVessel(this)">' + array['ShipName'] + '</a></td>' +
                        '<td>' + array['ImoNumber'] + '</td>' +
                        '<td>' + array['MmsiNumber'] + '</td>' +
                        '<td>' + array['CallSign'] + '</td>' +
                        '<td><ul><li><b>Address-</b>' + array['ShipOwner']['address'] + '</li>' +
                        '<li><b>Company imo-</b>' + array['ShipOwner']['company_imo'] + '</li>' +
                        '<li><b>Company name-</b>' + array['ShipOwner']['company_name'] + '</li>' +
                        '<li><b>Date of effect-</b>' + array['ShipOwner']['date_of_effect'] + '</li>' +
                        '<li><b>Role-</b>' + array['ShipOwner']['role'] + '</li></ul></td>' +
                        '<td><ul><li><b>Address-</b>' + array['ShipManager']['address'] + '</li>' +
                        '<li><b>Company imo-</b>' + array['ShipManager']['company_imo'] + '</li>' +
                        '<li><b>Company name-</b>' + array['ShipManager']['company_name'] + '</li>' +
                        '<li><b>Date of effect-</b>' + array['ShipManager']['date_of_effect'] + '</li>' +
                        '<li><b>Role-</b>' + array['ShipManager']['role'] + '</li></ul></td>' +
                        '<td>' + array['ShipType'] + '</td>' +
                        '<td>' + array['DeadWeight'] + '</td>' +
                        '<td>' + array['GrossTonnage'] + '</td>' +
                        '<td>' + array['OperationStatus'] + '</td>' +
                        '<td>' + array['YearOfBuilt'] + '</td></tr>').appendTo("#FfaDetailHedgeVsl");
                });
            } else {
                $('#FfaDetailHedgeVsl').html('<tr><td align="center" colspan="11">No data found</td></tr>');
            }
        });
    }, 100);
}



function toDMS(deg) {
	var d = Math.floor(deg);
	var minfloat = (deg - d) * 60;
	var m = Math.floor(minfloat);
	var secfloat = (minfloat - m) * 60;
	var s = Math.round(secfloat);
	if (s == 60) {
		m++;
		s = 0;
	}
	if (m == 60) {
		d++;
		m = 0;
	}
	return "" + d + "°" + m + "'" + s + "\"";
}





let map;

function getLastPositionOfVessel(ele) {
    const vesselName = $(ele).data('id');
    const fromDate = $("#txtFromDate").val();

    if (!vesselName) {
        alert("Vessel name is required.");
        return;
    }

     $.post("<?= base_url('operation/getLastPosVessel'); ?>", { vesselName, txtFromDate: fromDate }, function(json) {
        $("#map").empty(); 
        
        let jsondata;
        try {
            jsondata = JSON.parse(json);
        } catch (error) {
            console.error("Error parsing JSON:", error);
            alert("Invalid JSON response.");
            return;
        }

        if (!jsondata || !jsondata.vessels_info || jsondata.vessels_info.length === 0) {
            alert("No vessel data found.");
            return;
        }

        const vesselInfo = jsondata.vessels_info[0];

       
        if (map) map.remove();

       
        map = L.map('map', {
            center: [vesselInfo.latitude_deg, vesselInfo.longitude_deg],
            zoom: 10,
            maxZoom: 15,
            attributionControl: true
        });

       
        const baseMaps = {
            "OpenStreetMap": L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', { attribution: 'OpenStreetMap' }).addTo(map),
            "Simple Map": L.tileLayer('https://tile3-service.seametrix.net/mapsapi/simplemap/5hn3w1x2ta/{z}/{x}/{y}.png'),
            "Color Map": L.tileLayer('https://tile3-service.seametrix.net/mapsapi/colormap/5hn3w1x2ta/{z}/{x}/{y}.png'),
         
        };

        const overlayMaps = {
            "Ports": L.tileLayer('https://tile3-service.seametrix.net/mapsapi/ports/5hn3w1x2ta/{z}/{x}/{y}.png'),
            "Risk Areas": L.tileLayer('https://tile3-service.seametrix.net/mapsapi/riskareas/5hn3w1x2ta/{z}/{x}/{y}.png'),
            
        };

        L.control.layers(baseMaps, overlayMaps).addTo(map);

        
        const latlng = new L.latLng(vesselInfo.latitude_deg, vesselInfo.longitude_deg);
        const marker = L.marker(latlng).addTo(map);
        marker.bindPopup(`Ship: ${vesselInfo.name}<br>Coordinates: ${latlng.toString()}`).openPopup();

       
        updateVesselInfo(vesselInfo);

    }).fail(function(xhr, status, error) {
        console.error("Error fetching vessel data:", error);
        alert("Error fetching vessel data.");
    });
}


function updateVesselInfo(vesselInfo) {
    $('#spanForName').text(vesselInfo.name || "N/A");
    $('#call_sign').text(vesselInfo.call_sign || "N/A");
    $('#destination').text(vesselInfo.destination || "N/A");
    $('#etaDateTime').text(vesselInfo.eta_datetime || "N/A");
    $('#max_draught').text(vesselInfo.max_draught || "N/A");
    $('#shipType').text(vesselInfo.ship_type || "N/A");
    $('#navigational_status').text(vesselInfo.navigational_status || "N/A");
    $('#Dimension_a_m').text(vesselInfo.dimension_a_m || "N/A");
    $('#Dimension_b_m').text(vesselInfo.dimension_b_m || "N/A");
    $('#Dimension_c_m').text(vesselInfo.dimension_c_m || "N/A");
    $('#Dimension_d_m').text(vesselInfo.dimension_d_m || "N/A");
    $('#spanForOrigin').text(vesselInfo.origin || "N/A");
}



function sumElements(selector) {
    var total = 0;
    $(selector).each(function () {
        var value = parseFloat($(this).val()) || 0; 
        total += value;
    });
    return total;
}

function getCalculatefunctiontotal(cargoid) {
    if ($('#m_FIXTURETYPE').val() == 1 || $('#m_FIXTURETYPE').val() == 3) {        
        var quantycum = parseFloat($('#e1_QUANTITY_' + cargoid).val()) || 0;
        var freightnum = parseFloat($('#e1_FREIGHT_' + cargoid).val()) || 0; 

        var totranpluse = parseFloat($('#e1_TOLERANCEPLUSE_' + cargoid).val()) || 0; 

        var totrannegitiv  = parseFloat($('#e1_TOLERANCENIG_' + cargoid).val()) || 0;

        var dedfreigrnum = parseFloat($('#e1_DEAD_FREIGHT_RATE_' + cargoid).val()) || 0;

        var totalquaty = quantycum * freightnum;
        var defrigtcomstion = quantycum * dedfreigrnum;
        var totalcum = totalquaty + defrigtcomstion;

        $('#e1_TOTAL_FREIGHT_' + cargoid).val(totalcum.toFixed(2));

        var comisson = parseFloat($('#e1_COMMISSION_' + cargoid).val()) || 0;
        var estimate = (comisson * totalcum) / 100;
        $('#e1_ESTIMATED_MINIMUM_' + cargoid).val(estimate.toFixed(2));

        
        var totalcommis = sumElements("[id^=e1_ESTIMATED_MINIMUM_]");
        var totalfright = sumElements("[id^=e1_TOTAL_FREIGHT_]");

        var addcenelcummison = parseFloat($('#m_ADDITIONALCOMM').val()) || 0;


        var totalcummison = parseFloat($('#m_LUMPSUMDATA').val()) || 0;	
        var totallumsum = parseFloat($('#m_LUMPSUM').val()) || 0;	

        var dumtotaltort = addcenelcummison + totalcommis;  

        var totalfreight = totalfright; 

        if (totallumsum!=0){ 
         $('#m_LUMPSUMFREIGHT').val(totallumsum.toFixed(2));}else{
          $('#m_LUMPSUMFREIGHT').val(totalfreight.toFixed(2)); }

        if (totalcummison!=0){ 

         var totalcummisstion = addcenelcummison + totalcummison;   

        	$('#m_ESTMINCOMMISSION').val(totalcummisstion.toFixed(2));
        }else{  $('#m_ESTMINCOMMISSION').val(dumtotaltort.toFixed(2)); }


       var totalpluse = (quantycum*totranpluse)/100;
       var totalnegive = (quantycum*totrannegitiv)/100;
      

      var  cpqutpluse =quantycum + totalpluse; 
      var  cpqutnegitive =quantycum - totalnegive; 

      $('#e1_TOTAL_PLUSE_' + cargoid).val(cpqutpluse.toFixed(2));
      $('#e1_TOTAL_NEGITV_' + cargoid).val(cpqutnegitive.toFixed(2));



      var totacpmaxsum = sumElements("[id^=e1_TOTAL_PLUSE_");
        var totacpminnegit = sumElements("[id^=e1_TOTAL_NEGITV_]");

      
      $('#m_CPQUNTITYMIN').val(totacpminnegit.toFixed(2)); 

        $('#m_CPQUNTITYMAX').val(totacpmaxsum.toFixed(2)); 



  
 
    }
}


function addPortQtyaa() {
   var pid = parseInt($("input[name='m_CARGO']").val());

   	if($("#e1_CARGOID_"+pid).val() && $("#e1_QUANTITY_"+pid).val() && $("#e1_TOLERANCEPLUSE_"+pid).val())
	{
		pid++;


		$('<tr id="row_'+pid+'"><td><a href="#Cancel Details" title="" data-toggle="tooltip" data-original-title="Cancel Details" onclick="cancelDetails('+pid+');"><i class="fa fa-times " style="color:red;"></i></a></td><td><select name="e1_CARGOID_'+pid+'" id="e1_CARGOID_'+pid+'" class="form-control"></select></td><td><input type="text" name="e1_QUANTITY_'+pid+'" value="" id="e1_QUANTITY_'+pid+'" autocomplete="off" class="form-control" placeholder="Quantity (MT)"   onkeyup="getCalculatefunctiontotal('+pid+');" ></td><td><input type="text" name="e1_FREIGHT_'+pid+'" value="" id="e1_FREIGHT_'+pid+'" autocomplete="off" class="form-control" placeholder="Freight (USD/MT)"  onkeyup="getCalculatefunctiontotal('+pid+');" ></td><td><input type="text" name="e1_TOTAL_FREIGHT_'+pid+'" value="" id="e1_TOTAL_FREIGHT_'+pid+'" autocomplete="off" class="form-control" placeholder="Total Freight" ></td><td><input type="text" name="e1_TOLERANCEPLUSE_'+pid+'" value="" id="e1_TOLERANCEPLUSE_'+pid+'" autocomplete="off" class="form-control" placeholder="Tolerance +(%)"></td><td><input type="text" name="e1_TOLERANCENIG_'+pid+'" value="" id="e1_TOLERANCENIG_'+pid+'" autocomplete="off" class="form-control" placeholder="Tolerance -(%)" ></td><td style="display:none;"><input type="text" name="e1_COMMISSION_'+pid+'" value="" id="e1_COMMISSION_'+pid+'" autocomplete="off" style="width: 113px;"  class="form-control" placeholder="Commission %" onkeyup="getCalculatefunctiontotal('+pid+');" ></td><td><select name="e1_OPTION_'+pid+'" id="e1_OPTION_'+pid+'" class="form-control" style="width: 130px;" ></select></td><td><input type="text" name="e1_DEMURRAGEPOL_'+pid+'" value="" id="e1_DEMURRAGEPOL_'+pid+'" autocomplete="off" class="form-control" placeholder="Demurrage POL(USD/MT)"></td><td><input type="text" name="e1_DEMURRAGEPOD_'+pid+'" value="" id="e1_DEMURRAGEPOD_'+pid+'" autocomplete="off" class="form-control" placeholder="Demurrage POD(USD/MT)"></td><td><input type="text" name="e1_ESTIMATED_MINIMUM_'+pid+'" value="" id="e1_ESTIMATED_MINIMUM_'+pid+'" autocomplete="off" class="form-control" placeholder="Estimated Minimum Commission (USD)"></td><td><input type="hidden" name="e1_TOTAL_PLUSE_'+pid+'" value="" id="e1_TOTAL_PLUSE_'+pid+'" autocomplete="off" class="form-control" placeholder=""  onkeyup="getCalculatefunctiontotal('+pid+');" ></td><td><input type="hidden" name="e1_TOTAL_NEGITV_'+pid+'" value="" id="e1_TOTAL_NEGITV_'+pid+'" autocomplete="off" class="form-control" placeholder=""  onkeyup="getCalculatefunctiontotal('+pid+');" ></td></tr>').appendTo("#cargo_body");

		$("#e1_CARGOID_"+pid).html($("#CARGOID").html());
		$("#e1_OPTION_"+pid).html($("#OPTION").html());
		$("[id^=e1_QUANTITY],[id^=e1_TOLERANCEPLUSE_]").numeric();
		$("input[name='m_CARGO']").val(pid);

		$('[id^=e1_BL_DATE_]').datepicker({
			format: 'dd-mm-yyyy',
			autoclose: true,
			minuteStep: 1	
		});
	}
	else
	{

		swal({title: 'Notice!',text: 'Please fill Cargo Details.',type: 'info',buttonsStyling: false,confirmButtonClass: 'btn btn-primary',allowOutsideClick:false});
	}




	
}




$(document).ready(function() {

	 var url = "<?= base_url();?>";  
    function reloadOwnerList2(selectedOwnerId2 = null) {
        $.ajax({
            url: url + "json/JsononerchaterList",
            dataType: "json",
            success: function(data) {
                console.log("Charterer List Data:", data); 

                $('#m_VENDORID').empty();
                $('#m_VENDORID').append('<option value="">Select Charterer</option>');

                $.each(data, function(index, item) {
                    $('#m_VENDORID').append(
                        $('<option>', { value: item.id, text: item.name.toUpperCase() })
                    );
                });

               
                if (selectedOwnerId2) {
                    $('#m_VENDORID').val(selectedOwnerId2).trigger('change');
                }

                
                $('#m_VENDORID').select2();
            },
            error: function(xhr, status, error) {
                console.error("Error loading owner list:", xhr.responseText);
            }
        });
    }


    reloadOwnerList2();


    
    $("#frm2").validate({
        rules: {
            m_VENDORNAME: { required: true },
            m_VENDORTYPE: { required: true }
        },
        messages: {
            m_VENDORNAME: "Vendor Name is required",
            m_VENDORTYPE: "Vendor Type is required"
        },
        submitHandler: function(form) {
            var formData = new FormData(form);

            $.ajax({
                type: 'POST',
                url: '<?= base_url("operation/insert_vendorCharterer") ?>',
                data: formData,
                processData: false,
                contentType: false,
                dataType: 'json',
                success: function(response) {
                    if (response.status === "success") {
                        alert('Vendor saved! Add another.');

                        
                        $('#frm2')[0].reset();

                      
                       
                         reloadOwnerList2(response.vendor_id);

                        
                        $('#edit-modal-dem').modal('hide');
                    } else {
                        console.error("Server Error Message:", response.message);
                        alert('Error: ' + response.message);
                    }
                },
                error: function(xhr, status, error) {
                    console.error("AJAX Error:", xhr.status, xhr.statusText);
                    console.error("Server Response:", xhr.responseText);
                    alert('Error saving vendor.');
                }
            });
        }
    });

   
    $('#saveAddAnother').click(function(e) {
        e.preventDefault();
        $("#frm2").submit();
    });

});

$(document).ready(function() {
    var url = "<?= base_url();?>";  
    function reloadOwnerList(selectedOwnerId = null) {
        $.ajax({
            url: url + "json/JsononerchaterList",
            dataType: "json",
            success: function(data) {
                console.log("Owner List Data:", data); 

                $('#m_OWNER').empty();
                $('#m_OWNER').append('<option value="">Select Owner</option>');

                $.each(data, function(index, item) {
                    $('#m_OWNER').append(
                        $('<option>', { value: item.id, text: item.name.toUpperCase() })
                    );
                });

               
                if (selectedOwnerId) {
                    $('#m_OWNER').val(selectedOwnerId).trigger('change');
                }

                
                $('#m_OWNER').select2();
            },
            error: function(xhr, status, error) {
                console.error("Error loading owner list:", xhr.responseText);
            }
        });
    }


    reloadOwnerList();

   
    $("#frm3").validate({
        rules: {
            m_VENDORNAME: { required: true },
            m_VENDORTYPE: { required: true }
        },
        messages: {
            m_VENDORNAME: "Vendor Name is required",
            m_VENDORTYPE: "Vendor Type is required"
        },
        submitHandler: function(form) {
            var formData = new FormData(form);

            $.ajax({
                type: "POST",
                url: url + "operation/insert_vendorowner",
                data: formData,
                processData: false,
                contentType: false,
                dataType: "json",
                success: function(response) {
                    if (response.status === "success") {
                        alert("Owner saved successfully!");

                      
                        $('#frm3')[0].reset();

                      
                        reloadOwnerList(response.vendor_id);

                        
                        $("#edit-modal-dem-owner").modal("hide");
                    } else {
                        console.error("Server Error:", response.message);
                        alert("Error: " + response.message);
                    }
                },
                error: function(xhr, status, error) {
                    console.error("AJAX Error:", xhr.responseText);
                    alert("Error saving owner.");
                }
            });
        }
    });


    $("#saveAddAnotherowner").click(function(e) {
        e.preventDefault();
        $("#frm3").submit();
    });
});



</script>