<?php
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');
?>               
<!-- Content Header (Page header) -->
<section class="content-header">
	<h1>
		<i class="fa fa-bar-chart-o"></i>&nbsp;Report&nbsp;&nbsp;&nbsp;&nbsp;<small><div class="headline text-center" id="time" style="color:#000; font-weight:bold; font-size:12px;"></div></small>
	</h1>
	<ol class="breadcrumb">
		<li><a href="<?= base_url('admin/dashboard');?>"><i class="fa fa-home"></i> Home</a></li>
		<li class="active">DETAILED ANNUAL REVENUE REPORT</li>
	</ol>
</section>

<!-- Main content -->
<section class="content">
<!--   content put here..................-->
	<div class="box box-primary">
			<div class="box-header">
				<h3 class="box-title"><b><?= strtoupper('Detailed Annual Revenue Report');?></b></h3>
			</div>		
			<div class="box-body table-responsive" >
				<div class="row invoice-info">	
					<div class="col-sm-3 invoice-col"><br />&nbsp;&nbsp;<a href="#Excel" class="btn btn-success btn-flat" onClick ="getExcel();" ><i class="fa fa-download"></i> Generate Excel</a></div> 					
                    <div class="col-sm-3 invoice-col text-right">
                        <div class="form-group">
                             <label>Company</label>
						     <?=form_dropdown(['name'=>'COMPANYID','id'=>'COMPANYID','class'=>'form-control', 'onChange'=>'getDefaultData();'],$company_list, $selCompanyid);?>
                    	</div>
                    </div>
					 <div class="col-sm-6 invoice-col text-right">
							<div class="form-group">
								<label>Date Range <small>(CP Date only)</small></label>
								<div class="input-group">
									<div class="input-group-addon">
										<i class="fa fa-calendar"></i>
									</div>
									<?=form_input(['name'=>'dateRange','id'=>'dateRange','class'=>'form-control pull-right','placeholder'=>'Please select CP Date range...','readonly'=>'true','value'=>set_value('dateRange',$dateRange)]);?><input type="hidden" name="startdate" id="startdate" value="<?=$startdate;?>"/><input type="hidden" name="enddate" id="enddate" value="<?=$enddate;?>"/>
								</div><!-- /.input group -->
							</div><!-- /.form group -->
					  </div>
				</div>	
				<div class="box-body table-responsive" style="overflow:auto;">	
				<table class="table table-bordered table-striped" width="100%" id="detailed_annual_revenue_report" >
					<thead>								
						<tr>
							<th valign='top' align='left' width='5%'>Fixture Type</th>									
							<th valign='top' align='left' width='5%'>Fixture No./ Nomination ID</th>
							<th valign='top' align='left' width='5%'>Broker</th>
							<th valign='top' align='left' width='5%'>CP Date</th>
							<th valign='top' align='left' width='5%'>Vessel</th>
							<th valign='top' align='left' width='5%'>Vessel Type</th>
							<th valign='top' align='left' width='5%'>Owner</th>
							<th valign='top' align='left' width='5%'>Charterer</th>									
							<th valign='top' align='left' width='5%'>Load Port</th>
							<th valign='top' align='left' width='5%'>Discharge Port</th>
							
							<th valign='top' align='left' width='5%'>Invoice Details Frt</th>
							<th valign='top' align='left' width='5%'>Invoice Details Dem</th>									
							<th valign='top' align='left' width='5%'>Comm on Frt Rcvd</th>
							<th valign='top' align='left' width='5%'>Comm on Dem Rcvd</th>	
							
							<th valign='top' align='left' width='5%'>Total</th>											
						</tr>
					</thead>
					<?php $frt_rcvd_total = $demu_rcvd_total = $snp_rcvd_total  = $total = 0;
						if(!$nom): ?>
						<tbody>															
						</tbody>
					<?php else:$i=1;?>
							<tbody>	
							<?php foreach($nom as $nomData) : 
									$frt_rcvd_total  += $nomData['FRT_RCVD'];
									$demu_rcvd_total += $nomData['DEM_RCVD'];
									
									$total = number_format(($nomData['FRT_RCVD'] + $nomData['DEM_RCVD']),2,'.','');?>																		
									<tr >
										<td  align='left' valign='top' ><?= $nomData['FIXTURETYPENAME'];?></td>												
										<td  align='left' valign='top' ><?= $nomData['NOMINATIONID'];?></td>
										<td  align='left' valign='top' ><?= $nomData['ADDEDBY'];?></td>
										<td  align='left' valign='top' ><?= formatedDate($nomData['CPDATE'], "d-m-Y");?></td>
										<td  align='left' valign='top' ><?= $nomData['FLEETNAME'];?></td>	
										<td  align='left' valign='top' ><?= $nomData['VESSELTYPENAME'];?></td>	
										<td  align='left' valign='top' ><?= $nomData['OWNERNAME'];?></td>
										<td  align='left' valign='top' ><?= $nomData['VENDORNAME'];?></td>		
										<td  align='left' valign='top' ><?= $nomData['LPORTNAME'];?></td>
										<td  align='left' valign='top' ><?= $nomData['DPORTNAME'];?></td>
										<td  align='left' valign='top' >
										<?php $f_arr = array();if(count($nomData['f_invoice_list']) > 0):
												foreach($nomData['f_invoice_list'] as $f_invoice):
													$f_arr[] = '<code>'.$f_invoice->INVOICENUMBER.'</code>-<code style="color:green;">'.formatedDate($f_invoice->INVOICEDATE, "d M Y").'</code>-<code style="color:blue;">'.abs(number_format(($f_invoice->COMMISSIONVALUE*$f_invoice->CONVERSION_RATE),2,'.','')).' '.$f_invoice->EXCURRENCY.'('.(($f_invoice->COMMISSIONVALUE < 0) ? '-ve' : '+ve').')</code>';
												endforeach;
											endif;?>
										<?=implode("<br>",$f_arr);?>
										</td>
										<td  align='left' valign='top' >
										<?php $d_arr = array();if(count($nomData['d_demu_list']) > 0):
												foreach($nomData['d_demu_list'] as $d_demu):
													$d_arr[] = '<code>'.$d_demu->INVOICENUMBER.'</code>-<code style="color:green;">'.date("d M Y",strtotime($d_demu->INVOICEDATE)).'</code>-<code style="color:blue;">'.number_format(($d_demu->COMMISSIONVALUE*$d_demu->CONVERSION_RATE),2,'.','').' '.$d_demu->EXCURRENCY.'</code>';
												endforeach;
											endif;?>
										<?=implode("<br>",$d_arr);?>
										</td>
										<td  align='left' valign='top' ><?= $nomData['FRT_RCVD'];?></td>															
										<td  align='left' valign='top' ><?= $nomData['DEM_RCVD'];?></td>
										
										<td  align='left' valign='top' ><?= ($total == 0) ? '' : $total;?></td>												
									</tr>
								
					<?php	$i++;	endforeach;?>									
						</tbody>
						<tfoot>
							<tr>	
								<td  align='right' valign='top' colspan="12" >GRAND TOTAL : </td>	
								<td  align='left' valign='top' ><code style="background:#ADD8E6;color:#000;"><?= number_format($frt_rcvd_total,2,'.','');?></code></td>	
								<td  align='left' valign='top' ><code style="background:#ADD8E6;color:#000;"><?= number_format($demu_rcvd_total,2,'.','');?></code></td>	
								
								<td  align='left' valign='top' ><code style="background:#ADD8E6;color:#000;"><?= number_format(($frt_rcvd_total + $demu_rcvd_total),2,'.','');?></code></td>												
							</tr>
						</tfoot>
					<?php endif;?>			
				</table>
				</div>			   
			</div>
	</div>
<!--   content ends here..................-->
</section><!-- /.content -->
<script>
var url="<?= base_url();?>";
$(document).ready(function() {
	$('#dateRange').daterangepicker({
		format: 'DD/MM/YYYY'
		}, 
		function(start, end, label) {
			$("#startdate").val(start.format('YYYY-MM-DD'));
			$("#enddate").val(end.format('YYYY-MM-DD'));
			getDefaultData();
			
	});
});

function getDefaultData()
{
	if($("#COMPANYID").val()!=''){var company = $("#COMPANYID").val();}else{var company = 0;}
	location.href = url+"admin/detailed-annual-revenue-report/"+company+"/"+$("#startdate").val()+"/"+$("#enddate").val();
}

function getExcel()
{
	$('#detailed_annual_revenue_report').table2excel({
		exclude: '.noExl',
		name: 'Sheet 1',
		filename: 'Detailed Annual Revenue Report '+getDateString(new Date(), "d-M-y")
	});
}
</script>