<?php
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');
?>               
<!-- Content Header (Page header) -->
<section class="content-header">
	<h1>
		<i class="fa fa-table"></i>&nbsp;Vendor List&nbsp;&nbsp;&nbsp;&nbsp;<small><div class="headline text-center" id="time" style="color:#000; font-weight:bold; font-size:12px;"></div></small>
	</h1>
	<ol class="breadcrumb">
		<li><a href="<?= base_url('admin/dashboard');?>"><i class="fa fa-home"></i> Home</a></li>
		<li class="active">Vendor List</li>
	</ol>
</section>

<!-- Main content -->
<section class="content">
<!--   content put here..................-->
	<div class="box box-primary">
			<div class="box-header">
				<!-- tools box -->
				<div class="pull-right box-tools">
					<a href="<?= base_url('admin/add-vendor');?>" data-toggle="tooltip" title="" data-original-title="Add New"><button class="btn btn-info btn-flat">Add New</button></a>
				</div><!-- /. tools -->
				<h3 class="box-title"><b>VENDOR LIST</b></h3>
			</div>			
			<!-- THE MESSAGES -->
			<div class="box-body table-responsive" style="min-height:280px;">
				<table id="vendor_list" class="table table-striped display" style="width:100%">
					<thead>
						<tr>
							<th valign='top' align='center' width='1%'>#</th>
								<th valign='top' align='left' width='10%'>Vendor Name</th>
								<th valign='top' align='left' width='10%'>Vendor Type</th>
								<th valign='top' align='left' width='10%'>Vendor Code</th>
								<th valign='top' align='left' width='10%'>Vendor Short Name</th>
								<th valign='top' align='left' width='5%' style="text-align:center;">Status</th>
								<th valign='top' align='left' width='1%'>Details</th>
						</tr>
					</thead>
				</table>
			</div>
			   
			
	</div>
	
<!--   content ends here..................-->
</section><!-- /.content -->
<script>
var url="<?= base_url();?>";
$(document).ready(function() {
	getDefaultData();
});

function getDefaultData()
{
	var table = $('#vendor_list').DataTable();
	if(table != null)$('#vendor_list').dataTable().fnDestroy();

	table = $('#vendor_list').DataTable({
			"processing": true,
			"serverSide": true,
			"stateSave": true,
			"autoWidth" : !1,
			"responsive": !0,
			"pageLength": 100,
			"order": [[1,'asc']],
			
			"dom"       : "Blfrtip",
			"buttons"   : [{extend:"excelHtml5",title:"VENDOR LIST"},{extend:"csvHtml5",title:"VENDOR LIST"},{extend:"print",title:"VENDOR LIST"}],
			"initComplete" : function(a,b){$(this).closest(".dataTables_wrapper").prepend('<div class="dataTables_length actions"><span class="actions__item zmdi zmdi-print" style="padding-right:10px; font-size:20px; cursor:pointer;" data-table-action="print" title="Print" /><span class="actions__item zmdi zmdi-download" data-table-action="excel" title="Excel" style="padding-right:10px; font-size:20px; cursor:pointer;" /><span class="actions__item  zmdi zmdi-file-text" data-table-action="csv" title="CSV" style="padding-right:10px; font-size:20px; cursor:pointer;" /></div>');$(".dataTables_filter input[type=search]").focus(function(){$(this).closest(".dataTables_filter").addClass("dataTables_filter--toggled")});$(".dataTables_filter input[type=search]").blur(function(){$(this).closest(".dataTables_filter").removeClass("dataTables_filter--toggled")});$("body").on("click","[data-table-action]",function(a){ a.preventDefault();var b=$(this).data("table-action");if("excel"===b && $(this).closest(".dataTables_wrapper").find(".buttons-excel").trigger("click"),"csv"===b && $(this).closest(".dataTables_wrapper").find(".buttons-csv").trigger("click"),"print" === b && $(this).closest(".dataTables_wrapper").find(".buttons-print").trigger("click"),"fullscreen"===b){var c = $(this).closest(".card");c.hasClass("card--fullscreen") ? (c.removeClass("card--fullscreen"),$("body").removeClass("data-table-toggled")):(c.addClass("card--fullscreen"),$("body").addClass("data-table-toggled")); }   });
				},
			
			"ajax": {
				"url": url+"json/JsonVendor",
				"type": "POST",
				"dataSrc": function ( d ) {
					if(d.csrf_token_name !== undefined) $('meta[name=csrf_token_name]').attr("content", d.csrf_token_name);
					return d.records;
				},	
				"data": function ( d ) {d.csrf_token_name = $('meta[name=csrf_token_name]').attr("content");},
			},
			"columns": [
				{ "data": "col1" },
				{ "data": "col2" },
				{ "data": "col3" },
				{ "data": "col4" },
				{ "data": "col5" },
				{ "data": "col6" },
				{ "data": "col7" },
			],
			"language": {
				  "zeroRecords": "SORRY CURRENTLY THERE ARE ZERO(0) RECORDS",
				  "searchPlaceholder" : "Search for records...",
				},
			 "fnDrawCallback": function(oSettings, json) {
				  $('[data-toggle="tooltip"]').tooltip();	
				},	
			"columnDefs": [ 
					{
						"targets": 0,
						"class": "text-center",
						"orderable": false
					},
					{
						"targets": 5,
						"class": "text-center",
						"data": null,
						"render": function ( data, type, full, meta ) {
								if(data == 'Active'){return '<small class="label label-success">Active</small>';}
											else    {return '<small class="label label-danger">In-Active</small>';}
							}
					},
					{
						"targets": 6,
						"class": "text-center",
						"orderable": false
					}   
				]
					
		});
}
</script>