'use strict';

$(document).ready(function () {
    /*--------------------------------------
        Animation
    ---------------------------------------*/
    var animationDuration;


    $('body').on('click', '.animation-demo .card-block .btn', function(){
        var animation = $(this).text();
        var cardImg = $(this).closest('.card').find('img');
        if (animation === "hinge") {
            animationDuration = 2100;
        }
        else {
            animationDuration = 1200;
        }

        cardImg.removeAttr('class');
        cardImg.addClass('animated '+animation);

        setTimeout(function(){
            cardImg.removeClass(animation);
        }, animationDuration);
    });
});


function notify(title, message, from, align, icon, type, animIn, animOut){
	$.notify({
		icon: icon,
		title: title,
		message: message,
		url: ''
	},{
		element: 'body',
		type: type,
		allow_dismiss: true,
		placement: {
			from: from,
			align: align
		},
		offset: {
			x: 20,
			y: 20
		},
		spacing: 10,
		z_index: 1031,
		delay: 2500,
		timer: 1000,
		url_target: '_blank',
		mouse_over: false,
		animate: {
			enter: animIn,
			exit: animOut
		},
		template:   '<div data-notify="container" class="alert alert-dismissible alert-{0} alert--notify" role="alert">' +
		'<span data-notify="icon"></span> ' +
		'<span data-notify="title">{1}</span> ' +
		'<span data-notify="message">{2}</span>' +
		'<div class="progress" data-notify="progressbar">' +
		'<div class="progress-bar progress-bar-{0}" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%;"></div>' +
		'</div>' +
		'<a href="{3}" target="{4}" data-notify="url"></a>' +
		'<button type="button" aria-hidden="true" data-notify="dismiss" class="btn btn-sm btn-flat bg-olive margin">Close</button>' +
		'</div>'
	});
}