<?php
class Pass extends App_model {

	public $varpass = array();

	public function __construct()
	{
		parent::__construct();
	}
	
	public function getSelectList($tableName, $options = array(), $type='')
	{
		$arr[''] = ($type == 'multiple') ? '' : '---Select from list---';		
			  self::call_method($options);
		$q = $this->db->get($tableName);
		if($q->result()):
			foreach($q->result() as $result):
				$arr[current($result)] = end($result);
			endforeach;				
		endif;
		return $arr;
	}
	
	public function getResultArray($result)
	{
		if($result):
			foreach($result as $result):
				$arr[current($result)] = end($result);
			endforeach;				
		endif;
		return $arr;
	}

	public function getUserTypeList()
	{
		return ['operation'=>'Operations','claims'=>'Claims'];
	}
	
	public function getInvoiceNoteList()
	{
		return [''=>'---Select from list---','1'=>'Credit Note','2'=>'Debit Note','3'=>'Invoice','4'=>'Deviation','5'=>'Other'];
	}
	
	public function getOwnerChartererList()
	{
		return ['Owner'=>'Owner','Charterer'=>'Charterer'];
	}
	
	public function getInvoiceStatusList()
	{
		return [''=>'---Select from list---','Agreed'=>'Agreed','Disputed'=>'Disputed','Original'=>'Original','Outstanding'=>'Outstanding','Received'=>'Received','Un-paid'=>'Un-paid','Under legal'=>'Under legal','Under negotiation'=>'Under negotiation'];
	}
	
	public function getNOMStatus()
	{
		return ['1'=>'<small class="label label-warning">Fixture Created</small>','2'=>'<small class="label label-success">Sent to Ops & Claims</small>','3'=>'<small class="label label-danger">Freight Paid</small>','4'=>'<small class="label label-danger">Demurrage Paid</small>','5'=>'<small class="label label-primary">Commission on Freight Received</small>','6'=>'<small class="label label-primary">Commission on Demurrage Received</small>'];
	}
	
	public function getFixtureTypeList()
	{
		return ['1'=>'Voyage Spot','2'=>'Time Charter','3'=>'COA'];
	}

	public function getUserStatusList()
	{
		return ['1'=>'Active','2'=>'In-Active'];
	}
	
	public function getCurrencyList()
	{
		return ['AED'=>'United Arab Emirates dirham (AED)','EUR'=>'Euro (EUR)','GBP'=>'British pound (GBP)','SGD'=>'Singapore dollar (SGD)','USD'=>'United States dollar (USD)','INR'=>'Indian Rupee (INR)'];
	}
	
	public function getYearListForNominationGrid()
	{
	    $arr_year = array();
	    for($year = date('Y',time());$year >= 2018;$year--)
		{
			$arr_year[$year] = $year;
		}
		return $arr_year ;
		//return self::getSelectList("nom_details",array("select"=>"YEAR(ADDONDATE), YEAR(ADDONDATE)",'order_by'=>array('YEAR(ADDONDATE)'=>'DESC'),"group_by"=>"YEAR(ADDONDATE)"),"multiple");
	}

	public function getVesselTypeList($type = '')
	{
		return self::getSelectList("vessel_type_master",array("select"=>"VESSELTYPEID, VESSELTYPE","where"=>array('STATUS'=>1),"order_by"=>array('VESSELTYPE'=>'asc')),$type);	
	}
	
	public function getCompanyList()
	{
		return self::getSelectList("company_master",array("select"=>"COMPANYID, COMPANY_NAME","where"=>array('STATUS'=>1),"order_by"=>array('COMPANY_NAME'=>'asc')));	
	}
	
	public function getBankList($type = '')
	{
		return self::getSelectList("bank_master",array("select"=>"BANKID, BANK_NAME","where"=>array('STATUS'=>1),"order_by"=>array('BANK_NAME'=>'asc')),$type);	
	}

	public function getCPFormTypeList($type = '')
	{
		return self::getSelectList("cp_form_type_master",array("select"=>"CPID, NAME","where"=>array('STATUS'=>1),"order_by"=>array('NAME'=>'asc')),$type);	
	}

	public function getHullTypeList($type = '')
	{
		return self::getSelectList("hull_type_master",array("select"=>"HULLTYPEID, HULLTYPE","where"=>array('STATUS'=>0),"order_by"=>array('HULLTYPE'=>'asc')),$type);	
	}
	
	public function getVendorTypeList($type = '')
	{
		return self::getSelectList("vendor_type_master",array("select"=>"VENDOR_TYPEID, NAME","where"=>array('STATUS'=>1),"order_by"=>array('NAME'=>'asc')),$type);	
	}
	
	public function getFleetlist($type = '')
	{
		return self::getSelectList("vessel_imo_master",array("select"=>"VESSELIMOID, VESSELNAME,","order_by"=>array('VESSELNAME'=>'asc')),$type);	
	}

	public function getPortlist($type = '')
	{
		return self::getSelectList("port_master",array("select"=>"PORTID, CONCAT(PORTNAME, ',', COUNTRYNAME)","order_by"=>array('PORTNAME'=>'asc')),$type);	
	}
	
	public function getVendorBasedOnVendorTypeID($vendor_typeid = array(), $type = '')
	{
		return self::getSelectList("vendor_master",array("select"=>"VENDORID, VENDORNAME","where"=>array('STATUS'=>1),"where_in"=>array('VENDORTYPE'=>$vendor_typeid),"order_by"=>array('VENDORNAME'=>'asc')),$type);	
	}
	
	public function getCargoList($type = '')
	{
		return self::getSelectList("cargo_master",array("select"=>"CARGOID, NAME","where"=>array('STATUS'=>1),"order_by"=>array('NAME'=>'asc')),$type);	
	}
	
	public function getUserList($userType = '', $type = '')
	{
		return self::getSelectList("login",array("select"=>"LOGINID, CONTACTPERSON","where"=>array('USERTYPE'=>$userType),"order_by"=>array('CONTACTPERSON'=>'asc')),$type);	
	}
	
	public function getBrokerList($type = '')
	{
		return self::getSelectList("broker_master",array("select"=>"BROKERID, NAME","where"=>array('STATUS'=>1),"order_by"=>array('NAME'=>'asc')),$type);	
	}
	
	public function getMaxNumberBasedOnCondition($field, $param = array())
	{
		$data  = self::getMaxID($field, $param);
		if($data->LATESTNUMBER != "" || $data->LATESTNUMBER != NULL)
		{
			$msgcode = $data->LATESTNUMBER + 1;
			if(strlen($msgcode)<=3)
			{
				$x = 3 - strlen($msgcode);
				for($i = 1; $i<=$x;$i++)
					{
						$msgcode = "0".$msgcode;
					}
			}
			return $msgcode;
		}
		else{return '001';}
	}
	
	
	public function getStatusMasterList()
	{
		return self::getSelectList("status_master",array("select"=>"STATUSID, STATUS_NAME","where"=>array('STATUS'=>1),"order_by"=>array('STATUS_NAME'=>'asc')));	
	}
	
	public function getPurposeOfCallMasterList()
	{
		return self::getSelectList("purposeofcall_master",array("select"=>"CALLID, PURPOSE_NAME","where"=>array('STATUS'=>1),"order_by"=>array('PURPOSE_NAME'=>'asc')));	
	}
	
	public function getGSTInMasterList()
	{
		return self::getSelectList("gstin_master",array("select"=>"GSTNOID, CONCAT(SHORTNAME, ' - ', GSTIN)","where"=>array('STATUS'=>1),"order_by"=>array('SHORTNAME'=>'asc')));	
	}
	
	public function getPortTypeList()
	{
		return ['1'=>'LP','2'=>'DP'];
	}

	public function getInvoiceList($type='')
	{
		return self::getSelectList("invoice_master",array("select"=>"INVOICETYPE","order_by"=>array('INVOICETYPE'=>'asc')),$type);	
	}
	
}