<?php
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');
?>	               
<!-- Content Header (Page header) -->
<section class="content-header">
	<h1>
		<i class="fa fa-anchor"></i>&nbsp;Fleet&nbsp;&nbsp;&nbsp;&nbsp;<small><div class="headline text-center" id="time" style="color:#000; font-weight:bold; font-size:12px;"></div></small>
	</h1>
	<ol class="breadcrumb">
		<li><a href="<?= base_url('operation/dashboard');?>"><i class="fa fa-home"></i> Home</a></li>
		<li class="active">Fleet</li>
	</ol>
</section>

<!-- Main content -->
<section class="content">
				<!--   content put here..................-->
			<div class="box box-primary">				
				<div class="box-header">
					<!-- tools box -->
					<div class="pull-right box-tools">
						<a href="<?= base_url('operation/fleet');?>" data-toggle="tooltip" title="" data-original-title="Back"><button class="btn btn-info btn-flat">Back</button></a>
					</div><!-- /. tools -->
					<h3 class="box-title"><b>ADD NEW VESSEL</b></h3>
				</div>	
				<!-- form start -->
				<?= form_open_multipart('operation/insert-fleet',['name'=>'frm1','id'=>'frm1']);?>				
					<div class="box-body">
						<div class="row invoice-info">	
							<div class="col-sm-6 invoice-col">
							 Vessel Name 
								<address>
									<?= form_input(['name'=>'m_VESSELNAME','id'=>'m_VESSELNAME','class'=>'form-control','placeholder'=>'Vessel Name','autocomplete'=>'off','value'=>set_value('m_VESSELNAME')]);?>	
									<?= form_error('m_VESSELNAME','<span style="color:#ff0000; font-size:12px;">','</span>');?>							   
								</address>
							</div><!-- /.col -->
							<div class="col-sm-6 invoice-col">
								Vessel IMO No.
								<address>
									<?= form_input(['name'=>'m_IMONO','id'=>'m_IMONO','class'=>'form-control','placeholder'=>'Vessel IMO No.','autocomplete'=>'off','value'=>set_value('m_IMONO')]);?>									
								</address>
							</div><!-- /.col -->
							
						</div>
						
						<div class="row invoice-info">	
							<div class="col-sm-6 invoice-col">
							  Vessel Type
								<address>
									<?= form_dropdown(['name'=>'m_VESSELTYPE','id'=>'m_VESSELTYPE','class'=>'form-control'],$vessel_type_list);?>
								</address>								
							</div><!-- /.col -->
							<div class="col-sm-6 invoice-col">
								Hull Type
								<address>
									<?= form_dropdown(['name'=>'m_HULLTYPE','id'=>'m_HULLTYPE','class'=>'form-control'],$hull_type_list);?>	
								</address>
							</div><!-- /.col -->							
						</div>
						
						<div class="row invoice-info">	
							<div class="col-sm-6 invoice-col">
								  DWT (MT)
								<address>
									<?= form_input(['name'=>'m_DWT','id'=>'m_DWT','class'=>'form-control','placeholder'=>'DWT','autocomplete'=>'off','value'=>set_value('m_DWT')]);?>									
								</address>
							</div><!-- /.col -->
							<div class="col-sm-6 invoice-col">
								Year Built
								<address>
									<?= form_input(['name'=>'m_YEARBUILT','id'=>'m_YEARBUILT','class'=>'form-control','placeholder'=>'Year Built','autocomplete'=>'off','value'=>set_value('m_YEARBUILT')]);?>
								 </address>
							</div><!-- /.col -->
							
						</div>
						
						<div class="row invoice-info">	
							<div class="col-sm-6 invoice-col">
								Coating
								<address>
									<?= form_input(['name'=>'m_COATING','id'=>'m_COATING','class'=>'form-control','placeholder'=>'Coating','autocomplete'=>'off','value'=>set_value('m_COATING')]);?>
								</address>
							</div><!-- /.col -->
							<div class="col-sm-6 invoice-col">
								Ship Owner
								<address>
									<?= form_input(['name'=>'m_SHIPOWNER','id'=>'m_SHIPOWNER','class'=>'form-control','placeholder'=>'Ship Owner','autocomplete'=>'off','value'=>set_value('m_SHIPOWNER')]);?>
								</address>
							</div><!-- /.col -->
						</div>
						
						<div class="row invoice-info">	
							<div class="col-sm-6 invoice-col">
								Summer Draft (M)
								<address>
									<?= form_input(['name'=>'m_DRAFTM','id'=>'m_DRAFTM','class'=>'form-control','placeholder'=>'Summer Draft','autocomplete'=>'off','value'=>set_value('m_DRAFTM')]);?>
								</address>
							</div><!-- /.col -->
							<div class="col-sm-6 invoice-col">
								Place Built
								<address>
									<?= form_input(['name'=>'m_PLACEBUILT','id'=>'m_PLACEBUILT','class'=>'form-control','placeholder'=>'Place Built','autocomplete'=>'off','value'=>set_value('m_PLACEBUILT')]);?>
								</address>
							</div><!-- /.col -->							
						</div>
												
						<div class="row invoice-info">	
							<div class="col-sm-6 invoice-col">
								Date Of Registery
								<address>
									<?= form_input(['name'=>'m_REGISTERYDATE','id'=>'m_REGISTERYDATE','class'=>'form-control','placeholder'=>'dd-mm-yyyy','autocomplete'=>'off','value'=>set_value('m_REGISTERYDATE')]);?>
								</address>
							</div><!-- /.col -->
							<div class="col-sm-6 invoice-col">
								Date Keel Laid
								<address>
									<?= form_input(['name'=>'m_KEELLAIDDATE','id'=>'m_KEELLAIDDATE','class'=>'form-control','placeholder'=>'dd-mm-yyyy','autocomplete'=>'off','value'=>set_value('m_KEELLAIDDATE')]);?>
								</address>
							</div><!-- /.col -->
						</div>						
					</div><!-- /.box-body -->

					<div class="box-footer" align="center">
						<?= form_submit(['name'=>'submit','value'=>'Submit','class'=>'btn btn-primary btn-flat']);?>
					</div>
				<?= form_close();?>
			</div>
			
<!--   content ends here..................-->
</section><!-- /.content -->
<script type="text/javascript">
$(document).ready(function(){
	$('#m_KEELLAIDDATE,#m_REGISTERYDATE').datepicker({
   		 format: 'dd-mm-yyyy',
		 autoclose: true
	});
	$("#m_IMONO,#m_DWT").numeric();
    $("#frm1").validate({
		rules: {
			m_VESSELNAME:{required: true},
			m_VESSELTYPE:"required",
			m_IMONO:"required",
			m_DWT:"required",
			m_YEARBUILT: "required"
			},
		submitHandler: function(form)  {
			$("button[type='submit']").attr("disabled","disabled").removeClass("btn-primary").addClass("btn-default disabled");
			swal({title: '<h1>Please Wait...</h1>',showCancelButton: false,type: 'warning',showConfirmButton: false,allowOutsideClick:false,animation: false,customClass: 'animated tada'}).catch(swal.noop);
			form.submit();
		}
	});
});
</script>