<?php
defined('BASEPATH') OR exit('No direct script access allowed');
defined('SECURITY_KEY') OR exit('No direct script access allowed');
?>               
<!-- Content Header (Page header) -->
<section class="content-header">
	<h1>
		<i class="fa fa-pagelines"></i>&nbsp;Fixtures&nbsp;&nbsp;&nbsp;&nbsp;<small><div class="headline text-center" id="time" style="color:#000; font-weight:bold; font-size:12px;"></div></small>
	</h1>
	<ol class="breadcrumb">
		<li><a href="<?= base_url('operation/dashboard');?>"><i class="fa fa-home"></i> Home</a></li>
		<li class="active">Fixtures</li>
	</ol>
</section>

<!-- Main content -->
<section class="content">
<!--   content put here..................-->
	<div class="box box-primary">
			<div class="box-header">
				<!-- tools box -->
				<div class="pull-right box-tools">
					<a href="<?= base_url('operation/add-fixture');?>" data-toggle="tooltip" title="" data-original-title="Add New"><button class="btn btn-info btn-flat">Add Fixture Slip</button></a>
				</div><!-- /. tools -->
				<h3 class="box-title"><b>Fixtures</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="#report" onclick="getpdfData();" title="" data-toggle="tooltip" data-original-title='Download Pdf' ><small class="label label-success" style="font-size:12px;">Download PDF <i class="fa fa-download"></i></small></a></h3><?= form_dropdown(['name'=>'m_YEARID','id'=>'m_YEARID','class'=>'form-control', 'style'=>'max-width:150px;margin-top: 5px;margin-right: 5px; float:right;','onchange'=>'getDefaultData();'],$year_list);?>
			</div>			
			<!-- THE MESSAGES -->
			<div class="box-body table-responsive" style="min-height:280px;">
				<table id="nom_list" class="table table-striped display" style="width:100%">
					<thead>
						<tr>
							<th valign='top' align='left' width='12%'>Fixture Type</th>
							<th valign='top' align='left' width='15%'>Fixture No./ Nomination ID</th>									
							<th valign='top' align='left' width='15%'>Vessel</th>
							<th valign='top' align='left' width='18%'>Charterer /Owner</th>							
							<th valign='top' align='left' width='12%'>Responsible Name</th>
							<th valign='top' align='left' width='12%'>Broker Name</th>
							<th valign='top' align='left' width='10%'>Operator</th>
							<th valign='top' align='left' width='10%'>CP Date</th>
							<th valign='top' align='left' width='15%'>Laycan Start/End</th>
							<th valign='top' align='left' width='10%'>Fixture Status</th>
							<th valign='top' align='left' width='5%'>Details</th>
						</tr>
					</thead>
				</table>
			</div>
			   
			
	</div>
	
<!--   content ends here..................-->
</section><!-- /.content -->
<script>
var url="<?= base_url();?>";
$(document).ready(function() {
	getDefaultData();
});

function getDefaultData()
{
	var table = $('#nom_list').DataTable();
	if(table != null)$('#nom_list').dataTable().fnDestroy();

	table = $('#nom_list').DataTable({
		"sScrollX": "100%",
            "sScrollXInner": "110%",
            "bScrollCollapse": true,
			"processing": true,
			"serverSide": true,
			"stateSave": true,
			"autoWidth" : !1,
			"responsive": !0,
			"pageLength": 100,
			"order": [[1,'asc']],
			
			"dom"       : "Blfrtip",
			"buttons"   : [{extend:"excelHtml5",title:"NOMINATION AT A GLANCE"},{extend:"csvHtml5",title:"NOMINATION AT A GLANCE"},{extend:"print",title:"NOMINATION AT A GLANCE"}],
			"initComplete" : function(a,b){$(this).closest(".dataTables_wrapper").prepend('<div class="dataTables_length actions"><span class="actions__item zmdi zmdi-print" style="padding-right:10px; font-size:20px; cursor:pointer;" data-table-action="print" title="Print" /><span class="actions__item zmdi zmdi-download" data-table-action="excel" title="Excel" style="padding-right:10px; font-size:20px; cursor:pointer;" /><span class="actions__item  zmdi zmdi-file-text" data-table-action="csv" title="CSV" style="padding-right:10px; font-size:20px; cursor:pointer;" /></div>');$(".dataTables_filter input[type=search]").focus(function(){$(this).closest(".dataTables_filter").addClass("dataTables_filter--toggled")});$(".dataTables_filter input[type=search]").blur(function(){$(this).closest(".dataTables_filter").removeClass("dataTables_filter--toggled")});$("body").on("click","[data-table-action]",function(a){ a.preventDefault();var b=$(this).data("table-action");if("excel"===b && $(this).closest(".dataTables_wrapper").find(".buttons-excel").trigger("click"),"csv"===b && $(this).closest(".dataTables_wrapper").find(".buttons-csv").trigger("click"),"print" === b && $(this).closest(".dataTables_wrapper").find(".buttons-print").trigger("click"),"fullscreen"===b){var c = $(this).closest(".card");c.hasClass("card--fullscreen") ? (c.removeClass("card--fullscreen"),$("body").removeClass("data-table-toggled")):(c.addClass("card--fullscreen"),$("body").addClass("data-table-toggled")); }   });
				},
			
			"ajax": {
				"url": url+"json/JsonNomAtGlance",
				"type": "POST",
				"dataSrc": function ( d ) {
					if(d.csrf_token_name !== undefined) $('meta[name=csrf_token_name]').attr("content", d.csrf_token_name);
					return d.records;
				},	
				"data": function ( d ) {d.csrf_token_name = $('meta[name=csrf_token_name]').attr("content");d.yearid=$('#m_YEARID').val();},
			},
			"columns": [
				{ "data": "col1" },
				{ "data": "col2" },
				{ "data": "col3" },
				{ "data": "col4" },
				{ "data": "col5" },
				{ "data": "col6" },
				{ "data": "col7" },
				{ "data": "col8" },
				{ "data": "col9" },
				{ "data": "col10" },
				{ "data": "col11" },
			],
			"language": {
				  "zeroRecords": "SORRY CURRENTLY THERE ARE ZERO(0) RECORDS",
				  "searchPlaceholder" : "Search for records...",
				},
			 "fnDrawCallback": function(oSettings, json) {
				  $('[data-toggle="tooltip"]').tooltip();	
				},	
			"columnDefs": [ 					
					{
						"targets": 10,
						"class": "text-center",
						"orderable": false
					},
					{
						"targets": 9,
						"class": "text-center",
						"orderable": false
					},
					{
						"targets": 8,
						"class": "text-center",
						"orderable": false
					} 
				]
					
		});
}

function removeDetails(value)
{
	swal({
			title: 'Are you sure?',
			text: 'You want to delete this Fixture Slip permanently!',
			type: 'warning',
			showCancelButton: true,
			buttonsStyling: false,
			confirmButtonClass: 'btn btn-danger',
			confirmButtonText: 'Yes, delete it!',
			cancelButtonClass: 'btn btn-secondary',
			allowOutsideClick:false,
		}).then(function(){
			var baseurl="<?= base_url();?>";
			$.ajax({
				type: "POST",
				url: baseurl+"json/removeFixture/",
				data: {nomid	: value,csrf_token_name: $('meta[name=csrf_token_name]').attr("content")},
				success: function(d)
				{
					if(d.items > 0){
						if(d.csrf_token_name !== undefined) $('meta[name=csrf_token_name]').attr("content", d.csrf_token_name);
						getDefaultData('default');
						swal({title: 'Successfully deleted.',text: 'You will not be able to recover this entry!',type: 'success',buttonsStyling: false,allowOutsideClick:false,confirmButtonClass: 'btn btn-primary'});
					}
					else
					{
						swal({title: 'Error',text: 'Please contact the Administrator!',type: 'success',buttonsStyling: false,allowOutsideClick:false,confirmButtonClass: 'btn btn-primary'});
					}
				}        
			});
		}).catch(swal.noop);
}

function getpdfData()
{
	var baseurl="<?= base_url();?>";
	window.location.href = baseurl+"report-pdf/Nomination-grid-pdf/0/"+$('#m_YEARID').val();
	return true;
}
</script>